
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

#pragma used+
unsigned char spi(unsigned char data);
#pragma used-

#pragma library spi.lib

typedef struct {
unsigned char        minRates;        
unsigned char        maxRates;        
unsigned char        minDRates;       
unsigned char        maxDRates;        
char                cur_nodes[7];
}CONTR_A1;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char		tcut;		  
char		        cur_nodes[7];
}CONTR_A2;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
char		        cur_nodes[7];
}CONTR_A3;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char       delay;        
}CONTR_D;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char       from;         
char		        cur_nodes[7];
}CONTR_V;

typedef struct {
CONTR_A1 contr_ab[3]; 
CONTR_A2 contr_tr; 
CONTR_A3 contr_ap; 
CONTR_D  contr_d[3]; 
CONTR_V  contr_v[2]; 
signed char chanels[8][10];
signed char trimmers[4];
}DEF_MODE;

typedef struct {
char name[8]; 
unsigned char type:1; 
unsigned char modulation:2; 
unsigned char timer_mode:2;
unsigned int  timer_set;
unsigned char num_ch:4;
unsigned char num_freq;
signed char contrs_reverse[10]; 
DEF_MODE modes[3];
} MODEL_SET;

struct typedef { unsigned char note; unsigned int ms; }BEEP_TRACK_DEF;

extern unsigned char posx, posy;

void LCD_init(void); 
void LCD_refresh (void);  
void LCD_clear (void);
void LCD_pixel (unsigned char x, unsigned char y, unsigned char color);
void LCD_line ( char x1, char y1, char x2, char y2, char mode );
void LCD_dashline ( char x1, char y1, char x2, char y2);
void LCD_rectangle(char x, char y, char x1, char y1,unsigned char color);  
void LCD_fillrect  (char x, char y, char x1, char y1,unsigned char color); 
void LCD_setxy(char x,unsigned char y);        
void LCD_deg12x16(unsigned char c, unsigned char color);    
void LCD_frame(unsigned char x);
unsigned char LCD_get_char_len(unsigned char ch);   
void LCD_char(unsigned char ch, unsigned char color);    
void  LCD_wrs (unsigned char*str,unsigned char color); 
void LCD_wrsf (unsigned char flash*str,unsigned char color); 

extern flash const BEEP_TRACK_DEF calibr_sound[];
extern flash const BEEP_TRACK_DEF key_sound[];
extern flash const BEEP_TRACK_DEF error_sound[];
extern bit  f_sound_en;

void TimerOn(void);
void save_trimmer(void);
void TX_init (void);
void keys_menu(void);
void MODEL_reset(unsigned char ind);

void displ_head (flash unsigned char * name);
void displ_menu (void);

extern eeprom MODEL_SET EEP_models[7];
extern eeprom unsigned char EEP_start_model;
extern eeprom unsigned char EEP_f_sound_en;
extern eeprom unsigned char EEP_BatCntr[3];
extern unsigned char g_MainMenuMode;
extern eeprom int EEPR_ADmid[5], EEPR_ADmax[5], EEPR_ADmin[5];  
extern eeprom unsigned char EEP_FirstON, EEP_Calibration;
extern eeprom signed int EPP_CalibrTemperature[];

extern signed int out_control[10];
extern signed int ADmid[5];
extern signed int ADmin[5];
extern signed int ADmax[5];
extern signed int out_ch[8];

extern MODEL_SET cur_model;
extern unsigned char cur_model_ind;
extern unsigned char cur_mode_ind;
extern bit f_TCut;
extern unsigned int cur_Batt;
extern unsigned int cur_Power;
extern unsigned int cur_Temperature;
extern signed int dir_Temperature;
extern unsigned char wd_Temperature;
extern unsigned int div_trimmer;
extern bit f_beep_timer;
extern bit f_beep_EEP;
extern bit f_beep_key;
extern bit f_beep_trimmer;

unsigned int read_adc(unsigned char adc_input);
void beep_start(BEEP_TRACK_DEF flash *notes, unsigned char cnt, unsigned char rep);
void calibr (void);
void calibr_thermometer (void);
void TX_reset (void);

eeprom MODEL_SET EEP_models[7];
eeprom unsigned char EEP_start_model;
eeprom unsigned char EEP_f_sound_en;
eeprom unsigned char EEP_BatCntr[3];
eeprom int EEPR_ADmid[5], EEPR_ADmax[5], EEPR_ADmin[5];  
eeprom unsigned char EEP_FirstON, EEP_Calibration;
eeprom signed int EPP_CalibrTemperature[2];

signed int out_control[10];
signed int ADmid[5];
signed int ADmin[5];
signed int ADmax[5];
signed int out_ch[8];

MODEL_SET cur_model;
unsigned char cur_model_ind;
unsigned char cur_mode_ind;
bit f_TCut;
unsigned int cur_Batt;
unsigned int cur_Power;
unsigned int cur_Temperature;
signed int dir_Temperature;
unsigned char wd_Temperature;
unsigned int div_trimmer;
unsigned char f_l;
unsigned char g_MainMenuMode;
extern bit f_timer_en;
unsigned int gRPMtmp=0;
unsigned int gRPM[3];
unsigned char gRPMn;
signed int g_pos_d[3];
unsigned char g_keys; 

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|0x00;

ADCSRA|=0x40;

while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

interrupt [2] void ext_int0_isr(void)
{
gRPMtmp++;
if(gRPMtmp==1024) EIMSK&=0xfe;
}

void TimerTachometer(void)
{ 
static unsigned char div;
div++;
if(div>=25)
{ 
div=0;
gRPM[gRPMn]=gRPMtmp;
if(++gRPMn>=3) gRPMn=0;
gRPMtmp=0;
}
}

__flash const unsigned int notes[]= {
440, 466, 494, 523,    554,  588,  612,  660,    698,  740,  784,  830, 
880, 932, 988, 1064,   1108, 1176, 1224, 1320,   1396, 1480, 1568, 1660};
BEEP_TRACK_DEF flash *beep_track;
unsigned int beep_length;
unsigned char beep_cnt;
unsigned char beep_cntn;
unsigned char beep_rep;
unsigned int beep_freq;
bit f_beep_fase;
bit f_beep_timer;
bit f_beep_EEP;
bit f_beep_key;
bit f_beep_trimmer;

extern flash const BEEP_TRACK_DEF hello_sound[];

void beep(BEEP_TRACK_DEF flash *note)
{
unsigned long ln, freq;

freq=notes[note->note]; freq*=2L;
ln=1500000L/freq; ln=65536L-ln;
beep_freq=ln;
(*(unsigned char *) 0x89)=beep_freq>>8;
(*(unsigned char *) 0x88)=beep_freq & 0xff;
ln=note->ms*freq; ln/=1000L;
beep_length=ln;
}

interrupt [30] void timer3_ovf_isr(void)
{
bit f_con;

(*(unsigned char *) 0x89)=beep_freq>>8;
(*(unsigned char *) 0x88)=beep_freq & 0xff;
if(--beep_length==0)
{
f_con=0;
if(++beep_cntn<beep_cnt)  f_con=1;
else if(beep_rep) { f_beep_fase=0; beep_rep--; beep_cntn=0; f_con=1; }
if(f_con==0) { (*(unsigned char *) 0x65)&=0b11111011  ; (*(unsigned char *) 0x7d)&=~0x4; return; }
else beep((beep_track+beep_cntn));
}
f_beep_fase=!f_beep_fase;
if(f_beep_fase) (*(unsigned char *) 0x65)|=0b00000100  ; else (*(unsigned char *) 0x65)&=0b11111011  ;
}

void beep_start(BEEP_TRACK_DEF flash *notes, unsigned char cnt, unsigned char rep)
{
beep_track=notes;
beep_cnt=cnt;
beep_cntn=0;
beep_rep=rep;
beep(notes);
(*(unsigned char *) 0x7d)|=0x4;
}

unsigned int CHcalc (char ch_ind)
{
signed long ln, ret;
unsigned char i;
signed char *chans;

chans=cur_model.modes[cur_mode_ind].chanels[ch_ind];
ret=2250; 
for (i=0; i<10; i++) 
{
if (chans[i]!=0)
{ ln=out_control[i]; ln*=chans[i]; ln/=100; ret+=ln; }
}  
if (ret>3150) ret=3150; 
if (ret<1350) ret=1350; 
return (unsigned int)ret;
}

signed int interpol(signed int val, signed char* nodes, )
{
unsigned char n;
signed int n1, n2, vmin;
signed long ln;

ln=val; ln*=6; n=ln/1500;
n1=*(nodes+n); n1=(n1*75)/10;
n2=*(nodes+n+1); n2=(n2*75)/10;
vmin=n; vmin*=250;
ln=(val-vmin); ln*=(n2-n1); ln/=250;
return ln + n1;
}

signed int rate_calc(signed int val, unsigned char min, unsigned char max)
{
unsigned char rate;
signed long v;

if(val<0) rate=min;
else rate=max;
v=val; v*=rate; v/=100;
return v;  
}

unsigned char ReadKeys(void)
{
unsigned char f;

f=0;
if(!PINE.4  ) f|=1;
if(!PINE.3) f|=2;
if(!PINE.2) f|=4;
if(!PINE.5) f|=8;
if(!PINC.1     ) f|=0x10;
if(!PINC.0  ) f|=0x20;
if(!PINC.2     ) f|=0x40;
if(!PINC.3     ) f|=0x80;
return f;
}

void Calc (void)
{ 
static unsigned char div_trim;
signed char *trim;
signed int input[10];
unsigned int i, n;
signed long vl;
const unsigned char acntr[]={ 4, 3, 5, 2, 7 };
signed int vi;
unsigned char mn, mx;
DEF_MODE *mode;
unsigned char f_dual[3];
unsigned char keys;
bit f;

if(!PINE.7    )           i=0;
else if(!PINE.6)      i=2;
else                     i=1;
if(cur_mode_ind!=i) { f_beep_key=1; save_trimmer(); cur_mode_ind=i; }

trim=cur_model.modes[cur_mode_ind].trimmers; 
if (div_trim)
{
f=0;
if(!PINA.3	 && trim[0]<80) { trim[0]++; f=1;  }
if(!PINA.0	 && trim[0]>-80) { trim[0]--;  f=1; }
if(!PINA.1	 && trim[1]<80) { trim[1]++; f=1; }
if(!PINA.2	 && trim[1]>-80) { trim[1]--; f=1; }
if(!PINA.5	 && trim[2]<80) { trim[2]++;   f=1; }
if(!PINA.4	 && trim[2]>-80) { trim[2]--; f=1; }
if(!PINA.7	 && trim[3]<80) { trim[3]++; f=1; }
if(!PINA.6	 && trim[3]>-80) { trim[3]--; f=1; }
if(f) { f_beep_trimmer=1; div_trimmer=1500; }
}
div_trim=!div_trim;

mode=&cur_model.modes[cur_mode_ind];

for(i=0; i<5; i++)
{
n=i; if(i==4) n=7;
vl=read_adc(acntr[i]);
if(vl<ADmid[i])
{
if(ADmin[i]>vl) ADmin[i]=vl;
vl-=ADmin[i]; vl*=750; input[n]=vl/(ADmid[i]-ADmin[i]);
}
else
{
if(ADmax[i]<vl) ADmax[i]=vl;
vl-=ADmid[i]; vl*=750; input[n]=750+(vl/(ADmax[i]-ADmid[i]));
}
}

keys=ReadKeys(); if(keys!=g_keys) { f_beep_key=1; g_keys=keys; }
if(keys & 1) input[4]=0; else input[4]=1500;
if(keys & 2) input[5]=0; 
else if(keys & 4) input[5]=1500;
else input[5]=750;
if(keys & 8) input[6]=0; else input[6]=1500;
for(i=0; i<3; i++)
{
vi=mode->contr_d[i].delay;
if(vi==0) g_pos_d[i]=input[4+i];
else if(g_pos_d[i]!=input[4+i])
{
vl=g_pos_d[i]; vl*=vi; vl/=(300/2); vl++; vl/=2;
if(g_pos_d[i]<input[4+i])
{
vl++; vl*=(300*2); vl/=vi; vl++; vl/=2;
if(vl>input[4+i]) vl=input[4+i];
} 
else
{
vl--; vl*=(300*2); vl/=vi; vl++; vl/=2;
if(vl<input[4+i]) vl=input[4+i];
}
g_pos_d[i]=vl; input[4+i]=vl;
}
input[4+i]-=750;     
}
input[8]=input[mode->contr_v[0].from];
input[9]=input[mode->contr_v[1].from];

if (keys & 0x80) f_TCut=1; else f_TCut=0;

f_dual[0]=(keys & 0x10);
f_dual[1]=(keys & 0x20);
f_dual[2]=(keys & 0x40);

for(i=0; i<3; i++)
{
n=i; if(i==2) n++;
vi=interpol(input[n], mode->contr_ab[i].cur_nodes);
if(f_dual[i]) { mn=mode->contr_ab[i].minDRates; mx=mode->contr_ab[i].maxDRates; }
else { mn=mode->contr_ab[i].minRates; mx=mode->contr_ab[i].maxRates; }
out_control[n]=rate_calc(vi, mn, mx);
vi=mode->trimmers[n]; vi*=5; out_control[n]+=vi;
}
if(f_TCut) { vi=mode->contr_tr.tcut; vi*=-75; out_control[2]=vi/10; }
else 
{
vi=interpol(input[2], mode->contr_tr.cur_nodes);
out_control[2]=rate_calc(vi, mode->contr_tr.minRates, mode->contr_tr.maxRates);
vi=mode->trimmers[2]; vi*=5; out_control[2]+=vi;
}
if(cur_model.timer_mode==2) { if(!f_TCut && input[2]>150) f_timer_en=1; else f_timer_en=0; }

for(i=0; i<3; i++)
out_control[4+i]=rate_calc(input[4+i], mode->contr_d[i].minRates, mode->contr_d[i].maxRates);

vi=interpol(input[7], mode->contr_ap.cur_nodes);
out_control[7]=rate_calc(vi, mode->contr_ap.minRates, mode->contr_ap.maxRates);

for(i=0; i<2; i++)
{
vi=interpol(input[8+i], mode->contr_v[i].cur_nodes);
out_control[8+i]=rate_calc(vi, mode->contr_v[i].minRates, mode->contr_v[i].maxRates);
}

for(i=0; i<10; i++) out_control[i]*=cur_model.contrs_reverse[i];
} 

interrupt [13] void timer1_compa_isr(void)
{ 
static unsigned char nb;
static unsigned int sum;
unsigned int out;

if (nb<cur_model.num_ch)
{       
out=CHcalc(nb);
ICR1H=out>>8;        
ICR1L=out&0xff;
out_ch[nb]=out;
sum+=out; nb++;
if(nb==1) TimerTachometer();
}
else
{
out=30000-sum; 
ICR1H=out>>8; 
ICR1L=out&0xff;     
nb=0; sum=0;
#asm("sei")
f_l++;  
Calc();
TimerOn();
f_l++;
}
}

void main(void)
{
unsigned char i;

PORTA=0xFF;
DDRA=0x00;

PORTB=0x01;
DDRB=0xA6;

PORTC=0x0F;
DDRC=0xF0;

PORTD=0xF0;
DDRD=0x00;

PORTE=0xFC;
DDRE=0x00;

(*(unsigned char *) 0x62)=0x00;
(*(unsigned char *) 0x61)=0x00;

(*(unsigned char *) 0x65)=0x00;
(*(unsigned char *) 0x64)=0x1C;

ASSR=0x00;
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0x82;
TCCR1B=0x1A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x17;
ICR1L=0x70;
OCR1AH=0x02;
OCR1AL=0x68;
OCR1BH=0x00;
OCR1BL=0x00;
(*(unsigned char *) 0x79)=0x00;
(*(unsigned char *) 0x78)=0x00;

TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

(*(unsigned char *) 0x8b)=0x00;
(*(unsigned char *) 0x8a)=0x02;
(*(unsigned char *) 0x89)=0x00;
(*(unsigned char *) 0x88)=0x10;
(*(unsigned char *) 0x81)=0x00;
(*(unsigned char *) 0x80)=0x00;
(*(unsigned char *) 0x87)=0x00;
(*(unsigned char *) 0x86)=0x00;
(*(unsigned char *) 0x85)=0x00;
(*(unsigned char *) 0x84)=0x00;
(*(unsigned char *) 0x83)=0x00;
(*(unsigned char *) 0x82)=0x00;

(*(unsigned char *) 0x6a)=0x02;
EICRB=0x00;
EIMSK=0x0;
EIFR=0x01;

TIMSK=0x01;
(*(unsigned char *) 0x7d)=0x00;

ACSR=0x80;
SFIOR=0x00;

ADMUX=0x00;
ADCSRA=0x86;

SPCR=0x50;
SPSR=0x01;

#asm("sei")
LCD_init();
LCD_clear();    
LCD_init();
if (EEP_FirstON!=0xa5 || (!PIND.6 && !PIND.7)) { TX_reset(); EEP_FirstON=0xa5; }
if (EEP_Calibration!=0xa5 || !PIND.6)
{
while(!PIND.6 || !PIND.7 || !PIND.4 || !PIND.5          ) delay_ms(100);
calibr();
while(!PIND.6 || !PIND.7 || !PIND.4 || !PIND.5          ) delay_ms(100);
calibr_thermometer();
}
while(!PIND.6 || !PIND.7 || !PIND.4 || !PIND.5          ) delay_ms(100);
g_MainMenuMode=0;
for(i=0; i<3; i++) g_pos_d[i]=0;
TX_init();
g_keys=ReadKeys();
if(!PINE.7    ) cur_mode_ind=0;
else if(!PINE.6) cur_mode_ind=2;
else cur_mode_ind=1;
cur_Batt=read_adc(6);
cur_Power=read_adc(0);
cur_Temperature=read_adc(1);

Calc();  
beep_start(hello_sound, 4, 0);
displ_menu();
delay_ms(500); 
TIMSK|=0x10; 

while (1)
{

displ_menu();
}
}

void calibr (void)
{
unsigned char i, x, y;
unsigned long v;
signed int AD[5];
signed int v11, v12, v13, v21, v22, v23;  

beep_start(calibr_sound, 3, 0);
delay_ms(10);
AD[0]=read_adc(4);
AD[1]=read_adc(3);
AD[2]=read_adc(5);
AD[3]=read_adc(2);
AD[4]=read_adc(7);

for (i=0; i<5; i++) { ADmin[i]=AD[i]; ADmax[i]=AD[i]; }
f_sound_en=1;

while(PIND.7 && PIND.6)
{
LCD_clear();
displ_head("Calibration");
AD[0]=read_adc(4);
AD[1]=read_adc(3);
AD[2]=read_adc(5);
AD[3]=read_adc(2);
AD[4]=read_adc(7);

for (i=0; i<5; i++)
{
if (ADmin[i]>AD[i]) ADmin[i]=AD[i];
if (ADmax[i]<AD[i]) ADmax[i]=AD[i];
}

if(ADmax[0]-ADmin[0]<512) { LCD_dashline(46, 10, 46, 40); LCD_dashline(76, 10, 76, 40); }
else { LCD_line(46, 10, 46, 40, 1); LCD_line(76, 10, 76, 40, 1); }
if(ADmax[1]-ADmin[1]<512) { LCD_dashline(46, 10, 76, 10); LCD_dashline(46, 40, 76, 40); }
else { LCD_line(46, 10, 76, 10, 1); LCD_line(46, 40, 76, 40, 1); }  
v=AD[0]-ADmin[0]; v*=28; v/=(ADmax[0]-ADmin[0]); x=47+v;
v=AD[1]-ADmin[1]; v*=28; v/=(ADmax[1]-ADmin[1]); y=39-v;
LCD_pixel(x, y-2,1);        
LCD_line(x-1, y-1, x+1, y-1, 1); 
LCD_line(x-2, y, x+2, y,1); 
LCD_line(x-1, y+1, x+1, y+1, 1); 
LCD_pixel(x, y+2, 1);
if(ADmax[0]-ADmin[0]>=512 && ADmax[1]-ADmin[1]>=512)
{ 
v11=(ADmax[0]-ADmin[0])/2; v12=v11/10;  v13=AD[0]-ADmin[0];
v21=(ADmax[1]-ADmin[1])/2; v22=v21/10;  v23=AD[1]-ADmin[1];
if( v13>(v11-v12) && v13<(v11+v12) && v23>(v21-v22) && v23<(v21+v22) )
LCD_rectangle(x-3, y-3, x+3, y+3, 1);
}

if(ADmax[3]-ADmin[3]<512) { LCD_dashline(7, 10, 7, 40); LCD_dashline(37, 10, 37, 40); }
else { LCD_line(7, 10, 7, 40, 1); LCD_line(37, 10, 37, 40, 1); }
if(ADmax[2]-ADmin[2]<512) { LCD_dashline(7, 10, 37, 10); LCD_dashline(7, 40, 37, 40); }
else { LCD_line(7, 10, 37, 10, 1); LCD_line(7, 40, 37, 40, 1); }    
v=AD[3]-ADmin[3]; v*=28; v/=(ADmax[3]-ADmin[3]); x=8+v;
v=AD[2]-ADmin[2]; v*=28; v/=(ADmax[2]-ADmin[2]); y=39-v;
LCD_pixel(x, y-2,1);        
LCD_line(x-1, y-1, x+1, y-1,1); 
LCD_line(x-2, y, x+2, y,1); 
LCD_line(x-1, y+1, x+1, y+1,1); 
LCD_pixel(x, y+2,1);
if(ADmax[3]-ADmin[3]>=512 && ADmax[2]-ADmin[2]>=512)
{ 
v11=(ADmax[3]-ADmin[3])/2; v12=v11/10;  v13=AD[3]-ADmin[3];
v21=(ADmax[2]-ADmin[2])/2; v22=v21/10;  v23=AD[2]-ADmin[2];
if( v13>(v11-v12) && v13<(v11+v12) && v23>(v21-v22) && v23<(v21+v22) )
LCD_rectangle(x-3, y-3, x+3, y+3, 1);
}

LCD_line(7, 43, 76, 43, 1); LCD_line(7, 47, 76, 47, 1);
if(ADmax[4]-ADmin[4]<512) { LCD_dashline(7, 43, 7, 47); LCD_dashline(76, 43, 76, 47); }
else { LCD_line(7, 43, 7, 47, 1); LCD_line(76, 43, 76, 47, 1); }
v=AD[4]-ADmin[4]; v*=67; v/=(ADmax[4]-ADmin[4]); x=8+v;
LCD_fillrect(x-1, 43, x+1, 47, 1);
if(ADmax[4]-ADmin[4]>=512)
{
v11=(ADmax[4]-ADmin[4])/2; v12=v11/10;  v13=AD[4]-ADmin[4];
if( v13>(v11-v12) && v13<(v11+v12))
LCD_rectangle(x-3, 43, x+3, 47, 1);
}  
LCD_refresh();       
}
if(!PIND.6) return; 
ADmid[0]=read_adc(4);
ADmid[1]=read_adc(3);
ADmid[2]=read_adc(5);
ADmid[3]=read_adc(2);
ADmid[4]=read_adc(7);
for (i=0; i<5; i++)
{
EEPR_ADmin[i]=ADmin[i];
EEPR_ADmid[i]=ADmid[i];
EEPR_ADmax[i]=ADmax[i];
}

for (i=0, x=0; i<5; i++)
{
if(ADmax[i]-ADmin[i]<512) { x=1; break; }
v11=(ADmax[i]-ADmin[i])/2; v12=v11/10;  v13=ADmid[i]-ADmin[i];
if( v13<(v11-v12) || v13>(v11+v12) ) { x=1; break; }
}
if(x)
{
LCD_clear();
LCD_setxy(8,11);
LCD_wrsf("Calibration", 1);
LCD_setxy(8,20);
LCD_wrsf("not correct!", 1);
LCD_refresh();
beep_start(error_sound, 2, 0);
delay_ms(2000);
EEP_Calibration=0;
return;
}  
EEP_Calibration=0xa5;  
}

void calibr_thermometer (void)
{
signed int t;
unsigned int AD;
char buff[20];
bit f;

t=25; f=0;
while(PIND.7 && PIND.6)
{
if(!PIND.4 || !PIND.5          )
{
beep_start(key_sound, 1, 0);
if(!PIND.4 && t<100) t++;
if(!PIND.5           && t>-25) t--;
f=1;
} 
LCD_clear();
displ_head("Thermometer");
sprintf(buff, "Set curr %c: %d", 131, t);
LCD_setxy(5,11); LCD_wrs(buff, 1);
AD=read_adc(1);
sprintf(buff, "%u", AD);
LCD_setxy(5,24); LCD_wrs(buff, 1);
LCD_refresh();
if(f) { f=0; while(!PIND.4 || !PIND.5          ) delay_ms(100); }
}
if(!PIND.6) return;
EPP_CalibrTemperature[0]=50+t;  
EPP_CalibrTemperature[1]=AD;
}       

void TX_reset (void)
{
unsigned char i, x;
unsigned int v;

displ_head("Initial");
LCD_rectangle(8, 29, 75, 38, 1);
LCD_refresh();
for(i=0, x=8; i<7; i++)
{
MODEL_reset(i);
v=(75-8)*(unsigned int)i; v/=(7-1); x=(unsigned char)(8+v);
LCD_fillrect(8, 29, x, 38, 1);
LCD_refresh();
}
EEP_start_model=0;
EEP_f_sound_en=1;
EEP_BatCntr[0]=98; EEP_BatCntr[1]=92; EEP_BatCntr[2]=110;
}

