
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+
unsigned char spi(unsigned char data);
#pragma used-

#pragma library spi.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

extern unsigned char posx, posy;

void LCD_init(void); 
void LCD_refresh (void);  
void LCD_clear (void);
void LCD_pixel (unsigned char x, unsigned char y, unsigned char color);
void LCD_line ( char x1, char y1, char x2, char y2, char mode );
void LCD_dashline ( char x1, char y1, char x2, char y2);
void LCD_rectangle(char x, char y, char x1, char y1,unsigned char color);  
void LCD_fillrect  (char x, char y, char x1, char y1,unsigned char color); 
void LCD_setxy(char x,unsigned char y);        
void LCD_deg12x16(unsigned char c, unsigned char color);    
void LCD_frame(unsigned char x);
unsigned char LCD_get_char_len(unsigned char ch);   
void LCD_char(unsigned char ch, unsigned char color);    
void  LCD_wrs (unsigned char*str,unsigned char color); 
void LCD_wrsf (unsigned char flash*str,unsigned char color); 

unsigned char buff[8][96];   

unsigned char posx, posy;

void LCD_init(void) 
{
unsigned int i;
PORTC.5 =0;
PORTC.4=0;
delay_ms(1);
PORTC.4=1;
delay_ms(1);
PORTC.5=0;
spi(0x21);     
spi(0xC8);     
spi(0x06);    
spi(0x13);      
spi(0x20);     
spi(0x0c);     
delay_us(500);

PORTC.5=0 ;
spi(64);
spi(128);
PORTC.5 =1;
for(i=0;i<909;i++) spi(0);   

PORTC.5=0  ;
spi(64);
spi(128);
PORTC.5 =1;

LCD_clear();  
LCD_refresh();  
}

void LCD_refresh (void)  
{
unsigned char i,j;

PORTC.5=0 ;
spi(64);
PORTC.5=1;
for(i=0; i<8; i++)
{ 
PORTC.5=0 ;
spi(64+i);
spi(128);
PORTC.5=1;
for (j=0; j<96; j++) spi(buff[i][j]);
}
}

void LCD_clear (void)
{
unsigned char x, y;
for (y=0; y<8; y++)    
for (x=0; x<96; x++) buff[y][x]=0;  
}

void LCD_pixel (unsigned char x, unsigned char y, unsigned char color)
{   
unsigned char i, bt;
i=y>>3;
bt=1<<(y & 0x7);
if(color) buff[i][x]|=bt;
else buff[i][x]&=(~bt); 
}

void LCD_line ( char x1, char y1, char x2, char y2, char mode ) 
{
int dx, dy, stepx, stepy, fraction;

dy = y2 - y1;
dx = x2 - x1;
if ( dy < 0 ) { dy= -dy; stepy= -1; }
else stepy = 1;
if ( dx < 0 ) { dx= -dx; stepx= -1; }
else stepx = 1;
dx <<= 1;
dy <<= 1;
LCD_pixel( x1, y1, mode );
if ( dx > dy )
{
fraction = dy - (dx >> 1);
while ( x1 != x2 )
{
if ( fraction >= 0 ) { y1 += stepy; fraction -= dx; }
x1 += stepx;
fraction += dy;
LCD_pixel( x1, y1, mode );
}
}
else
{
fraction = dx - (dy >> 1);
while ( y1 != y2 )
{
if ( fraction >= 0 ) { x1 += stepx; fraction -= dy; }
y1 += stepy;
fraction += dx;
LCD_pixel( x1, y1, mode );
}
}
}

void LCD_dashline ( char x1, char y1, char x2, char y2)
{
char mode;
int dx, dy, stepx, stepy, fraction;

dy = y2 - y1;
dx = x2 - x1;
mode=1;

if ( dy < 0 ) { dy= -dy; stepy = -1; }
else stepy = 1;
if ( dx < 0 ) { dx= -dx; stepx = -1; }
else stepx = 1;
dx <<= 1;
dy <<= 1;
LCD_pixel( x1, y1, mode );
if ( dx > dy )
{
fraction = dy - (dx >> 1);
while ( x1 != x2 )
{
if(fraction >= 0 ) { y1 += stepy; fraction -= dx; }
x1 += stepx;
fraction += dy;
if (mode) mode=0;
else mode=1;
LCD_pixel( x1, y1, mode );
}
}
else
{
fraction = dx - (dy >> 1);
while ( y1 != y2 )
{
if ( fraction >= 0 ) { x1 += stepx; fraction -= dy; }
y1 += stepy;
fraction += dx;
if (mode) mode=0;
else mode=1;
LCD_pixel( x1, y1, mode );
}
}
}

void LCD_rectangle(char x, char y, char x1, char y1,unsigned char color)  
{
LCD_line (x,y,x,y1,color);
LCD_line (x,y1,x1,y1,color);
LCD_line (x1,y1,x1,y,color);
LCD_line (x,y,x1,y,color);
}

void LCD_fillrect  (char x, char y, char x1, char y1,unsigned char color)  
{
unsigned char i;
for (i=y; i<=y1; i++) LCD_line(x,i,x1,i,color);
}

__flash const unsigned char font_norm[][9] = {         

{0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x03,0x5F,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x04,0x03,0x00,0x03,0x00,0x00,0x00,0x00,0x00},    
{0x07,0x24,0x7E,0x24,0x24,0x7E,0x24,0x00,0x00},    
{0x06,0x04,0x2A,0x7F,0x2A,0x10,0x00,0x00,0x00},    
{0x08,0x02,0x05,0x62,0x18,0x26,0x50,0x20,0x00},    
{0x07,0x36,0x49,0x49,0x56,0x20,0x50,0x00,0x00},    
{0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x03,0x3E,0x41,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x03,0x41,0x3E,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x14,0x08,0x3E,0x08,0x14,0x00,0x00,0x00},    
{0x06,0x08,0x08,0x3E,0x08,0x08,0x00,0x00,0x00},    
{0x04,0x80,0x60,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x05,0x08,0x08,0x08,0x08,0x00,0x00,0x00,0x00},    
{0x03,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x04,0x60,0x1C,0x03,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x3E,0x61,0x5D,0x43,0x3E,0x00,0x00,0x00},    
{0x06,0x04,0x02,0x7F,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x42,0x61,0x51,0x49,0x46,0x00,0x00,0x00},    
{0x06,0x22,0x41,0x49,0x49,0x36,0x00,0x00,0x00},    
{0x06,0x18,0x14,0x12,0x7F,0x10,0x00,0x00,0x00},    
{0x06,0x27,0x45,0x45,0x45,0x39,0x00,0x00,0x00},    
{0x06,0x3E,0x45,0x45,0x45,0x38,0x00,0x00,0x00},    
{0x06,0x01,0x61,0x19,0x07,0x01,0x00,0x00,0x00},    
{0x06,0x36,0x49,0x49,0x49,0x36,0x00,0x00,0x00},    
{0x06,0x0E,0x51,0x51,0x51,0x3E,0x00,0x00,0x00},    
{0x03,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x04,0x80,0x62,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x04,0x08,0x14,0x22,0x00,0x00,0x00,0x00,0x00},    
{0x05,0x14,0x14,0x14,0x14,0x00,0x00,0x00,0x00},    
{0x04,0x22,0x14,0x08,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x02,0x01,0x51,0x09,0x06,0x00,0x00,0x00},    
{0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x7C,0x12,0x11,0x12,0x7C,0x00,0x00,0x00},    
{0x06,0x7F,0x49,0x49,0x49,0x3E,0x00,0x00,0x00},    
{0x06,0x3E,0x41,0x41,0x41,0x22,0x00,0x00,0x00},    
{0x06,0x7F,0x41,0x41,0x22,0x1C,0x00,0x00,0x00},    
{0x06,0x7F,0x49,0x49,0x49,0x49,0x00,0x00,0x00},    
{0x05,0x7F,0x09,0x09,0x01,0x00,0x00,0x00,0x00},    
{0x06,0x3C,0x42,0x41,0x51,0x72,0x00,0x00,0x00},    
{0x06,0x7F,0x08,0x08,0x08,0x7F,0x00,0x00,0x00},    
{0x03,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x30,0x40,0x40,0x40,0x3F,0x00,0x00,0x00},    
{0x06,0x7F,0x08,0x14,0x22,0x41,0x00,0x00,0x00},    
{0x06,0x7F,0x40,0x40,0x40,0x40,0x00,0x00,0x00},    
{0x07,0x7F,0x02,0x04,0x04,0x02,0x7F,0x00,0x00},    
{0x06,0x7F,0x04,0x08,0x10,0x7F,0x00,0x00,0x00},    
{0x06,0x3E,0x41,0x41,0x41,0x3E,0x00,0x00,0x00},    
{0x06,0x7F,0x09,0x09,0x09,0x06,0x00,0x00,0x00},    
{0x06,0x3E,0x41,0x61,0xC1,0x3E,0x00,0x00,0x00},    
{0x06,0x7F,0x09,0x09,0x19,0x66,0x00,0x00,0x00},    
{0x06,0x26,0x49,0x49,0x49,0x32,0x00,0x00,0x00},    
{0x06,0x01,0x01,0x7F,0x01,0x01,0x00,0x00,0x00},    
{0x06,0x3F,0x40,0x40,0x40,0x3F,0x00,0x00,0x00},    
{0x07,0x07,0x38,0x40,0x40,0x38,0x07,0x00,0x00},    
{0x08,0x3F,0x40,0x38,0x06,0x38,0x40,0x3F,0x00},    
{0x06,0x63,0x14,0x08,0x14,0x63,0x00,0x00,0x00},    
{0x06,0x03,0x04,0x78,0x04,0x03,0x00,0x00,0x00},    
{0x06,0x61,0x51,0x49,0x45,0x43,0x00,0x00,0x00},    
{0x03,0x7F,0x41,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x04,0x03,0x1C,0x60,0x00,0x00,0x00,0x00,0x00},    
{0x03,0x41,0x7F,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x04,0x02,0x01,0x02,0x04,0x00,0x00,0x00},    
{0x05,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00},    
{0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x05,0x20,0x54,0x54,0x78,0x00,0x00,0x00,0x00},    
{0x05,0x7F,0x44,0x44,0x38,0x00,0x00,0x00,0x00},    
{0x05,0x38,0x44,0x44,0x44,0x00,0x00,0x00,0x00},    
{0x05,0x38,0x44,0x44,0x7F,0x00,0x00,0x00,0x00},    
{0x05,0x38,0x54,0x54,0x58,0x00,0x00,0x00,0x00},    
{0x04,0x04,0x7E,0x05,0x00,0x00,0x00,0x00,0x00},    
{0x05,0x18,0xA4,0xA4,0x7C,0x00,0x00,0x00,0x00},    
{0x05,0x7F,0x04,0x04,0x78,0x00,0x00,0x00,0x00},    
{0x02,0x7D,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x04,0x40,0x80,0x7D,0x00,0x00,0x00,0x00,0x00},    
{0x05,0x7F,0x10,0x28,0x44,0x00,0x00,0x00,0x00},    
{0x03,0x7F,0x40,0x00,0x00,0x00,0x00,0x00,0x00},    
{0x06,0x7C,0x04,0x7C,0x04,0x78,0x00,0x00,0x00},    
{0x05,0x7C,0x04,0x04,0x78,0x00,0x00,0x00,0x00},    
{0x05,0x38,0x44,0x44,0x38,0x00,0x00,0x00,0x00},    
{0x05,0xFC,0x24,0x24,0x18,0x00,0x00,0x00,0x00},    
{0x05,0x18,0x24,0x24,0xFC,0x80,0x00,0x00,0x00},    
{0x04,0x78,0x04,0x04,0x00,0x00,0x00,0x00,0x00},    
{0x05,0x48,0x54,0x54,0x24,0x00,0x00,0x00,0x00},    
{0x04,0x04,0x7F,0x44,0x00,0x00,0x00,0x00,0x00},    
{0x05,0x3C,0x40,0x40,0x7C,0x00,0x00,0x00,0x00},    
{0x06,0x04,0x38,0x40,0x38,0x04,0x00,0x00,0x00},    
{0x08,0x3C,0x40,0x30,0x08,0x30,0x40,0x3C,0x00},    
{0x06,0x44,0x28,0x10,0x28,0x44,0x00,0x00,0x00},    
{0x06,0x04,0x98,0x60,0x18,0x04,0x00,0x00,0x00},    
{0x06,0x44,0x64,0x54,0x4C,0x44,0x00,0x00,0x00},     

{0x08, 0xFF,0x81,0x81,0x81,0x81,0x81,0x81,0xFF}, 
{0x08, 0xFF,0x81,0xBD,0xBD,0xBD,0xBD,0x81,0xFF}, 

{0x08, 0x01,0x31,0x79,0x79,0x7D,0x7F,0x7D,0x31},  
{0x08, 0x11,0x11,0x11,0x10,0x10,0x10,0x38,0x10},

{0x08, 0x3E,0x08,0x1C,0x1C,0x7C,0x3E,0x1E,0x1E},  
{0x08, 0x1E,0x1C,0x18,0x18,0x18,0x1C,0x0E,0x0E},
{0x06, 0x07,0x05,0x05,0x05,0x07,0x02,0x00,0x00}, 
{0x05, 0x01,0x02,0x0f,0x02,0x01,0x00,0x00,0x00}, 
{0x08, 0x04,0x7f,0x44,0x00,0x02,0x05,0x02,0x00}, 
{0x08, 0x0a,0xfe,0xab,0xff,0xfe,0xea,0xe0,0x40}, 
{0x08, 0x3c,0x42,0x85,0x99,0x99,0x85,0x42,0x3c}, 
{0x08, 0x20,0x30,0x38,0x3c,0x38,0x30,0x20,0x00}, 
{0x08, 0x04,0x0c,0x1c,0x3c,0x1c,0x0c,0x04,0x00}, 

};

__flash const unsigned char deg12x16[][24] = {

{0x00, 0xF8, 0xFE, 0x06, 0x03, 0x03, 0x03, 0x03, 0x03, 0x06, 0xFE, 0xF8,
0x00, 0x07, 0x1F, 0x18, 0x30, 0x30, 0x30, 0x30, 0x30, 0x18, 0x1F, 0x07},

{0x00, 0x00, 0x00, 0x0c, 0x0c, 0x0e, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x30, 0x30, 0x30, 0x3f, 0x3f, 0x30, 0x30, 0x30, 0x00},

{0x00, 0x1c, 0x1e, 0x07, 0x03, 0x03, 0x83, 0xc3, 0xe3, 0x77, 0x3e, 0x1c,
0x00, 0x30, 0x38, 0x3c, 0x3e, 0x37, 0x33, 0x31, 0x30, 0x30, 0x30, 0x30},

{0x00, 0x0c, 0x0e, 0x07, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0x7e, 0x3c,
0x00, 0x0c, 0x1c, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x39, 0x1f, 0x0e},

{0x00, 0xc0, 0xe0, 0x70, 0x38, 0x1c, 0x0e, 0x07, 0xff, 0xff, 0x00, 0x00,
0x00, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x3f, 0x3f, 0x03, 0x03},

{0x00, 0x3f, 0x7f, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0xe3, 0xc3, 0x83,
0x00, 0x0c, 0x1c, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x38, 0x1f, 0x0f},

{0x00, 0xc0, 0xf0, 0xf8, 0xdc, 0xce, 0xc7, 0xc3, 0xc3, 0xc3, 0x80, 0x00,
0x00, 0x0f, 0x1f, 0x39, 0x30, 0x30, 0x30, 0x30, 0x30, 0x39, 0x1f, 0x0f},

{0x00, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0xc3, 0xf3, 0x3f, 0x0f, 0x03,
0x00, 0x00, 0x00, 0x00, 0x30, 0x3c, 0x0f, 0x03, 0x00, 0x00, 0x00, 0x00},

{0x00, 0x00, 0xbc, 0xfe, 0xe7, 0xc3, 0xc3, 0xc3, 0xe7, 0xfe, 0xbc, 0x00,
0x00, 0x0f, 0x1f, 0x39, 0x30, 0x30, 0x30, 0x30, 0x30, 0x39, 0x1f, 0x0f},

{0x00, 0x3c, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0xfe, 0xfc,
0x00, 0x00, 0x00, 0x30, 0x30, 0x30, 0x38, 0x1c, 0x0e, 0x07, 0x03, 0x00},

{0x00, 0x00, 0x00, 0x00, 0x70, 0x70, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x1c, 0x1c, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00}
};

void LCD_setxy(char x,unsigned char y)        
{
posx=x;
posy=y;
}

void LCD_deg12x16(unsigned char c, unsigned char color)    
{ 
char i, j;
unsigned char b;

for(i=0; i<12; i++) 
{
b=deg12x16[c][i];
for(j=0; j<8; j++) 
{
LCD_pixel(posx, posy+j, (~(b ^ color)) & 1);
b >>= 1;
}
posx++;
}
posy+=8;
posx-=12;
for(i=12; i<24; i++) 
{
b = deg12x16[c][i];
for(j=0; j<8; j++) 
{
LCD_pixel(posx, posy+j, (~(b ^ color)) & 1);
b >>= 1;
}
posx++;
}
}

unsigned char LCD_get_char_len(unsigned char ch)
{
return font_norm[ch-32][0];
}

void LCD_char(unsigned char ch, unsigned char color)    
{ 
unsigned char x, y, len, b;
flash unsigned char *p;

if(ch=='\t') { posx=72; return; }
p=font_norm[ch-32];
len=*p++; 
for(x=0; x<len; x++) 
{
b=*p++;
for(y=0; y<8; y++) 
{
LCD_pixel(posx, posy+y, (~(b ^ color)) & 1);
b >>= 1;
}
posx++; 
}
}

void LCD_frame(unsigned char x)   
{
LCD_line(x-1, posy-1, posx-1, posy-1, 1);
LCD_line(x-1, posy-1, x-1, posy+7, 1);
}

void  LCD_wrs (unsigned char*str,unsigned char color) 
{
unsigned char x;

x=posx;
while(*str!='\0')  LCD_char(*str++, color);
if(color==0) LCD_frame(x);
}

void LCD_wrsf (unsigned char flash*str,unsigned char color) 
{
unsigned char x;

x=posx;
while(*str!='\0') LCD_char(*str++, color);
if(color==0) LCD_frame(x);
}
