
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

typedef struct {
unsigned char        minRates;        
unsigned char        maxRates;        
unsigned char        minDRates;       
unsigned char        maxDRates;        
char                cur_nodes[7];
}CONTR_A1;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char		tcut;		  
char		        cur_nodes[7];
}CONTR_A2;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
char		        cur_nodes[7];
}CONTR_A3;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char       delay;        
}CONTR_D;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char       from;         
char		        cur_nodes[7];
}CONTR_V;

typedef struct {
CONTR_A1 contr_ab[3]; 
CONTR_A2 contr_tr; 
CONTR_A3 contr_ap; 
CONTR_D  contr_d[3]; 
CONTR_V  contr_v[2]; 
signed char chanels[8][10];
signed char trimmers[4];
}DEF_MODE;

typedef struct {
char name[8]; 
unsigned char type:1; 
unsigned char modulation:2; 
unsigned char timer_mode:2;
unsigned int  timer_set;
unsigned char num_ch:4;
unsigned char num_freq;
signed char contrs_reverse[10]; 
DEF_MODE modes[3];
} MODEL_SET;

struct typedef { unsigned char note; unsigned int ms; }BEEP_TRACK_DEF;

extern unsigned char posx, posy;

void LCD_init(void); 
void LCD_refresh (void);  
void LCD_clear (void);
void LCD_pixel (unsigned char x, unsigned char y, unsigned char color);
void LCD_line ( char x1, char y1, char x2, char y2, char mode );
void LCD_dashline ( char x1, char y1, char x2, char y2);
void LCD_rectangle(char x, char y, char x1, char y1,unsigned char color);  
void LCD_fillrect  (char x, char y, char x1, char y1,unsigned char color); 
void LCD_setxy(char x,unsigned char y);        
void LCD_deg12x16(unsigned char c, unsigned char color);    
void LCD_frame(unsigned char x);
unsigned char LCD_get_char_len(unsigned char ch);   
void LCD_char(unsigned char ch, unsigned char color);    
void  LCD_wrs (unsigned char*str,unsigned char color); 
void LCD_wrsf (unsigned char flash*str,unsigned char color); 

void PLL_send(unsigned long data, unsigned char cn);
void PLL_SetFreq(unsigned char num_freq);
unsigned int PLL_GetFreq(unsigned char num_freq);

void displ_head (flash unsigned char * name);
void displ_menu (void);

extern eeprom MODEL_SET EEP_models[7];
extern signed int out_ch[8];
extern unsigned int cur_Batt;
extern unsigned int cur_Power;
extern unsigned int cur_Temperature;
extern signed int dir_Temperature;
extern unsigned char BatCntr[3];
extern bit f_TCut;
extern unsigned int time;
extern bit  f_sound_en;
extern unsigned char g_MainMenuMode;
extern unsigned int gRPM[];
extern signed int CalibrTemperature[2];  

__flash const char *modeNames[2][3] = 
{
{ "Land", "Norm", "Pilot" },
{ "Norm", "IDU", "THL"    }
}; 
__flash const char *modulNames[] = { "PPM", "IPPM", "PCM" };
__flash const char *menuT0[] = {
"Select\t>",
"Model\t>",
"Copy\t>",
"Options\t>"
};
__flash const char *menuT1[] ={
"Controls\t>",
"Channels\t>",
"Name\t>",
"Type\t>",
"Frequency\t>",
"Coding\t>",
"Max channel\t>",
"Timer\t>",
"Modes copy\t>",
"Reset\t"

};
__flash const char *menuT2[] = {
"Ailerons\t>",
"Elevator\t>",
"Throttle\t>",
"Rudder\t>",
"Switch 1\t>",
"Switch 2\t>",
"Switch 3\t>",
"Add Prop\t>",
"Virtual 1\t>",
"Virtual 2\t>"
};
__flash const char *menuT3[] = {
"Set timer\t>",
"Timer modes\t>"
};
__flash const char *menuT4[] = {
"Sound\t>",
"Battery\t>",
"Monitor\t>",
"Tachometer\t>",
"Version\t>"
};
__flash const char *menuT5[] = {
"Channel 1\t>",
"Channel 2\t>",
"Channel 3\t>",
"Channel 4\t>",
"Channel 5\t>",
"Channel 6\t>",
"Channel 7\t>",
"Channel 8\t>"    
};

__flash const char *TypesModel[] = { "Plane", "Heli" };
__flash const char *Timer_modes1[] = { "UP", "DOWN","AUTO" };

__flash const char *menuT7[]= { "Save", "Cancel", "Restore" };
__flash const char *menuT8[]= { "Warning", "Alarm", "Max" };
__flash char _str_VER[]="V1.7, 22/07/09";
__flash char _str_Co[]="(c) MSV";

unsigned char dg_list_topitem;
unsigned char dg_list_selitem;
unsigned char dg_list_cnt;
bit df_edit;
bit df_edit_cur;
bit df_clip;
unsigned char dpos[6];
unsigned char dT[2];
MODEL_SET dcur_model;
DEF_MODE *dcur_mode;
unsigned char dcur_mode_ind;
unsigned char tmp[12];

void list_draw_scrollbar (void)
{
unsigned char l;
unsigned int pos;

l=5*9; 
LCD_line((96-2), 11, (96-2), 11+l-1, 1);
if(dg_list_cnt<=5) return;
pos=l-(5+2); 

pos*=dg_list_selitem; pos/=(dg_list_cnt-1); pos+=12;
LCD_line((96-3), pos, (96-3), pos+4, 1);
LCD_line((96-2), pos, (96-2), pos+4, 0);
LCD_line((96-1), pos, (96-1), pos+4, 1);
}

void list_displ(__flash const char **list)
{
unsigned char i, y, att, n;

n=dg_list_topitem;
for(i=0, y=11; i<5 && n<dg_list_cnt; i++, n++, y+=9)
{
LCD_setxy(2, y);
if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, (96-6), y+7, 1); }
else att=1;
LCD_wrsf(list[n], att);
}
list_draw_scrollbar();  
}

void list_displ_names (void)
{
unsigned char i, j, y, att, n;

n=dg_list_topitem;
for(i=0, y=11; i<5 && n<dg_list_cnt; i++, n++, y+=9)
{
LCD_setxy(2, y);
if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, (96-6), y+7, 1); }
else att=1;
for(j=0; j<8; j++) LCD_char(EEP_models[n].name[j], att);
}
list_draw_scrollbar();  
}

void displ_contr_short(unsigned char ind, unsigned char x, unsigned char y, unsigned char att)
{
flash char *p;
LCD_setxy(x,y); p=menuT2[ind];
while(*p>=' ') { LCD_char(*p, att); p++; }
if(att==0) LCD_frame(x);
}

void displ_controls (char N, char sel)
{
unsigned char  att, ind;

LCD_setxy(0,11);
LCD_wrsf("Reverse", 1);
LCD_setxy(39, 11);   
if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
if (dcur_model.contrs_reverse[N]==-1) LCD_wrsf("Yes",att);
else LCD_wrsf("No ",att);
if (N<=3 && N!=2)
{ 
ind=N; if(N>2) ind=2;
LCD_setxy(0,20); LCD_wrsf("Rate", 1);  
sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minRates);
if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(39,20); LCD_wrs(tmp, att);
sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxRates);
if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(62,20); LCD_wrs(tmp, att);      
LCD_setxy(0, 29); LCD_wrsf("DRate", 1); 
sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minDRates);
if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=255;
LCD_setxy(39, 29); LCD_wrs(tmp, att);
sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxDRates);   
if (sel==4) { att=0; if(df_edit) att=df_clip; } else att=255;
LCD_setxy(62, 29); LCD_wrs(tmp, att);
if (sel==5) att=0; else att=1;
LCD_setxy(39, 38); LCD_wrsf("Curve >", att);  
}
else if (N==2)
{ 
LCD_setxy(0,20); LCD_wrsf("Rate", 1);  
sprintf(tmp,"%-i",dcur_mode->contr_tr.minRates);
if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(39,20); LCD_wrs(tmp, att);
sprintf(tmp,"%-i",dcur_mode->contr_tr.maxRates);
if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(62,20); LCD_wrs(tmp, att);
LCD_setxy(0, 29); LCD_wrsf("Tcut", 1); 
sprintf(tmp,"%-i",dcur_mode->contr_tr.tcut);
if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(39, 29); LCD_wrs(tmp, att);
if (sel==4) att=0; else att=1;
LCD_setxy(39, 38);  LCD_wrsf("Curve >", att);  
}
else if(N>=4 && N<=6)
{ 
ind=N-4;
LCD_setxy(0,20); LCD_wrsf("Rate", 1);  
sprintf(tmp,"%-i",dcur_mode->contr_d[ind].minRates);
if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(39,20); LCD_wrs(tmp, att);
sprintf(tmp,"%-i",dcur_mode->contr_d[ind].maxRates);
if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(62,20); LCD_wrs(tmp, att);
LCD_setxy(0, 29); LCD_wrsf("Delay", 1); 
sprintf(tmp,"%i.%i",dcur_mode->contr_d[ind].delay/10, dcur_mode->contr_d[ind].delay%10);
if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(39, 29); LCD_wrs(tmp, att);
}
else if (N==7)
{ 
LCD_setxy(0,20); LCD_wrsf("Rate", 1);  
sprintf(tmp,"%-i",dcur_mode->contr_ap.minRates);
if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(39,20); LCD_wrs(tmp, att);
sprintf(tmp,"%-i",dcur_mode->contr_ap.maxRates);
if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(62,20); LCD_wrs(tmp, att);      
if (sel==3) att=0; else att=1;
LCD_setxy(39, 38);  LCD_wrsf("Curve >", att);  
}
else if(N>=8)
{ 
ind=N-8;
LCD_setxy(0,20); LCD_wrsf("Rate", 1);  
sprintf(tmp,"%-i",dcur_mode->contr_v[ind].minRates);
if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(39,20); LCD_wrs(tmp, att);
sprintf(tmp,"%-i",dcur_mode->contr_v[ind].maxRates);
if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(62,20); LCD_wrs(tmp, att);      
LCD_setxy(0, 29); LCD_wrsf("From:", 1);
if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=1; 
displ_contr_short(dcur_mode->contr_v[ind].from, 39, 29, att);
if (sel==4) att=0; else att=1;
LCD_setxy(39, 38); LCD_wrsf("Curve >", att);  
}
}

void displ_curve (unsigned char N, unsigned char sel)
{
char Y[7];
int i;
unsigned char x, att, ind;
char *val;

if (N<=3 && N!=2)
{
ind=N; if(N>2) ind=2;
val=dcur_mode->contr_ab[ind].cur_nodes;
}
else if(N==2) val=dcur_mode->contr_tr.cur_nodes;
else if(N==7) val=dcur_mode->contr_ap.cur_nodes;
else if(N>=8) val=dcur_mode->contr_v[N-8].cur_nodes;

LCD_rectangle(((96/2)-37),13, ((96/2)+35), 37, 1);  
LCD_dashline(((96/2)-37), 25, ((96/2)+35), 25);     
for(i=0, x=((96/2)-25); i<5; i++, x+=12) LCD_dashline(x, 13, x, 37);     
for(i=0; i<7; i++) Y[i]=25-(val[i]/8);
for(i=0, x=((96/2)-37); i<6; i++, x+=12) LCD_line(x, Y[i], x+12, Y[i+1], 1);          
LCD_rectangle(((96/2)-39)+sel*12, Y[sel]+2, ((96/2)-35)+sel*12, Y[sel]-2,1);
sprintf(tmp,"%-i",val[sel]);
LCD_setxy(((96/2)-40), 40);
if (!df_edit) att=1; else att=df_clip;
LCD_wrs(tmp, att);

}

void displ_chanel (unsigned char N)
{
unsigned char i, n, y, att;
flash char *p;

for(i=0, n=dg_list_topitem, y=11; i<5 && n<dg_list_cnt; i++, n++, y+=9)
{
LCD_setxy(2,y);
if(n==dg_list_selitem && !df_edit) { att=0; LCD_fillrect(0, y-1, 46, y+7, 1); } else att=1;
p=menuT2[n];
while(*p>=' ') { LCD_char(*p, att); p++; }
if(n==dg_list_selitem && df_edit) att=df_clip; else att=1;
LCD_setxy(48, y);
sprintf(tmp, "%-i", dcur_mode->chanels[N][n]);
LCD_wrs(tmp, att);
}
list_draw_scrollbar();  
} 

void displ_monitor(void)
{
unsigned char i, j, y, n, y1, x;
signed int v;

for(i=0, n=dg_list_selitem, y=11; i<5 && n<dcur_model.num_ch; i++, n++, y+=9)
{
v=out_ch[n]-2250; 
if(dpos[3]==0)
{
sprintf(tmp, "%-i", n+1);
LCD_setxy(2,y); LCD_wrs(tmp, 1);
y1=y+7;
LCD_line(14, y1, 78, y1, 1);
for(j=0, x=14; j<17; j++, x+=4)
{ LCD_pixel(x, y1-1, 1); if(!(j%2)) LCD_pixel(x, y1-2, 1); }
v*=32; v/=900; v+=46;
LCD_pixel(v, y1-1, 1);
LCD_line(v-1, y1-2, v+1, y1-2, 1);
LCD_line(v-2, y1-3, v+2, y1-3, 1);
}
else   
{
v*=10; v/=75;
sprintf(tmp, "Ch%-i %-i", n+1, v);
LCD_setxy(2,y); LCD_wrs(tmp, 1);
}
}
}   

void displ_trimmer (void)
{
unsigned char i, x, y, v;

x=0;
LCD_line(x, 11, x, 43, 1);
for(i=0, y=11; i<9; i++, y+=4)
{ LCD_pixel(x+1, y, 1); if(!(i%2)) LCD_pixel(x+2, y, 1); }
v=(dcur_mode->trimmers[2]/-5)+27;
LCD_pixel(x+1, v, 1);
LCD_line(x+2, v-1, x+2, v+1,1);
LCD_line(x+3, v-2, x+3, v+2,1);

x=(96-1); 
LCD_line(x, 11, x, 43, 1);
for(i=0, y=11; i<9; i++, y+=4)
{ LCD_pixel(x-1, y, 1); if(!(i%2)) LCD_pixel(x-2, y, 1); }
v=(dcur_mode->trimmers[1]/-5)+27;
LCD_pixel(x-1, v, 1);
LCD_line(x-2, v-1, x-2, v+1, 1);
LCD_line(x-3, v-2, x-3, v+2, 1);

y=(65-3); 
LCD_line(4, y, 36, y, 1);
for(i=0, x=4; i<9; i++, x+=4)
{ LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1); }
v=(dcur_mode->trimmers[3]/5)+20;
LCD_pixel(v, y-1, 1);
LCD_line(v-1, y-2, v+1, y-2, 1);
LCD_line(v-2, y-3, v+2, y-3, 1);

y=(65-3); 
LCD_line((96-37), y, (96-5), y, 1);  

for(i=0, x=(96-37); i<9; i++, x+=4)   
{ LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1); }

v=(dcur_mode->trimmers[0]/5)+(96-37+16); 
LCD_pixel(v, y-1, 1);
LCD_line(v-1, y-2, v+1, y-2, 1);
LCD_line(v-2, y-3, v+2, y-3, 1);
}

void main_scr (void)
{
unsigned char i;
char min[2], sec[2];
signed int k;
signed long l;
char ch;

LCD_setxy(0, 0);
if(dcur_model.type==1) { LCD_char(125,1); LCD_char(126,1); } 
else  { LCD_char(127,1);  LCD_char(128,1); } 

LCD_setxy(24,0);
for(i=0; i<8; i++) LCD_char(dcur_model.name[i], 1);
LCD_dashline(0, 8, 83, 8);

LCD_setxy(57,12);
if(f_TCut) LCD_wrsf("TCut", df_clip); 
else LCD_wrsf(modeNames[dcur_model.type][dcur_mode_ind],1);

displ_trimmer();

min[0]=(time/600)%10;
min[1]=(time/60)%10;
sec[0]=(time%60)/10;
sec[1]=time%10;
switch(g_MainMenuMode)
{
case 0:

LCD_setxy(((96/2)-30),24);

LCD_deg12x16(min[0], 1);

LCD_setxy((((96/2)-18)),24);
LCD_deg12x16(min[1], 1);

LCD_setxy((((96/2)-6)),24);
LCD_deg12x16(10, 1); 

LCD_setxy((((96/2)+6)),24);
LCD_deg12x16(sec[0], 1);

LCD_setxy((((96/2)+18)),24);
LCD_deg12x16(sec[1], 1);

k=(cur_Batt/5);
if((k>BatCntr[0] && k>BatCntr[1]) || df_clip)  
{ LCD_setxy(5, 11); LCD_char(129, 1); }
LCD_rectangle(12,11, 50,14, 1);
k-=(int)BatCntr[1]; k*=(49-15); k/=(int)(BatCntr[2]-BatCntr[1]);
k+=15; if(k>49) k=49;
if(k>=13) { LCD_line(13, 12, k, 12, 1); LCD_line(13, 13, k, 13, 1); }

LCD_setxy(5, 16); LCD_char(130, 1);
LCD_rectangle(12,16, 50,19, 1);
k=(cur_Power/2); k*=(49-12); k/=500; k+=12; if(k>49) k=49;
if(k>=13) { LCD_line(13, 17, k, 17, 1); LCD_line(13, 18, k, 18, 1); }
break;
case 1:

sprintf(tmp,"%u%u:%u%u", min[0], min[1], sec[0], sec[1]);
LCD_setxy(12, 12); LCD_wrs(tmp, 1);

i=cur_Batt/5;
sprintf(tmp,"%-i.%-iV", i/10, i%10);
if((i>BatCntr[0] && i>BatCntr[1]) || df_clip) 
{ LCD_setxy(12,22); LCD_wrs(tmp, 1); }

sprintf(tmp,"%umA", cur_Power/5);

LCD_setxy(((96/2)+6),22); LCD_wrs(tmp, 1);

if(CalibrTemperature[1]==0) break;
l=cur_Temperature;
l*=CalibrTemperature[0];
l/=CalibrTemperature[1];
l-=50;
ch=' ';
if(dir_Temperature>0) ch=134; else if(dir_Temperature<0) ch=135;
sprintf(tmp,"%c %dC%c", 131,  (signed int)l, ch);
LCD_setxy(32,34); LCD_wrs(tmp, 1);
break;
}
}

void displ_head (flash unsigned char * name)
{
flash unsigned char *p;
unsigned char x, l;

l=LCD_get_char_len('-'); l+=LCD_get_char_len(' '); l*=2;
p=name;
while(*p>=' ') { l+=LCD_get_char_len(*p); p++; }
x=(96/2)-(l/2);
LCD_setxy(x,0);
LCD_wrsf("- ", 1);
p=name;
while(*p>=' ') { LCD_char(*p, 1); p++; }
LCD_wrsf(" -", 1);
LCD_dashline(0, 8, (96-1), 8); 
}

extern unsigned char g_list_topitem;
extern unsigned char g_list_selitem;
extern unsigned char g_list_cnt;
extern bit f_edit;
extern bit f_edit_cur;
extern bit f_clip;
extern unsigned char pos[6];
extern unsigned char T[2];
extern MODEL_SET cur_model;
extern unsigned char cur_mode_ind;
extern unsigned char f_l;

void displ_menu (void)
{
unsigned char i, att, x;
unsigned int k; 

do
{
f_l=0;
dg_list_topitem=g_list_topitem;
dg_list_selitem=g_list_selitem;
dg_list_cnt=g_list_cnt;
df_edit=f_edit;
df_edit_cur=f_edit_cur;
df_clip=f_clip;
for(i=0; i<6; i++) dpos[i]=pos[i];
for(i=0; i<2; i++) dT[i]=T[i];
dcur_model=cur_model;
dcur_mode=&dcur_model.modes[cur_mode_ind];
dcur_mode_ind=cur_mode_ind;
}
while(f_l!=0);

LCD_clear();
switch(dpos[0])
{
case 0: 
main_scr();
break;
case 1:
switch(dpos[1])
{
case 0: 
displ_head("Main menu");
list_displ(menuT0);
break;
case 1: 
displ_head(menuT0[dpos[1]-1]);
list_displ_names();
break;
case 2: 
switch(dpos[2])
{
case 0:
displ_head(menuT0[dpos[1]-1]);
list_displ( menuT1);
break;
case 1: 
switch(dpos[3])
{
case 0:
displ_head(menuT1[dpos[2]-1]);
list_displ(menuT2);
break;
default:
displ_head(menuT2[dpos[3]-1]);
if(!df_edit_cur) displ_controls(dpos[3]-1, dpos[4]);
else displ_curve(dpos[3]-1, dpos[5]);
break;
}
break;    
case 2: 
switch(dpos[3])
{
case 0:
displ_head(menuT1[dpos[2]-1]);
list_displ( menuT5);
break;
default:
displ_head(menuT5[dpos[3]-1]);
displ_chanel(dpos[3]-1);
break;
}
break;
case 3: 
displ_head(menuT1[dpos[2]-1]); 
LCD_setxy(8,20);          
for (i=0; i<8; i++) 
{
if(dpos[3]==i) { att=0; if(df_edit) att=df_clip; } else att=1;
x=posx;
LCD_char(dcur_model.name[i], att);
if(att==0) LCD_frame(x);
}
break;    
case 4: 
displ_head(menuT1[dpos[2]-1]);
LCD_setxy(8,20);
LCD_wrsf(TypesModel[dcur_model.type], 1);
break;
case 5: 
displ_head(menuT1[dpos[2]-1]);
LCD_setxy(2,20); LCD_wrsf("Channel:", 1);
sprintf(tmp,"%u", dcur_model.num_freq+61);
LCD_setxy(45,20); LCD_wrs(tmp, 1);
LCD_setxy(2,29); LCD_wrsf("Freq:", 1);
sprintf(tmp,"%u", PLL_GetFreq(dcur_model.num_freq));
LCD_setxy(45,29); LCD_wrs(tmp, 1);
break;   
case 6:  
displ_head(menuT1[dpos[2]-1]); 
LCD_setxy(30,20);
LCD_wrsf(modulNames[dcur_model.modulation], 1); 
break;
case 7: 
displ_head(menuT1[dpos[2]-1]);
LCD_setxy(34,20);
LCD_deg12x16(dcur_model.num_ch, 1);
break;
case 8: 
switch(dpos[3])
{
case 0: 
displ_head(menuT1[dpos[2]-1]);
list_displ( menuT3);
break;
case 1: 
displ_head(menuT3[dpos[3]-1]);
sprintf(tmp,"%-i:%-i",dcur_model.timer_set/60, dcur_model.timer_set%60);
LCD_setxy(24,18); LCD_wrs(tmp,255);
break;
case 2:  
displ_head(menuT3[dpos[3]-1]);
LCD_setxy(30,20);
LCD_wrsf(Timer_modes1[dcur_model.timer_mode],1);
break;
}
break;  
case 9:  
displ_head(menuT1[dpos[2]-1]);
LCD_dashline(0, 8, 83, 8);
LCD_setxy(2,11); LCD_wrsf("From:",255);
LCD_setxy(2,20); LCD_wrsf("To:",255);
if(dpos[3]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(32, 11); LCD_wrsf(modeNames[dcur_model.type][dT[0]], att);
if(dpos[3]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(32, 20); LCD_wrsf(modeNames[dcur_model.type][dT[1]], att);
if(dpos[3]==2) att=0; else att=1;
LCD_setxy(32,34); LCD_wrsf("OK", att);
break;
case 10: 
displ_head(menuT1[dpos[2]-1]);
LCD_setxy(8,20); LCD_wrsf("Are you sure?",1);                
break;
case 11: 
displ_head("All change");
list_displ( menuT7);
break;  
}
break;
case 3: 
displ_head(menuT0[dpos[1]-1]);
LCD_setxy(2,11); LCD_wrsf("From:",255);
LCD_setxy(2,20); LCD_wrsf("To:",255);
if(dpos[2]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(32, 11); x=posx;
for (i=0; i<8; i++) LCD_char(EEP_models[dT[0]].name[i], att);
if(att==0) LCD_frame(x);
if(dpos[2]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
LCD_setxy(32, 20); x=posx;
for (i=0; i<8; i++) LCD_char(EEP_models[dT[1]].name[i], att);
if(att==0) LCD_frame(x);
if(dpos[2]==2) att=0; else att=1;
LCD_setxy(32,34); LCD_wrsf("OK", att);
break;
case 4:
switch(dpos[2])
{
case 0:  
displ_head(menuT0[dpos[1]-1]);
list_displ( menuT4);
break;
case 1: 
displ_head(menuT4[dpos[2]-1]);
LCD_setxy(32,20);
if (f_sound_en) LCD_wrsf("ON",255); 
else LCD_wrsf("OFF",255);
break;  
case 2: 
displ_head(menuT4[dpos[2]-1]);
for(i=0, x=11; i<3; i++, x+=9)
{
if(dpos[3]==i && !df_edit) att=0; else att=1;
if(att==0) LCD_fillrect(0, x-1, 40, x+7, 1);
LCD_setxy(2,x); LCD_wrsf(menuT8[i], att);
sprintf(tmp,"%-i.%-i", BatCntr[i]/10, BatCntr[i]%10);
if(dpos[3]==i && df_edit) att=df_clip; else att=1;
LCD_setxy(45,x); LCD_wrs(tmp, att);
}
break;  
case 3: 
displ_head(menuT4[dpos[2]-1]);
displ_monitor();
break;  
case 4: 
displ_head(menuT4[dpos[2]-1]);
for(i=0, k=0; i<3; i++) k+=gRPM[i];
k=k*(40/2);
sprintf(tmp,"%u RPM", k);
LCD_setxy(16,20); LCD_wrs(tmp, 1);
break;
case 5: 
displ_head(menuT4[dpos[2]-1]);
LCD_setxy(2,20); LCD_wrsf(_str_VER, 1);
LCD_setxy(24,38); LCD_wrsf(_str_Co, 1);
break;  
}
break;
}
break;
}      
LCD_refresh();
}

