
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef struct {
unsigned char        minRates;        
unsigned char        maxRates;        
unsigned char        minDRates;       
unsigned char        maxDRates;        
char                cur_nodes[7];
}CONTR_A1;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char		tcut;		  
char		        cur_nodes[7];
}CONTR_A2;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
char		        cur_nodes[7];
}CONTR_A3;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char       delay;        
}CONTR_D;

typedef struct {
unsigned char		minRates;	  
unsigned char		maxRates;	  
unsigned char       from;         
char		        cur_nodes[7];
}CONTR_V;

typedef struct {
CONTR_A1 contr_ab[3]; 
CONTR_A2 contr_tr; 
CONTR_A3 contr_ap; 
CONTR_D  contr_d[3]; 
CONTR_V  contr_v[2]; 
signed char chanels[8][10];
signed char trimmers[4];
}DEF_MODE;

typedef struct {
char name[8]; 
unsigned char type:1; 
unsigned char modulation:2; 
unsigned char timer_mode:2;
unsigned int  timer_set;
unsigned char num_ch:4;
unsigned char num_freq;
signed char contrs_reverse[10]; 
DEF_MODE modes[3];
} MODEL_SET;

struct typedef { unsigned char note; unsigned int ms; }BEEP_TRACK_DEF;

extern eeprom MODEL_SET EEP_models[7];
extern eeprom unsigned char EEP_start_model;
extern eeprom unsigned char EEP_f_sound_en;
extern eeprom unsigned char EEP_BatCntr[3];
extern unsigned char g_MainMenuMode;
extern eeprom int EEPR_ADmid[5], EEPR_ADmax[5], EEPR_ADmin[5];  
extern eeprom unsigned char EEP_FirstON, EEP_Calibration;
extern eeprom signed int EPP_CalibrTemperature[];

extern signed int out_control[10];
extern signed int ADmid[5];
extern signed int ADmin[5];
extern signed int ADmax[5];
extern signed int out_ch[8];

extern MODEL_SET cur_model;
extern unsigned char cur_model_ind;
extern unsigned char cur_mode_ind;
extern bit f_TCut;
extern unsigned int cur_Batt;
extern unsigned int cur_Power;
extern unsigned int cur_Temperature;
extern signed int dir_Temperature;
extern unsigned char wd_Temperature;
extern unsigned int div_trimmer;
extern bit f_beep_timer;
extern bit f_beep_EEP;
extern bit f_beep_key;
extern bit f_beep_trimmer;

unsigned int read_adc(unsigned char adc_input);
void beep_start(BEEP_TRACK_DEF flash *notes, unsigned char cnt, unsigned char rep);
void calibr (void);
void calibr_thermometer (void);
void TX_reset (void);

void displ_head (flash unsigned char * name);
void displ_menu (void);

void PLL_send(unsigned long data, unsigned char cn);
void PLL_SetFreq(unsigned char num_freq);
unsigned int PLL_GetFreq(unsigned char num_freq);

extern flash const BEEP_TRACK_DEF calibr_sound[];
extern flash const BEEP_TRACK_DEF key_sound[];
extern flash const BEEP_TRACK_DEF error_sound[];
extern bit  f_sound_en;

void TimerOn(void);
void save_trimmer(void);
void TX_init (void);
void keys_menu(void);
void MODEL_reset(unsigned char ind);

__flash const char Name_table[] = {
' ','_','-','0','1','2','3','4','5','6','7','8','9','A','a','B','b','C','c','D',
'd','E','e','F','f','G','g','H','h','I','i','J','j','K','k','L','l','M','m','N',	
'n','O','o','P','p','Q','q','R','r','S','s','T','t','U','u','V','v','W','w','X',
'x','Y','y','Z','z'};

unsigned char pos[6];
unsigned char T[2];
bit f_edit_cur;
bit f_edit;
unsigned char mnu_keys;
bit f_clip;
bit  f_sound_en;
unsigned char BatCntr[3];
unsigned int time;
bit f_timer_en;
unsigned char div_beep_batt;
unsigned char g_rep;
signed int CalibrTemperature[2];  

flash const BEEP_TRACK_DEF hello_sound[]={ {10,200}, {7,50},{3,50}, {10,200} };
flash const BEEP_TRACK_DEF error_sound[]={ {20,500}, {10,1000} };
flash const BEEP_TRACK_DEF calibr_sound[]={ {10,50}, {20,50}, {10,50} };
flash const BEEP_TRACK_DEF key_sound[]={ {20, 20} };
flash const BEEP_TRACK_DEF EEP_sound[]={ {20, 20}, {10, 40} };
flash const BEEP_TRACK_DEF batt_sound[]={ {10,50}, {20,50} };
flash const BEEP_TRACK_DEF timer_sound[]={ {10,20}, {20,20} };
flash const BEEP_TRACK_DEF trimmer_sound[]={ {10,5} };

void beep_work(void)
{
unsigned char i;

if((*(unsigned char *) 0x7d) & 0x4) return;
i=cur_Batt/5;
if(i<=BatCntr[1]) 
{ 
if(div_beep_batt>(1000/20)) div_beep_batt=0;
if(!div_beep_batt) { beep_start(batt_sound, 2, 4); div_beep_batt=(1000/20); }
}
if(i<=BatCntr[0] && !div_beep_batt)  
{ beep_start(batt_sound, 2, 1); div_beep_batt=(5000/20); }
if(f_beep_timer) { f_beep_timer=0; beep_start(timer_sound, 2, 25);  return; }
if(f_beep_EEP) { f_beep_EEP=0; if(f_sound_en) beep_start(EEP_sound, 2, 0); return; }
if(f_beep_key) { f_beep_key=0; if(f_sound_en) beep_start(key_sound, 1, 0); return; }
if(f_beep_trimmer) { f_beep_trimmer=0; if(f_sound_en) beep_start(trimmer_sound, 1, 0); return; }
}

void keys_driver(void)
{  
unsigned char kf, n, m;
static unsigned char kf1;
static unsigned char cnt_rep;

kf=0;
if(!PIND.4) kf|=1;
if(!PIND.5          ) kf|=2;
if(!PIND.6) kf|=4;
if(!PIND.7) kf|=8;
for(m=1, n=0; m; m<<=1) if(kf & m) n++;
if(n>1) kf=0; 
if(kf!=kf1) { kf1=kf; mnu_keys=0; cnt_rep=0; return; }
if(kf==0) { mnu_keys=0; cnt_rep=0; return; }
if(!cnt_rep) mnu_keys=kf;
cnt_rep++;
if( ((kf & 1) || (kf & 2)) && g_rep)
{
if(cnt_rep>g_rep+25) cnt_rep=25;
if(cnt_rep==25) mnu_keys=kf;
}  
}

void TimerOn(void)
{
static unsigned char dev_clip=0;
static unsigned char dev_timer=0;
unsigned int i;

if(g_MainMenuMode==0 || dev_clip==0) 
{
cur_Batt=read_adc(6);
cur_Power=read_adc(0);
}
i=read_adc(1);
if(i!=cur_Temperature)
{
if(++wd_Temperature>50*2)
{
wd_Temperature=0;
if(i>cur_Temperature) dir_Temperature=50*10;
else if(i<cur_Temperature) dir_Temperature=-50*10;
cur_Temperature=i;
}
}
else wd_Temperature=0;    
if(dir_Temperature>0) dir_Temperature--;
else if(dir_Temperature<0) dir_Temperature++; 
if(++dev_clip>=30)  { dev_clip=0; f_clip=!f_clip; }
if (f_timer_en)
{ 
if (++dev_timer>=50)
{
dev_timer=0;
if(cur_model.timer_mode!=1) 
{
time++;
if(time && !(time%cur_model.timer_set)) f_beep_timer=1;
}
else
{
if(time) time--;
if(time==0) { f_timer_en=0; f_beep_timer=1; }
}  
}
}
if(div_beep_batt) div_beep_batt--;
if(div_trimmer) { div_trimmer--;  if(div_trimmer==1) save_trimmer();  } 

keys_driver();
keys_menu();
beep_work();
}

void save_trimmer(void)
{
unsigned char i;

if(!div_trimmer) return;
div_trimmer=0;
for(i=0; i<4; i++)
{
EEP_models[cur_model_ind].modes[cur_mode_ind].trimmers[i]=
cur_model.modes[cur_mode_ind].trimmers[i];
}
f_beep_EEP=1;  
}  

void MODEL_reset(unsigned char ind)
{
static signed char nod_val[7]= { -100, -66, -34, 0,  34, 66, 100 };
unsigned char i, j, n;
eeprom MODEL_SET *model;
eeprom DEF_MODE *cm;
char buff[12];

#asm("cli")
model=&EEP_models[ind];
sprintf(buff,"Model %-i ", ind+1);  
for (i=0; i<8; i++) model->name[i]=buff[i];
model->type=0;  
model->modulation=0; 
model->timer_mode=0;
model->timer_set=300;
model->num_ch=6;
model->num_freq=0;
for (i=0; i<10; i++) model->contrs_reverse[i]=1;
for (i=0; i<3; i++)
{
cm=&model->modes[i];
for(j=0; j<3; j++) 
{
cm->contr_ab[j].minRates=100;  cm->contr_ab[j].maxRates=100;
cm->contr_ab[j].minDRates=150; cm->contr_ab[j].maxDRates=150;
for(n=0; n<7; n++) cm->contr_ab[j].cur_nodes[n]=nod_val[n];
}
cm->contr_tr.minRates=100;  cm->contr_tr.maxRates=100;
cm->contr_tr.tcut=120;
for(n=0; n<7; n++) cm->contr_tr.cur_nodes[n]=nod_val[n];
cm->contr_ap.minRates=100;  cm->contr_ap.maxRates=100;
for(n=0; n<7; n++) cm->contr_ap.cur_nodes[n]=nod_val[n];
for(j=0; j<3; j++) 
{
cm->contr_d[j].minRates=100;  cm->contr_d[j].maxRates=100;
cm->contr_d[j].delay=0; 
}
for(j=0; j<2; j++) 
{
cm->contr_v[j].minRates=100;  cm->contr_v[j].maxRates=100;
cm->contr_v[j].from=j;
for(n=0; n<7; n++) cm->contr_v[j].cur_nodes[n]=nod_val[n];
}
for(j=0; j<8; j++) 
for(n=0; n<10; n++)
if(j==n) cm->chanels[j][n]=100; else cm->chanels[j][n]=0;
for(j=0; j<4; j++) cm->trimmers[j]=0;    
}  
#asm("sei")
}

void MODEL_init(unsigned char ind)
{
#asm("cli")
save_trimmer();
cur_model_ind=ind;
cur_model=EEP_models[ind];
if (cur_model.modulation==0) TCCR1A=0x82;
if (cur_model.modulation==1) TCCR1A=0xC2;
if (cur_model.timer_mode!=1) time=0;
else time=cur_model.timer_set;
PLL_SetFreq(cur_model.num_freq);
#asm("sei")
}

void MODEL_copy (unsigned char from, unsigned char to)
{
unsigned char i;
#asm("cli")
EEP_models[to].type=EEP_models[from].type;
EEP_models[to].modulation=EEP_models[from].modulation;
EEP_models[to].timer_mode=EEP_models[from].timer_mode;
EEP_models[to].timer_set=EEP_models[from].timer_set;
EEP_models[to].num_ch=EEP_models[from].num_ch;
EEP_models[to].num_freq=EEP_models[from].num_freq;
for(i=0; i<10; i++)
EEP_models[to].contrs_reverse[i]=EEP_models[from].contrs_reverse[i];
for(i=0; i<3; i++) EEP_models[to].modes[i]=EEP_models[from].modes[i];
#asm("sei")
}

unsigned char g_list_topitem=0;
unsigned char g_list_selitem=0;
unsigned char g_list_cnt=0;

void list_ini (unsigned char cnt,unsigned char sel)
{
g_list_cnt=cnt; g_list_selitem=sel; g_list_topitem=0;
if(g_list_selitem>=(g_list_topitem+5)) 
g_list_topitem=g_list_selitem-(5-1);
else if(g_list_selitem<g_list_topitem) g_list_topitem=g_list_selitem; 
}

void list_scroll (void)
{ 
if((mnu_keys & 2))
{
if(g_list_selitem==g_list_cnt-1) return;
g_list_selitem++;
if(g_list_selitem>=(g_list_topitem+5)) 
g_list_topitem=g_list_selitem-(5-1);
f_beep_key=1;  
}
else if((mnu_keys & 1))
{
if(g_list_selitem==0) return;
g_list_selitem--;
if(g_list_selitem<g_list_topitem) g_list_topitem=g_list_selitem;
f_beep_key=1;  
}  
}

void list_scroll_roll(void)
{ 
if(g_list_selitem==g_list_cnt-1) { g_list_selitem=0; g_list_topitem=0; }
else
{
g_list_selitem++;
if(g_list_selitem>=(g_list_topitem+5)) 
g_list_topitem=g_list_selitem-(5-1);
}  
f_beep_key=1;  
}

void change_paru(unsigned char *par, unsigned char max)
{
if((mnu_keys & 1) && (*par)<max) { (*par)++; f_beep_key=1; }
else if((mnu_keys & 2) && (*par)>0) { (*par)--; f_beep_key=1; }
}

void change_pars(signed char *par, signed char min, signed char max)
{
if((mnu_keys & 1) && (*par)<max) { (*par)++; f_beep_key=1; }
else if((mnu_keys & 2) && (*par)>min) { (*par)--; f_beep_key=1; }
}

void change_parr(unsigned char *par, unsigned char max)
{
if((mnu_keys & 1)) { if((*par)>0) (*par)--; else *par=max; f_beep_key=1; }
else if((mnu_keys & 2)) { if((*par)<max) (*par)++; else *par=0; f_beep_key=1; }
}

void change_name_ch(unsigned char *ch)
{
char i;

if(!(mnu_keys & 1) && !(mnu_keys & 2)) return;
for(i=0; i<sizeof(Name_table); i++) if( *ch==Name_table[i]) break;
if(i==sizeof(Name_table)) i=0;
if((mnu_keys & 1)) { if(i<sizeof(Name_table)-1) i++; else i=0; }
else if((mnu_keys & 2)) { if(i>0) i--; else i=sizeof(Name_table)-1;  }
*ch=Name_table[i];
f_beep_key=1;
}

void keys_menu(void)
{
unsigned char ind, ch, v;
unsigned int i;
DEF_MODE *rm;
unsigned char *p1;
eeprom unsigned char *p2;

switch(pos[0])
{
case 0: 
if((mnu_keys & 1)) 
{
if(cur_model.timer_mode!=2)
{
if(!f_timer_en)
{
if(cur_model.timer_mode==1 && time==0) time=cur_model.timer_set;
f_timer_en=1;
}
else f_timer_en=0;
f_beep_key=1;
}
}
if((mnu_keys & 2))
{
if(cur_model.timer_mode!=2) f_timer_en=0;
if(cur_model.timer_mode==1) time=cur_model.timer_set; else time=0; 
f_beep_key=1;
}       
if((mnu_keys & 8)) { pos[0]=1; pos[1]=0; list_ini(4, 0); g_rep=10; f_beep_key=1;  }
if((mnu_keys & 4)) 
{
if(g_MainMenuMode<1) g_MainMenuMode++; else g_MainMenuMode=0; 
f_beep_key=1; 
} 
break;
case 1:
switch(pos[1])
{
case 0: 
if((mnu_keys & 4)) { pos[0]=0; g_rep=0; f_beep_key=1; break; }
if((mnu_keys & 8)) 
{
pos[1]=g_list_selitem+1; pos[2]=0;
switch(pos[1])
{
case 1: list_ini(7, cur_model_ind); break;
case 2: list_ini(10 , 0); break;
case 3: T[0]=cur_model_ind; T[1]=cur_model_ind+1; if(T[1]>=7) T[1]=0; break;
case 4: list_ini(5, 0); break;
}
f_beep_key=1; 
break; 
}
list_scroll();
break;
case 1: 
if((mnu_keys & 4)) { list_ini(4, pos[1]-1); pos[1]=0; f_beep_key=1; break; } 
if((mnu_keys & 8)) 
{ 
MODEL_init(g_list_selitem);
EEP_start_model=g_list_selitem;

pos[0]=0; g_rep=0; 
f_beep_EEP=1; break; 
}
list_scroll();
break;
case 2: 
switch(pos[2])
{
case 0:
if((mnu_keys & 4)) 
{
#asm("cli")
p1=(unsigned char *)&cur_model;
p2=(eeprom unsigned char *)&EEP_models[cur_model_ind];
for(i=0, v=0; i<sizeof(MODEL_SET); i++) 
if( (*(p1+i))!=(*(p2+i)) ) { v=1; break; }
#asm("sei")
if(v) { list_ini(3 , 0); pos[2]=11;  f_beep_key=1; break; }
list_ini(4, pos[1]-1); pos[1]=0;
f_beep_key=1;
break;
}
if((mnu_keys & 8)) 
{
pos[2]=g_list_selitem+1; pos[3]=0; f_edit=0;
switch(pos[2])
{
case 1: list_ini(10 , 0); break;  
case 2: list_ini(8 , 0); break;
case 8: list_ini(2 , 0); break;
case 9: T[0]=cur_mode_ind; T[1]=cur_mode_ind+1; if(T[1]>2) T[1]=0; break;
}           
f_beep_key=1; 
break; 
}
list_scroll();
break;
case 1: 
switch(pos[3])
{
case 0:
if((mnu_keys & 4)) { list_ini(10 , pos[2]-1); pos[2]=0;  f_beep_key=1; }
if((mnu_keys & 8)) 
{
pos[3]=g_list_selitem+1; pos[4]=0;
f_edit=0; f_edit_cur=0;
f_beep_key=1; 
break; 
}
list_scroll();
break;
default:
ch=pos[3]-1;
rm=&cur_model.modes[cur_mode_ind];
if(!f_edit_cur)
{
if((mnu_keys & 8)) 
{
if( ((ch==0 || ch==1 || ch==3) && pos[4]==5) ||
((ch==2 || ch==8 || ch==9) && pos[4]==4) ||
(ch==7 && pos[4]==3) ) 
{ f_edit=0; f_edit_cur=1; pos[5]=0; g_rep=10; f_beep_key=1; break; }
}
if(ch==0 || ch==1 || ch==3) v=5;
else if(ch==2 || ch==8 || ch==9) v=4;
else if(ch==7) v=3;
else v=3;                
if(!f_edit)
{
if((mnu_keys & 4)) { list_ini(10 , pos[3]-1); pos[3]=0; f_beep_key=1; break; }
if((mnu_keys & 8)) { f_edit=1; if(pos[4]!=0) g_rep=5; f_beep_key=1; break; }
change_parr(&pos[4], v);
}
else 
{ 
if ((mnu_keys & 4))  { f_edit=0; g_rep=10; f_beep_key=1; break; }
if ((mnu_keys & 8))
{
if(pos[4]<v) pos[4]++; else pos[4]=0;
if(pos[4]!=0) g_rep=5; else g_rep=10; 
f_beep_key=1; break;
}
if(pos[4]==0) 
{
if((mnu_keys & 1) || (mnu_keys & 2)) 
{ if(cur_model.contrs_reverse[ch]==1) cur_model.contrs_reverse[ch]=-1; 
else cur_model.contrs_reverse[ch]=1; f_beep_key=1; }
break;
}    
if(ch<=3 && ch!=2) 
{ 
ind=ch; if(ch>2) ind=2;
switch(pos[4])
{
case 1: change_paru(&rm->contr_ab[ind].minRates, 150); break;
case 2: change_paru(&rm->contr_ab[ind].maxRates, 150); break;
case 3: change_paru(&rm->contr_ab[ind].minDRates, 150); break;
case 4: change_paru(&rm->contr_ab[ind].maxDRates, 150); break;
}
}
else if (ch==2) 
{ 
switch(pos[4])
{
case 1: change_paru(&rm->contr_tr.minRates, 150); break;
case 2: change_paru(&rm->contr_tr.maxRates, 150); break;
case 3: change_paru(&rm->contr_tr.tcut,  150); break;
}
}  
else if(ch>=4 && ch<=6) 
{ 
ind=ch-4;
switch(pos[4])
{
case 1: change_paru(&rm->contr_d[ind].minRates, 150); break;
case 2: change_paru(&rm->contr_d[ind].maxRates, 150); break;
case 3: change_paru(&rm->contr_d[ind].delay, 100); break;
}
}  
else if (ch==7) 
{ 
switch(pos[4])
{
case 1: change_paru(&rm->contr_ap.minRates, 150); break;
case 2: change_paru(&rm->contr_ap.maxRates, 150); break;
}
}  
else if(ch>=8)
{ 
ind=ch-8;
switch(pos[4])
{
case 1: change_paru(&rm->contr_v[ind].minRates, 150); break;
case 2: change_paru(&rm->contr_v[ind].maxRates, 150); break;
case 3: change_paru(&rm->contr_v[ind].from, 7); break;
}
}   
}                
}
else 
{ 
if(!f_edit)
{
if ((mnu_keys & 4))  { f_edit_cur=0; f_beep_key=1; break; }
if ((mnu_keys & 8)) { f_edit=1; g_rep=5; f_beep_key=1; break; } 
change_paru(&pos[5], 6); 
}
else 
{
if ((mnu_keys & 4))  { f_edit=0; g_rep=10; f_beep_key=1; break; }
if ((mnu_keys & 8)) { if(pos[5]<6) pos[5]++; else pos[5]=0; f_beep_key=1; break; }
if(ch<=3 && ch!=2)
{ 
ind=ch; if(ch>2) ind=2;
change_pars(&rm->contr_ab[ind].cur_nodes[pos[5]], -100, 100);
}
else if (ch==2) 
change_pars(&rm->contr_tr.cur_nodes[pos[5]], -100, 100);
else if (ch==7) 
change_pars(&rm->contr_ap.cur_nodes[pos[5]], -100, 100);
else if(ch>=8)
{ 
ind=ch-8;
change_pars(&rm->contr_v[ind].cur_nodes[pos[5]], -100, 100);
}
}  
}  
break;
}
break;    
case 2: 
switch(pos[3])
{
case 0:
if((mnu_keys & 4)) { list_ini(10 , pos[2]-1); pos[2]=0;  f_beep_key=1; break;}
if((mnu_keys & 8)) 
{
pos[3]=g_list_selitem+1; pos[4]=0;
list_ini(10 , 0);
f_edit=0;
f_beep_key=1; 
break; 
}
list_scroll();
break;
default:
if(!f_edit)
{
if((mnu_keys & 4)) { list_ini(8 , pos[3]-1); pos[3]=0;  f_beep_key=1; break; } 
if((mnu_keys & 8)) { f_edit=1; g_rep=5; f_beep_key=1; break; } 
list_scroll();
}
else
{
ind=pos[3]-1; 
if ((mnu_keys & 4)) { f_edit=0; g_rep=10; f_beep_key=1; break; }
if((mnu_keys & 8)) { list_scroll_roll(); break; }
change_pars(&cur_model.modes[cur_mode_ind].chanels[ind][g_list_selitem],-100,100);  
}
break;  
}  
break;
case 3: 
if(!f_edit)
{
if((mnu_keys & 4)) {  list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; break; }
if((mnu_keys & 8)) { f_edit=1; g_rep=5; f_beep_key=1; break; }
change_paru(&pos[3], 7);
break;
}
if((mnu_keys & 4))  { f_edit=0; g_rep=10; f_beep_key=1; break; } 
if((mnu_keys & 8)) { if(pos[3]<7) pos[3]++; else pos[3]=0; f_beep_key=1; break; }  
change_name_ch(&cur_model.name[pos[3]]); 
break;    
case 4: 
if((mnu_keys & 4))  { list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; break; }
if ((mnu_keys & 2) || (mnu_keys & 1) ) { cur_model.type=!cur_model.type; f_beep_key=1; } 
break;
case 5: 
if((mnu_keys & 4)) {  list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; break; }
v=0;
if ((mnu_keys & 1) &&  cur_model.num_freq<(20-1)) { cur_model.num_freq++; v=1; }
else if ((mnu_keys & 2) && cur_model.num_freq) { cur_model.num_freq--; v=1;  }
if(v) { PLL_SetFreq(cur_model.num_freq); f_beep_key=1; }
break;      
case 6:  
if((mnu_keys & 4)) { list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; break; }
v=cur_model.modulation; change_parr(&v, 1);
if(cur_model.modulation!=v)
{
cur_model.modulation=v;
if (cur_model.modulation==0) TCCR1A=0x82;
else if (cur_model.modulation==1) TCCR1A=0xC2;
}  
break;
case 7: 
if((mnu_keys & 4)) { list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; break; }
if ((mnu_keys & 1) && cur_model.num_ch<8) {  cur_model.num_ch++; f_beep_key=1; } 
if ((mnu_keys & 2) && cur_model.num_ch>2) {  cur_model.num_ch--; f_beep_key=1; }  
break;
case 8: 
switch(pos[3])
{
case 0:
if((mnu_keys & 4)) { list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; }
if((mnu_keys & 8)) 
{
pos[3]=g_list_selitem+1; pos[4]=0; 
if(pos[3]==1) g_rep=5;
f_beep_key=1;
break; 
}
list_scroll();
break;
case 1: 
if((mnu_keys & 4)) { list_ini(2 , pos[3]-1); pos[3]=0; g_rep=10; f_beep_key=1; break; }
if ((mnu_keys & 1) && cur_model.timer_set<3599) { cur_model.timer_set+=10; f_beep_key=1; }
if ((mnu_keys & 2) && cur_model.timer_set>=10) { cur_model.timer_set-=10; f_beep_key=1; }
break;
case 2: 
if((mnu_keys & 4))  { list_ini(2 , pos[3]-1); pos[3]=0; f_beep_key=1; break; }
v=cur_model.timer_mode; change_paru(&v, 2); cur_model.timer_mode=v; 
break;
}
break;  
case 9:  
if(!f_edit)
{
if((mnu_keys & 4)) { list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; break; }
if((mnu_keys & 8))
{
if(pos[3]<2) { f_edit=1; f_beep_key=1; break; }
cur_model.modes[T[1]]=cur_model.modes[T[0]];
list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1;  break;
}
change_parr(&pos[3], 2);  
break;
}
if((mnu_keys & 4)) { f_edit=0; f_beep_key=1; break; }
if((mnu_keys & 8)) { if(pos[3]<1) pos[3]++; else pos[3]=0; f_beep_key=1; break; }
if(pos[3]<2) { change_parr(&T[pos[3]], 2); break; }
break;
case 10: 
if((mnu_keys & 4)) 
{ list_ini(10 , pos[2]-1); pos[2]=0; f_beep_key=1; break; }
if((mnu_keys & 8)) 
{ 
MODEL_reset(cur_model_ind);
MODEL_init(cur_model_ind);
list_ini(10 , pos[2]-1); pos[2]=0;
f_beep_EEP=1;
}
break;
case 11: 
if((mnu_keys & 8)) 
{
switch(g_list_selitem)
{
case 0: 
#asm("cli")
EEP_models[cur_model_ind]=cur_model;
#asm("sei") 
f_beep_EEP=1; 
break; 
case 1: f_beep_key=1; break; 
case 2: MODEL_init(cur_model_ind); f_beep_key=1; break; 
}
list_ini(4, pos[1]-1); pos[1]=0;
break;  
}
list_scroll();
break;
}
break;  
case 3: 
if(!f_edit)
{
if((mnu_keys & 4)) { list_ini(4, pos[1]-1); pos[1]=0; f_beep_key=1; break; }
if((mnu_keys & 8))
{
if(pos[2]<2) { f_edit=1; f_beep_key=1; break; }
MODEL_copy(T[0],T[1]); MODEL_init(cur_model_ind);
list_ini(4, pos[1]-1); pos[1]=0; f_beep_EEP=1; break;
}
change_parr(&pos[2], 2);  
break;
}
if((mnu_keys & 4)) { f_edit=0; f_beep_key=1; break; }
if((mnu_keys & 8)) { if(pos[2]<1) pos[2]++; else pos[2]=0; f_beep_key=1; break; }
if(pos[2]<2)
{
change_parr(&T[pos[2]], 7-1);
break;
}
break;
case 4: 
switch(pos[2])
{
case 0:
if((mnu_keys & 4)) { list_ini(4, pos[1]-1); pos[1]=0;  f_beep_key=1; }
if((mnu_keys & 8)) 
{
pos[2]=g_list_selitem+1; pos[3]=0; 
if(pos[2]==3) g_list_selitem=0;
if(pos[2]==4) { EIMSK|=0x01; EIFR=0x01; }
f_beep_key=1; break; 
}
list_scroll();
break;
case 1: 
if ((mnu_keys & 2) || (mnu_keys & 1)) { f_sound_en=!f_sound_en; f_beep_key=1; break;}
if ((mnu_keys & 4)) { EEP_f_sound_en=f_sound_en; 
list_ini(5, pos[2]-1); pos[2]=0;
f_beep_EEP=1; }
break;
case 2: 
if(!f_edit)
{
if((mnu_keys & 4)) {  list_ini(5, pos[2]-1); pos[2]=0; f_beep_key=1; break;}
if((mnu_keys & 8)) { f_edit=1; g_rep=5; f_beep_key=1; break;}
change_parr(&pos[3], 2);
break;
}
if((mnu_keys & 4)) {  EEP_BatCntr[pos[3]]=BatCntr[pos[3]]; f_edit=0; g_rep=10; f_beep_EEP=1; break; }
if((mnu_keys & 8)) {  if(++pos[3]>2) pos[3]=0; f_beep_key=1; break; }
change_paru( &BatCntr[pos[3]], 120);  
break;        
case 3: 
if((mnu_keys & 4)) {  list_ini(5, pos[2]-1); pos[2]=0; f_beep_key=1; break; }
if((mnu_keys & 8)) { pos[3]=!pos[3]; f_beep_key=1; break; }
if ((mnu_keys & 2) &&  g_list_selitem<(cur_model.num_ch-5)) { g_list_selitem++; f_beep_key=1; break; }
if ((mnu_keys & 1) && g_list_selitem) { g_list_selitem--; f_beep_key=1; break; }        
break;
case 4: 
if((mnu_keys & 4)) {  EIMSK&=0xfe; list_ini(5, pos[2]-1); pos[2]=0; f_beep_key=1; break; }
break;
case 5: 
if((mnu_keys & 4)) {  list_ini(5, pos[2]-1); pos[2]=0; f_beep_key=1; break; }
break;
}
break;
}
break;
}
mnu_keys=0;        
}

void TX_init (void)
{
char i;
cur_model_ind=EEP_start_model;
f_sound_en=EEP_f_sound_en;
BatCntr[0]=EEP_BatCntr[0]; BatCntr[1]=EEP_BatCntr[1]; BatCntr[2]=EEP_BatCntr[2];
CalibrTemperature[0]=EPP_CalibrTemperature[0];  
CalibrTemperature[1]=EPP_CalibrTemperature[1];  
for (i=0; i<5; i++)
{
ADmin[i]=EEPR_ADmin[i];
ADmid[i]=EEPR_ADmid[i];
ADmax[i]=EEPR_ADmax[i];
}
MODEL_init(cur_model_ind);
}
