
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega128
;Program type             : Application
;Clock frequency          : 12,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 1024 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : No
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _f_l=R5
	.DEF _gRPMtmp=R6
	.DEF _gRPMn=R4
	.DEF _g_keys=R9
	.DEF _beep_track=R10
	.DEF _beep_length=R12
	.DEF _beep_cnt=R8

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer3_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_calibr_sound:
	.DB  0xA,0x32,0x0,0x14,0x32,0x0,0xA,0x32
	.DB  0x0
_key_sound:
	.DB  0x14,0x14,0x0
_error_sound:
	.DB  0x14,0xF4,0x1,0xA,0xE8,0x3
_notes:
	.DB  0xB8,0x1,0xD2,0x1,0xEE,0x1,0xB,0x2
	.DB  0x2A,0x2,0x4C,0x2,0x64,0x2,0x94,0x2
	.DB  0xBA,0x2,0xE4,0x2,0x10,0x3,0x3E,0x3
	.DB  0x70,0x3,0xA4,0x3,0xDC,0x3,0x28,0x4
	.DB  0x54,0x4,0x98,0x4,0xC8,0x4,0x28,0x5
	.DB  0x74,0x5,0xC8,0x5,0x20,0x6,0x7C,0x6
_hello_sound:
	.DB  0xA,0xC8,0x0,0x7,0x32,0x0,0x3,0x32
	.DB  0x0,0xA,0xC8,0x0
__str_VER:
	.DB  0x56,0x31,0x2E,0x37,0x2C,0x20,0x32,0x32
	.DB  0x2F,0x30,0x37,0x2F,0x30,0x39,0x0
__str_Co:
	.DB  0x28,0x63,0x29,0x20,0x4D,0x53,0x56,0x0
_Name_table:
	.DB  0x20,0x5F,0x2D,0x30,0x31,0x32,0x33,0x34
	.DB  0x35,0x36,0x37,0x38,0x39,0x41,0x61,0x42
	.DB  0x62,0x43,0x63,0x44,0x64,0x45,0x65,0x46
	.DB  0x66,0x47,0x67,0x48,0x68,0x49,0x69,0x4A
	.DB  0x6A,0x4B,0x6B,0x4C,0x6C,0x4D,0x6D,0x4E
	.DB  0x6E,0x4F,0x6F,0x50,0x70,0x51,0x71,0x52
	.DB  0x72,0x53,0x73,0x54,0x74,0x55,0x75,0x56
	.DB  0x76,0x57,0x77,0x58,0x78,0x59,0x79,0x5A
	.DB  0x7A
_EEP_sound:
	.DB  0x14,0x14,0x0,0xA,0x28,0x0
_batt_sound:
	.DB  0xA,0x32,0x0,0x14,0x32,0x0
_timer_sound:
	.DB  0xA,0x14,0x0,0x14,0x14,0x0
_trimmer_sound:
	.DB  0xA,0x5,0x0
_font_norm:
	.DB  0x3,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x3,0x5F,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x4,0x3,0x0,0x3,0x0,0x0
	.DB  0x0,0x0,0x0,0x7,0x24,0x7E,0x24,0x24
	.DB  0x7E,0x24,0x0,0x0,0x6,0x4,0x2A,0x7F
	.DB  0x2A,0x10,0x0,0x0,0x0,0x8,0x2,0x5
	.DB  0x62,0x18,0x26,0x50,0x20,0x0,0x7,0x36
	.DB  0x49,0x49,0x56,0x20,0x50,0x0,0x0,0x4
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x3,0x3E,0x41,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x3,0x41,0x3E,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x6,0x14,0x8,0x3E,0x8,0x14
	.DB  0x0,0x0,0x0,0x6,0x8,0x8,0x3E,0x8
	.DB  0x8,0x0,0x0,0x0,0x4,0x80,0x60,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x5,0x8,0x8
	.DB  0x8,0x8,0x0,0x0,0x0,0x0,0x3,0x40
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4
	.DB  0x60,0x1C,0x3,0x0,0x0,0x0,0x0,0x0
	.DB  0x6,0x3E,0x61,0x5D,0x43,0x3E,0x0,0x0
	.DB  0x0,0x6,0x4,0x2,0x7F,0x0,0x0,0x0
	.DB  0x0,0x0,0x6,0x42,0x61,0x51,0x49,0x46
	.DB  0x0,0x0,0x0,0x6,0x22,0x41,0x49,0x49
	.DB  0x36,0x0,0x0,0x0,0x6,0x18,0x14,0x12
	.DB  0x7F,0x10,0x0,0x0,0x0,0x6,0x27,0x45
	.DB  0x45,0x45,0x39,0x0,0x0,0x0,0x6,0x3E
	.DB  0x45,0x45,0x45,0x38,0x0,0x0,0x0,0x6
	.DB  0x1,0x61,0x19,0x7,0x1,0x0,0x0,0x0
	.DB  0x6,0x36,0x49,0x49,0x49,0x36,0x0,0x0
	.DB  0x0,0x6,0xE,0x51,0x51,0x51,0x3E,0x0
	.DB  0x0,0x0,0x3,0x22,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x4,0x80,0x62,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x4,0x8,0x14,0x22
	.DB  0x0,0x0,0x0,0x0,0x0,0x5,0x14,0x14
	.DB  0x14,0x14,0x0,0x0,0x0,0x0,0x4,0x22
	.DB  0x14,0x8,0x0,0x0,0x0,0x0,0x0,0x6
	.DB  0x2,0x1,0x51,0x9,0x6,0x0,0x0,0x0
	.DB  0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x6,0x7C,0x12,0x11,0x12,0x7C,0x0
	.DB  0x0,0x0,0x6,0x7F,0x49,0x49,0x49,0x3E
	.DB  0x0,0x0,0x0,0x6,0x3E,0x41,0x41,0x41
	.DB  0x22,0x0,0x0,0x0,0x6,0x7F,0x41,0x41
	.DB  0x22,0x1C,0x0,0x0,0x0,0x6,0x7F,0x49
	.DB  0x49,0x49,0x49,0x0,0x0,0x0,0x5,0x7F
	.DB  0x9,0x9,0x1,0x0,0x0,0x0,0x0,0x6
	.DB  0x3C,0x42,0x41,0x51,0x72,0x0,0x0,0x0
	.DB  0x6,0x7F,0x8,0x8,0x8,0x7F,0x0,0x0
	.DB  0x0,0x3,0x7F,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x6,0x30,0x40,0x40,0x40,0x3F
	.DB  0x0,0x0,0x0,0x6,0x7F,0x8,0x14,0x22
	.DB  0x41,0x0,0x0,0x0,0x6,0x7F,0x40,0x40
	.DB  0x40,0x40,0x0,0x0,0x0,0x7,0x7F,0x2
	.DB  0x4,0x4,0x2,0x7F,0x0,0x0,0x6,0x7F
	.DB  0x4,0x8,0x10,0x7F,0x0,0x0,0x0,0x6
	.DB  0x3E,0x41,0x41,0x41,0x3E,0x0,0x0,0x0
	.DB  0x6,0x7F,0x9,0x9,0x9,0x6,0x0,0x0
	.DB  0x0,0x6,0x3E,0x41,0x61,0xC1,0x3E,0x0
	.DB  0x0,0x0,0x6,0x7F,0x9,0x9,0x19,0x66
	.DB  0x0,0x0,0x0,0x6,0x26,0x49,0x49,0x49
	.DB  0x32,0x0,0x0,0x0,0x6,0x1,0x1,0x7F
	.DB  0x1,0x1,0x0,0x0,0x0,0x6,0x3F,0x40
	.DB  0x40,0x40,0x3F,0x0,0x0,0x0,0x7,0x7
	.DB  0x38,0x40,0x40,0x38,0x7,0x0,0x0,0x8
	.DB  0x3F,0x40,0x38,0x6,0x38,0x40,0x3F,0x0
	.DB  0x6,0x63,0x14,0x8,0x14,0x63,0x0,0x0
	.DB  0x0,0x6,0x3,0x4,0x78,0x4,0x3,0x0
	.DB  0x0,0x0,0x6,0x61,0x51,0x49,0x45,0x43
	.DB  0x0,0x0,0x0,0x3,0x7F,0x41,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x4,0x3,0x1C,0x60
	.DB  0x0,0x0,0x0,0x0,0x0,0x3,0x41,0x7F
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x6,0x4
	.DB  0x2,0x1,0x2,0x4,0x0,0x0,0x0,0x5
	.DB  0x80,0x80,0x80,0x80,0x0,0x0,0x0,0x0
	.DB  0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x5,0x20,0x54,0x54,0x78,0x0,0x0
	.DB  0x0,0x0,0x5,0x7F,0x44,0x44,0x38,0x0
	.DB  0x0,0x0,0x0,0x5,0x38,0x44,0x44,0x44
	.DB  0x0,0x0,0x0,0x0,0x5,0x38,0x44,0x44
	.DB  0x7F,0x0,0x0,0x0,0x0,0x5,0x38,0x54
	.DB  0x54,0x58,0x0,0x0,0x0,0x0,0x4,0x4
	.DB  0x7E,0x5,0x0,0x0,0x0,0x0,0x0,0x5
	.DB  0x18,0xA4,0xA4,0x7C,0x0,0x0,0x0,0x0
	.DB  0x5,0x7F,0x4,0x4,0x78,0x0,0x0,0x0
	.DB  0x0,0x2,0x7D,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x4,0x40,0x80,0x7D,0x0,0x0
	.DB  0x0,0x0,0x0,0x5,0x7F,0x10,0x28,0x44
	.DB  0x0,0x0,0x0,0x0,0x3,0x7F,0x40,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x6,0x7C,0x4
	.DB  0x7C,0x4,0x78,0x0,0x0,0x0,0x5,0x7C
	.DB  0x4,0x4,0x78,0x0,0x0,0x0,0x0,0x5
	.DB  0x38,0x44,0x44,0x38,0x0,0x0,0x0,0x0
	.DB  0x5,0xFC,0x24,0x24,0x18,0x0,0x0,0x0
	.DB  0x0,0x5,0x18,0x24,0x24,0xFC,0x80,0x0
	.DB  0x0,0x0,0x4,0x78,0x4,0x4,0x0,0x0
	.DB  0x0,0x0,0x0,0x5,0x48,0x54,0x54,0x24
	.DB  0x0,0x0,0x0,0x0,0x4,0x4,0x7F,0x44
	.DB  0x0,0x0,0x0,0x0,0x0,0x5,0x3C,0x40
	.DB  0x40,0x7C,0x0,0x0,0x0,0x0,0x6,0x4
	.DB  0x38,0x40,0x38,0x4,0x0,0x0,0x0,0x8
	.DB  0x3C,0x40,0x30,0x8,0x30,0x40,0x3C,0x0
	.DB  0x6,0x44,0x28,0x10,0x28,0x44,0x0,0x0
	.DB  0x0,0x6,0x4,0x98,0x60,0x18,0x4,0x0
	.DB  0x0,0x0,0x6,0x44,0x64,0x54,0x4C,0x44
	.DB  0x0,0x0,0x0,0x8,0xFF,0x81,0x81,0x81
	.DB  0x81,0x81,0x81,0xFF,0x8,0xFF,0x81,0xBD
	.DB  0xBD,0xBD,0xBD,0x81,0xFF,0x8,0x1,0x31
	.DB  0x79,0x79,0x7D,0x7F,0x7D,0x31,0x8,0x11
	.DB  0x11,0x11,0x10,0x10,0x10,0x38,0x10,0x8
	.DB  0x3E,0x8,0x1C,0x1C,0x7C,0x3E,0x1E,0x1E
	.DB  0x8,0x1E,0x1C,0x18,0x18,0x18,0x1C,0xE
	.DB  0xE,0x6,0x7,0x5,0x5,0x5,0x7,0x2
	.DB  0x0,0x0,0x5,0x1,0x2,0xF,0x2,0x1
	.DB  0x0,0x0,0x0,0x8,0x4,0x7F,0x44,0x0
	.DB  0x2,0x5,0x2,0x0,0x8,0xA,0xFE,0xAB
	.DB  0xFF,0xFE,0xEA,0xE0,0x40,0x8,0x3C,0x42
	.DB  0x85,0x99,0x99,0x85,0x42,0x3C,0x8,0x20
	.DB  0x30,0x38,0x3C,0x38,0x30,0x20,0x0,0x8
	.DB  0x4,0xC,0x1C,0x3C,0x1C,0xC,0x4,0x0
_deg12x16:
	.DB  0x0,0xF8,0xFE,0x6,0x3,0x3,0x3,0x3
	.DB  0x3,0x6,0xFE,0xF8,0x0,0x7,0x1F,0x18
	.DB  0x30,0x30,0x30,0x30,0x30,0x18,0x1F,0x7
	.DB  0x0,0x0,0x0,0xC,0xC,0xE,0xFF,0xFF
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30
	.DB  0x30,0x30,0x3F,0x3F,0x30,0x30,0x30,0x0
	.DB  0x0,0x1C,0x1E,0x7,0x3,0x3,0x83,0xC3
	.DB  0xE3,0x77,0x3E,0x1C,0x0,0x30,0x38,0x3C
	.DB  0x3E,0x37,0x33,0x31,0x30,0x30,0x30,0x30
	.DB  0x0,0xC,0xE,0x7,0xC3,0xC3,0xC3,0xC3
	.DB  0xC3,0xE7,0x7E,0x3C,0x0,0xC,0x1C,0x38
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xE
	.DB  0x0,0xC0,0xE0,0x70,0x38,0x1C,0xE,0x7
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3F,0x3F,0x3,0x3
	.DB  0x0,0x3F,0x7F,0x63,0x63,0x63,0x63,0x63
	.DB  0x63,0xE3,0xC3,0x83,0x0,0xC,0x1C,0x38
	.DB  0x30,0x30,0x30,0x30,0x30,0x38,0x1F,0xF
	.DB  0x0,0xC0,0xF0,0xF8,0xDC,0xCE,0xC7,0xC3
	.DB  0xC3,0xC3,0x80,0x0,0x0,0xF,0x1F,0x39
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xF
	.DB  0x0,0x3,0x3,0x3,0x3,0x3,0x3,0xC3
	.DB  0xF3,0x3F,0xF,0x3,0x0,0x0,0x0,0x0
	.DB  0x30,0x3C,0xF,0x3,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xBC,0xFE,0xE7,0xC3,0xC3,0xC3
	.DB  0xE7,0xFE,0xBC,0x0,0x0,0xF,0x1F,0x39
	.DB  0x30,0x30,0x30,0x30,0x30,0x39,0x1F,0xF
	.DB  0x0,0x3C,0x7E,0xE7,0xC3,0xC3,0xC3,0xC3
	.DB  0xC3,0xE7,0xFE,0xFC,0x0,0x0,0x0,0x30
	.DB  0x30,0x30,0x38,0x1C,0xE,0x7,0x3,0x0
	.DB  0x0,0x0,0x0,0x0,0x70,0x70,0x70,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1C,0x1C,0x1C,0x0,0x0,0x0,0x0,0x0
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0xEC:
	.DB  0x0,0x0
_0x0:
	.DB  0x43,0x61,0x6C,0x69,0x62,0x72,0x61,0x74
	.DB  0x69,0x6F,0x6E,0x0,0x6E,0x6F,0x74,0x20
	.DB  0x63,0x6F,0x72,0x72,0x65,0x63,0x74,0x21
	.DB  0x0,0x54,0x68,0x65,0x72,0x6D,0x6F,0x6D
	.DB  0x65,0x74,0x65,0x72,0x0,0x53,0x65,0x74
	.DB  0x20,0x63,0x75,0x72,0x72,0x20,0x25,0x63
	.DB  0x3A,0x20,0x25,0x64,0x0,0x25,0x75,0x0
	.DB  0x49,0x6E,0x69,0x74,0x69,0x61,0x6C,0x0
_0x20003:
	.DB  LOW(_0x20000*2),HIGH(_0x20000*2),LOW(_0x20000*2+5),HIGH(_0x20000*2+5),LOW(_0x20000*2+10),HIGH(_0x20000*2+10),LOW(_0x20000*2+5),HIGH(_0x20000*2+5)
	.DB  LOW(_0x20000*2+16),HIGH(_0x20000*2+16),LOW(_0x20000*2+20),HIGH(_0x20000*2+20)
_0x20004:
	.DB  LOW(_0x20000*2+24),HIGH(_0x20000*2+24),LOW(_0x20000*2+28),HIGH(_0x20000*2+28),LOW(_0x20000*2+33),HIGH(_0x20000*2+33)
_0x20005:
	.DB  LOW(_0x20000*2+37),HIGH(_0x20000*2+37),LOW(_0x20000*2+46),HIGH(_0x20000*2+46),LOW(_0x20000*2+54),HIGH(_0x20000*2+54),LOW(_0x20000*2+61),HIGH(_0x20000*2+61)
_0x20006:
	.DB  LOW(_0x20000*2+71),HIGH(_0x20000*2+71),LOW(_0x20000*2+82),HIGH(_0x20000*2+82),LOW(_0x20000*2+93),HIGH(_0x20000*2+93),LOW(_0x20000*2+100),HIGH(_0x20000*2+100)
	.DB  LOW(_0x20000*2+107),HIGH(_0x20000*2+107),LOW(_0x20000*2+119),HIGH(_0x20000*2+119),LOW(_0x20000*2+128),HIGH(_0x20000*2+128),LOW(_0x20000*2+142),HIGH(_0x20000*2+142)
	.DB  LOW(_0x20000*2+150),HIGH(_0x20000*2+150),LOW(_0x20000*2+163),HIGH(_0x20000*2+163)
_0x20007:
	.DB  LOW(_0x20000*2+170),HIGH(_0x20000*2+170),LOW(_0x20000*2+181),HIGH(_0x20000*2+181),LOW(_0x20000*2+192),HIGH(_0x20000*2+192),LOW(_0x20000*2+203),HIGH(_0x20000*2+203)
	.DB  LOW(_0x20000*2+212),HIGH(_0x20000*2+212),LOW(_0x20000*2+223),HIGH(_0x20000*2+223),LOW(_0x20000*2+234),HIGH(_0x20000*2+234),LOW(_0x20000*2+245),HIGH(_0x20000*2+245)
	.DB  LOW(_0x20000*2+256),HIGH(_0x20000*2+256),LOW(_0x20000*2+268),HIGH(_0x20000*2+268)
_0x20008:
	.DB  LOW(_0x20000*2+280),HIGH(_0x20000*2+280),LOW(_0x20000*2+292),HIGH(_0x20000*2+292)
_0x20009:
	.DB  LOW(_0x20000*2+306),HIGH(_0x20000*2+306),LOW(_0x20000*2+314),HIGH(_0x20000*2+314),LOW(_0x20000*2+324),HIGH(_0x20000*2+324),LOW(_0x20000*2+334),HIGH(_0x20000*2+334)
	.DB  LOW(_0x20000*2+347),HIGH(_0x20000*2+347)
_0x2000A:
	.DB  LOW(_0x20000*2+357),HIGH(_0x20000*2+357),LOW(_0x20000*2+369),HIGH(_0x20000*2+369),LOW(_0x20000*2+381),HIGH(_0x20000*2+381),LOW(_0x20000*2+393),HIGH(_0x20000*2+393)
	.DB  LOW(_0x20000*2+405),HIGH(_0x20000*2+405),LOW(_0x20000*2+417),HIGH(_0x20000*2+417),LOW(_0x20000*2+429),HIGH(_0x20000*2+429),LOW(_0x20000*2+441),HIGH(_0x20000*2+441)
_0x2000B:
	.DB  LOW(_0x20000*2+453),HIGH(_0x20000*2+453),LOW(_0x20000*2+459),HIGH(_0x20000*2+459)
_0x2000C:
	.DB  LOW(_0x20000*2+464),HIGH(_0x20000*2+464),LOW(_0x20000*2+467),HIGH(_0x20000*2+467),LOW(_0x20000*2+472),HIGH(_0x20000*2+472)
_0x2000D:
	.DB  LOW(_0x20000*2+477),HIGH(_0x20000*2+477),LOW(_0x20000*2+482),HIGH(_0x20000*2+482),LOW(_0x20000*2+489),HIGH(_0x20000*2+489)
_0x2000E:
	.DB  LOW(_0x20000*2+497),HIGH(_0x20000*2+497),LOW(_0x20000*2+505),HIGH(_0x20000*2+505),LOW(_0x20000*2+511),HIGH(_0x20000*2+511)
_0x20000:
	.DB  0x4C,0x61,0x6E,0x64,0x0,0x4E,0x6F,0x72
	.DB  0x6D,0x0,0x50,0x69,0x6C,0x6F,0x74,0x0
	.DB  0x49,0x44,0x55,0x0,0x54,0x48,0x4C,0x0
	.DB  0x50,0x50,0x4D,0x0,0x49,0x50,0x50,0x4D
	.DB  0x0,0x50,0x43,0x4D,0x0,0x53,0x65,0x6C
	.DB  0x65,0x63,0x74,0x9,0x3E,0x0,0x4D,0x6F
	.DB  0x64,0x65,0x6C,0x9,0x3E,0x0,0x43,0x6F
	.DB  0x70,0x79,0x9,0x3E,0x0,0x4F,0x70,0x74
	.DB  0x69,0x6F,0x6E,0x73,0x9,0x3E,0x0,0x43
	.DB  0x6F,0x6E,0x74,0x72,0x6F,0x6C,0x73,0x9
	.DB  0x3E,0x0,0x43,0x68,0x61,0x6E,0x6E,0x65
	.DB  0x6C,0x73,0x9,0x3E,0x0,0x4E,0x61,0x6D
	.DB  0x65,0x9,0x3E,0x0,0x54,0x79,0x70,0x65
	.DB  0x9,0x3E,0x0,0x46,0x72,0x65,0x71,0x75
	.DB  0x65,0x6E,0x63,0x79,0x9,0x3E,0x0,0x43
	.DB  0x6F,0x64,0x69,0x6E,0x67,0x9,0x3E,0x0
	.DB  0x4D,0x61,0x78,0x20,0x63,0x68,0x61,0x6E
	.DB  0x6E,0x65,0x6C,0x9,0x3E,0x0,0x54,0x69
	.DB  0x6D,0x65,0x72,0x9,0x3E,0x0,0x4D,0x6F
	.DB  0x64,0x65,0x73,0x20,0x63,0x6F,0x70,0x79
	.DB  0x9,0x3E,0x0,0x52,0x65,0x73,0x65,0x74
	.DB  0x9,0x0,0x41,0x69,0x6C,0x65,0x72,0x6F
	.DB  0x6E,0x73,0x9,0x3E,0x0,0x45,0x6C,0x65
	.DB  0x76,0x61,0x74,0x6F,0x72,0x9,0x3E,0x0
	.DB  0x54,0x68,0x72,0x6F,0x74,0x74,0x6C,0x65
	.DB  0x9,0x3E,0x0,0x52,0x75,0x64,0x64,0x65
	.DB  0x72,0x9,0x3E,0x0,0x53,0x77,0x69,0x74
	.DB  0x63,0x68,0x20,0x31,0x9,0x3E,0x0,0x53
	.DB  0x77,0x69,0x74,0x63,0x68,0x20,0x32,0x9
	.DB  0x3E,0x0,0x53,0x77,0x69,0x74,0x63,0x68
	.DB  0x20,0x33,0x9,0x3E,0x0,0x41,0x64,0x64
	.DB  0x20,0x50,0x72,0x6F,0x70,0x9,0x3E,0x0
	.DB  0x56,0x69,0x72,0x74,0x75,0x61,0x6C,0x20
	.DB  0x31,0x9,0x3E,0x0,0x56,0x69,0x72,0x74
	.DB  0x75,0x61,0x6C,0x20,0x32,0x9,0x3E,0x0
	.DB  0x53,0x65,0x74,0x20,0x74,0x69,0x6D,0x65
	.DB  0x72,0x9,0x3E,0x0,0x54,0x69,0x6D,0x65
	.DB  0x72,0x20,0x6D,0x6F,0x64,0x65,0x73,0x9
	.DB  0x3E,0x0,0x53,0x6F,0x75,0x6E,0x64,0x9
	.DB  0x3E,0x0,0x42,0x61,0x74,0x74,0x65,0x72
	.DB  0x79,0x9,0x3E,0x0,0x4D,0x6F,0x6E,0x69
	.DB  0x74,0x6F,0x72,0x9,0x3E,0x0,0x54,0x61
	.DB  0x63,0x68,0x6F,0x6D,0x65,0x74,0x65,0x72
	.DB  0x9,0x3E,0x0,0x56,0x65,0x72,0x73,0x69
	.DB  0x6F,0x6E,0x9,0x3E,0x0,0x43,0x68,0x61
	.DB  0x6E,0x6E,0x65,0x6C,0x20,0x31,0x9,0x3E
	.DB  0x0,0x43,0x68,0x61,0x6E,0x6E,0x65,0x6C
	.DB  0x20,0x32,0x9,0x3E,0x0,0x43,0x68,0x61
	.DB  0x6E,0x6E,0x65,0x6C,0x20,0x33,0x9,0x3E
	.DB  0x0,0x43,0x68,0x61,0x6E,0x6E,0x65,0x6C
	.DB  0x20,0x34,0x9,0x3E,0x0,0x43,0x68,0x61
	.DB  0x6E,0x6E,0x65,0x6C,0x20,0x35,0x9,0x3E
	.DB  0x0,0x43,0x68,0x61,0x6E,0x6E,0x65,0x6C
	.DB  0x20,0x36,0x9,0x3E,0x0,0x43,0x68,0x61
	.DB  0x6E,0x6E,0x65,0x6C,0x20,0x37,0x9,0x3E
	.DB  0x0,0x43,0x68,0x61,0x6E,0x6E,0x65,0x6C
	.DB  0x20,0x38,0x9,0x3E,0x0,0x50,0x6C,0x61
	.DB  0x6E,0x65,0x0,0x48,0x65,0x6C,0x69,0x0
	.DB  0x55,0x50,0x0,0x44,0x4F,0x57,0x4E,0x0
	.DB  0x41,0x55,0x54,0x4F,0x0,0x53,0x61,0x76
	.DB  0x65,0x0,0x43,0x61,0x6E,0x63,0x65,0x6C
	.DB  0x0,0x52,0x65,0x73,0x74,0x6F,0x72,0x65
	.DB  0x0,0x57,0x61,0x72,0x6E,0x69,0x6E,0x67
	.DB  0x0,0x41,0x6C,0x61,0x72,0x6D,0x0,0x4D
	.DB  0x61,0x78,0x0,0x52,0x65,0x76,0x65,0x72
	.DB  0x73,0x65,0x0,0x59,0x65,0x73,0x0,0x4E
	.DB  0x6F,0x20,0x0,0x52,0x61,0x74,0x65,0x0
	.DB  0x25,0x2D,0x69,0x0,0x44,0x52,0x61,0x74
	.DB  0x65,0x0,0x43,0x75,0x72,0x76,0x65,0x20
	.DB  0x3E,0x0,0x54,0x63,0x75,0x74,0x0,0x44
	.DB  0x65,0x6C,0x61,0x79,0x0,0x25,0x69,0x2E
	.DB  0x25,0x69,0x0,0x46,0x72,0x6F,0x6D,0x3A
	.DB  0x0,0x43,0x68,0x25,0x2D,0x69,0x20,0x25
	.DB  0x2D,0x69,0x0,0x54,0x43,0x75,0x74,0x0
	.DB  0x25,0x75,0x25,0x75,0x3A,0x25,0x75,0x25
	.DB  0x75,0x0,0x25,0x2D,0x69,0x2E,0x25,0x2D
	.DB  0x69,0x56,0x0,0x25,0x75,0x6D,0x41,0x0
	.DB  0x25,0x63,0x20,0x25,0x64,0x43,0x25,0x63
	.DB  0x0,0x2D,0x20,0x0,0x20,0x2D,0x0,0x4D
	.DB  0x61,0x69,0x6E,0x20,0x6D,0x65,0x6E,0x75
	.DB  0x0,0x43,0x68,0x61,0x6E,0x6E,0x65,0x6C
	.DB  0x3A,0x0,0x46,0x72,0x65,0x71,0x3A,0x0
	.DB  0x25,0x2D,0x69,0x3A,0x25,0x2D,0x69,0x0
	.DB  0x54,0x6F,0x3A,0x0,0x4F,0x4B,0x0,0x41
	.DB  0x72,0x65,0x20,0x79,0x6F,0x75,0x20,0x73
	.DB  0x75,0x72,0x65,0x3F,0x0,0x41,0x6C,0x6C
	.DB  0x20,0x63,0x68,0x61,0x6E,0x67,0x65,0x0
	.DB  0x4F,0x4E,0x0,0x4F,0x46,0x46,0x0,0x25
	.DB  0x2D,0x69,0x2E,0x25,0x2D,0x69,0x0,0x25
	.DB  0x75,0x20,0x52,0x50,0x4D,0x0
_0x40041:
	.DB  0x9C,0xBE,0xDE,0x0,0x22,0x42,0x64
_0x40000:
	.DB  0x4D,0x6F,0x64,0x65,0x6C,0x20,0x25,0x2D
	.DB  0x69,0x20,0x0
_0x20A005F:
	.DB  0x1
_0x20A0000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  0x06
	.DW  _0xEC*2

	.DW  0x0C
	.DW  _modeNames
	.DW  _0x20003*2

	.DW  0x06
	.DW  _modulNames
	.DW  _0x20004*2

	.DW  0x08
	.DW  _menuT0
	.DW  _0x20005*2

	.DW  0x14
	.DW  _menuT1
	.DW  _0x20006*2

	.DW  0x14
	.DW  _menuT2
	.DW  _0x20007*2

	.DW  0x04
	.DW  _menuT3
	.DW  _0x20008*2

	.DW  0x0A
	.DW  _menuT4
	.DW  _0x20009*2

	.DW  0x10
	.DW  _menuT5
	.DW  _0x2000A*2

	.DW  0x04
	.DW  _TypesModel
	.DW  _0x2000B*2

	.DW  0x06
	.DW  _Timer_modes1
	.DW  _0x2000C*2

	.DW  0x06
	.DW  _menuT7
	.DW  _0x2000D*2

	.DW  0x06
	.DW  _menuT8
	.DW  _0x2000E*2

	.DW  0x07
	.DW  _nod_val_S0020004000
	.DW  _0x40041*2

	.DW  0x01
	.DW  __seed_G105
	.DW  _0x20A005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

	OUT  RAMPZ,R24

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;#include <math.h>
;#include <spi.h>
;#include "def.h"
;#include "LCD_3320.h"
;#include "menu.h"
;#include "displ.h"
;#include "coder.h"
;
;//    EEPROM'
;eeprom MODEL_SET EEP_models[MAX_MODELS];
;eeprom unsigned char EEP_start_model;
;eeprom unsigned char EEP_f_sound_en;
;eeprom unsigned char EEP_BatCntr[3];
;eeprom int EEPR_ADmid[5], EEPR_ADmax[5], EEPR_ADmin[5];
;eeprom unsigned char EEP_FirstON, EEP_Calibration;
;eeprom signed int EPP_CalibrTemperature[2];
;//------------------------------------------------------
;//extern unsigned char WidthS, HeightS;
;
;signed int out_control[MAX_CONTRS];
;signed int ADmid[5];
;signed int ADmin[5];
;signed int ADmax[5];
;signed int out_ch[MAX_CHANS];
;//signed int VOut[5];
;MODEL_SET cur_model;
;unsigned char cur_model_ind;
;unsigned char cur_mode_ind;
;bit f_TCut;
;unsigned int cur_Batt;
;unsigned int cur_Power;
;unsigned int cur_Temperature;
;signed int dir_Temperature;
;unsigned char wd_Temperature;
;unsigned int div_trimmer;
;unsigned char f_l;
;unsigned char g_MainMenuMode;
;extern bit f_timer_en;
;unsigned int gRPMtmp=0;
;unsigned int gRPM[SIZE_RPM_BUFF];
;unsigned char gRPMn;
;signed int g_pos_d[3];
;unsigned char g_keys;
;#define F_SW1 1
;#define F_SW2_1 2
;#define F_SW2_2 4
;#define F_SW3 8
;#define F_DUAL1 0x10
;#define F_DUAL2 0x20
;#define F_DUAL3 0x40
;#define F_TCUT 0x80
;
;
;
;
;
;
;//------------------------------------------------------
;//------------------------------------------------------
;#define ADC_VREF_TYPE 0x00
;unsigned int read_adc(unsigned char adc_input)
; 0000 0041 {

	.CSEG
_read_adc:
; 0000 0042 ADMUX=adc_input|ADC_VREF_TYPE;
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
; 0000 0043 // Start the AD conversion
; 0000 0044 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0045 // Wait for the AD conversion to complete
; 0000 0046 while ((ADCSRA & 0x10)==0);
_0x3:
	SBIS 0x6,4
	RJMP _0x3
; 0000 0047 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0048 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 0049 }
;//------------------------------------------------------
;//------------------------------------------------------
;// (PD0-tachometr)
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 004E {
_ext_int0_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 004F gRPMtmp++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
; 0000 0050 if(gRPMtmp==1024) EIMSK&=0xfe;
	LDI  R30,LOW(1024)
	LDI  R31,HIGH(1024)
	CP   R30,R6
	CPC  R31,R7
	BRNE _0x6
	IN   R30,0x39
	ANDI R30,0xFE
	OUT  0x39,R30
; 0000 0051 }
_0x6:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;//------------------------------------------------------
;void TimerTachometer(void)
; 0000 0054 { // 50Hz
_TimerTachometer:
; 0000 0055 static unsigned char div;
; 0000 0056 div++;
	LDS  R30,_div_S0000002000
	SUBI R30,-LOW(1)
	STS  _div_S0000002000,R30
; 0000 0057 if(div>=25)
	LDS  R26,_div_S0000002000
	CPI  R26,LOW(0x19)
	BRLO _0x7
; 0000 0058   { // ~2Hz
; 0000 0059   div=0;
	LDI  R30,LOW(0)
	STS  _div_S0000002000,R30
; 0000 005A   gRPM[gRPMn]=gRPMtmp;
	MOV  R30,R4
	LDI  R26,LOW(_gRPM)
	LDI  R27,HIGH(_gRPM)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R6
	STD  Z+1,R7
; 0000 005B   if(++gRPMn>=SIZE_RPM_BUFF) gRPMn=0;
	INC  R4
	LDI  R30,LOW(3)
	CP   R4,R30
	BRLO _0x8
	CLR  R4
; 0000 005C   gRPMtmp=0;
_0x8:
	CLR  R6
	CLR  R7
; 0000 005D   }
; 0000 005E }
_0x7:
	RET
;//------------------------------------------------------
;//------------------------------------------------------
;__flash const unsigned int notes[]= {//Note A 1-okt;
;440, 466, 494, 523,    554,  588,  612,  660,    698,  740,  784,  830,
;880, 932, 988, 1064,   1108, 1176, 1224, 1320,   1396, 1480, 1568, 1660};
;BEEP_TRACK_DEF flash *beep_track;
;unsigned int beep_length;
;unsigned char beep_cnt;
;unsigned char beep_cntn;
;unsigned char beep_rep;
;unsigned int beep_freq;
;bit f_beep_fase;
;bit f_beep_timer;
;bit f_beep_EEP;
;bit f_beep_key;
;bit f_beep_trimmer;
;
;extern flash const BEEP_TRACK_DEF hello_sound[];
;//------------------------------------------------------
;void beep(BEEP_TRACK_DEF flash *note)
; 0000 0073 {
_beep:
; 0000 0074 unsigned long ln, freq;
; 0000 0075 
; 0000 0076 freq=notes[note->note]; freq*=2L;
	SBIW R28,8
;	*note -> Y+8
;	ln -> Y+4
;	freq -> Y+0
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LPM  R30,Z
	LDI  R26,LOW(_notes*2)
	LDI  R27,HIGH(_notes*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	CLR  R22
	CLR  R23
	CALL __PUTD1S0
	CALL __LSLD1
	CALL __PUTD1S0
; 0000 0077 ln=1500000L/freq; ln=65536L-ln;
	__GETD2N 0x16E360
	CALL __DIVD21U
	__PUTD1S 4
	__GETD2S 4
	__GETD1N 0x10000
	CALL __SUBD12
	__PUTD1S 4
; 0000 0078 beep_freq=ln;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	STS  _beep_freq,R30
	STS  _beep_freq+1,R31
; 0000 0079 TCNT3H=beep_freq>>8;
	LDS  R30,_beep_freq+1
	STS  137,R30
; 0000 007A TCNT3L=beep_freq & 0xff;
	LDS  R30,_beep_freq
	STS  136,R30
; 0000 007B ln=note->ms*freq; ln/=1000L;
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	CALL __GETW2PF
	CALL __GETD1S0
	CLR  R24
	CLR  R25
	CALL __MULD12U
	__PUTD1S 4
	__GETD2S 4
	__GETD1N 0x3E8
	CALL __DIVD21U
	__PUTD1S 4
; 0000 007C beep_length=ln;
	__GETWRS 12,13,4
; 0000 007D }
	ADIW R28,10
	RET
;//------------------------------------------------------
;// Timer 3 overflow interrupt service routine
;//------------------------------------------------------
;interrupt [TIM3_OVF] void timer3_ovf_isr(void)
; 0000 0082 {
_timer3_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0083 bit f_con;
; 0000 0084 
; 0000 0085 TCNT3H=beep_freq>>8;
;	f_con -> R15.0
	LDS  R30,_beep_freq+1
	STS  137,R30
; 0000 0086 TCNT3L=beep_freq & 0xff;
	LDS  R30,_beep_freq
	STS  136,R30
; 0000 0087 if(--beep_length==0)
	MOVW R30,R12
	SBIW R30,1
	MOVW R12,R30
	BRNE _0x9
; 0000 0088   {
; 0000 0089   f_con=0;
	CLT
	BLD  R15,0
; 0000 008A   if(++beep_cntn<beep_cnt)  f_con=1;
	LDS  R26,_beep_cntn
	SUBI R26,-LOW(1)
	STS  _beep_cntn,R26
	CP   R26,R8
	BRLO _0xE3
; 0000 008B   else if(beep_rep) { f_beep_fase=0; beep_rep--; beep_cntn=0; f_con=1; }
	LDS  R30,_beep_rep
	CPI  R30,0
	BREQ _0xC
	BLD  R2,7
	SUBI R30,LOW(1)
	STS  _beep_rep,R30
	LDI  R30,LOW(0)
	STS  _beep_cntn,R30
_0xE3:
	SET
	BLD  R15,0
; 0000 008C   if(f_con==0) { BUZ0; ETIMSK&=~0x4; return; }
_0xC:
	SBRC R15,0
	RJMP _0xD
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
	LDS  R30,125
	ANDI R30,0xFB
	STS  125,R30
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; 0000 008D   else beep((beep_track+beep_cntn));
_0xD:
	LDS  R30,_beep_cntn
	LDI  R26,LOW(3)
	MUL  R30,R26
	MOVW R30,R0
	ADD  R30,R10
	ADC  R31,R11
	ST   -Y,R31
	ST   -Y,R30
	RCALL _beep
; 0000 008E   }
; 0000 008F f_beep_fase=!f_beep_fase;
_0x9:
	LDI  R30,LOW(128)
	EOR  R2,R30
; 0000 0090 if(f_beep_fase) BUZ1; else BUZ0;
	SBRS R2,7
	RJMP _0xF
	LDS  R30,101
	ORI  R30,4
	RJMP _0xE4
_0xF:
	LDS  R30,101
	ANDI R30,0xFB
_0xE4:
	STS  101,R30
; 0000 0091 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;//------------------------------------------------------
;void beep_start(BEEP_TRACK_DEF flash *notes, unsigned char cnt, unsigned char rep)
; 0000 0094 {
_beep_start:
; 0000 0095 beep_track=notes;
;	*notes -> Y+2
;	cnt -> Y+1
;	rep -> Y+0
	__GETWRS 10,11,2
; 0000 0096 beep_cnt=cnt;
	LDD  R8,Y+1
; 0000 0097 beep_cntn=0;
	LDI  R30,LOW(0)
	STS  _beep_cntn,R30
; 0000 0098 beep_rep=rep;
	LD   R30,Y
	STS  _beep_rep,R30
; 0000 0099 beep(notes);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _beep
; 0000 009A ETIMSK|=0x4;
	LDS  R30,125
	ORI  R30,4
	STS  125,R30
; 0000 009B }
	ADIW R28,4
	RET
;//-------------------------------------------------------------
;//-------------------------------------------------------------
;//-------------------------------------------------------------
;unsigned int CHcalc (char ch_ind)
; 0000 00A0 {
_CHcalc:
; 0000 00A1 signed long ln, ret;
; 0000 00A2 unsigned char i;
; 0000 00A3 signed char *chans;
; 0000 00A4 
; 0000 00A5 chans=cur_model.modes[cur_mode_ind].chanels[ch_ind];
	SBIW R28,8
	CALL __SAVELOCR4
;	ch_ind -> Y+12
;	ln -> Y+8
;	ret -> Y+4
;	i -> R17
;	*chans -> R18,R19
	__POINTW2MN _cur_model,23
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	SUBI R26,LOW(-81)
	SBCI R27,HIGH(-81)
	LDD  R30,Y+12
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	MOVW R18,R30
; 0000 00A6 ret=2250; // 1,5 ms
	__GETD1N 0x8CA
	__PUTD1S 4
; 0000 00A7 for (i=0; i<MAX_CONTRS; i++)
	LDI  R17,LOW(0)
_0x12:
	CPI  R17,10
	BRLO PC+3
	JMP _0x13
; 0000 00A8   {
; 0000 00A9   if (chans[i]!=0)
	MOVW R26,R18
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	CPI  R30,0
	BRNE PC+3
	JMP _0x14
; 0000 00AA     { ln=out_control[i]; ln*=chans[i]; ln/=100; ret+=ln; }
	MOV  R30,R17
	LDI  R26,LOW(_out_control)
	LDI  R27,HIGH(_out_control)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	__PUTD1S 8
	MOVW R26,R18
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	__GETD2S 8
	CALL __CBD1
	CALL __MULD12
	__PUTD1S 8
	__GETD2S 8
	__GETD1N 0x64
	CALL __DIVD21
	__PUTD1S 8
	__GETD2S 4
	CALL __ADDD12
	__PUTD1S 4
; 0000 00AB   }
_0x14:
	SUBI R17,-1
	RJMP _0x12
_0x13:
; 0000 00AC if (ret>3150) ret=3150; //   2,1 
	__GETD2S 4
	__CPD2N 0xC4F
	BRLT _0x15
	__GETD1N 0xC4E
	__PUTD1S 4
; 0000 00AD if (ret<1350) ret=1350; //   0,9 
_0x15:
	__GETD2S 4
	__CPD2N 0x546
	BRGE _0x16
	__GETD1N 0x546
	__PUTD1S 4
; 0000 00AE return (unsigned int)ret;
_0x16:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CALL __LOADLOCR4
	ADIW R28,13
	RET
; 0000 00AF }
;//-------------------------------------------------------------
;signed int interpol(signed int val, signed char* nodes, )
; 0000 00B2 {
_interpol:
; 0000 00B3 unsigned char n;
; 0000 00B4 signed int n1, n2, vmin;
; 0000 00B5 signed long ln;
; 0000 00B6 
; 0000 00B7 ln=val; ln*=6; n=ln/1500;
	SBIW R28,6
	CALL __SAVELOCR6
;	val -> Y+14
;	*nodes -> Y+12
;	n -> R17
;	n1 -> R18,R19
;	n2 -> R20,R21
;	vmin -> Y+10
;	ln -> Y+6
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	CALL __CWD1
	__PUTD1S 6
	__GETD2N 0x6
	CALL __MULD12
	__PUTD1S 6
	__GETD2S 6
	__GETD1N 0x5DC
	CALL __DIVD21
	MOV  R17,R30
; 0000 00B8 n1=*(nodes+n); n1=(n1*75)/10;
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R18,R30
	MOVW R30,R18
	LDI  R26,LOW(75)
	LDI  R27,HIGH(75)
	CALL __MULW12
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R18,R30
; 0000 00B9 n2=*(nodes+n+1); n2=(n2*75)/10;
	MOV  R30,R17
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R20,R30
	MOVW R30,R20
	LDI  R26,LOW(75)
	LDI  R27,HIGH(75)
	CALL __MULW12
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R20,R30
; 0000 00BA vmin=n; vmin*=250;
	MOV  R30,R17
	LDI  R31,0
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R26,LOW(250)
	LDI  R27,HIGH(250)
	CALL __MULW12
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0000 00BB ln=(val-vmin); ln*=(n2-n1); ln/=250;
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	__PUTD1S 6
	MOVW R30,R20
	SUB  R30,R18
	SBC  R31,R19
	__GETD2S 6
	CALL __CWD1
	CALL __MULD12
	__PUTD1S 6
	__GETD2S 6
	__GETD1N 0xFA
	CALL __DIVD21
	__PUTD1S 6
; 0000 00BC return ln + n1;
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	CALL __LOADLOCR6
	ADIW R28,16
	RET
; 0000 00BD }
;//-------------------------------------------------------------
;signed int rate_calc(signed int val, unsigned char min, unsigned char max)
; 0000 00C0 {
_rate_calc:
; 0000 00C1 unsigned char rate;
; 0000 00C2 signed long v;
; 0000 00C3 
; 0000 00C4 if(val<0) rate=min;
	SBIW R28,4
	ST   -Y,R17
;	val -> Y+7
;	min -> Y+6
;	max -> Y+5
;	rate -> R17
;	v -> Y+1
	LDD  R26,Y+8
	TST  R26
	BRPL _0x17
	LDD  R17,Y+6
; 0000 00C5 else rate=max;
	RJMP _0x18
_0x17:
	LDD  R17,Y+5
; 0000 00C6 v=val; v*=rate; v/=100;
_0x18:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	CALL __CWD1
	__PUTD1S 1
	MOV  R30,R17
	__GETD2S 1
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __MULD12
	__PUTD1S 1
	__GETD2S 1
	__GETD1N 0x64
	CALL __DIVD21
	__PUTD1S 1
; 0000 00C7 return v;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R17,Y+0
	ADIW R28,9
	RET
; 0000 00C8 }
;//-------------------------------------------------------------
;unsigned char ReadKeys(void)
; 0000 00CB {
_ReadKeys:
; 0000 00CC unsigned char f;
; 0000 00CD 
; 0000 00CE f=0;
	ST   -Y,R17
;	f -> R17
	LDI  R17,LOW(0)
; 0000 00CF if(!SW1) f|=F_SW1;
	SBIS 0x1,4
	ORI  R17,LOW(1)
; 0000 00D0 if(!SW2_1) f|=F_SW2_1;
	SBIS 0x1,3
	ORI  R17,LOW(2)
; 0000 00D1 if(!SW2_2) f|=F_SW2_2;
	SBIS 0x1,2
	ORI  R17,LOW(4)
; 0000 00D2 if(!SW3) f|=F_SW3;
	SBIS 0x1,5
	ORI  R17,LOW(8)
; 0000 00D3 if(!DUAL_ail) f|=F_DUAL1;
	SBIS 0x13,1
	ORI  R17,LOW(16)
; 0000 00D4 if(!DUAL_elev) f|=F_DUAL2;
	SBIS 0x13,0
	ORI  R17,LOW(32)
; 0000 00D5 if(!DUAL_rud) f|=F_DUAL3;
	SBIS 0x13,2
	ORI  R17,LOW(64)
; 0000 00D6 if(!Tcut_KEY) f|=F_TCUT;
	SBIS 0x13,3
	ORI  R17,LOW(128)
; 0000 00D7 return f;
	MOV  R30,R17
	LD   R17,Y+
	RET
; 0000 00D8 }
;//-------------------------------------------------------------
;void Calc (void)
; 0000 00DB { // 50Hz (20ms)
_Calc:
	PUSH R15
; 0000 00DC static unsigned char div_trim;
; 0000 00DD signed char *trim;
; 0000 00DE signed int input[10];
; 0000 00DF unsigned int i, n;
; 0000 00E0 signed long vl;
; 0000 00E1 const unsigned char acntr[]={ ch_Ailerons, ch_Elevator, ch_Throttle, ch_Rudder, ch_Rpop_contr };
; 0000 00E2 signed int vi;
; 0000 00E3 unsigned char mn, mx;
; 0000 00E4 DEF_MODE *mode;
; 0000 00E5 unsigned char f_dual[3];
; 0000 00E6 unsigned char keys;
; 0000 00E7 bit f;
; 0000 00E8 
; 0000 00E9 //  
; 0000 00EA if(!MODE_KEY2)           i=0;
	SBIW R28,39
	LDI  R30,LOW(6)
	STD  Y+10,R30
	LDI  R30,LOW(5)
	STD  Y+11,R30
	LDI  R30,LOW(4)
	STD  Y+12,R30
	LDI  R30,LOW(3)
	STD  Y+13,R30
	LDI  R30,LOW(2)
	STD  Y+14,R30
	CALL __SAVELOCR6
;	*trim -> R16,R17
;	input -> Y+25
;	i -> R18,R19
;	n -> R20,R21
;	vl -> Y+21
;	acntr -> Y+16
;	vi -> Y+14
;	mn -> Y+13
;	mx -> Y+12
;	*mode -> Y+10
;	f_dual -> Y+7
;	keys -> Y+6
;	f -> R15.0
	SBIC 0x1,7
	RJMP _0x21
	__GETWRN 18,19,0
; 0000 00EB else if(!MODE_KEY1)      i=2;
	RJMP _0x22
_0x21:
	SBIC 0x1,6
	RJMP _0x23
	__GETWRN 18,19,2
; 0000 00EC else                     i=1;
	RJMP _0x24
_0x23:
	__GETWRN 18,19,1
; 0000 00ED if(cur_mode_ind!=i) { BEEP; save_trimmer(); cur_mode_ind=i; }
_0x24:
_0x22:
	MOVW R30,R18
	LDS  R26,_cur_mode_ind
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x25
	SET
	BLD  R2,4
	CALL _save_trimmer
	STS  _cur_mode_ind,R18
; 0000 00EE 
; 0000 00EF // 
; 0000 00F0 trim=cur_model.modes[cur_mode_ind].trimmers;
_0x25:
	__POINTW2MN _cur_model,23
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	SUBI R30,LOW(-161)
	SBCI R31,HIGH(-161)
	MOVW R16,R30
; 0000 00F1 if (div_trim)
	LDS  R30,_div_trim_S000000A000
	CPI  R30,0
	BRNE PC+3
	JMP _0x26
; 0000 00F2   {
; 0000 00F3   f=0;
	CLT
	BLD  R15,0
; 0000 00F4   if(!trim_0up && trim[0]<80) { trim[0]++; f=1;  }
	SBIC 0x19,3
	RJMP _0x28
	MOVW R26,R16
	LD   R26,X
	CPI  R26,LOW(0x50)
	BRLT _0x29
_0x28:
	RJMP _0x27
_0x29:
	MOVW R26,R16
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00F5   if(!trim_0down && trim[0]>-80) { trim[0]--;  f=1; }
_0x27:
	SBIC 0x19,0
	RJMP _0x2B
	MOVW R26,R16
	LD   R26,X
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
	MOVW R26,R16
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00F6   if(!trim_1up && trim[1]<80) { trim[1]++; f=1; }
_0x2A:
	SBIC 0x19,1
	RJMP _0x2E
	MOVW R30,R16
	LDD  R26,Z+1
	CPI  R26,LOW(0x50)
	BRLT _0x2F
_0x2E:
	RJMP _0x2D
_0x2F:
	MOVW R26,R16
	ADIW R26,1
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00F7   if(!trim_1down && trim[1]>-80) { trim[1]--; f=1; }
_0x2D:
	SBIC 0x19,2
	RJMP _0x31
	MOVW R30,R16
	LDD  R26,Z+1
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x32
_0x31:
	RJMP _0x30
_0x32:
	MOVW R26,R16
	ADIW R26,1
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00F8   if(!trim_2up && trim[2]<80) { trim[2]++;   f=1; }
_0x30:
	SBIC 0x19,5
	RJMP _0x34
	MOVW R30,R16
	LDD  R26,Z+2
	CPI  R26,LOW(0x50)
	BRLT _0x35
_0x34:
	RJMP _0x33
_0x35:
	MOVW R26,R16
	ADIW R26,2
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00F9   if(!trim_2down && trim[2]>-80) { trim[2]--; f=1; }
_0x33:
	SBIC 0x19,4
	RJMP _0x37
	MOVW R30,R16
	LDD  R26,Z+2
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x38
_0x37:
	RJMP _0x36
_0x38:
	MOVW R26,R16
	ADIW R26,2
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00FA   if(!trim_3up && trim[3]<80) { trim[3]++; f=1; }
_0x36:
	SBIC 0x19,7
	RJMP _0x3A
	MOVW R30,R16
	LDD  R26,Z+3
	CPI  R26,LOW(0x50)
	BRLT _0x3B
_0x3A:
	RJMP _0x39
_0x3B:
	MOVW R26,R16
	ADIW R26,3
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00FB   if(!trim_3down && trim[3]>-80) { trim[3]--; f=1; }
_0x39:
	SBIC 0x19,6
	RJMP _0x3D
	MOVW R30,R16
	LDD  R26,Z+3
	LDI  R30,LOW(176)
	CP   R30,R26
	BRLT _0x3E
_0x3D:
	RJMP _0x3C
_0x3E:
	MOVW R26,R16
	ADIW R26,3
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	SET
	BLD  R15,0
; 0000 00FC   if(f) { f_beep_trimmer=1; div_trimmer=1500; }
_0x3C:
	SBRS R15,0
	RJMP _0x3F
	SET
	BLD  R2,5
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	STS  _div_trimmer,R30
	STS  _div_trimmer+1,R31
; 0000 00FD   }
_0x3F:
; 0000 00FE div_trim=!div_trim;
_0x26:
	LDS  R30,_div_trim_S000000A000
	CALL __LNEGB1
	STS  _div_trim_S000000A000,R30
; 0000 00FF 
; 0000 0100 mode=&cur_model.modes[cur_mode_ind];
	__POINTW2MN _cur_model,23
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0000 0101 //  
; 0000 0102 for(i=0; i<5; i++)
	__GETWRN 18,19,0
_0x41:
	__CPWRN 18,19,5
	BRLO PC+3
	JMP _0x42
; 0000 0103   {
; 0000 0104   n=i; if(i==4) n=7;
	MOVW R20,R18
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x43
	__GETWRN 20,21,7
; 0000 0105   vl=read_adc(acntr[i]);
_0x43:
	MOVW R26,R28
	ADIW R26,16
	ADD  R26,R18
	ADC  R27,R19
	LD   R30,X
	ST   -Y,R30
	RCALL _read_adc
	CLR  R22
	CLR  R23
	__PUTD1S 21
; 0000 0106   if(vl<ADmid[i])
	MOVW R30,R18
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__GETD2S 21
	CALL __CWD1
	CALL __CPD21
	BRLT PC+3
	JMP _0x44
; 0000 0107     {
; 0000 0108     if(ADmin[i]>vl) ADmin[i]=vl;
	MOVW R30,R18
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 21
	CALL __CWD2
	CALL __CPD12
	BRGE _0x45
	MOVW R30,R18
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	STD  Z+0,R26
	STD  Z+1,R27
; 0000 0109     vl-=ADmin[i]; vl*=750; input[n]=vl/(ADmid[i]-ADmin[i]);
_0x45:
	MOVW R30,R18
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__GETD2S 21
	CALL __CWD1
	CALL __SUBD21
	__PUTD2S 21
	__GETD1S 21
	__GETD2N 0x2EE
	CALL __MULD12
	__PUTD1S 21
	MOVW R30,R20
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R30,R18
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOVW R30,R18
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOVW R30,R0
	SUB  R30,R26
	SBC  R31,R27
	__GETD2S 21
	CALL __CWD1
	CALL __DIVD21
	POP  R26
	POP  R27
	RJMP _0xE5
; 0000 010A     }
; 0000 010B   else
_0x44:
; 0000 010C     {
; 0000 010D     if(ADmax[i]<vl) ADmax[i]=vl;
	MOVW R30,R18
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	__GETD1S 21
	CALL __CWD2
	CALL __CPD21
	BRGE _0x47
	MOVW R30,R18
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	STD  Z+0,R26
	STD  Z+1,R27
; 0000 010E     vl-=ADmid[i]; vl*=750; input[n]=750+(vl/(ADmax[i]-ADmid[i]));
_0x47:
	MOVW R30,R18
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__GETD2S 21
	CALL __CWD1
	CALL __SUBD21
	__PUTD2S 21
	__GETD1S 21
	__GETD2N 0x2EE
	CALL __MULD12
	__PUTD1S 21
	MOVW R30,R20
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R30,R18
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOVW R30,R18
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R30
	MOVW R30,R0
	SUB  R30,R26
	SBC  R31,R27
	__GETD2S 21
	CALL __CWD1
	CALL __DIVD21
	SUBI R30,LOW(-750)
	SBCI R31,HIGH(-750)
	POP  R26
	POP  R27
_0xE5:
	ST   X+,R30
	ST   X,R31
; 0000 010F     }
; 0000 0110   }
	__ADDWRN 18,19,1
	RJMP _0x41
_0x42:
; 0000 0111 
; 0000 0112 keys=ReadKeys(); if(keys!=g_keys) { BEEP; g_keys=keys; }
	RCALL _ReadKeys
	STD  Y+6,R30
	LDD  R26,Y+6
	CP   R9,R26
	BREQ _0x48
	SET
	BLD  R2,4
	LDD  R9,Y+6
; 0000 0113 if(keys & F_SW1) input[4]=0; else input[4]=1500;
_0x48:
	LDD  R30,Y+6
	ANDI R30,LOW(0x1)
	BREQ _0x49
	LDI  R30,LOW(0)
	STD  Y+33,R30
	STD  Y+33+1,R30
	RJMP _0x4A
_0x49:
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	STD  Y+33,R30
	STD  Y+33+1,R31
; 0000 0114 if(keys & F_SW2_1) input[5]=0;
_0x4A:
	LDD  R30,Y+6
	ANDI R30,LOW(0x2)
	BREQ _0x4B
	LDI  R30,LOW(0)
	STD  Y+35,R30
	STD  Y+35+1,R30
; 0000 0115 else if(keys & F_SW2_2) input[5]=1500;
	RJMP _0x4C
_0x4B:
	LDD  R30,Y+6
	ANDI R30,LOW(0x4)
	BREQ _0x4D
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	RJMP _0xE6
; 0000 0116 else input[5]=750;
_0x4D:
	LDI  R30,LOW(750)
	LDI  R31,HIGH(750)
_0xE6:
	STD  Y+35,R30
	STD  Y+35+1,R31
; 0000 0117 if(keys & F_SW3) input[6]=0; else input[6]=1500;
_0x4C:
	LDD  R30,Y+6
	ANDI R30,LOW(0x8)
	BREQ _0x4F
	LDI  R30,LOW(0)
	STD  Y+37,R30
	STD  Y+37+1,R30
	RJMP _0x50
_0x4F:
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	STD  Y+37,R30
	STD  Y+37+1,R31
; 0000 0118 for(i=0; i<3; i++)
_0x50:
	__GETWRN 18,19,0
_0x52:
	__CPWRN 18,19,3
	BRLO PC+3
	JMP _0x53
; 0000 0119   {
; 0000 011A   vi=mode->contr_d[i].delay;
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,52
	MOVW R30,R18
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R30,X
	LDI  R31,0
	STD  Y+14,R30
	STD  Y+14+1,R31
; 0000 011B   if(vi==0) g_pos_d[i]=input[4+i];
	SBIW R30,0
	BRNE _0x54
	MOVW R30,R18
	LDI  R26,LOW(_g_pos_d)
	LDI  R27,HIGH(_g_pos_d)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 011C   else if(g_pos_d[i]!=input[4+i])
	RJMP _0x55
_0x54:
	MOVW R30,R18
	LDI  R26,LOW(_g_pos_d)
	LDI  R27,HIGH(_g_pos_d)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CP   R30,R0
	CPC  R31,R1
	BRNE PC+3
	JMP _0x56
; 0000 011D     {
; 0000 011E     vl=g_pos_d[i]; vl*=vi; vl/=(300/2); vl++; vl/=2;
	MOVW R30,R18
	LDI  R26,LOW(_g_pos_d)
	LDI  R27,HIGH(_g_pos_d)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	__PUTD1S 21
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	__GETD2S 21
	CALL __CWD1
	CALL __MULD12
	__PUTD1S 21
	__GETD2S 21
	__GETD1N 0x96
	CALL __DIVD21
	__PUTD1S 21
	__SUBD1N -1
	__PUTD1S 21
	__GETD2S 21
	__GETD1N 0x2
	CALL __DIVD21
	__PUTD1S 21
; 0000 011F     if(g_pos_d[i]<input[4+i])
	MOVW R30,R18
	LDI  R26,LOW(_g_pos_d)
	LDI  R27,HIGH(_g_pos_d)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CP   R0,R30
	CPC  R1,R31
	BRLT PC+3
	JMP _0x57
; 0000 0120       {
; 0000 0121       vl++; vl*=(300*2); vl/=vi; vl++; vl/=2;
	__GETD1S 21
	__SUBD1N -1
	__PUTD1S 21
	__GETD2N 0x258
	CALL __MULD12
	__PUTD1S 21
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	__GETD2S 21
	CALL __CWD1
	CALL __DIVD21
	__PUTD1S 21
	__SUBD1N -1
	__PUTD1S 21
	__GETD2S 21
	__GETD1N 0x2
	CALL __DIVD21
	__PUTD1S 21
; 0000 0122       if(vl>input[4+i]) vl=input[4+i];
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__GETD2S 21
	CALL __CWD1
	CALL __CPD12
	BRGE _0x58
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	__PUTD1S 21
; 0000 0123       }
_0x58:
; 0000 0124     else
	RJMP _0x59
_0x57:
; 0000 0125       {
; 0000 0126       vl--; vl*=(300*2); vl/=vi; vl++; vl/=2;
	__GETD1S 21
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__PUTD1S 21
	__GETD2N 0x258
	CALL __MULD12
	__PUTD1S 21
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	__GETD2S 21
	CALL __CWD1
	CALL __DIVD21
	__PUTD1S 21
	__SUBD1N -1
	__PUTD1S 21
	__GETD2S 21
	__GETD1N 0x2
	CALL __DIVD21
	__PUTD1S 21
; 0000 0127       if(vl<input[4+i]) vl=input[4+i];
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__GETD2S 21
	CALL __CWD1
	CALL __CPD21
	BRGE _0x5A
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CALL __CWD1
	__PUTD1S 21
; 0000 0128       }
_0x5A:
_0x59:
; 0000 0129     g_pos_d[i]=vl; input[4+i]=vl;
	MOVW R30,R18
	LDI  R26,LOW(_g_pos_d)
	LDI  R27,HIGH(_g_pos_d)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	STD  Z+0,R26
	STD  Z+1,R27
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	STD  Z+0,R26
	STD  Z+1,R27
; 0000 012A     }
; 0000 012B   input[4+i]-=750;
_0x56:
_0x55:
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	SUBI R30,LOW(750)
	SBCI R31,HIGH(750)
	ST   -X,R31
	ST   -X,R30
; 0000 012C   }
	__ADDWRN 18,19,1
	RJMP _0x52
_0x53:
; 0000 012D input[8]=input[mode->contr_v[0].from];
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R30,Z+63
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+41,R30
	STD  Y+41+1,R31
; 0000 012E input[9]=input[mode->contr_v[1].from];
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUBI R30,LOW(-73)
	SBCI R31,HIGH(-73)
	LD   R30,Z
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	STD  Y+43,R30
	STD  Y+43+1,R31
; 0000 012F //   
; 0000 0130 if (keys & F_TCUT) f_TCut=1; else f_TCut=0;
	LDD  R30,Y+6
	ANDI R30,LOW(0x80)
	BREQ _0x5B
	SET
	RJMP _0xE7
_0x5B:
	CLT
_0xE7:
	BLD  R2,1
; 0000 0131 //  
; 0000 0132 f_dual[0]=(keys & F_DUAL1);
	LDD  R30,Y+6
	ANDI R30,LOW(0x10)
	STD  Y+7,R30
; 0000 0133 f_dual[1]=(keys & F_DUAL2);
	LDD  R30,Y+6
	ANDI R30,LOW(0x20)
	STD  Y+8,R30
; 0000 0134 f_dual[2]=(keys & F_DUAL3);
	LDD  R30,Y+6
	ANDI R30,LOW(0x40)
	STD  Y+9,R30
; 0000 0135 //  
; 0000 0136 for(i=0; i<3; i++)
	__GETWRN 18,19,0
_0x5E:
	__CPWRN 18,19,3
	BRLO PC+3
	JMP _0x5F
; 0000 0137   {
; 0000 0138   n=i; if(i==2) n++;
	MOVW R20,R18
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x60
	__ADDWRN 20,21,1
; 0000 0139   vi=interpol(input[n], mode->contr_ab[i].cur_nodes);
_0x60:
	MOVW R30,R20
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	__GETWRS 22,23,12
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL _interpol
	STD  Y+14,R30
	STD  Y+14+1,R31
; 0000 013A   if(f_dual[i]) { mn=mode->contr_ab[i].minDRates; mx=mode->contr_ab[i].maxDRates; }
	MOVW R26,R28
	ADIW R26,7
	ADD  R26,R18
	ADC  R27,R19
	LD   R30,X
	CPI  R30,0
	BREQ _0x61
	MOVW R30,R18
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R30,X
	STD  Y+13,R30
	MOVW R30,R18
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,3
	RJMP _0xE8
; 0000 013B   else { mn=mode->contr_ab[i].minRates; mx=mode->contr_ab[i].maxRates; }
_0x61:
	MOVW R30,R18
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	STD  Y+13,R30
	MOVW R30,R18
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
_0xE8:
	LD   R30,X
	STD  Y+12,R30
; 0000 013C   out_control[n]=rate_calc(vi, mn, mx);
	MOVW R30,R20
	LDI  R26,LOW(_out_control)
	LDI  R27,HIGH(_out_control)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	RCALL _rate_calc
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
; 0000 013D   vi=mode->trimmers[n]; vi*=5; out_control[n]+=vi;
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUBI R30,LOW(-161)
	SBCI R31,HIGH(-161)
	ADD  R30,R20
	ADC  R31,R21
	LD   R30,Z
	LDI  R31,0
	SBRC R30,7
	SER  R31
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12
	STD  Y+14,R30
	STD  Y+14+1,R31
	MOVW R30,R20
	LDI  R26,LOW(_out_control)
	LDI  R27,HIGH(_out_control)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R26,R30
	CALL __GETW1P
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 013E   }
	__ADDWRN 18,19,1
	RJMP _0x5E
_0x5F:
; 0000 013F if(f_TCut) { vi=mode->contr_tr.tcut; vi*=-75; out_control[2]=vi/10; }
	SBRS R2,1
	RJMP _0x63
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R30,Z+35
	LDI  R31,0
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDI  R26,LOW(65461)
	LDI  R27,HIGH(65461)
	CALL __MULW12
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RJMP _0xE9
; 0000 0140 else
_0x63:
; 0000 0141   {
; 0000 0142   vi=interpol(input[2], mode->contr_tr.cur_nodes);
	LDD  R30,Y+29
	LDD  R31,Y+29+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,36
	ST   -Y,R31
	ST   -Y,R30
	RCALL _interpol
	STD  Y+14,R30
	STD  Y+14+1,R31
; 0000 0143   out_control[2]=rate_calc(vi, mode->contr_tr.minRates, mode->contr_tr.maxRates);
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	LDD  R26,Z+33
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	LDD  R30,Z+34
	ST   -Y,R30
	RCALL _rate_calc
	__PUTW1MN _out_control,4
; 0000 0144   vi=mode->trimmers[2]; vi*=5; out_control[2]+=vi;
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUBI R30,LOW(-163)
	SBCI R31,HIGH(-163)
	LD   R30,Z
	LDI  R31,0
	SBRC R30,7
	SER  R31
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12
	STD  Y+14,R30
	STD  Y+14+1,R31
	__GETW1MN _out_control,4
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
_0xE9:
	__PUTW1MN _out_control,4
; 0000 0145   }
; 0000 0146 if(cur_model.timer_mode==2) { if(!f_TCut && input[2]>150) f_timer_en=1; else f_timer_en=0; }
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x18)
	CPI  R30,LOW(0x10)
	BRNE _0x65
	SBRC R2,1
	RJMP _0x67
	LDD  R26,Y+29
	LDD  R27,Y+29+1
	CPI  R26,LOW(0x97)
	LDI  R30,HIGH(0x97)
	CPC  R27,R30
	BRGE _0x68
_0x67:
	RJMP _0x66
_0x68:
	SET
	RJMP _0xEA
_0x66:
	CLT
_0xEA:
	BLD  R2,6
; 0000 0147 
; 0000 0148 for(i=0; i<3; i++)
_0x65:
	__GETWRN 18,19,0
_0x6B:
	__CPWRN 18,19,3
	BRSH _0x6C
; 0000 0149   out_control[4+i]=rate_calc(input[4+i], mode->contr_d[i].minRates, mode->contr_d[i].maxRates);
	MOVW R30,R18
	ADIW R30,4
	LDI  R26,LOW(_out_control)
	LDI  R27,HIGH(_out_control)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R30,R18
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,52
	MOVW R30,R18
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	ADIW R26,52
	MOVW R30,R18
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LD   R30,X
	ST   -Y,R30
	RCALL _rate_calc
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
	__ADDWRN 18,19,1
	RJMP _0x6B
_0x6C:
; 0000 014B vi=interpol(input[7], mode->contr_ap.cur_nodes);
	LDD  R30,Y+39
	LDD  R31,Y+39+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,45
	ST   -Y,R31
	ST   -Y,R30
	RCALL _interpol
	STD  Y+14,R30
	STD  Y+14+1,R31
; 0000 014C out_control[7]=rate_calc(vi, mode->contr_ap.minRates, mode->contr_ap.maxRates);
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	LDD  R26,Z+43
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	LDD  R30,Z+44
	ST   -Y,R30
	RCALL _rate_calc
	__PUTW1MN _out_control,14
; 0000 014D 
; 0000 014E for(i=0; i<2; i++)
	__GETWRN 18,19,0
_0x6E:
	__CPWRN 18,19,2
	BRLO PC+3
	JMP _0x6F
; 0000 014F   {
; 0000 0150   vi=interpol(input[8+i], mode->contr_v[i].cur_nodes);
	MOVW R30,R18
	ADIW R30,8
	MOVW R26,R28
	ADIW R26,25
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,61
	MOVW R30,R18
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL _interpol
	STD  Y+14,R30
	STD  Y+14+1,R31
; 0000 0151   out_control[8+i]=rate_calc(vi, mode->contr_v[i].minRates, mode->contr_v[i].maxRates);
	MOVW R30,R18
	ADIW R30,8
	LDI  R26,LOW(_out_control)
	LDI  R27,HIGH(_out_control)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,61
	MOVW R30,R18
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	ADIW R26,61
	MOVW R30,R18
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LD   R30,X
	ST   -Y,R30
	RCALL _rate_calc
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
; 0000 0152   }
	__ADDWRN 18,19,1
	RJMP _0x6E
_0x6F:
; 0000 0153 
; 0000 0154 for(i=0; i<MAX_CONTRS; i++) out_control[i]*=cur_model.contrs_reverse[i];
	__GETWRN 18,19,0
_0x71:
	__CPWRN 18,19,10
	BRSH _0x72
	MOVW R30,R18
	LDI  R26,LOW(_out_control)
	LDI  R27,HIGH(_out_control)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	MOVW R26,R30
	CALL __GETW1P
	MOVW R26,R30
	__POINTW1MN _cur_model,13
	ADD  R30,R18
	ADC  R31,R19
	LD   R30,Z
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CALL __MULW12
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
	__ADDWRN 18,19,1
	RJMP _0x71
_0x72:
; 0000 0155 }
	CALL __LOADLOCR6
	ADIW R28,45
	POP  R15
	RET
;//------------------------------------------------------
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 0158 {
_timer1_compa_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0159 static unsigned char nb;
; 0000 015A static unsigned int sum;
; 0000 015B unsigned int out;
; 0000 015C 
; 0000 015D if (nb<cur_model.num_ch)
	ST   -Y,R17
	ST   -Y,R16
;	out -> R16,R17
	__GETB1MN _cur_model,11
	ANDI R30,LOW(0xF)
	LDS  R26,_nb_S000000B000
	CP   R26,R30
	BRSH _0x73
; 0000 015E   {
; 0000 015F   out=CHcalc(nb);
	LDS  R30,_nb_S000000B000
	ST   -Y,R30
	RCALL _CHcalc
	MOVW R16,R30
; 0000 0160   ICR1H=out>>8;        //  
	MOV  R30,R17
	ANDI R31,HIGH(0x0)
	OUT  0x27,R30
; 0000 0161   ICR1L=out&0xff;
	MOV  R30,R16
	OUT  0x26,R30
; 0000 0162   out_ch[nb]=out;
	LDS  R30,_nb_S000000B000
	LDI  R26,LOW(_out_ch)
	LDI  R27,HIGH(_out_ch)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R16
	STD  Z+1,R17
; 0000 0163   sum+=out; nb++;
	MOVW R30,R16
	LDS  R26,_sum_S000000B000
	LDS  R27,_sum_S000000B000+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _sum_S000000B000,R30
	STS  _sum_S000000B000+1,R31
	LDS  R30,_nb_S000000B000
	SUBI R30,-LOW(1)
	STS  _nb_S000000B000,R30
; 0000 0164   if(nb==1) TimerTachometer();
	LDS  R26,_nb_S000000B000
	CPI  R26,LOW(0x1)
	BRNE _0x74
	CALL _TimerTachometer
; 0000 0165   }
_0x74:
; 0000 0166 else
	RJMP _0x75
_0x73:
; 0000 0167   {
; 0000 0168   out=30000-sum; //1500,000/30000= 50Hz
	LDS  R26,_sum_S000000B000
	LDS  R27,_sum_S000000B000+1
	LDI  R30,LOW(30000)
	LDI  R31,HIGH(30000)
	SUB  R30,R26
	SBC  R31,R27
	MOVW R16,R30
; 0000 0169   ICR1H=out>>8;
	MOV  R30,R17
	ANDI R31,HIGH(0x0)
	OUT  0x27,R30
; 0000 016A   ICR1L=out&0xff;     //  
	MOV  R30,R16
	OUT  0x26,R30
; 0000 016B   nb=0; sum=0;
	LDI  R30,LOW(0)
	STS  _nb_S000000B000,R30
	STS  _sum_S000000B000,R30
	STS  _sum_S000000B000+1,R30
; 0000 016C #asm("sei")
	sei
; 0000 016D   f_l++;
	INC  R5
; 0000 016E   Calc();
	RCALL _Calc
; 0000 016F   TimerOn();
	CALL _TimerOn
; 0000 0170   f_l++;
	INC  R5
; 0000 0171   }
_0x75:
; 0000 0172 }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;//------------------------------------------------------
;//------------------------------------------------------
;//------------------------------------------------------
;void main(void)
; 0000 0177 {
_main:
; 0000 0178 unsigned char i;
; 0000 0179 // Input/Output Ports initialization
; 0000 017A // Port A initialization
; 0000 017B // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 017C // State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P
; 0000 017D PORTA=0xFF;
;	i -> R17
	LDI  R30,LOW(255)
	OUT  0x1B,R30
; 0000 017E DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 017F // Port B initialization
; 0000 0180 // Func7=Out Func6=In Func5=Out Func4=In Func3=In Func2=Out Func1=Out Func0=In
; 0000 0181 // State7=0 State6=T State5=0 State4=T State3=T State2=0 State1=0 State0=T
; 0000 0182 PORTB=0x01;
	LDI  R30,LOW(1)
	OUT  0x18,R30
; 0000 0183 DDRB=0xA6;
	LDI  R30,LOW(166)
	OUT  0x17,R30
; 0000 0184 // Port C initialization
; 0000 0185 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 0186 // State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T
; 0000 0187 PORTC=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
; 0000 0188 DDRC=0xF0;
	LDI  R30,LOW(240)
	OUT  0x14,R30
; 0000 0189 // Port D initialization
; 0000 018A // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 018B // State7=P State6=P State5=P State4=P State3=T State2=T State1=T State0=T
; 0000 018C PORTD=0xF0;
	OUT  0x12,R30
; 0000 018D DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 018E // Port E initialization
; 0000 018F // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0190 // State7=P State6=P State5=P State4=P State3=P State2=P State1=T State0=T
; 0000 0191 PORTE=0xFC;
	LDI  R30,LOW(252)
	OUT  0x3,R30
; 0000 0192 DDRE=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 0193 // Port F initialization
; 0000 0194 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0195 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0196 PORTF=0x00;
	STS  98,R30
; 0000 0197 DDRF=0x00;
	STS  97,R30
; 0000 0198 // Port G initialization
; 0000 0199 // Func4=Out Func3=Out Func2=Out Func1=In Func0=In
; 0000 019A // State4=0 State3=0 State2=0 State1=T State0=T
; 0000 019B PORTG=0x00;
	STS  101,R30
; 0000 019C DDRG=0x1C;
	LDI  R30,LOW(28)
	STS  100,R30
; 0000 019D // Timer/Counter 0 initialization
; 0000 019E // Clock source: System Clock
; 0000 019F // Clock value: Timer 0 Stopped
; 0000 01A0 // Mode: Normal top=FFh
; 0000 01A1 // OC0 output: Disconnected
; 0000 01A2 ASSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 01A3 TCCR0=0x00;
	OUT  0x33,R30
; 0000 01A4 TCNT0=0x00;
	OUT  0x32,R30
; 0000 01A5 OCR0=0x00;
	OUT  0x31,R30
; 0000 01A6 // Timer/Counter 1 initialization
; 0000 01A7 // Clock source: System Clock
; 0000 01A8 // Clock value: 1500,000 kHz
; 0000 01A9 // Mode: Fast PWM top=ICR1
; 0000 01AA // OC1A output: Non-Inv.
; 0000 01AB // OC1B output: Discon.
; 0000 01AC // OC1C output: Discon.
; 0000 01AD // Noise Canceler: Off
; 0000 01AE // Input Capture on Falling Edge
; 0000 01AF // Timer 1 Overflow Interrupt: Off
; 0000 01B0 // Input Capture Interrupt: Off
; 0000 01B1 // Compare A Match Interrupt: On
; 0000 01B2 // Compare B Match Interrupt: Off
; 0000 01B3 // Compare C Match Interrupt: Off
; 0000 01B4 TCCR1A=0x82;
	LDI  R30,LOW(130)
	OUT  0x2F,R30
; 0000 01B5 TCCR1B=0x1A;
	LDI  R30,LOW(26)
	OUT  0x2E,R30
; 0000 01B6 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 01B7 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 01B8 ICR1H=0x17;
	LDI  R30,LOW(23)
	OUT  0x27,R30
; 0000 01B9 ICR1L=0x70;
	LDI  R30,LOW(112)
	OUT  0x26,R30
; 0000 01BA OCR1AH=0x02;
	LDI  R30,LOW(2)
	OUT  0x2B,R30
; 0000 01BB OCR1AL=0x68;
	LDI  R30,LOW(104)
	OUT  0x2A,R30
; 0000 01BC OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 01BD OCR1BL=0x00;
	OUT  0x28,R30
; 0000 01BE OCR1CH=0x00;
	STS  121,R30
; 0000 01BF OCR1CL=0x00;
	STS  120,R30
; 0000 01C0 // Timer/Counter 2 initialization
; 0000 01C1 // Clock source: System Clock
; 0000 01C2 // Clock value: Timer 2 Stopped
; 0000 01C3 // Mode: Normal top=FFh
; 0000 01C4 // OC2 output: Disconnected
; 0000 01C5 TCCR2=0x00;
	OUT  0x25,R30
; 0000 01C6 TCNT2=0x00;
	OUT  0x24,R30
; 0000 01C7 OCR2=0x00;
	OUT  0x23,R30
; 0000 01C8 // Timer/Counter 3 initialization
; 0000 01C9 // Clock source: System Clock
; 0000 01CA // Clock value: 1500,000 kHz
; 0000 01CB // Mode: Normal top=FFFFh
; 0000 01CC // Noise Canceler: Off
; 0000 01CD // Input Capture on Falling Edge
; 0000 01CE // OC3A output: Discon.
; 0000 01CF // OC3B output: Discon.
; 0000 01D0 // OC3C output: Discon.
; 0000 01D1 // Timer 3 Overflow Interrupt: On
; 0000 01D2 // Input Capture Interrupt: Off
; 0000 01D3 // Compare A Match Interrupt: Off
; 0000 01D4 // Compare B Match Interrupt: Off
; 0000 01D5 // Compare C Match Interrupt: Off
; 0000 01D6 TCCR3A=0x00;
	STS  139,R30
; 0000 01D7 TCCR3B=0x02;
	LDI  R30,LOW(2)
	STS  138,R30
; 0000 01D8 TCNT3H=0x00;
	LDI  R30,LOW(0)
	STS  137,R30
; 0000 01D9 TCNT3L=0x10;
	LDI  R30,LOW(16)
	STS  136,R30
; 0000 01DA ICR3H=0x00;
	LDI  R30,LOW(0)
	STS  129,R30
; 0000 01DB ICR3L=0x00;
	STS  128,R30
; 0000 01DC OCR3AH=0x00;
	STS  135,R30
; 0000 01DD OCR3AL=0x00;
	STS  134,R30
; 0000 01DE OCR3BH=0x00;
	STS  133,R30
; 0000 01DF OCR3BL=0x00;
	STS  132,R30
; 0000 01E0 OCR3CH=0x00;
	STS  131,R30
; 0000 01E1 OCR3CL=0x00;
	STS  130,R30
; 0000 01E2 // External Interrupt(s) initialization
; 0000 01E3 // INT0: On
; 0000 01E4 // INT0 Mode: Falling Edge
; 0000 01E5 // INT1: Off
; 0000 01E6 // INT2: Off
; 0000 01E7 // INT3: Off
; 0000 01E8 // INT4: Off
; 0000 01E9 // INT5: Off
; 0000 01EA // INT6: Off
; 0000 01EB // INT7: Off
; 0000 01EC EICRA=0x02;
	LDI  R30,LOW(2)
	STS  106,R30
; 0000 01ED EICRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x3A,R30
; 0000 01EE EIMSK=0x0;//0x01;
	OUT  0x39,R30
; 0000 01EF EIFR=0x01;
	LDI  R30,LOW(1)
	OUT  0x38,R30
; 0000 01F0 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01F1 TIMSK=0x01;
	OUT  0x37,R30
; 0000 01F2 ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
; 0000 01F3 // Analog Comparator initialization
; 0000 01F4 // Analog Comparator: Off
; 0000 01F5 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01F6 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 01F7 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 01F8 // ADC initialization
; 0000 01F9 // ADC Clock frequency: 187,500 kHz
; 0000 01FA // ADC Voltage Reference: AREF pin
; 0000 01FB ADMUX=ADC_VREF_TYPE;
	OUT  0x7,R30
; 0000 01FC ADCSRA=0x86;
	LDI  R30,LOW(134)
	OUT  0x6,R30
; 0000 01FD /*
; 0000 01FE // SPI initialization
; 0000 01FF // SPI Type: Master
; 0000 0200 // SPI Clock Rate: 3000,000 kHz
; 0000 0201 // SPI Clock Phase: Cycle Half
; 0000 0202 // SPI Clock Polarity: Low
; 0000 0203 // SPI Data Order: MSB First
; 0000 0204 SPCR=0x50;
; 0000 0205 SPSR=0x00;
; 0000 0206  */
; 0000 0207 // SPI initialization
; 0000 0208 // SPI Type: Master
; 0000 0209 // SPI Clock Rate: 2*3000,000 kHz
; 0000 020A // SPI Clock Phase: Cycle Half
; 0000 020B // SPI Clock Polarity: Low
; 0000 020C // SPI Data Order: MSB First
; 0000 020D SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 020E SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 020F 
; 0000 0210 #asm("sei")
	sei
; 0000 0211 LCD_init();
	CALL _LCD_init
; 0000 0212 LCD_clear();    //*******************************************
	CALL _LCD_clear
; 0000 0213 LCD_init();
	CALL _LCD_init
; 0000 0214 if (EEP_FirstON!=0xa5 || (!KEY_LEFT && !KEY_RIGHT)) { TX_reset(); EEP_FirstON=0xa5; }
	LDI  R26,LOW(_EEP_FirstON)
	LDI  R27,HIGH(_EEP_FirstON)
	CALL __EEPROMRDB
	CPI  R30,LOW(0xA5)
	BRNE _0x77
	SBIC 0x10,6
	RJMP _0x78
	SBIS 0x10,7
	RJMP _0x77
_0x78:
	RJMP _0x76
_0x77:
	RCALL _TX_reset
	LDI  R26,LOW(_EEP_FirstON)
	LDI  R27,HIGH(_EEP_FirstON)
	LDI  R30,LOW(165)
	CALL __EEPROMWRB
; 0000 0215 if (EEP_Calibration!=0xa5 || !KEY_LEFT)
_0x76:
	LDI  R26,LOW(_EEP_Calibration)
	LDI  R27,HIGH(_EEP_Calibration)
	CALL __EEPROMRDB
	CPI  R30,LOW(0xA5)
	BRNE _0x7C
	SBIC 0x10,6
	RJMP _0x7B
_0x7C:
; 0000 0216   {
; 0000 0217   while(!KEY_LEFT || !KEY_RIGHT || !KEY_UP || !KEY_DOWN) delay_ms(100);
_0x7E:
	SBIS 0x10,6
	RJMP _0x81
	SBIS 0x10,7
	RJMP _0x81
	SBIS 0x10,4
	RJMP _0x81
	SBIC 0x10,5
	RJMP _0x80
_0x81:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	RJMP _0x7E
_0x80:
; 0000 0218 calibr();
	RCALL _calibr
; 0000 0219   while(!KEY_LEFT || !KEY_RIGHT || !KEY_UP || !KEY_DOWN) delay_ms(100);
_0x83:
	SBIS 0x10,6
	RJMP _0x86
	SBIS 0x10,7
	RJMP _0x86
	SBIS 0x10,4
	RJMP _0x86
	SBIC 0x10,5
	RJMP _0x85
_0x86:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	RJMP _0x83
_0x85:
; 0000 021A calibr_thermometer();
	RCALL _calibr_thermometer
; 0000 021B   }
; 0000 021C while(!KEY_LEFT || !KEY_RIGHT || !KEY_UP || !KEY_DOWN) delay_ms(100);
_0x7B:
_0x88:
	SBIS 0x10,6
	RJMP _0x8B
	SBIS 0x10,7
	RJMP _0x8B
	SBIS 0x10,4
	RJMP _0x8B
	SBIC 0x10,5
	RJMP _0x8A
_0x8B:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	RJMP _0x88
_0x8A:
; 0000 021D g_MainMenuMode=0;
	LDI  R30,LOW(0)
	STS  _g_MainMenuMode,R30
; 0000 021E for(i=0; i<3; i++) g_pos_d[i]=0;
	LDI  R17,LOW(0)
_0x8E:
	CPI  R17,3
	BRSH _0x8F
	MOV  R30,R17
	LDI  R26,LOW(_g_pos_d)
	LDI  R27,HIGH(_g_pos_d)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	SUBI R17,-1
	RJMP _0x8E
_0x8F:
; 0000 021F TX_init();
	CALL _TX_init
; 0000 0220 g_keys=ReadKeys();
	RCALL _ReadKeys
	MOV  R9,R30
; 0000 0221 if(!MODE_KEY2) cur_mode_ind=0;
	SBIC 0x1,7
	RJMP _0x90
	LDI  R30,LOW(0)
	RJMP _0xEB
; 0000 0222 else if(!MODE_KEY1) cur_mode_ind=2;
_0x90:
	SBIC 0x1,6
	RJMP _0x92
	LDI  R30,LOW(2)
	RJMP _0xEB
; 0000 0223 else cur_mode_ind=1;
_0x92:
	LDI  R30,LOW(1)
_0xEB:
	STS  _cur_mode_ind,R30
; 0000 0224 cur_Batt=read_adc(ch_Batt);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _read_adc
	STS  _cur_Batt,R30
	STS  _cur_Batt+1,R31
; 0000 0225 cur_Power=read_adc(ch_Power);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _read_adc
	STS  _cur_Power,R30
	STS  _cur_Power+1,R31
; 0000 0226 cur_Temperature=read_adc(ch_Temperature);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _read_adc
	STS  _cur_Temperature,R30
	STS  _cur_Temperature+1,R31
; 0000 0227 
; 0000 0228 Calc();  // c;
	CALL _Calc
; 0000 0229 beep_start(hello_sound, 4, 0);
	LDI  R30,LOW(_hello_sound*2)
	LDI  R31,HIGH(_hello_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _beep_start
; 0000 022A displ_menu();
	CALL _displ_menu
; 0000 022B delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 022C TIMSK|=0x10; //   
	IN   R30,0x37
	ORI  R30,0x10
	OUT  0x37,R30
; 0000 022D 
; 0000 022E while (1)
_0x94:
; 0000 022F   {
; 0000 0230 //  keys_menu();
; 0000 0231   displ_menu();
	CALL _displ_menu
; 0000 0232   }
	RJMP _0x94
; 0000 0233 }
_0x97:
	RJMP _0x97
;//-------------------------------------------------------------
;void calibr (void)
; 0000 0236 {
_calibr:
; 0000 0237 unsigned char i, x, y;
; 0000 0238 unsigned long v;
; 0000 0239 signed int AD[5];
; 0000 023A signed int v11, v12, v13, v21, v22, v23;
; 0000 023B 
; 0000 023C beep_start(calibr_sound, 3, 0);
	SBIW R28,24
	CALL __SAVELOCR6
;	i -> R17
;	x -> R16
;	y -> R19
;	v -> Y+26
;	AD -> Y+16
;	v11 -> R20,R21
;	v12 -> Y+14
;	v13 -> Y+12
;	v21 -> Y+10
;	v22 -> Y+8
;	v23 -> Y+6
	LDI  R30,LOW(_calibr_sound*2)
	LDI  R31,HIGH(_calibr_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _beep_start
; 0000 023D delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 023E AD[0]=read_adc(ch_Ailerons);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+16,R30
	STD  Y+16+1,R31
; 0000 023F AD[1]=read_adc(ch_Elevator);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+18,R30
	STD  Y+18+1,R31
; 0000 0240 AD[2]=read_adc(ch_Throttle);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+20,R30
	STD  Y+20+1,R31
; 0000 0241 AD[3]=read_adc(ch_Rudder);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+22,R30
	STD  Y+22+1,R31
; 0000 0242 AD[4]=read_adc(ch_Rpop_contr);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+24,R30
	STD  Y+24+1,R31
; 0000 0243 
; 0000 0244 for (i=0; i<5; i++) { ADmin[i]=AD[i]; ADmax[i]=AD[i]; }
	LDI  R17,LOW(0)
_0x99:
	CPI  R17,5
	BRSH _0x9A
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	SUBI R17,-1
	RJMP _0x99
_0x9A:
; 0000 0245 f_sound_en=1;
	SET
	BLD  R2,0
; 0000 0246 
; 0000 0247 while(KEY_RIGHT && KEY_LEFT)
_0x9B:
	SBIS 0x10,7
	RJMP _0x9E
	SBIC 0x10,6
	RJMP _0x9F
_0x9E:
	RJMP _0x9D
_0x9F:
; 0000 0248   {
; 0000 0249   LCD_clear();
	CALL _LCD_clear
; 0000 024A   displ_head("Calibration");
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _displ_head
; 0000 024B   AD[0]=read_adc(ch_Ailerons);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+16,R30
	STD  Y+16+1,R31
; 0000 024C   AD[1]=read_adc(ch_Elevator);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+18,R30
	STD  Y+18+1,R31
; 0000 024D   AD[2]=read_adc(ch_Throttle);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+20,R30
	STD  Y+20+1,R31
; 0000 024E   AD[3]=read_adc(ch_Rudder);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+22,R30
	STD  Y+22+1,R31
; 0000 024F   AD[4]=read_adc(ch_Rpop_contr);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
	STD  Y+24,R30
	STD  Y+24+1,R31
; 0000 0250 
; 0000 0251   for (i=0; i<5; i++)
	LDI  R17,LOW(0)
_0xA1:
	CPI  R17,5
	BRLO PC+3
	JMP _0xA2
; 0000 0252     {
; 0000 0253     if (ADmin[i]>AD[i]) ADmin[i]=AD[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CP   R30,R0
	CPC  R31,R1
	BRGE _0xA3
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0254     if (ADmax[i]<AD[i]) ADmax[i]=AD[i];
_0xA3:
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	CP   R0,R30
	CPC  R1,R31
	BRGE _0xA4
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0000 0255     }
_0xA4:
	SUBI R17,-1
	RJMP _0xA1
_0xA2:
; 0000 0256 
; 0000 0257 //  LCD_rectangle(46,10, 76, 40, 1); // .
; 0000 0258 //  LCD_rectangle(45, 9, 77, 41, 1);
; 0000 0259   if(ADmax[0]-ADmin[0]<512) { LCD_dashline(46, 10, 46, 40); LCD_dashline(76, 10, 76, 40); }
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDS  R30,_ADmax
	LDS  R31,_ADmax+1
	SUB  R30,R26
	SBC  R31,R27
	CPI  R30,LOW(0x200)
	LDI  R26,HIGH(0x200)
	CPC  R31,R26
	BRGE _0xA5
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _LCD_dashline
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _LCD_dashline
; 0000 025A   else { LCD_line(46, 10, 46, 40, 1); LCD_line(76, 10, 76, 40, 1); }
	RJMP _0xA6
_0xA5:
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
_0xA6:
; 0000 025B   if(ADmax[1]-ADmin[1]<512) { LCD_dashline(46, 10, 76, 10); LCD_dashline(46, 40, 76, 40); }
	__GETW2MN _ADmax,2
	__GETW1MN _ADmin,2
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE _0xA7
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	CALL _LCD_dashline
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _LCD_dashline
; 0000 025C   else { LCD_line(46, 10, 76, 10, 1); LCD_line(46, 40, 76, 40, 1); }
	RJMP _0xA8
_0xA7:
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(46)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
_0xA8:
; 0000 025D   v=AD[0]-ADmin[0]; v*=28; v/=(ADmax[0]-ADmin[0]); x=47+v;
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	__PUTD1S 26
	__GETD2N 0x1C
	CALL __MULD12U
	__PUTD1S 26
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDS  R30,_ADmax
	LDS  R31,_ADmax+1
	SUB  R30,R26
	SBC  R31,R27
	__GETD2S 26
	CALL __CWD1
	CALL __DIVD21U
	__PUTD1S 26
	LDD  R30,Y+26
	SUBI R30,-LOW(47)
	MOV  R16,R30
; 0000 025E   v=AD[1]-ADmin[1]; v*=28; v/=(ADmax[1]-ADmin[1]); y=39-v;
	__GETW1MN _ADmin,2
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	__PUTD1S 26
	__GETD2N 0x1C
	CALL __MULD12U
	__PUTD1S 26
	__GETW1MN _ADmax,2
	__GETW2MN _ADmin,2
	SUB  R30,R26
	SBC  R31,R27
	__GETD2S 26
	CALL __CWD1
	CALL __DIVD21U
	__PUTD1S 26
	__GETD2S 26
	__GETD1N 0x27
	CALL __SUBD12
	MOV  R19,R30
; 0000 025F   LCD_pixel(x, y-2,1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0000 0260   LCD_line(x-1, y-1, x+1, y-1, 1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0000 0261   LCD_line(x-2, y, x+2, y,1);
	MOV  R30,R16
	SUBI R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	MOV  R30,R16
	SUBI R30,-LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0000 0262   LCD_line(x-1, y+1, x+1, y+1, 1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0000 0263   LCD_pixel(x, y+2, 1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0000 0264   if(ADmax[0]-ADmin[0]>=512 && ADmax[1]-ADmin[1]>=512)
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDS  R30,_ADmax
	LDS  R31,_ADmax+1
	SUB  R30,R26
	SBC  R31,R27
	CPI  R30,LOW(0x200)
	LDI  R26,HIGH(0x200)
	CPC  R31,R26
	BRLT _0xAA
	__GETW2MN _ADmax,2
	__GETW1MN _ADmin,2
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE _0xAB
_0xAA:
	RJMP _0xA9
_0xAB:
; 0000 0265     {
; 0000 0266     v11=(ADmax[0]-ADmin[0])/2; v12=v11/10; /* +- 10% */ v13=AD[0]-ADmin[0];
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDS  R30,_ADmax
	LDS  R31,_ADmax+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	MOVW R20,R30
	MOVW R26,R20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDS  R26,_ADmin
	LDS  R27,_ADmin+1
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
; 0000 0267     v21=(ADmax[1]-ADmin[1])/2; v22=v21/10; /* +- 10% */ v23=AD[1]-ADmin[1];
	__GETW2MN _ADmax,2
	__GETW1MN _ADmin,2
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	STD  Y+8,R30
	STD  Y+8+1,R31
	__GETW1MN _ADmin,2
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+6,R26
	STD  Y+6+1,R27
; 0000 0268     if( v13>(v11-v12) && v13<(v11+v12) && v23>(v21-v22) && v23<(v21+v22) )
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0xAD
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADD  R30,R20
	ADC  R31,R21
	CP   R26,R30
	CPC  R27,R31
	BRGE _0xAD
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0xAD
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0xAE
_0xAD:
	RJMP _0xAC
_0xAE:
; 0000 0269       LCD_rectangle(x-3, y-3, x+3, y+3, 1);
	MOV  R30,R16
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(3)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0000 026A     }
_0xAC:
; 0000 026B 
; 0000 026C //  LCD_rectangle(7,10, 37, 40, 1); // 
; 0000 026D //  LCD_rectangle(6,9, 38, 41, 1);
; 0000 026E   if(ADmax[3]-ADmin[3]<512) { LCD_dashline(7, 10, 7, 40); LCD_dashline(37, 10, 37, 40); }
_0xA9:
	__GETW2MN _ADmax,6
	__GETW1MN _ADmin,6
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE _0xAF
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _LCD_dashline
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _LCD_dashline
; 0000 026F   else { LCD_line(7, 10, 7, 40, 1); LCD_line(37, 10, 37, 40, 1); }
	RJMP _0xB0
_0xAF:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
_0xB0:
; 0000 0270   if(ADmax[2]-ADmin[2]<512) { LCD_dashline(7, 10, 37, 10); LCD_dashline(7, 40, 37, 40); }
	__GETW2MN _ADmax,4
	__GETW1MN _ADmin,4
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE _0xB1
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	CALL _LCD_dashline
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _LCD_dashline
; 0000 0271   else { LCD_line(7, 10, 37, 10, 1); LCD_line(7, 40, 37, 40, 1); }
	RJMP _0xB2
_0xB1:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
_0xB2:
; 0000 0272   v=AD[3]-ADmin[3]; v*=28; v/=(ADmax[3]-ADmin[3]); x=8+v;
	__GETW1MN _ADmin,6
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	__PUTD1S 26
	__GETD2N 0x1C
	CALL __MULD12U
	__PUTD1S 26
	__GETW1MN _ADmax,6
	__GETW2MN _ADmin,6
	SUB  R30,R26
	SBC  R31,R27
	__GETD2S 26
	CALL __CWD1
	CALL __DIVD21U
	__PUTD1S 26
	LDD  R30,Y+26
	SUBI R30,-LOW(8)
	MOV  R16,R30
; 0000 0273   v=AD[2]-ADmin[2]; v*=28; v/=(ADmax[2]-ADmin[2]); y=39-v;
	__GETW1MN _ADmin,4
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	__PUTD1S 26
	__GETD2N 0x1C
	CALL __MULD12U
	__PUTD1S 26
	__GETW1MN _ADmax,4
	__GETW2MN _ADmin,4
	SUB  R30,R26
	SBC  R31,R27
	__GETD2S 26
	CALL __CWD1
	CALL __DIVD21U
	__PUTD1S 26
	__GETD2S 26
	__GETD1N 0x27
	CALL __SUBD12
	MOV  R19,R30
; 0000 0274   LCD_pixel(x, y-2,1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0000 0275   LCD_line(x-1, y-1, x+1, y-1,1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0000 0276   LCD_line(x-2, y, x+2, y,1);
	MOV  R30,R16
	SUBI R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	MOV  R30,R16
	SUBI R30,-LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0000 0277   LCD_line(x-1, y+1, x+1, y+1,1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0000 0278   LCD_pixel(x, y+2,1);
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0000 0279   if(ADmax[3]-ADmin[3]>=512 && ADmax[2]-ADmin[2]>=512)
	__GETW2MN _ADmax,6
	__GETW1MN _ADmin,6
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRLT _0xB4
	__GETW2MN _ADmax,4
	__GETW1MN _ADmin,4
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE _0xB5
_0xB4:
	RJMP _0xB3
_0xB5:
; 0000 027A     {
; 0000 027B     v11=(ADmax[3]-ADmin[3])/2; v12=v11/10; /* +- 10% */ v13=AD[3]-ADmin[3];
	__GETW2MN _ADmax,6
	__GETW1MN _ADmin,6
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	MOVW R20,R30
	MOVW R26,R20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	STD  Y+14,R30
	STD  Y+14+1,R31
	__GETW1MN _ADmin,6
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+12,R26
	STD  Y+12+1,R27
; 0000 027C     v21=(ADmax[2]-ADmin[2])/2; v22=v21/10; /* +- 10% */ v23=AD[2]-ADmin[2];
	__GETW2MN _ADmax,4
	__GETW1MN _ADmin,4
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	STD  Y+8,R30
	STD  Y+8+1,R31
	__GETW1MN _ADmin,4
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+6,R26
	STD  Y+6+1,R27
; 0000 027D     if( v13>(v11-v12) && v13<(v11+v12) && v23>(v21-v22) && v23<(v21+v22) )
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0xB7
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADD  R30,R20
	ADC  R31,R21
	CP   R26,R30
	CPC  R27,R31
	BRGE _0xB7
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0xB7
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0xB8
_0xB7:
	RJMP _0xB6
_0xB8:
; 0000 027E       LCD_rectangle(x-3, y-3, x+3, y+3, 1);
	MOV  R30,R16
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(3)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0000 027F     }
_0xB6:
; 0000 0280 
; 0000 0281 //  LCD_rectangle(7, 43, 76, 47, 1);
; 0000 0282   LCD_line(7, 43, 76, 43, 1); LCD_line(7, 47, 76, 47, 1);
_0xB3:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0000 0283   if(ADmax[4]-ADmin[4]<512) { LCD_dashline(7, 43, 7, 47); LCD_dashline(76, 43, 76, 47); }
	__GETW2MN _ADmax,8
	__GETW1MN _ADmin,8
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE _0xB9
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	CALL _LCD_dashline
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	CALL _LCD_dashline
; 0000 0284   else { LCD_line(7, 43, 7, 47, 1); LCD_line(76, 43, 76, 47, 1); }
	RJMP _0xBA
_0xB9:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
_0xBA:
; 0000 0285   v=AD[4]-ADmin[4]; v*=67; v/=(ADmax[4]-ADmin[4]); x=8+v;
	__GETW1MN _ADmin,8
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	__PUTD1S 26
	__GETD2N 0x43
	CALL __MULD12U
	__PUTD1S 26
	__GETW1MN _ADmax,8
	__GETW2MN _ADmin,8
	SUB  R30,R26
	SBC  R31,R27
	__GETD2S 26
	CALL __CWD1
	CALL __DIVD21U
	__PUTD1S 26
	LDD  R30,Y+26
	SUBI R30,-LOW(8)
	MOV  R16,R30
; 0000 0286   LCD_fillrect(x-1, 43, x+1, 47, 1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_fillrect
; 0000 0287   if(ADmax[4]-ADmin[4]>=512)
	__GETW2MN _ADmax,8
	__GETW1MN _ADmin,8
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE PC+3
	JMP _0xBB
; 0000 0288     {
; 0000 0289     v11=(ADmax[4]-ADmin[4])/2; v12=v11/10; /* +- 10% */ v13=AD[4]-ADmin[4];
	__GETW2MN _ADmax,8
	__GETW1MN _ADmin,8
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	MOVW R20,R30
	MOVW R26,R20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	STD  Y+14,R30
	STD  Y+14+1,R31
	__GETW1MN _ADmin,8
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+12,R26
	STD  Y+12+1,R27
; 0000 028A     if( v13>(v11-v12) && v13<(v11+v12))
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0xBD
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADD  R30,R20
	ADC  R31,R21
	CP   R26,R30
	CPC  R27,R31
	BRLT _0xBE
_0xBD:
	RJMP _0xBC
_0xBE:
; 0000 028B       LCD_rectangle(x-3, 43, x+3, 47, 1);
	MOV  R30,R16
	SUBI R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(43)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(47)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0000 028C     }
_0xBC:
; 0000 028D   LCD_refresh();
_0xBB:
	CALL _LCD_refresh
; 0000 028E   }
	RJMP _0x9B
_0x9D:
; 0000 028F if(!KEY_LEFT) return;
	SBIS 0x10,6
	RJMP _0x20C0013
; 0000 0290 ADmid[0]=read_adc(ch_Ailerons);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _read_adc
	STS  _ADmid,R30
	STS  _ADmid+1,R31
; 0000 0291 ADmid[1]=read_adc(ch_Elevator);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
	__PUTW1MN _ADmid,2
; 0000 0292 ADmid[2]=read_adc(ch_Throttle);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
	__PUTW1MN _ADmid,4
; 0000 0293 ADmid[3]=read_adc(ch_Rudder);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
	__PUTW1MN _ADmid,6
; 0000 0294 ADmid[4]=read_adc(ch_Rpop_contr);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
	__PUTW1MN _ADmid,8
; 0000 0295 for (i=0; i<5; i++)
	LDI  R17,LOW(0)
_0xC1:
	CPI  R17,5
	BRLO PC+3
	JMP _0xC2
; 0000 0296   {
; 0000 0297   EEPR_ADmin[i]=ADmin[i];
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmin)
	LDI  R27,HIGH(_EEPR_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	CALL __EEPROMWRW
; 0000 0298   EEPR_ADmid[i]=ADmid[i];
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmid)
	LDI  R27,HIGH(_EEPR_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	CALL __EEPROMWRW
; 0000 0299   EEPR_ADmax[i]=ADmax[i];
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmax)
	LDI  R27,HIGH(_EEPR_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	CALL __EEPROMWRW
; 0000 029A   }
	SUBI R17,-1
	RJMP _0xC1
_0xC2:
; 0000 029B 
; 0000 029C for (i=0, x=0; i<5; i++)
	LDI  R17,LOW(0)
	LDI  R16,LOW(0)
_0xC4:
	CPI  R17,5
	BRLO PC+3
	JMP _0xC5
; 0000 029D   {
; 0000 029E   if(ADmax[i]-ADmin[i]<512) { x=1; break; }
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	SUB  R26,R30
	SBC  R27,R31
	CPI  R26,LOW(0x200)
	LDI  R30,HIGH(0x200)
	CPC  R27,R30
	BRGE _0xC6
	LDI  R16,LOW(1)
	RJMP _0xC5
; 0000 029F   v11=(ADmax[i]-ADmin[i])/2; v12=v11/10; /* +- 10% */ v13=ADmid[i]-ADmin[i];
_0xC6:
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	MOVW R20,R30
	MOVW R26,R20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	STD  Y+14,R30
	STD  Y+14+1,R31
	MOV  R30,R17
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	MOVW R26,R0
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+12,R26
	STD  Y+12+1,R27
; 0000 02A0   if( v13<(v11-v12) || v13>(v11+v12) ) { x=1; break; }
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0xC8
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADD  R30,R20
	ADC  R31,R21
	CP   R30,R26
	CPC  R31,R27
	BRGE _0xC7
_0xC8:
	LDI  R16,LOW(1)
	RJMP _0xC5
; 0000 02A1   }
_0xC7:
	SUBI R17,-1
	RJMP _0xC4
_0xC5:
; 0000 02A2 if(x)
	CPI  R16,0
	BREQ _0xCA
; 0000 02A3   {
; 0000 02A4   LCD_clear();
	CALL _LCD_clear
; 0000 02A5   LCD_setxy(8,11);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
; 0000 02A6   LCD_wrsf("Calibration", 1);
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0000 02A7   LCD_setxy(8,20);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
; 0000 02A8   LCD_wrsf("not correct!", 1);
	__POINTW1FN _0x0,12
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0000 02A9   LCD_refresh();
	CALL _LCD_refresh
; 0000 02AA   beep_start(error_sound, 2, 0);
	LDI  R30,LOW(_error_sound*2)
	LDI  R31,HIGH(_error_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _beep_start
; 0000 02AB   delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 02AC   EEP_Calibration=0;
	LDI  R26,LOW(_EEP_Calibration)
	LDI  R27,HIGH(_EEP_Calibration)
	LDI  R30,LOW(0)
	RJMP _0x20C0012
; 0000 02AD   return;
; 0000 02AE   }
; 0000 02AF EEP_Calibration=0xa5;
_0xCA:
	LDI  R26,LOW(_EEP_Calibration)
	LDI  R27,HIGH(_EEP_Calibration)
	LDI  R30,LOW(165)
_0x20C0012:
	CALL __EEPROMWRB
; 0000 02B0 }
_0x20C0013:
	CALL __LOADLOCR6
	ADIW R28,30
	RET
;//-------------------------------------------------------------
;void calibr_thermometer (void)
; 0000 02B3 {
_calibr_thermometer:
	PUSH R15
; 0000 02B4 signed int t;
; 0000 02B5 unsigned int AD;
; 0000 02B6 char buff[20];
; 0000 02B7 bit f;
; 0000 02B8 
; 0000 02B9 t=25; f=0;
	SBIW R28,20
	CALL __SAVELOCR4
;	t -> R16,R17
;	AD -> R18,R19
;	buff -> Y+4
;	f -> R15.0
	__GETWRN 16,17,25
	CLT
	BLD  R15,0
; 0000 02BA while(KEY_RIGHT && KEY_LEFT)
_0xCB:
	SBIS 0x10,7
	RJMP _0xCE
	SBIC 0x10,6
	RJMP _0xCF
_0xCE:
	RJMP _0xCD
_0xCF:
; 0000 02BB   {
; 0000 02BC   if(!KEY_UP || !KEY_DOWN)
	SBIS 0x10,4
	RJMP _0xD1
	SBIC 0x10,5
	RJMP _0xD0
_0xD1:
; 0000 02BD     {
; 0000 02BE     beep_start(key_sound, 1, 0);
	LDI  R30,LOW(_key_sound*2)
	LDI  R31,HIGH(_key_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _beep_start
; 0000 02BF     if(!KEY_UP && t<100) t++;
	SBIC 0x10,4
	RJMP _0xD4
	__CPWRN 16,17,100
	BRLT _0xD5
_0xD4:
	RJMP _0xD3
_0xD5:
	__ADDWRN 16,17,1
; 0000 02C0     if(!KEY_DOWN && t>-25) t--;
_0xD3:
	SBIC 0x10,5
	RJMP _0xD7
	LDI  R30,LOW(65511)
	LDI  R31,HIGH(65511)
	CP   R30,R16
	CPC  R31,R17
	BRLT _0xD8
_0xD7:
	RJMP _0xD6
_0xD8:
	__SUBWRN 16,17,1
; 0000 02C1     f=1;
_0xD6:
	SET
	BLD  R15,0
; 0000 02C2     }
; 0000 02C3   LCD_clear();
_0xD0:
	CALL _LCD_clear
; 0000 02C4   displ_head("Thermometer");
	__POINTW1FN _0x0,25
	ST   -Y,R31
	ST   -Y,R30
	CALL _displ_head
; 0000 02C5   sprintf(buff, "Set curr %c: %d", 131, t);
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,37
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0x83
	CALL __PUTPARD1
	MOVW R30,R16
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 02C6   LCD_setxy(5,11); LCD_wrs(buff, 1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0000 02C7   AD=read_adc(ch_Temperature);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _read_adc
	MOVW R18,R30
; 0000 02C8   sprintf(buff, "%u", AD);
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,53
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 02C9   LCD_setxy(5,24); LCD_wrs(buff, 1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _LCD_setxy
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0000 02CA   LCD_refresh();
	CALL _LCD_refresh
; 0000 02CB   if(f) { f=0; while(!KEY_UP || !KEY_DOWN) delay_ms(100); }
	SBRS R15,0
	RJMP _0xD9
	CLT
	BLD  R15,0
_0xDA:
	SBIS 0x10,4
	RJMP _0xDD
	SBIC 0x10,5
	RJMP _0xDC
_0xDD:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	RJMP _0xDA
_0xDC:
; 0000 02CC   }
_0xD9:
	RJMP _0xCB
_0xCD:
; 0000 02CD if(!KEY_LEFT) return;
	SBIS 0x10,6
	RJMP _0x20C0011
; 0000 02CE EPP_CalibrTemperature[0]=50+t;
	MOVW R30,R16
	ADIW R30,50
	LDI  R26,LOW(_EPP_CalibrTemperature)
	LDI  R27,HIGH(_EPP_CalibrTemperature)
	CALL __EEPROMWRW
; 0000 02CF EPP_CalibrTemperature[1]=AD;
	__POINTW2MN _EPP_CalibrTemperature,2
	MOVW R30,R18
	CALL __EEPROMWRW
; 0000 02D0 }
_0x20C0011:
	CALL __LOADLOCR4
	ADIW R28,24
	POP  R15
	RET
;//-------------------------------------------------------------
;void TX_reset (void)
; 0000 02D3 {
_TX_reset:
; 0000 02D4 unsigned char i, x;
; 0000 02D5 unsigned int v;
; 0000 02D6 
; 0000 02D7 displ_head("Initial");
	CALL __SAVELOCR4
;	i -> R17
;	x -> R16
;	v -> R18,R19
	__POINTW1FN _0x0,56
	ST   -Y,R31
	ST   -Y,R30
	CALL _displ_head
; 0000 02D8 LCD_rectangle(8, 29, 75, 38, 1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	LDI  R30,LOW(75)
	ST   -Y,R30
	LDI  R30,LOW(38)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0000 02D9 LCD_refresh();
	CALL _LCD_refresh
; 0000 02DA for(i=0, x=8; i<MAX_MODELS; i++)
	LDI  R17,LOW(0)
	LDI  R16,LOW(8)
_0xE1:
	CPI  R17,7
	BRSH _0xE2
; 0000 02DB   {
; 0000 02DC   MODEL_reset(i);
	ST   -Y,R17
	CALL _MODEL_reset
; 0000 02DD   v=(75-8)*(unsigned int)i; v/=(MAX_MODELS-1); x=(unsigned char)(8+v);
	LDI  R26,LOW(67)
	MUL  R17,R26
	MOVW R18,R0
	MOVW R26,R18
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL __DIVW21U
	MOVW R18,R30
	MOV  R30,R18
	SUBI R30,-LOW(8)
	MOV  R16,R30
; 0000 02DE   LCD_fillrect(8, 29, x, 38, 1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	ST   -Y,R16
	LDI  R30,LOW(38)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_fillrect
; 0000 02DF   LCD_refresh();
	CALL _LCD_refresh
; 0000 02E0   }
	SUBI R17,-1
	RJMP _0xE1
_0xE2:
; 0000 02E1 EEP_start_model=0;
	LDI  R26,LOW(_EEP_start_model)
	LDI  R27,HIGH(_EEP_start_model)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 02E2 EEP_f_sound_en=1;
	LDI  R26,LOW(_EEP_f_sound_en)
	LDI  R27,HIGH(_EEP_f_sound_en)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
; 0000 02E3 EEP_BatCntr[0]=98; EEP_BatCntr[1]=92; EEP_BatCntr[2]=110;
	LDI  R26,LOW(_EEP_BatCntr)
	LDI  R27,HIGH(_EEP_BatCntr)
	LDI  R30,LOW(98)
	CALL __EEPROMWRB
	__POINTW2MN _EEP_BatCntr,1
	LDI  R30,LOW(92)
	CALL __EEPROMWRB
	__POINTW2MN _EEP_BatCntr,2
	LDI  R30,LOW(110)
	CALL __EEPROMWRB
; 0000 02E4 }
	RJMP _0x20C0010
;//-------------------------------------------------------------
;/****************************
;  Nokia
;3310 - 84  48
;3410 - 96  65
;     
;*****************************/
;
;#define NOK_3310
;//#define NOK_3410
;
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;#include "def.h"
;#include "LCD_3320.h"
;#include "LMX2306.h"
;#include "displ.h"
;                                       //***********************************************************************
;//extern unsigned char WidthS, HeightS ;
;
;//extern __flash char WidthS;    //const
;//extern __flash char HeightS;
;
;
;//  !!
;extern eeprom MODEL_SET EEP_models[MAX_MODELS];
;extern signed int out_ch[MAX_CHANS];
;extern unsigned int cur_Batt;
;extern unsigned int cur_Power;
;extern unsigned int cur_Temperature;
;extern signed int dir_Temperature;
;extern unsigned char BatCntr[3];
;extern bit f_TCut;
;extern unsigned int time;
;extern bit  f_sound_en;
;extern unsigned char g_MainMenuMode;
;extern unsigned int gRPM[];
;extern signed int CalibrTemperature[2];
;//
;
;__flash const char *modeNames[2][3] =
;   {
;     { "Land", "Norm", "Pilot" },
;     { "Norm", "IDU", "THL"    }
;    };

	.DSEG
;__flash const char *modulNames[] = { "PPM", "IPPM", "PCM" };
;__flash const char *menuT0[] = {
;    "Select\t>",
;    "Model\t>",
;    "Copy\t>",
;    "Options\t>"
;};
;__flash const char *menuT1[] ={
;    "Controls\t>",
;    "Channels\t>",
;    "Name\t>",
;    "Type\t>",
;    "Frequency\t>",
;    "Coding\t>",
;    "Max channel\t>",
;    "Timer\t>",
;    "Modes copy\t>",
;    "Reset\t"
;
;};
;__flash const char *menuT2[] = {
;    "Ailerons\t>",
;    "Elevator\t>",
;    "Throttle\t>",
;    "Rudder\t>",
;    "Switch 1\t>",
;    "Switch 2\t>",
;    "Switch 3\t>",
;    "Add Prop\t>",
;    "Virtual 1\t>",
;    "Virtual 2\t>"
;};
;__flash const char *menuT3[] = {
;    "Set timer\t>",
;    "Timer modes\t>"
;};
;__flash const char *menuT4[] = {
;    "Sound\t>",
;    "Battery\t>",
;    "Monitor\t>",
;    "Tachometer\t>",
;    "Version\t>"
;};
;__flash const char *menuT5[] = {
;    "Channel 1\t>",
;    "Channel 2\t>",
;    "Channel 3\t>",
;    "Channel 4\t>",
;    "Channel 5\t>",
;    "Channel 6\t>",
;    "Channel 7\t>",
;    "Channel 8\t>"
;};
;
;__flash const char *TypesModel[] = { "Plane", "Heli" };
;__flash const char *Timer_modes1[] = { "UP", "DOWN","AUTO" };
;//__flash const char *Timer_modes2[] = { "Sound ON", "Sound OFF" };
;__flash const char *menuT7[]= { "Save", "Cancel", "Restore" };
;__flash const char *menuT8[]= { "Warning", "Alarm", "Max" };
;__flash char _str_VER[]="V1.7, 22/07/09";
;__flash char _str_Co[]="(c) MSV";
;//-------------------------------------------------------------
;unsigned char dg_list_topitem;
;unsigned char dg_list_selitem;
;unsigned char dg_list_cnt;
;bit df_edit;
;bit df_edit_cur;
;bit df_clip;
;unsigned char dpos[6];
;unsigned char dT[2];
;MODEL_SET dcur_model;
;DEF_MODE *dcur_mode;
;unsigned char dcur_mode_ind;
;unsigned char tmp[12];
;
;
;
;//-------------------------------------------------------------
;void list_draw_scrollbar (void)
; 0001 007D {

	.CSEG
_list_draw_scrollbar:
; 0001 007E unsigned char l;
; 0001 007F unsigned int pos;
; 0001 0080 
; 0001 0081 l=MAX_LIST_LINES*9;
	CALL __SAVELOCR4
;	l -> R17
;	pos -> R18,R19
	LDI  R17,LOW(45)
; 0001 0082 LCD_line((WidthS-2), 11, (WidthS-2), 11+l-1, 1);
	LDI  R30,LOW(94)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(94)
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,-LOW(11)
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0083 if(dg_list_cnt<=MAX_LIST_LINES) return;
	LDS  R26,_dg_list_cnt
	CPI  R26,LOW(0x6)
	BRLO _0x20C0010
; 0001 0084 pos=l-(5+2);
	MOV  R30,R17
	SUBI R30,LOW(7)
	MOV  R18,R30
	CLR  R19
; 0001 0085 //pos*=dg_list_topitem; pos/=(dg_list_cnt-MAX_LIST_LINES); pos+=12;
; 0001 0086 pos*=dg_list_selitem; pos/=(dg_list_cnt-1); pos+=12;
	LDS  R30,_dg_list_selitem
	MOVW R26,R18
	LDI  R31,0
	CALL __MULW12U
	MOVW R18,R30
	LDS  R30,_dg_list_cnt
	SUBI R30,LOW(1)
	MOVW R26,R18
	LDI  R31,0
	CALL __DIVW21U
	MOVW R18,R30
	__ADDWRN 18,19,12
; 0001 0087 LCD_line((WidthS-3), pos, (WidthS-3), pos+4, 1);
	LDI  R30,LOW(93)
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0088 LCD_line((WidthS-2), pos, (WidthS-2), pos+4, 0);
	LDI  R30,LOW(94)
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0089 LCD_line((WidthS-1), pos, (WidthS-1), pos+4, 1);
	LDI  R30,LOW(95)
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 008A }
_0x20C0010:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;
;
;
;
;
;//-------------------------------------------------------------
;void list_displ(__flash const char **list)
; 0001 0092 {
_list_displ:
; 0001 0093 unsigned char i, y, att, n;
; 0001 0094 
; 0001 0095 n=dg_list_topitem;
	CALL __SAVELOCR4
;	*list -> Y+4
;	i -> R17
;	y -> R16
;	att -> R19
;	n -> R18
	LDS  R18,_dg_list_topitem
; 0001 0096 for(i=0, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9)
	LDI  R17,LOW(0)
	LDI  R16,LOW(11)
_0x20011:
	CPI  R17,5
	BRSH _0x20013
	LDS  R30,_dg_list_cnt
	CP   R18,R30
	BRLO _0x20014
_0x20013:
	RJMP _0x20012
_0x20014:
; 0001 0097   {
; 0001 0098   LCD_setxy(2, y);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_setxy
; 0001 0099   if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, (WidthS-6), y+7, 1); }
	LDS  R30,_dg_list_selitem
	CP   R30,R18
	BRNE _0x20015
	LDI  R19,LOW(0)
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(90)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_fillrect
; 0001 009A   else att=1;
	RJMP _0x20016
_0x20015:
	LDI  R19,LOW(1)
; 0001 009B   LCD_wrsf(list[n], att);
_0x20016:
	MOV  R30,R18
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_wrsf
; 0001 009C   }
	SUBI R17,-1
	SUBI R18,-1
	SUBI R16,-LOW(9)
	RJMP _0x20011
_0x20012:
; 0001 009D list_draw_scrollbar();
	RCALL _list_draw_scrollbar
; 0001 009E }
	CALL __LOADLOCR4
	RJMP _0x20C000F
;//-------------------------------------------------------------
;void list_displ_names (void)
; 0001 00A1 {
_list_displ_names:
; 0001 00A2 unsigned char i, j, y, att, n;
; 0001 00A3 
; 0001 00A4 n=dg_list_topitem;
	CALL __SAVELOCR6
;	i -> R17
;	j -> R16
;	y -> R19
;	att -> R18
;	n -> R21
	LDS  R21,_dg_list_topitem
; 0001 00A5 for(i=0, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9)
	LDI  R17,LOW(0)
	LDI  R19,LOW(11)
_0x20018:
	CPI  R17,5
	BRSH _0x2001A
	LDS  R30,_dg_list_cnt
	CP   R21,R30
	BRLO _0x2001B
_0x2001A:
	RJMP _0x20019
_0x2001B:
; 0001 00A6   {
; 0001 00A7   LCD_setxy(2, y);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_setxy
; 0001 00A8   if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, (WidthS-6), y+7, 1); }
	LDS  R30,_dg_list_selitem
	CP   R30,R21
	BRNE _0x2001C
	LDI  R18,LOW(0)
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(90)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_fillrect
; 0001 00A9   else att=1;
	RJMP _0x2001D
_0x2001C:
	LDI  R18,LOW(1)
; 0001 00AA   for(j=0; j<8; j++) LCD_char(EEP_models[n].name[j], att);
_0x2001D:
	LDI  R16,LOW(0)
_0x2001F:
	CPI  R16,8
	BRSH _0x20020
	MOV  R30,R21
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	SUBI R30,LOW(-_EEP_models)
	SBCI R31,HIGH(-_EEP_models)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	CALL __EEPROMRDB
	ST   -Y,R30
	ST   -Y,R18
	CALL _LCD_char
	SUBI R16,-1
	RJMP _0x2001F
_0x20020:
; 0001 00AB }
	SUBI R17,-1
	SUBI R21,-1
	SUBI R19,-LOW(9)
	RJMP _0x20018
_0x20019:
; 0001 00AC list_draw_scrollbar();
	RCALL _list_draw_scrollbar
; 0001 00AD }
	CALL __LOADLOCR6
	RJMP _0x20C000F
;//-------------------------------------------------------------
;void displ_contr_short(unsigned char ind, unsigned char x, unsigned char y, unsigned char att)
; 0001 00B0 {
_displ_contr_short:
; 0001 00B1 flash char *p;
; 0001 00B2 LCD_setxy(x,y); p=menuT2[ind];
	ST   -Y,R17
	ST   -Y,R16
;	ind -> Y+5
;	x -> Y+4
;	y -> Y+3
;	att -> Y+2
;	*p -> R16,R17
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	CALL _LCD_setxy
	LDD  R30,Y+5
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X+
	LD   R17,X
; 0001 00B3 while(*p>=' ') { LCD_char(*p, att); p++; }
_0x20021:
	MOVW R30,R16
	LPM  R26,Z
	CPI  R26,LOW(0x20)
	BRLT _0x20023
	LPM  R30,Z
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	CALL _LCD_char
	__ADDWRN 16,17,1
	RJMP _0x20021
_0x20023:
; 0001 00B4 if(att==0) LCD_frame(x);
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x20024
	LDD  R30,Y+4
	ST   -Y,R30
	CALL _LCD_frame
; 0001 00B5 }
_0x20024:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20C000F:
	ADIW R28,6
	RET
;//-------------------------------------------------------------
;void displ_controls (char N, char sel)
; 0001 00B8 {
_displ_controls:
; 0001 00B9 unsigned char  att, ind;
; 0001 00BA 
; 0001 00BB LCD_setxy(0,11);
	ST   -Y,R17
	ST   -Y,R16
;	N -> Y+3
;	sel -> Y+2
;	att -> R17
;	ind -> R16
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 00BC LCD_wrsf("Reverse", 1);
	__POINTW1FN _0x20000,515
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00BD LCD_setxy(39, 11);
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 00BE if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x20025
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20026
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20026:
	RJMP _0x20027
_0x20025:
	LDI  R17,LOW(1)
; 0001 00BF if (dcur_model.contrs_reverse[N]==-1) LCD_wrsf("Yes",att);
_0x20027:
	__POINTW2MN _dcur_model,13
	LDD  R30,Y+3
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0x20028
	__POINTW1FN _0x20000,523
	RJMP _0x20141
; 0001 00C0 else LCD_wrsf("No ",att);
_0x20028:
	__POINTW1FN _0x20000,527
_0x20141:
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrsf
; 0001 00C1 if (N<=3 && N!=2)
	LDD  R26,Y+3
	CPI  R26,LOW(0x4)
	BRGE _0x2002B
	CPI  R26,LOW(0x2)
	BRNE _0x2002C
_0x2002B:
	RJMP _0x2002A
_0x2002C:
; 0001 00C2   { //     
; 0001 00C3   ind=N; if(N>2) ind=2;
	LDD  R16,Y+3
	LDD  R26,Y+3
	CPI  R26,LOW(0x3)
	BRLT _0x2002D
	LDI  R16,LOW(2)
; 0001 00C4   LCD_setxy(0,20); LCD_wrsf("Rate", 1);
_0x2002D:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,531
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00C5   sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	LDI  R31,0
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	MOVW R22,R26
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00C6   if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRNE _0x2002E
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x2002F
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x2002F:
	RJMP _0x20030
_0x2002E:
	LDI  R17,LOW(1)
; 0001 00C7   LCD_setxy(39,20); LCD_wrs(tmp, att);
_0x20030:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00C8   sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	LDI  R31,0
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	MOVW R22,R26
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00C9   if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x2)
	BRNE _0x20031
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20032
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20032:
	RJMP _0x20033
_0x20031:
	LDI  R17,LOW(1)
; 0001 00CA   LCD_setxy(62,20); LCD_wrs(tmp, att);
_0x20033:
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00CB   LCD_setxy(0, 29); LCD_wrsf("DRate", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,540
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00CC   sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minDRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	LDI  R31,0
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	MOVW R22,R26
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00CD   if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=255;
	LDD  R26,Y+2
	CPI  R26,LOW(0x3)
	BRNE _0x20034
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20035
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20035:
	RJMP _0x20036
_0x20034:
	LDI  R17,LOW(255)
; 0001 00CE   LCD_setxy(39, 29); LCD_wrs(tmp, att);
_0x20036:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00CF   sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxDRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	LDI  R31,0
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	MOVW R22,R26
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,3
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00D0   if (sel==4) { att=0; if(df_edit) att=df_clip; } else att=255;
	LDD  R26,Y+2
	CPI  R26,LOW(0x4)
	BRNE _0x20037
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20038
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20038:
	RJMP _0x20039
_0x20037:
	LDI  R17,LOW(255)
; 0001 00D1   LCD_setxy(62, 29); LCD_wrs(tmp, att);
_0x20039:
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00D2   if (sel==5) att=0; else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x5)
	BRNE _0x2003A
	LDI  R17,LOW(0)
	RJMP _0x2003B
_0x2003A:
	LDI  R17,LOW(1)
; 0001 00D3   LCD_setxy(39, 38); LCD_wrsf("Curve >", att);
_0x2003B:
	RJMP _0x20142
; 0001 00D4   }
; 0001 00D5 else if (N==2)
_0x2002A:
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x2003D
; 0001 00D6   { // 
; 0001 00D7   LCD_setxy(0,20); LCD_wrsf("Rate", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,531
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00D8   sprintf(tmp,"%-i",dcur_mode->contr_tr.minRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,33
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00D9   if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRNE _0x2003E
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x2003F
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x2003F:
	RJMP _0x20040
_0x2003E:
	LDI  R17,LOW(1)
; 0001 00DA   LCD_setxy(39,20); LCD_wrs(tmp, att);
_0x20040:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00DB   sprintf(tmp,"%-i",dcur_mode->contr_tr.maxRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	LDD  R30,Z+34
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00DC   if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x2)
	BRNE _0x20041
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20042
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20042:
	RJMP _0x20043
_0x20041:
	LDI  R17,LOW(1)
; 0001 00DD   LCD_setxy(62,20); LCD_wrs(tmp, att);
_0x20043:
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00DE   LCD_setxy(0, 29); LCD_wrsf("Tcut", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,554
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00DF   sprintf(tmp,"%-i",dcur_mode->contr_tr.tcut);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	LDD  R30,Z+35
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00E0   if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x3)
	BRNE _0x20044
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20045
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20045:
	RJMP _0x20046
_0x20044:
	LDI  R17,LOW(1)
; 0001 00E1   LCD_setxy(39, 29); LCD_wrs(tmp, att);
_0x20046:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00E2   if (sel==4) att=0; else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x4)
	BRNE _0x20047
	LDI  R17,LOW(0)
	RJMP _0x20048
_0x20047:
	LDI  R17,LOW(1)
; 0001 00E3   LCD_setxy(39, 38);  LCD_wrsf("Curve >", att);
_0x20048:
	RJMP _0x20142
; 0001 00E4   }
; 0001 00E5 else if(N>=4 && N<=6)
_0x2003D:
	LDD  R26,Y+3
	CPI  R26,LOW(0x4)
	BRLT _0x2004B
	CPI  R26,LOW(0x7)
	BRLT _0x2004C
_0x2004B:
	RJMP _0x2004A
_0x2004C:
; 0001 00E6   { //  
; 0001 00E7   ind=N-4;
	LDD  R30,Y+3
	SUBI R30,LOW(4)
	MOV  R16,R30
; 0001 00E8   LCD_setxy(0,20); LCD_wrsf("Rate", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,531
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00E9   sprintf(tmp,"%-i",dcur_mode->contr_d[ind].minRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,52
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00EA   if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRNE _0x2004D
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x2004E
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x2004E:
	RJMP _0x2004F
_0x2004D:
	LDI  R17,LOW(1)
; 0001 00EB   LCD_setxy(39,20); LCD_wrs(tmp, att);
_0x2004F:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00EC   sprintf(tmp,"%-i",dcur_mode->contr_d[ind].maxRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,52
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00ED   if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x2)
	BRNE _0x20050
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20051
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20051:
	RJMP _0x20052
_0x20050:
	LDI  R17,LOW(1)
; 0001 00EE   LCD_setxy(62,20); LCD_wrs(tmp, att);
_0x20052:
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00EF   LCD_setxy(0, 29); LCD_wrsf("Delay", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,559
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00F0   sprintf(tmp,"%i.%i",dcur_mode->contr_d[ind].delay/10, dcur_mode->contr_d[ind].delay%10);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,565
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,52
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R26,X
	LDI  R30,LOW(10)
	CALL __DIVB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,52
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R26,X
	LDI  R30,LOW(10)
	CALL __MODB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0001 00F1   if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x3)
	BRNE _0x20053
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20054
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20054:
	RJMP _0x20055
_0x20053:
	LDI  R17,LOW(1)
; 0001 00F2   LCD_setxy(39, 29); LCD_wrs(tmp, att);
_0x20055:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00F3   }
; 0001 00F4 else if (N==7)
	RJMP _0x20056
_0x2004A:
	LDD  R26,Y+3
	CPI  R26,LOW(0x7)
	BREQ PC+3
	JMP _0x20057
; 0001 00F5   { //  
; 0001 00F6   LCD_setxy(0,20); LCD_wrsf("Rate", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,531
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 00F7   sprintf(tmp,"%-i",dcur_mode->contr_ap.minRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,43
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00F8   if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRNE _0x20058
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20059
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20059:
	RJMP _0x2005A
_0x20058:
	LDI  R17,LOW(1)
; 0001 00F9   LCD_setxy(39,20); LCD_wrs(tmp, att);
_0x2005A:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00FA   sprintf(tmp,"%-i",dcur_mode->contr_ap.maxRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	LDD  R30,Z+44
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 00FB   if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x2)
	BRNE _0x2005B
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x2005C
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x2005C:
	RJMP _0x2005D
_0x2005B:
	LDI  R17,LOW(1)
; 0001 00FC   LCD_setxy(62,20); LCD_wrs(tmp, att);
_0x2005D:
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 00FD   if (sel==3) att=0; else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x3)
	BRNE _0x2005E
	LDI  R17,LOW(0)
	RJMP _0x2005F
_0x2005E:
	LDI  R17,LOW(1)
; 0001 00FE   LCD_setxy(39, 38);  LCD_wrsf("Curve >", att);
_0x2005F:
	RJMP _0x20142
; 0001 00FF   }
; 0001 0100 else if(N>=8)
_0x20057:
	LDD  R26,Y+3
	CPI  R26,LOW(0x8)
	BRGE PC+3
	JMP _0x20061
; 0001 0101   { //  
; 0001 0102   ind=N-8;
	LDD  R30,Y+3
	SUBI R30,LOW(8)
	MOV  R16,R30
; 0001 0103   LCD_setxy(0,20); LCD_wrsf("Rate", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,531
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 0104   sprintf(tmp,"%-i",dcur_mode->contr_v[ind].minRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,61
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 0105   if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRNE _0x20062
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20063
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20063:
	RJMP _0x20064
_0x20062:
	LDI  R17,LOW(1)
; 0001 0106   LCD_setxy(39,20); LCD_wrs(tmp, att);
_0x20064:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 0107   sprintf(tmp,"%-i",dcur_mode->contr_v[ind].maxRates);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,61
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 0108   if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x2)
	BRNE _0x20065
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20066
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20066:
	RJMP _0x20067
_0x20065:
	LDI  R17,LOW(1)
; 0001 0109   LCD_setxy(62,20); LCD_wrs(tmp, att);
_0x20067:
	LDI  R30,LOW(62)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrs
; 0001 010A   LCD_setxy(0, 29); LCD_wrsf("From:", 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,571
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 010B   if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x3)
	BRNE _0x20068
	LDI  R17,LOW(0)
	SBRS R3,0
	RJMP _0x20069
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R17,R30
_0x20069:
	RJMP _0x2006A
_0x20068:
	LDI  R17,LOW(1)
; 0001 010C   displ_contr_short(dcur_mode->contr_v[ind].from, 39, 29, att);
_0x2006A:
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,61
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LD   R30,X
	ST   -Y,R30
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _displ_contr_short
; 0001 010D   if (sel==4) att=0; else att=1;
	LDD  R26,Y+2
	CPI  R26,LOW(0x4)
	BRNE _0x2006B
	LDI  R17,LOW(0)
	RJMP _0x2006C
_0x2006B:
	LDI  R17,LOW(1)
; 0001 010E   LCD_setxy(39, 38); LCD_wrsf("Curve >", att);
_0x2006C:
_0x20142:
	LDI  R30,LOW(39)
	ST   -Y,R30
	LDI  R30,LOW(38)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,546
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	CALL _LCD_wrsf
; 0001 010F   }
; 0001 0110 }
_0x20061:
_0x20056:
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20C000E
;//-------------------------------------------------------------
;void displ_curve (unsigned char N, unsigned char sel)
; 0001 0113 {
_displ_curve:
; 0001 0114 char Y[7];
; 0001 0115 int i;
; 0001 0116 unsigned char x, att, ind;
; 0001 0117 char *val;
; 0001 0118 
; 0001 0119 
; 0001 011A if (N<=3 && N!=2)
	SBIW R28,9
	CALL __SAVELOCR6
;	N -> Y+16
;	sel -> Y+15
;	Y -> Y+8
;	i -> R16,R17
;	x -> R19
;	att -> R18
;	ind -> R21
;	*val -> Y+6
	LDD  R26,Y+16
	CPI  R26,LOW(0x4)
	BRSH _0x2006E
	CPI  R26,LOW(0x2)
	BRNE _0x2006F
_0x2006E:
	RJMP _0x2006D
_0x2006F:
; 0001 011B   {
; 0001 011C   ind=N; if(N>2) ind=2;
	LDD  R21,Y+16
	LDD  R26,Y+16
	CPI  R26,LOW(0x3)
	BRLO _0x20070
	LDI  R21,LOW(2)
; 0001 011D   val=dcur_mode->contr_ab[ind].cur_nodes;
_0x20070:
	MOV  R30,R21
	LDI  R31,0
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	MOVW R22,R26
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,4
	RJMP _0x20143
; 0001 011E   }
; 0001 011F else if(N==2) val=dcur_mode->contr_tr.cur_nodes;
_0x2006D:
	LDD  R26,Y+16
	CPI  R26,LOW(0x2)
	BRNE _0x20072
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	ADIW R30,36
	RJMP _0x20143
; 0001 0120 else if(N==7) val=dcur_mode->contr_ap.cur_nodes;
_0x20072:
	LDD  R26,Y+16
	CPI  R26,LOW(0x7)
	BRNE _0x20074
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	ADIW R30,45
	RJMP _0x20143
; 0001 0121 else if(N>=8) val=dcur_mode->contr_v[N-8].cur_nodes;
_0x20074:
	LDD  R26,Y+16
	CPI  R26,LOW(0x8)
	BRLO _0x20076
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	ADIW R26,61
	LDD  R30,Y+16
	SUBI R30,LOW(8)
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,3
_0x20143:
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0001 0122 //****************************************************************************
; 0001 0123 /*
; 0001 0124 LCD_rectangle(5,12, 77, 38, 1);
; 0001 0125 LCD_dashline(5, 25, 77, 25);
; 0001 0126 for(i=0, x=17; i<5; i++, x+=12) LCD_dashline(x, 12, x, 38);
; 0001 0127 for(i=0; i<7; i++) Y[i]=25-(val[i]/8);
; 0001 0128 for(i=0, x=5; i<6; i++, x+=12) LCD_line(x, Y[i], x+12, Y[i+1], 1);
; 0001 0129 LCD_rectangle(3+sel*12, Y[sel]+2, 7+sel*12, Y[sel]-2,1);
; 0001 012A sprintf(tmp,"%-i",val[sel]);
; 0001 012B LCD_setxy(2, 40);
; 0001 012C if (!df_edit) att=1; else att=df_clip;
; 0001 012D LCD_wrs(tmp, att);
; 0001 012E */
; 0001 012F //****************************************************************************
; 0001 0130 LCD_rectangle(((WidthS/2)-37),13, ((WidthS/2)+35), 37, 1);  //****
_0x20076:
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(83)
	ST   -Y,R30
	LDI  R30,LOW(37)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0001 0131 LCD_dashline(((WidthS/2)-37), 25, ((WidthS/2)+35), 25);     //****
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	LDI  R30,LOW(83)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	CALL _LCD_dashline
; 0001 0132 for(i=0, x=((WidthS/2)-25); i<5; i++, x+=12) LCD_dashline(x, 13, x, 37);     // 17=84/2-25
	__GETWRN 16,17,0
	LDI  R19,LOW(23)
_0x20078:
	__CPWRN 16,17,5
	BRGE _0x20079
	ST   -Y,R19
	LDI  R30,LOW(13)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(37)
	ST   -Y,R30
	CALL _LCD_dashline
	__ADDWRN 16,17,1
	SUBI R19,-LOW(12)
	RJMP _0x20078
_0x20079:
; 0001 0133 for(i=0; i<7; i++) Y[i]=25-(val[i]/8);
	__GETWRN 16,17,0
_0x2007B:
	__CPWRN 16,17,7
	BRGE _0x2007C
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,8
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	MOVW R30,R16
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	LDI  R30,LOW(8)
	CALL __DIVB21
	LDI  R26,LOW(25)
	CALL __SWAPB12
	SUB  R30,R26
	MOVW R26,R22
	ST   X,R30
	__ADDWRN 16,17,1
	RJMP _0x2007B
_0x2007C:
; 0001 0134 for(i=0, x=((96/2)-37); i<6; i++, x+=12) LCD_line(x, Y[i], x+12, Y[i+1], 1);
	__GETWRN 16,17,0
	LDI  R19,LOW(11)
_0x2007E:
	__CPWRN 16,17,6
	BRGE _0x2007F
	ST   -Y,R19
	MOVW R26,R28
	ADIW R26,9
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(12)
	ST   -Y,R30
	MOVW R30,R16
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,11
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	__ADDWRN 16,17,1
	SUBI R19,-LOW(12)
	RJMP _0x2007E
_0x2007F:
; 0001 0135 LCD_rectangle(((96/2)-39)+sel*12, Y[sel]+2, ((96/2)-35)+sel*12, Y[sel]-2,1);
	LDD  R30,Y+15
	LDI  R26,LOW(12)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(9)
	ST   -Y,R30
	LDD  R30,Y+16
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,9
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDD  R30,Y+17
	LDI  R26,LOW(12)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(13)
	ST   -Y,R30
	LDD  R30,Y+18
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,11
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0001 0136 sprintf(tmp,"%-i",val[sel]);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+19
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 0137 LCD_setxy(((WidthS/2)-40), 40);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 0138 if (!df_edit) att=1; else att=df_clip;
	SBRC R3,0
	RJMP _0x20080
	LDI  R18,LOW(1)
	RJMP _0x20081
_0x20080:
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R18,R30
; 0001 0139 LCD_wrs(tmp, att);
_0x20081:
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R18
	CALL _LCD_wrs
; 0001 013A 
; 0001 013B 
; 0001 013C 
; 0001 013D 
; 0001 013E }
	CALL __LOADLOCR6
	ADIW R28,17
	RET
;//-------------------------------------------------------------
;void displ_chanel (unsigned char N)
; 0001 0141 {
_displ_chanel:
; 0001 0142 unsigned char i, n, y, att;
; 0001 0143 flash char *p;
; 0001 0144 
; 0001 0145 for(i=0, n=dg_list_topitem, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9)
	CALL __SAVELOCR6
;	N -> Y+6
;	i -> R17
;	n -> R16
;	y -> R19
;	att -> R18
;	*p -> R20,R21
	LDI  R17,LOW(0)
	LDS  R16,_dg_list_topitem
	LDI  R19,LOW(11)
_0x20083:
	CPI  R17,5
	BRSH _0x20085
	LDS  R30,_dg_list_cnt
	CP   R16,R30
	BRLO _0x20086
_0x20085:
	RJMP _0x20084
_0x20086:
; 0001 0146   {
; 0001 0147   LCD_setxy(2,y);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_setxy
; 0001 0148   if(n==dg_list_selitem && !df_edit) { att=0; LCD_fillrect(0, y-1, 46, y+7, 1); } else att=1;
	LDS  R30,_dg_list_selitem
	CP   R30,R16
	BRNE _0x20088
	SBRS R3,0
	RJMP _0x20089
_0x20088:
	RJMP _0x20087
_0x20089:
	LDI  R18,LOW(0)
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(46)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_fillrect
	RJMP _0x2008A
_0x20087:
	LDI  R18,LOW(1)
; 0001 0149   p=menuT2[n];
_0x2008A:
	MOV  R30,R16
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R20,X+
	LD   R21,X
; 0001 014A   while(*p>=' ') { LCD_char(*p, att); p++; }
_0x2008B:
	MOVW R30,R20
	LPM  R26,Z
	CPI  R26,LOW(0x20)
	BRLT _0x2008D
	LPM  R30,Z
	ST   -Y,R30
	ST   -Y,R18
	CALL _LCD_char
	__ADDWRN 20,21,1
	RJMP _0x2008B
_0x2008D:
; 0001 014B   if(n==dg_list_selitem && df_edit) att=df_clip; else att=1;
	LDS  R30,_dg_list_selitem
	CP   R30,R16
	BRNE _0x2008F
	SBRC R3,0
	RJMP _0x20090
_0x2008F:
	RJMP _0x2008E
_0x20090:
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R18,R30
	RJMP _0x20091
_0x2008E:
	LDI  R18,LOW(1)
; 0001 014C   LCD_setxy(48, y);
_0x20091:
	LDI  R30,LOW(48)
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_setxy
; 0001 014D   sprintf(tmp, "%-i", dcur_mode->chanels[N][n]);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	SUBI R26,LOW(-81)
	SBCI R27,HIGH(-81)
	LDD  R30,Y+10
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 014E   LCD_wrs(tmp, att);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R18
	CALL _LCD_wrs
; 0001 014F   }
	SUBI R17,-1
	SUBI R16,-1
	SUBI R19,-LOW(9)
	RJMP _0x20083
_0x20084:
; 0001 0150 list_draw_scrollbar();
	RCALL _list_draw_scrollbar
; 0001 0151 }
	CALL __LOADLOCR6
	ADIW R28,7
	RET
;//-------------------------------------------------------------
;void displ_monitor(void)
; 0001 0154 {
_displ_monitor:
; 0001 0155 unsigned char i, j, y, n, y1, x;
; 0001 0156 signed int v;
; 0001 0157 
; 0001 0158 for(i=0, n=dg_list_selitem, y=11; i<MAX_LIST_LINES && n<dcur_model.num_ch; i++, n++, y+=9)
	SBIW R28,2
	CALL __SAVELOCR6
;	i -> R17
;	j -> R16
;	y -> R19
;	n -> R18
;	y1 -> R21
;	x -> R20
;	v -> Y+6
	LDI  R17,LOW(0)
	LDS  R18,_dg_list_selitem
	LDI  R19,LOW(11)
_0x20093:
	CPI  R17,5
	BRSH _0x20095
	__GETB1MN _dcur_model,11
	ANDI R30,LOW(0xF)
	CP   R18,R30
	BRLO _0x20096
_0x20095:
	RJMP _0x20094
_0x20096:
; 0001 0159   {
; 0001 015A   v=out_ch[n]-2250; // +- 900
	MOV  R30,R18
	LDI  R26,LOW(_out_ch)
	LDI  R27,HIGH(_out_ch)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(2250)
	SBCI R31,HIGH(2250)
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0001 015B   if(dpos[3]==0)
	__GETB1MN _dpos,3
	CPI  R30,0
	BREQ PC+3
	JMP _0x20097
; 0001 015C     {
; 0001 015D     sprintf(tmp, "%-i", n+1);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,536
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(1)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 015E     LCD_setxy(2,y); LCD_wrs(tmp, 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 015F     y1=y+7;
	MOV  R30,R19
	SUBI R30,-LOW(7)
	MOV  R21,R30
; 0001 0160     LCD_line(14, y1, 78, y1, 1);
	LDI  R30,LOW(14)
	ST   -Y,R30
	ST   -Y,R21
	LDI  R30,LOW(78)
	ST   -Y,R30
	ST   -Y,R21
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0161     for(j=0, x=14; j<17; j++, x+=4)
	LDI  R16,LOW(0)
	LDI  R20,LOW(14)
_0x20099:
	CPI  R16,17
	BRSH _0x2009A
; 0001 0162       { LCD_pixel(x, y1-1, 1); if(!(j%2)) LCD_pixel(x, y1-2, 1); }
	ST   -Y,R20
	MOV  R30,R21
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
	SBRC R16,0
	RJMP _0x2009B
	ST   -Y,R20
	MOV  R30,R21
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
_0x2009B:
	SUBI R16,-1
	SUBI R20,-LOW(4)
	RJMP _0x20099
_0x2009A:
; 0001 0163     v*=32; v/=900; v+=46;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LSL  R30
	ROL  R31
	CALL __LSLW4
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(900)
	LDI  R31,HIGH(900)
	CALL __DIVW21
	STD  Y+6,R30
	STD  Y+6+1,R31
	ADIW R30,46
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0001 0164     LCD_pixel(v, y1-1, 1);
	LDD  R30,Y+6
	ST   -Y,R30
	MOV  R30,R21
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0001 0165     LCD_line(v-1, y1-2, v+1, y1-2, 1);
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	ST   -Y,R30
	MOV  R30,R21
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDD  R30,Y+8
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R21
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0166     LCD_line(v-2, y1-3, v+2, y1-3, 1);
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,2
	ST   -Y,R30
	MOV  R30,R21
	SUBI R30,LOW(3)
	ST   -Y,R30
	LDD  R30,Y+8
	SUBI R30,-LOW(2)
	ST   -Y,R30
	MOV  R30,R21
	SUBI R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0167     }
; 0001 0168   else
	RJMP _0x2009C
_0x20097:
; 0001 0169     {
; 0001 016A     v*=10; v/=75;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(75)
	LDI  R31,HIGH(75)
	CALL __DIVW21
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0001 016B     sprintf(tmp, "Ch%-i %-i", n+1, v);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,577
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(1)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0001 016C     LCD_setxy(2,y); LCD_wrs(tmp, 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 016D     }
_0x2009C:
; 0001 016E   }
	SUBI R17,-1
	SUBI R18,-1
	SUBI R19,-LOW(9)
	RJMP _0x20093
_0x20094:
; 0001 016F }
	CALL __LOADLOCR6
	ADIW R28,8
	RET
;//-------------------------------------------------------------
;void displ_trimmer (void)
; 0001 0172 {
_displ_trimmer:
; 0001 0173 unsigned char i, x, y, v;
; 0001 0174 
; 0001 0175 // left, vert
; 0001 0176 x=0;
	CALL __SAVELOCR4
;	i -> R17
;	x -> R16
;	y -> R19
;	v -> R18
	LDI  R16,LOW(0)
; 0001 0177 LCD_line(x, 11, x, 43, 1);
	ST   -Y,R16
	LDI  R30,LOW(11)
	ST   -Y,R30
	ST   -Y,R16
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0178 for(i=0, y=11; i<9; i++, y+=4)
	LDI  R17,LOW(0)
	LDI  R19,LOW(11)
_0x2009E:
	CPI  R17,9
	BRSH _0x2009F
; 0001 0179   { LCD_pixel(x+1, y, 1); if(!(i%2)) LCD_pixel(x+2, y, 1); }
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
	SBRC R17,0
	RJMP _0x200A0
	MOV  R30,R16
	SUBI R30,-LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
_0x200A0:
	SUBI R17,-1
	SUBI R19,-LOW(4)
	RJMP _0x2009E
_0x2009F:
; 0001 017A v=(dcur_mode->trimmers[2]/-5)+27;
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	SUBI R30,LOW(-163)
	SBCI R31,HIGH(-163)
	LD   R26,Z
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(27)
	MOV  R18,R30
; 0001 017B LCD_pixel(x+1, v, 1);
	MOV  R30,R16
	SUBI R30,-LOW(1)
	ST   -Y,R30
	ST   -Y,R18
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0001 017C LCD_line(x+2, v-1, x+2, v+1,1);
	MOV  R30,R16
	SUBI R30,-LOW(2)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(2)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 017D LCD_line(x+3, v-2, x+3, v+2,1);
	MOV  R30,R16
	SUBI R30,-LOW(3)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,-LOW(3)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 017E // right, vert
; 0001 017F x=(WidthS-1); //83
	LDI  R16,LOW(95)
; 0001 0180 LCD_line(x, 11, x, 43, 1);
	ST   -Y,R16
	LDI  R30,LOW(11)
	ST   -Y,R30
	ST   -Y,R16
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0181 for(i=0, y=11; i<9; i++, y+=4)
	LDI  R17,LOW(0)
	LDI  R19,LOW(11)
_0x200A2:
	CPI  R17,9
	BRSH _0x200A3
; 0001 0182   { LCD_pixel(x-1, y, 1); if(!(i%2)) LCD_pixel(x-2, y, 1); }
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
	SBRC R17,0
	RJMP _0x200A4
	MOV  R30,R16
	SUBI R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
_0x200A4:
	SUBI R17,-1
	SUBI R19,-LOW(4)
	RJMP _0x200A2
_0x200A3:
; 0001 0183 v=(dcur_mode->trimmers[1]/-5)+27;
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	SUBI R30,LOW(-162)
	SBCI R31,HIGH(-162)
	LD   R26,Z
	LDI  R30,LOW(251)
	CALL __DIVB21
	SUBI R30,-LOW(27)
	MOV  R18,R30
; 0001 0184 LCD_pixel(x-1, v, 1);
	MOV  R30,R16
	SUBI R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R18
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0001 0185 LCD_line(x-2, v-1, x-2, v+1, 1);
	MOV  R30,R16
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0186 LCD_line(x-3, v-2, x-3, v+2, 1);
	MOV  R30,R16
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R16
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0187 // left, horz
; 0001 0188 y=(HeightS-3); //47
	LDI  R19,LOW(62)
; 0001 0189 LCD_line(4, y, 36, y, 1);
	LDI  R30,LOW(4)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(36)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 018A for(i=0, x=4; i<9; i++, x+=4)
	LDI  R17,LOW(0)
	LDI  R16,LOW(4)
_0x200A6:
	CPI  R17,9
	BRSH _0x200A7
; 0001 018B   { LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1); }
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
	SBRC R17,0
	RJMP _0x200A8
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
_0x200A8:
	SUBI R17,-1
	SUBI R16,-LOW(4)
	RJMP _0x200A6
_0x200A7:
; 0001 018C v=(dcur_mode->trimmers[3]/5)+20;
	LDS  R30,_dcur_mode
	LDS  R31,_dcur_mode+1
	SUBI R30,LOW(-164)
	SBCI R31,HIGH(-164)
	LD   R26,Z
	LDI  R30,LOW(5)
	CALL __DIVB21
	SUBI R30,-LOW(20)
	MOV  R18,R30
; 0001 018D LCD_pixel(v, y-1, 1);
	ST   -Y,R18
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0001 018E LCD_line(v-1, y-2, v+1, y-2, 1);
	MOV  R30,R18
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 018F LCD_line(v-2, y-3, v+2, y-3, 1);
	MOV  R30,R18
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(2)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0190 // right, horz
; 0001 0191 y=(HeightS-3);
	LDI  R19,LOW(62)
; 0001 0192 LCD_line((WidthS-37), y, (WidthS-5), y, 1);  // 47  79
	LDI  R30,LOW(59)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(91)
	ST   -Y,R30
	ST   -Y,R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 0193 //for(i=0, x=47; i<9; i++, x+=4)
; 0001 0194 for(i=0, x=(WidthS-37); i<9; i++, x+=4)
	LDI  R17,LOW(0)
	LDI  R16,LOW(59)
_0x200AA:
	CPI  R17,9
	BRSH _0x200AB
; 0001 0195   { LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1); }
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
	SBRC R17,0
	RJMP _0x200AC
	ST   -Y,R16
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
_0x200AC:
	SUBI R17,-1
	SUBI R16,-LOW(4)
	RJMP _0x200AA
_0x200AB:
; 0001 0196 //v=(dcur_mode->trimmers[0]/5)+63;        //******************************
; 0001 0197 v=(dcur_mode->trimmers[0]/5)+(WidthS-37+16); // !!!!!
	LDS  R26,_dcur_mode
	LDS  R27,_dcur_mode+1
	SUBI R26,LOW(-161)
	SBCI R27,HIGH(-161)
	LD   R26,X
	LDI  R30,LOW(5)
	CALL __DIVB21
	SUBI R30,-LOW(75)
	MOV  R18,R30
; 0001 0198 LCD_pixel(v, y-1, 1);
	ST   -Y,R18
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_pixel
; 0001 0199 LCD_line(v-1, y-2, v+1, y-2, 1);
	MOV  R30,R18
	SUBI R30,LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(1)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 019A LCD_line(v-2, y-3, v+2, y-3, 1);
	MOV  R30,R18
	SUBI R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R18
	SUBI R30,-LOW(2)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 019B }
	CALL __LOADLOCR4
_0x20C000E:
	ADIW R28,4
	RET
;//-------------------------------------------------------------
;/*sprintf(tmp,"%-i", VOut[0]);
;LCD_setxy(0, 0);
;LCD_wrs(tmp, 1);
;sprintf(tmp,"%-i", VOut[1]);
;LCD_setxy(0, 9);
;LCD_wrs(tmp, 1);
;sprintf(tmp,"%-i", VOut[2]);
;LCD_setxy(0, 18);
;LCD_wrs(tmp, 1);
;sprintf(tmp,"%-i", VOut[3]);
;LCD_setxy(0, 27);
;LCD_wrs(tmp, 1);
;sprintf(tmp,"%-i", VOut[4]);
;LCD_setxy(0, 36);
;LCD_wrs(tmp, 1);*/
;//-------------------------------------------------------------
;void main_scr (void)
; 0001 01AE {
_main_scr:
; 0001 01AF unsigned char i;
; 0001 01B0 char min[2], sec[2];
; 0001 01B1 signed int k;
; 0001 01B2 signed long l;
; 0001 01B3 char ch;
; 0001 01B4 
; 0001 01B5 //  
; 0001 01B6 LCD_setxy(0, 0);
	SBIW R28,8
	CALL __SAVELOCR4
;	i -> R17
;	min -> Y+10
;	sec -> Y+8
;	k -> R18,R19
;	l -> Y+4
;	ch -> R16
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01B7 if(dcur_model.type==1) { LCD_char(125,1); LCD_char(126,1); } //                                                                ///***************************
	__GETB1MN _dcur_model,8
	ANDI R30,LOW(0x1)
	CPI  R30,LOW(0x1)
	BRNE _0x200AD
	LDI  R30,LOW(125)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_char
	LDI  R30,LOW(126)
	RJMP _0x20144
; 0001 01B8 else  { LCD_char(127,1);  LCD_char(128,1); } // 
_0x200AD:
	LDI  R30,LOW(127)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_char
	LDI  R30,LOW(128)
_0x20144:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_char
; 0001 01B9 //  
; 0001 01BA LCD_setxy(24,0);
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01BB for(i=0; i<8; i++) LCD_char(dcur_model.name[i], 1);
	LDI  R17,LOW(0)
_0x200B0:
	CPI  R17,8
	BRSH _0x200B1
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_dcur_model)
	SBCI R31,HIGH(-_dcur_model)
	LD   R30,Z
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_char
	SUBI R17,-1
	RJMP _0x200B0
_0x200B1:
; 0001 01BC LCD_dashline(0, 8, 83, 8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(83)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _LCD_dashline
; 0001 01BD //  
; 0001 01BE LCD_setxy(57,12);
	LDI  R30,LOW(57)
	ST   -Y,R30
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01BF if(f_TCut) LCD_wrsf("TCut", df_clip); //  
	SBRS R2,1
	RJMP _0x200B2
	__POINTW1FN _0x20000,587
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	RJMP _0x20145
; 0001 01C0 else LCD_wrsf(modeNames[dcur_model.type][dcur_mode_ind],1);
_0x200B2:
	__GETB1MN _dcur_model,8
	ANDI R30,LOW(0x1)
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_modeNames)
	SBCI R31,HIGH(-_modeNames)
	MOVW R26,R30
	LDS  R30,_dcur_mode_ind
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
_0x20145:
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 01C1 // 
; 0001 01C2 displ_trimmer();
	RCALL _displ_trimmer
; 0001 01C3 //  
; 0001 01C4 min[0]=(time/600)%10;
	LDS  R26,_time
	LDS  R27,_time+1
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __DIVW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	STD  Y+10,R30
; 0001 01C5 min[1]=(time/60)%10;
	LDS  R26,_time
	LDS  R27,_time+1
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __DIVW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	STD  Y+11,R30
; 0001 01C6 sec[0]=(time%60)/10;
	LDS  R26,_time
	LDS  R27,_time+1
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	STD  Y+8,R30
; 0001 01C7 sec[1]=time%10;
	LDS  R26,_time
	LDS  R27,_time+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	STD  Y+9,R30
; 0001 01C8 switch(g_MainMenuMode)
	LDS  R30,_g_MainMenuMode
; 0001 01C9   {
; 0001 01CA case 0:
	CPI  R30,0
	BREQ PC+3
	JMP _0x200B7
; 0001 01CB // 
; 0001 01CC   LCD_setxy(((WidthS/2)-30),24);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01CD   //LCD_setxy(12,24);
; 0001 01CE   LCD_deg12x16(min[0], 1);
	LDD  R30,Y+10
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_deg12x16
; 0001 01CF   //LCD_setxy((((WidthS/2)-30)+12),24);
; 0001 01D0   LCD_setxy((((WidthS/2)-18)),24);
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01D1   LCD_deg12x16(min[1], 1);
	LDD  R30,Y+11
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_deg12x16
; 0001 01D2   //LCD_setxy((((WidthS/2)-30)+24),24);
; 0001 01D3   LCD_setxy((((WidthS/2)-6)),24);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01D4   LCD_deg12x16(10, 1); // ':'
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_deg12x16
; 0001 01D5   //LCD_setxy((((WidthS/2)-30)+36),24);
; 0001 01D6   LCD_setxy((((WidthS/2)+6)),24);
	LDI  R30,LOW(54)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01D7   LCD_deg12x16(sec[0], 1);
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_deg12x16
; 0001 01D8   //LCD_setxy((((WidthS/2)-30)+48),24);
; 0001 01D9   LCD_setxy((((WidthS/2)+18)),24);
	LDI  R30,LOW(66)
	ST   -Y,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 01DA   LCD_deg12x16(sec[1], 1);
	LDD  R30,Y+9
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_deg12x16
; 0001 01DB // Battery
; 0001 01DC   k=(cur_Batt/5);
	LDS  R26,_cur_Batt
	LDS  R27,_cur_Batt+1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __DIVW21U
	MOVW R18,R30
; 0001 01DD   if((k>BatCntr[0] && k>BatCntr[1]) || df_clip)
	LDS  R30,_BatCntr
	MOVW R26,R18
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x200B9
	__GETB1MN _BatCntr,1
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x200BB
_0x200B9:
	SBRS R3,2
	RJMP _0x200B8
_0x200BB:
; 0001 01DE     { LCD_setxy(5, 11); LCD_char(129, 1); }
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(129)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_char
; 0001 01DF   LCD_rectangle(12,11, 50,14, 1);
_0x200B8:
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0001 01E0   k-=(int)BatCntr[1]; k*=(49-15); k/=(int)(BatCntr[2]-BatCntr[1]);
	__GETB2MN _BatCntr,1
	CLR  R27
	__SUBWRR 18,19,26,27
	MOVW R30,R18
	LDI  R26,LOW(34)
	LDI  R27,HIGH(34)
	CALL __MULW12
	MOVW R18,R30
	__GETB1MN _BatCntr,2
	__GETB2MN _BatCntr,1
	SUB  R30,R26
	LDI  R31,0
	MOVW R26,R18
	CALL __DIVW21
	MOVW R18,R30
; 0001 01E1   k+=15; if(k>49) k=49;
	__ADDWRN 18,19,15
	__CPWRN 18,19,50
	BRLT _0x200BD
	__GETWRN 18,19,49
; 0001 01E2   if(k>=13) { LCD_line(13, 12, k, 12, 1); LCD_line(13, 13, k, 13, 1); }
_0x200BD:
	__CPWRN 18,19,13
	BRLT _0x200BE
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(12)
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(13)
	ST   -Y,R30
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 01E3 // Antenna
; 0001 01E4   LCD_setxy(5, 16); LCD_char(130, 1);
_0x200BE:
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(130)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_char
; 0001 01E5   LCD_rectangle(12,16, 50,19, 1);
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_rectangle
; 0001 01E6   k=(cur_Power/2); k*=(49-12); k/=500; k+=12; if(k>49) k=49;
	LDS  R30,_cur_Power
	LDS  R31,_cur_Power+1
	LSR  R31
	ROR  R30
	MOVW R18,R30
	MOVW R30,R18
	LDI  R26,LOW(37)
	LDI  R27,HIGH(37)
	CALL __MULW12
	MOVW R18,R30
	MOVW R26,R18
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	CALL __DIVW21
	MOVW R18,R30
	__ADDWRN 18,19,12
	__CPWRN 18,19,50
	BRLT _0x200BF
	__GETWRN 18,19,49
; 0001 01E7   if(k>=13) { LCD_line(13, 17, k, 17, 1); LCD_line(13, 18, k, 18, 1); }
_0x200BF:
	__CPWRN 18,19,13
	BRLT _0x200C0
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(17)
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	ST   -Y,R18
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_line
; 0001 01E8 break;
_0x200C0:
	RJMP _0x200B6
; 0001 01E9 case 1:
_0x200B7:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x200B6
; 0001 01EA // 
; 0001 01EB //  LCD_setxy(5, 11); LCD_char(133, 1);
; 0001 01EC   sprintf(tmp,"%u%u:%u%u", min[0], min[1], sec[0], sec[1]);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,592
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+14
	CALL __CBD1
	CALL __PUTPARD1
	LDD  R30,Y+19
	CALL __CBD1
	CALL __PUTPARD1
	LDD  R30,Y+20
	CALL __CBD1
	CALL __PUTPARD1
	LDD  R30,Y+25
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,16
	CALL _sprintf
	ADIW R28,20
; 0001 01ED   LCD_setxy(12, 12); LCD_wrs(tmp, 1);
	LDI  R30,LOW(12)
	ST   -Y,R30
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 01EE   //LCD_setxy(((WidthS/2)-30), 12); LCD_wrs(tmp, 1);
; 0001 01EF 
; 0001 01F0 // Battery
; 0001 01F1 //  LCD_setxy(5, 25); LCD_char(129, 1);
; 0001 01F2   i=cur_Batt/5;
	LDS  R26,_cur_Batt
	LDS  R27,_cur_Batt+1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __DIVW21U
	MOV  R17,R30
; 0001 01F3   sprintf(tmp,"%-i.%-iV", i/10, i%10);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,602
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R17
	LDI  R30,LOW(10)
	CALL __DIVB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R26,R17
	LDI  R30,LOW(10)
	CALL __MODB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0001 01F4   if((i>BatCntr[0] && i>BatCntr[1]) || df_clip)
	LDS  R30,_BatCntr
	CP   R30,R17
	BRSH _0x200C3
	__GETB1MN _BatCntr,1
	CP   R30,R17
	BRLO _0x200C5
_0x200C3:
	SBRS R3,2
	RJMP _0x200C2
_0x200C5:
; 0001 01F5     { LCD_setxy(12,22); LCD_wrs(tmp, 1); }
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(22)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 01F6     //{ LCD_setxy(((WidthS/2)-30),22); LCD_wrs(tmp, 1); }
; 0001 01F7 // Antenna
; 0001 01F8 //  LCD_setxy(50, 25); LCD_char(130, 1);
; 0001 01F9   sprintf(tmp,"%umA", cur_Power/5);
_0x200C2:
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,611
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_cur_Power
	LDS  R27,_cur_Power+1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __DIVW21U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 01FA   //LCD_setxy(48,22); LCD_wrs(tmp, 1);
; 0001 01FB   LCD_setxy(((WidthS/2)+6),22); LCD_wrs(tmp, 1);
	LDI  R30,LOW(54)
	ST   -Y,R30
	LDI  R30,LOW(22)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 01FC // 
; 0001 01FD   if(CalibrTemperature[1]==0) break;
	__GETW1MN _CalibrTemperature,2
	SBIW R30,0
	BRNE _0x200C7
	RJMP _0x200B6
; 0001 01FE   l=cur_Temperature;
_0x200C7:
	LDS  R30,_cur_Temperature
	LDS  R31,_cur_Temperature+1
	CLR  R22
	CLR  R23
	__PUTD1S 4
; 0001 01FF   l*=CalibrTemperature[0];
	LDS  R30,_CalibrTemperature
	LDS  R31,_CalibrTemperature+1
	__GETD2S 4
	CALL __CWD1
	CALL __MULD12
	__PUTD1S 4
; 0001 0200   l/=CalibrTemperature[1];
	__GETW1MN _CalibrTemperature,2
	__GETD2S 4
	CALL __CWD1
	CALL __DIVD21
	__PUTD1S 4
; 0001 0201   l-=50;
	__SUBD1N 50
	__PUTD1S 4
; 0001 0202   ch=' ';
	LDI  R16,LOW(32)
; 0001 0203   if(dir_Temperature>0) ch=134; else if(dir_Temperature<0) ch=135;
	LDS  R26,_dir_Temperature
	LDS  R27,_dir_Temperature+1
	CALL __CPW02
	BRGE _0x200C8
	LDI  R16,LOW(134)
	RJMP _0x200C9
_0x200C8:
	LDS  R26,_dir_Temperature+1
	TST  R26
	BRPL _0x200CA
	LDI  R16,LOW(135)
; 0001 0204   sprintf(tmp,"%c %dC%c", 131,  (signed int)l, ch);
_0x200CA:
_0x200C9:
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,616
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0x83
	CALL __PUTPARD1
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	CALL __CWD1
	CALL __PUTPARD1
	MOV  R30,R16
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0001 0205   LCD_setxy(32,34); LCD_wrs(tmp, 1);
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(34)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 0206 break;
; 0001 0207   }
_0x200B6:
; 0001 0208 }
	CALL __LOADLOCR4
	ADIW R28,12
	RET
;//-------------------------------------------------------------
;void displ_head (flash unsigned char * name)
; 0001 020B {
_displ_head:
; 0001 020C flash unsigned char *p;
; 0001 020D unsigned char x, l;
; 0001 020E 
; 0001 020F l=LCD_get_char_len('-'); l+=LCD_get_char_len(' '); l*=2;
	CALL __SAVELOCR4
;	*name -> Y+4
;	*p -> R16,R17
;	x -> R19
;	l -> R18
	LDI  R30,LOW(45)
	ST   -Y,R30
	CALL _LCD_get_char_len
	MOV  R18,R30
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _LCD_get_char_len
	ADD  R18,R30
	LSL  R18
; 0001 0210 p=name;
	__GETWRS 16,17,4
; 0001 0211 while(*p>=' ') { l+=LCD_get_char_len(*p); p++; }
_0x200CB:
	MOVW R30,R16
	LPM  R26,Z
	CPI  R26,LOW(0x20)
	BRLO _0x200CD
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_get_char_len
	ADD  R18,R30
	__ADDWRN 16,17,1
	RJMP _0x200CB
_0x200CD:
; 0001 0212 x=(WidthS/2)-(l/2);
	MOV  R30,R18
	LSR  R30
	LDI  R26,LOW(48)
	SUB  R26,R30
	MOV  R19,R26
; 0001 0213 LCD_setxy(x,0);
	ST   -Y,R19
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 0214 LCD_wrsf("- ", 1);
	__POINTW1FN _0x20000,625
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 0215 p=name;
	__GETWRS 16,17,4
; 0001 0216 while(*p>=' ') { LCD_char(*p, 1); p++; }
_0x200CE:
	MOVW R30,R16
	LPM  R26,Z
	CPI  R26,LOW(0x20)
	BRLO _0x200D0
	LPM  R30,Z
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_char
	__ADDWRN 16,17,1
	RJMP _0x200CE
_0x200D0:
; 0001 0217 LCD_wrsf(" -", 1);
	__POINTW1FN _0x20000,628
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 0218 LCD_dashline(0, 8, (WidthS-1), 8); //*************
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _LCD_dashline
; 0001 0219 }
	CALL __LOADLOCR4
	RJMP _0x20C000D
;
;//-------------------------------------------------------------
;extern unsigned char g_list_topitem;
;extern unsigned char g_list_selitem;
;extern unsigned char g_list_cnt;
;extern bit f_edit;
;extern bit f_edit_cur;
;extern bit f_clip;
;extern unsigned char pos[6];
;extern unsigned char T[2];
;extern MODEL_SET cur_model;
;extern unsigned char cur_mode_ind;
;extern unsigned char f_l;
;//-------------------------------------------------------------
;void displ_menu (void)
; 0001 0229 {
_displ_menu:
; 0001 022A unsigned char i, att, x;
; 0001 022B unsigned int k;
; 0001 022C 
; 0001 022D 
; 0001 022E //#asm("cli")
; 0001 022F do
	CALL __SAVELOCR6
;	i -> R17
;	att -> R16
;	x -> R19
;	k -> R20,R21
_0x200D2:
; 0001 0230   {
; 0001 0231   f_l=0;
	CLR  R5
; 0001 0232   dg_list_topitem=g_list_topitem;
	LDS  R30,_g_list_topitem
	STS  _dg_list_topitem,R30
; 0001 0233   dg_list_selitem=g_list_selitem;
	LDS  R30,_g_list_selitem
	STS  _dg_list_selitem,R30
; 0001 0234   dg_list_cnt=g_list_cnt;
	LDS  R30,_g_list_cnt
	STS  _dg_list_cnt,R30
; 0001 0235   df_edit=f_edit;
	BST  R3,3
	BLD  R3,0
; 0001 0236   df_edit_cur=f_edit_cur;
	BST  R3,4
	BLD  R3,1
; 0001 0237   df_clip=f_clip;
	BST  R3,5
	BLD  R3,2
; 0001 0238   for(i=0; i<6; i++) dpos[i]=pos[i];
	LDI  R17,LOW(0)
_0x200D5:
	CPI  R17,6
	BRSH _0x200D6
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_dpos)
	SBCI R27,HIGH(-_dpos)
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_pos)
	SBCI R31,HIGH(-_pos)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0x200D5
_0x200D6:
; 0001 0239 for(i=0; i<2; i++) dT[i]=T[i];
	LDI  R17,LOW(0)
_0x200D8:
	CPI  R17,2
	BRSH _0x200D9
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_dT)
	SBCI R27,HIGH(-_dT)
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0x200D8
_0x200D9:
; 0001 023A dcur_model=cur_model;
	LDI  R30,LOW(_cur_model)
	LDI  R31,HIGH(_cur_model)
	LDI  R26,LOW(_dcur_model)
	LDI  R27,HIGH(_dcur_model)
	LDI  R24,LOW(518)
	LDI  R25,HIGH(518)
	CALL __COPYMM
; 0001 023B   dcur_mode=&dcur_model.modes[cur_mode_ind];
	__POINTW2MN _dcur_model,23
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	STS  _dcur_mode,R30
	STS  _dcur_mode+1,R31
; 0001 023C   dcur_mode_ind=cur_mode_ind;
	LDS  R30,_cur_mode_ind
	STS  _dcur_mode_ind,R30
; 0001 023D   }
; 0001 023E while(f_l!=0);
	TST  R5
	BREQ _0x200D3
	RJMP _0x200D2
_0x200D3:
; 0001 023F //#asm("sei")
; 0001 0240 
; 0001 0241 LCD_clear();
	CALL _LCD_clear
; 0001 0242 switch(dpos[0])
	LDS  R30,_dpos
; 0001 0243   {
; 0001 0244   case 0: // Main screen
	CPI  R30,0
	BRNE _0x200DD
; 0001 0245   main_scr();
	RCALL _main_scr
; 0001 0246   break;
	RJMP _0x200DC
; 0001 0247   case 1:
_0x200DD:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x200DC
; 0001 0248   switch(dpos[1])
	__GETB1MN _dpos,1
; 0001 0249     {
; 0001 024A     case 0: // 
	CPI  R30,0
	BRNE _0x200E2
; 0001 024B     displ_head("Main menu");
	__POINTW1FN _0x20000,631
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 024C     list_displ(menuT0);
	LDI  R30,LOW(_menuT0)
	LDI  R31,HIGH(_menuT0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _list_displ
; 0001 024D     break;
	RJMP _0x200E1
; 0001 024E     case 1: // Select
_0x200E2:
	CPI  R30,LOW(0x1)
	BRNE _0x200E3
; 0001 024F     displ_head(menuT0[dpos[1]-1]);
	__GETB1MN _dpos,1
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT0)
	LDI  R27,HIGH(_menuT0)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0250     list_displ_names();
	CALL _list_displ_names
; 0001 0251     break;
	RJMP _0x200E1
; 0001 0252     case 2: // Model
_0x200E3:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x200E4
; 0001 0253     switch(dpos[2])
	__GETB1MN _dpos,2
; 0001 0254       {
; 0001 0255       case 0:
	CPI  R30,0
	BRNE _0x200E8
; 0001 0256         displ_head(menuT0[dpos[1]-1]);
	__GETB1MN _dpos,1
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT0)
	LDI  R27,HIGH(_menuT0)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0257         list_displ( menuT1);
	LDI  R30,LOW(_menuT1)
	LDI  R31,HIGH(_menuT1)
	RJMP _0x20146
; 0001 0258       break;
; 0001 0259       case 1: // CONTROLS
_0x200E8:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x200E9
; 0001 025A       switch(dpos[3])
	__GETB1MN _dpos,3
; 0001 025B         {
; 0001 025C         case 0:
	CPI  R30,0
	BRNE _0x200EE
; 0001 025D         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 025E         list_displ(menuT2);
	LDI  R30,LOW(_menuT2)
	LDI  R31,HIGH(_menuT2)
	ST   -Y,R31
	ST   -Y,R30
	CALL _list_displ
; 0001 025F         break;
	RJMP _0x200EC
; 0001 0260         default:
_0x200EE:
; 0001 0261         displ_head(menuT2[dpos[3]-1]);
	__GETB1MN _dpos,3
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT2)
	LDI  R27,HIGH(_menuT2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0262         if(!df_edit_cur) displ_controls(dpos[3]-1, dpos[4]);
	SBRC R3,1
	RJMP _0x200EF
	__GETB1MN _dpos,3
	SUBI R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dpos,4
	ST   -Y,R30
	CALL _displ_controls
; 0001 0263         else displ_curve(dpos[3]-1, dpos[5]);
	RJMP _0x200F0
_0x200EF:
	__GETB1MN _dpos,3
	SUBI R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dpos,5
	ST   -Y,R30
	RCALL _displ_curve
; 0001 0264         break;
_0x200F0:
; 0001 0265         }
_0x200EC:
; 0001 0266       break;
	RJMP _0x200E7
; 0001 0267       case 2: // CHANNELS
_0x200E9:
	CPI  R30,LOW(0x2)
	BRNE _0x200F1
; 0001 0268       switch(dpos[3])
	__GETB1MN _dpos,3
; 0001 0269         {
; 0001 026A         case 0:
	CPI  R30,0
	BRNE _0x200F6
; 0001 026B         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 026C         list_displ( menuT5);
	LDI  R30,LOW(_menuT5)
	LDI  R31,HIGH(_menuT5)
	ST   -Y,R31
	ST   -Y,R30
	CALL _list_displ
; 0001 026D         break;
	RJMP _0x200F4
; 0001 026E         default:
_0x200F6:
; 0001 026F         displ_head(menuT5[dpos[3]-1]);
	__GETB1MN _dpos,3
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT5)
	LDI  R27,HIGH(_menuT5)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0270         displ_chanel(dpos[3]-1);
	__GETB1MN _dpos,3
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _displ_chanel
; 0001 0271         break;
; 0001 0272         }
_0x200F4:
; 0001 0273       break;
	RJMP _0x200E7
; 0001 0274       case 3: // 
_0x200F1:
	CPI  R30,LOW(0x3)
	BRNE _0x200F7
; 0001 0275       displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0276       LCD_setxy(8,20);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 0277       for (i=0; i<8; i++)
	LDI  R17,LOW(0)
_0x200F9:
	CPI  R17,8
	BRSH _0x200FA
; 0001 0278         {
; 0001 0279         if(dpos[3]==i) { att=0; if(df_edit) att=df_clip; } else att=1;
	__GETB2MN _dpos,3
	CP   R17,R26
	BRNE _0x200FB
	LDI  R16,LOW(0)
	SBRS R3,0
	RJMP _0x200FC
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R16,R30
_0x200FC:
	RJMP _0x200FD
_0x200FB:
	LDI  R16,LOW(1)
; 0001 027A         x=posx;
_0x200FD:
	LDS  R19,_posx
; 0001 027B         LCD_char(dcur_model.name[i], att);
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_dcur_model)
	SBCI R31,HIGH(-_dcur_model)
	LD   R30,Z
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_char
; 0001 027C         if(att==0) LCD_frame(x);
	CPI  R16,0
	BRNE _0x200FE
	ST   -Y,R19
	CALL _LCD_frame
; 0001 027D         }
_0x200FE:
	SUBI R17,-1
	RJMP _0x200F9
_0x200FA:
; 0001 027E       break;
	RJMP _0x200E7
; 0001 027F       case 4: //  
_0x200F7:
	CPI  R30,LOW(0x4)
	BRNE _0x200FF
; 0001 0280         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0281         LCD_setxy(8,20);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 0282         LCD_wrsf(TypesModel[dcur_model.type], 1);
	__GETB1MN _dcur_model,8
	ANDI R30,LOW(0x1)
	LDI  R26,LOW(_TypesModel)
	LDI  R27,HIGH(_TypesModel)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 0283       break;
	RJMP _0x200E7
; 0001 0284       case 5: // 
_0x200FF:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x20100
; 0001 0285         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0286         LCD_setxy(2,20); LCD_wrsf("Channel:", 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,641
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 0287         sprintf(tmp,"%u", dcur_model.num_freq+PLL_OffDisplNCh);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,599
	ST   -Y,R31
	ST   -Y,R30
	__GETB1MN _dcur_model,12
	SUBI R30,-LOW(61)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 0288         LCD_setxy(45,20); LCD_wrs(tmp, 1);
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 0289         LCD_setxy(2,29); LCD_wrsf("Freq:", 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,650
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 028A         sprintf(tmp,"%u", PLL_GetFreq(dcur_model.num_freq));
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,599
	ST   -Y,R31
	ST   -Y,R30
	__GETB1MN _dcur_model,12
	ST   -Y,R30
	CALL _PLL_GetFreq
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 028B         LCD_setxy(45,29); LCD_wrs(tmp, 1);
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 028C       break;
	RJMP _0x200E7
; 0001 028D       case 6:  // 
_0x20100:
	CPI  R30,LOW(0x6)
	BRNE _0x20101
; 0001 028E         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 028F         LCD_setxy(30,20);
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 0290         LCD_wrsf(modulNames[dcur_model.modulation], 1);
	__GETB1MN _dcur_model,8
	LSR  R30
	ANDI R30,LOW(0x3)
	LDI  R26,LOW(_modulNames)
	LDI  R27,HIGH(_modulNames)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 0291       break;
	RJMP _0x200E7
; 0001 0292       case 7: // 
_0x20101:
	CPI  R30,LOW(0x7)
	BRNE _0x20102
; 0001 0293         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 0294         LCD_setxy(34,20);
	LDI  R30,LOW(34)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 0295         LCD_deg12x16(dcur_model.num_ch, 1);
	__GETB1MN _dcur_model,11
	ANDI R30,LOW(0xF)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_deg12x16
; 0001 0296       break;
	RJMP _0x200E7
; 0001 0297       case 8: // TIMER
_0x20102:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x20103
; 0001 0298       switch(dpos[3])
	__GETB1MN _dpos,3
; 0001 0299         {
; 0001 029A         case 0:
	CPI  R30,0
	BRNE _0x20107
; 0001 029B         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 029C         list_displ( menuT3);
	LDI  R30,LOW(_menuT3)
	LDI  R31,HIGH(_menuT3)
	ST   -Y,R31
	ST   -Y,R30
	CALL _list_displ
; 0001 029D         break;
	RJMP _0x20106
; 0001 029E         case 1: //"- Set timer -"
_0x20107:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x20108
; 0001 029F         displ_head(menuT3[dpos[3]-1]);
	__GETB1MN _dpos,3
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT3)
	LDI  R27,HIGH(_menuT3)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02A0         sprintf(tmp,"%-i:%-i",dcur_model.timer_set/60, dcur_model.timer_set%60);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,656
	ST   -Y,R31
	ST   -Y,R30
	__GETW2MN _dcur_model,9
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __DIVW21U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETW2MN _dcur_model,9
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0001 02A1         LCD_setxy(24,18); LCD_wrs(tmp,255);
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 02A2         break;
	RJMP _0x20106
; 0001 02A3         case 2:  // 
_0x20108:
	CPI  R30,LOW(0x2)
	BRNE _0x20106
; 0001 02A4         displ_head(menuT3[dpos[3]-1]);
	__GETB1MN _dpos,3
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT3)
	LDI  R27,HIGH(_menuT3)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02A5         LCD_setxy(30,20);
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 02A6         LCD_wrsf(Timer_modes1[dcur_model.timer_mode],1);
	__GETB1MN _dcur_model,8
	LSR  R30
	LSR  R30
	LSR  R30
	ANDI R30,LOW(0x3)
	LDI  R26,LOW(_Timer_modes1)
	LDI  R27,HIGH(_Timer_modes1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02A7         break;
; 0001 02A8         }
_0x20106:
; 0001 02A9       break;
	RJMP _0x200E7
; 0001 02AA       case 9:  //  
_0x20103:
	CPI  R30,LOW(0x9)
	BREQ PC+3
	JMP _0x2010A
; 0001 02AB         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02AC         LCD_dashline(0, 8, 83, 8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(83)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _LCD_dashline
; 0001 02AD         LCD_setxy(2,11); LCD_wrsf("From:",255);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,571
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02AE         LCD_setxy(2,20); LCD_wrsf("To:",255);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,664
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02AF         if(dpos[3]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
	__GETB1MN _dpos,3
	CPI  R30,0
	BRNE _0x2010B
	LDI  R16,LOW(0)
	SBRS R3,0
	RJMP _0x2010C
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R16,R30
_0x2010C:
	RJMP _0x2010D
_0x2010B:
	LDI  R16,LOW(1)
; 0001 02B0         LCD_setxy(32, 11); LCD_wrsf(modeNames[dcur_model.type][dT[0]], att);
_0x2010D:
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
	__GETB1MN _dcur_model,8
	ANDI R30,LOW(0x1)
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_modeNames)
	SBCI R31,HIGH(-_modeNames)
	MOVW R26,R30
	LDS  R30,_dT
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_wrsf
; 0001 02B1         if(dpos[3]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
	__GETB2MN _dpos,3
	CPI  R26,LOW(0x1)
	BRNE _0x2010E
	LDI  R16,LOW(0)
	SBRS R3,0
	RJMP _0x2010F
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R16,R30
_0x2010F:
	RJMP _0x20110
_0x2010E:
	LDI  R16,LOW(1)
; 0001 02B2         LCD_setxy(32, 20); LCD_wrsf(modeNames[dcur_model.type][dT[1]], att);
_0x20110:
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__GETB1MN _dcur_model,8
	ANDI R30,LOW(0x1)
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_modeNames)
	SBCI R31,HIGH(-_modeNames)
	MOVW R26,R30
	__GETB1MN _dT,1
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_wrsf
; 0001 02B3         if(dpos[3]==2) att=0; else att=1;
	__GETB2MN _dpos,3
	CPI  R26,LOW(0x2)
	BRNE _0x20111
	LDI  R16,LOW(0)
	RJMP _0x20112
_0x20111:
	LDI  R16,LOW(1)
; 0001 02B4         LCD_setxy(32,34); LCD_wrsf("OK", att);
_0x20112:
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(34)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,668
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_wrsf
; 0001 02B5       break;
	RJMP _0x200E7
; 0001 02B6       case 10: // Reset
_0x2010A:
	CPI  R30,LOW(0xA)
	BRNE _0x20113
; 0001 02B7         displ_head(menuT1[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT1)
	LDI  R27,HIGH(_menuT1)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02B8         LCD_setxy(8,20); LCD_wrsf("Are you sure?",1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,671
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02B9       break;
	RJMP _0x200E7
; 0001 02BA       case 11: // Confirm
_0x20113:
	CPI  R30,LOW(0xB)
	BRNE _0x200E7
; 0001 02BB         displ_head("All change");
	__POINTW1FN _0x20000,685
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02BC         list_displ( menuT7);
	LDI  R30,LOW(_menuT7)
	LDI  R31,HIGH(_menuT7)
_0x20146:
	ST   -Y,R31
	ST   -Y,R30
	CALL _list_displ
; 0001 02BD       break;
; 0001 02BE       }
_0x200E7:
; 0001 02BF     break;
	RJMP _0x200E1
; 0001 02C0     case 3: //  
_0x200E4:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x20115
; 0001 02C1       displ_head(menuT0[dpos[1]-1]);
	__GETB1MN _dpos,1
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT0)
	LDI  R27,HIGH(_menuT0)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02C2       LCD_setxy(2,11); LCD_wrsf("From:",255);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,571
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02C3       LCD_setxy(2,20); LCD_wrsf("To:",255);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,664
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02C4       if(dpos[2]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
	__GETB1MN _dpos,2
	CPI  R30,0
	BRNE _0x20116
	LDI  R16,LOW(0)
	SBRS R3,0
	RJMP _0x20117
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R16,R30
_0x20117:
	RJMP _0x20118
_0x20116:
	LDI  R16,LOW(1)
; 0001 02C5       LCD_setxy(32, 11); x=posx;
_0x20118:
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _LCD_setxy
	LDS  R19,_posx
; 0001 02C6       for (i=0; i<8; i++) LCD_char(EEP_models[dT[0]].name[i], att);
	LDI  R17,LOW(0)
_0x2011A:
	CPI  R17,8
	BRSH _0x2011B
	LDS  R30,_dT
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	SUBI R30,LOW(-_EEP_models)
	SBCI R31,HIGH(-_EEP_models)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_char
	SUBI R17,-1
	RJMP _0x2011A
_0x2011B:
; 0001 02C7 if(att==0) LCD_frame(x);
	CPI  R16,0
	BRNE _0x2011C
	ST   -Y,R19
	CALL _LCD_frame
; 0001 02C8       if(dpos[2]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
_0x2011C:
	__GETB2MN _dpos,2
	CPI  R26,LOW(0x1)
	BRNE _0x2011D
	LDI  R16,LOW(0)
	SBRS R3,0
	RJMP _0x2011E
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R16,R30
_0x2011E:
	RJMP _0x2011F
_0x2011D:
	LDI  R16,LOW(1)
; 0001 02C9       LCD_setxy(32, 20); x=posx;
_0x2011F:
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDS  R19,_posx
; 0001 02CA       for (i=0; i<8; i++) LCD_char(EEP_models[dT[1]].name[i], att);
	LDI  R17,LOW(0)
_0x20121:
	CPI  R17,8
	BRSH _0x20122
	__GETB1MN _dT,1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	SUBI R30,LOW(-_EEP_models)
	SBCI R31,HIGH(-_EEP_models)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_char
	SUBI R17,-1
	RJMP _0x20121
_0x20122:
; 0001 02CB if(att==0) LCD_frame(x);
	CPI  R16,0
	BRNE _0x20123
	ST   -Y,R19
	CALL _LCD_frame
; 0001 02CC       if(dpos[2]==2) att=0; else att=1;
_0x20123:
	__GETB2MN _dpos,2
	CPI  R26,LOW(0x2)
	BRNE _0x20124
	LDI  R16,LOW(0)
	RJMP _0x20125
_0x20124:
	LDI  R16,LOW(1)
; 0001 02CD       LCD_setxy(32,34); LCD_wrsf("OK", att);
_0x20125:
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(34)
	ST   -Y,R30
	CALL _LCD_setxy
	__POINTW1FN _0x20000,668
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	RJMP _0x20147
; 0001 02CE     break;
; 0001 02CF     case 4:
_0x20115:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x200E1
; 0001 02D0     switch(dpos[2])
	__GETB1MN _dpos,2
; 0001 02D1       {
; 0001 02D2       case 0:
	CPI  R30,0
	BRNE _0x2012A
; 0001 02D3         displ_head(menuT0[dpos[1]-1]);
	__GETB1MN _dpos,1
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT0)
	LDI  R27,HIGH(_menuT0)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02D4         list_displ( menuT4);
	LDI  R30,LOW(_menuT4)
	LDI  R31,HIGH(_menuT4)
	ST   -Y,R31
	ST   -Y,R30
	CALL _list_displ
; 0001 02D5       break;
	RJMP _0x20129
; 0001 02D6       case 1: // "Sound"
_0x2012A:
	CPI  R30,LOW(0x1)
	BRNE _0x2012B
; 0001 02D7         displ_head(menuT4[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT4)
	LDI  R27,HIGH(_menuT4)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02D8         LCD_setxy(32,20);
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
; 0001 02D9         if (f_sound_en) LCD_wrsf("ON",255);
	SBRS R2,0
	RJMP _0x2012C
	__POINTW1FN _0x20000,696
	RJMP _0x20148
; 0001 02DA         else LCD_wrsf("OFF",255);
_0x2012C:
	__POINTW1FN _0x20000,699
_0x20148:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02DB       break;
	RJMP _0x20129
; 0001 02DC       case 2: // "Battery"
_0x2012B:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x2012E
; 0001 02DD         displ_head(menuT4[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT4)
	LDI  R27,HIGH(_menuT4)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02DE         for(i=0, x=11; i<3; i++, x+=9)
	LDI  R17,LOW(0)
	LDI  R19,LOW(11)
_0x20130:
	CPI  R17,3
	BRLO PC+3
	JMP _0x20131
; 0001 02DF           {
; 0001 02E0           if(dpos[3]==i && !df_edit) att=0; else att=1;
	__GETB2MN _dpos,3
	CP   R17,R26
	BRNE _0x20133
	SBRS R3,0
	RJMP _0x20134
_0x20133:
	RJMP _0x20132
_0x20134:
	LDI  R16,LOW(0)
	RJMP _0x20135
_0x20132:
	LDI  R16,LOW(1)
; 0001 02E1           if(att==0) LCD_fillrect(0, x-1, 40, x+7, 1);
_0x20135:
	CPI  R16,0
	BRNE _0x20136
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_fillrect
; 0001 02E2           LCD_setxy(2,x); LCD_wrsf(menuT8[i], att);
_0x20136:
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_setxy
	MOV  R30,R17
	LDI  R26,LOW(_menuT8)
	LDI  R27,HIGH(_menuT8)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_wrsf
; 0001 02E3           sprintf(tmp,"%-i.%-i", BatCntr[i]/10, BatCntr[i]%10);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,703
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_BatCntr)
	SBCI R31,HIGH(-_BatCntr)
	LD   R26,Z
	LDI  R30,LOW(10)
	CALL __DIVB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_BatCntr)
	SBCI R31,HIGH(-_BatCntr)
	LD   R26,Z
	LDI  R30,LOW(10)
	CALL __MODB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0001 02E4           if(dpos[3]==i && df_edit) att=df_clip; else att=1;
	__GETB2MN _dpos,3
	CP   R17,R26
	BRNE _0x20138
	SBRC R3,0
	RJMP _0x20139
_0x20138:
	RJMP _0x20137
_0x20139:
	LDI  R30,0
	SBRC R3,2
	LDI  R30,1
	MOV  R16,R30
	RJMP _0x2013A
_0x20137:
	LDI  R16,LOW(1)
; 0001 02E5           LCD_setxy(45,x); LCD_wrs(tmp, att);
_0x2013A:
	LDI  R30,LOW(45)
	ST   -Y,R30
	ST   -Y,R19
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	CALL _LCD_wrs
; 0001 02E6           }
	SUBI R17,-1
	SUBI R19,-LOW(9)
	RJMP _0x20130
_0x20131:
; 0001 02E7       break;
	RJMP _0x20129
; 0001 02E8       case 3: // "Monitor"
_0x2012E:
	CPI  R30,LOW(0x3)
	BRNE _0x2013B
; 0001 02E9         displ_head(menuT4[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT4)
	LDI  R27,HIGH(_menuT4)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02EA         displ_monitor();
	CALL _displ_monitor
; 0001 02EB       break;
	RJMP _0x20129
; 0001 02EC       case 4: // "Tachometer"
_0x2013B:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x2013C
; 0001 02ED         displ_head(menuT4[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT4)
	LDI  R27,HIGH(_menuT4)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02EE         for(i=0, k=0; i<SIZE_RPM_BUFF; i++) k+=gRPM[i];
	LDI  R17,LOW(0)
	__GETWRN 20,21,0
_0x2013E:
	CPI  R17,3
	BRSH _0x2013F
	MOV  R30,R17
	LDI  R26,LOW(_gRPM)
	LDI  R27,HIGH(_gRPM)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__ADDWRR 20,21,30,31
	SUBI R17,-1
	RJMP _0x2013E
_0x2013F:
; 0001 02EF k=k*(40/2);
	__MULBNWRU 20,21,20
	MOVW R20,R30
; 0001 02F0         sprintf(tmp,"%u RPM", k);
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x20000,711
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R20
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0001 02F1         LCD_setxy(16,20); LCD_wrs(tmp, 1);
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(_tmp)
	LDI  R31,HIGH(_tmp)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrs
; 0001 02F2       break;
	RJMP _0x20129
; 0001 02F3       case 5: // Version
_0x2013C:
	CPI  R30,LOW(0x5)
	BRNE _0x20129
; 0001 02F4         displ_head(menuT4[dpos[2]-1]);
	__GETB1MN _dpos,2
	SUBI R30,LOW(1)
	LDI  R26,LOW(_menuT4)
	LDI  R27,HIGH(_menuT4)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	RCALL _displ_head
; 0001 02F5         LCD_setxy(2,20); LCD_wrsf(_str_VER, 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(__str_VER*2)
	LDI  R31,HIGH(__str_VER*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_wrsf
; 0001 02F6         LCD_setxy(24,38); LCD_wrsf(_str_Co, 1);
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(38)
	ST   -Y,R30
	CALL _LCD_setxy
	LDI  R30,LOW(__str_Co*2)
	LDI  R31,HIGH(__str_Co*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
_0x20147:
	CALL _LCD_wrsf
; 0001 02F7       break;
; 0001 02F8       }
_0x20129:
; 0001 02F9     break;
; 0001 02FA     }
_0x200E1:
; 0001 02FB   break;
; 0001 02FC   }
_0x200DC:
; 0001 02FD LCD_refresh();
	CALL _LCD_refresh
; 0001 02FE }
	CALL __LOADLOCR6
_0x20C000D:
	ADIW R28,6
	RET
;//-------------------------------------------------------------
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <delay.h>
;#include "def.h"
;#include "coder.h"
;//#include "LCD_3320.h"
;#include "displ.h"
;#include "LMX2306.h"
;#include "menu.h"
;
;#define menuT0L 4
;#define menuT1L 10
;#define menuT2L 10
;#define menuT3L 2
;#define menuT4L 5
;#define menuT5L 8
;#define menuT7L 3
;
;__flash const char Name_table[] = {
;' ','_','-','0','1','2','3','4','5','6','7','8','9','A','a','B','b','C','c','D',
;'d','E','e','F','f','G','g','H','h','I','i','J','j','K','k','L','l','M','m','N',
;'n','O','o','P','p','Q','q','R','r','S','s','T','t','U','u','V','v','W','w','X',
;'x','Y','y','Z','z'};
;
;unsigned char pos[6];
;unsigned char T[2];
;bit f_edit_cur;
;bit f_edit;
;unsigned char mnu_keys;
;bit f_clip;
;bit  f_sound_en;
;unsigned char BatCntr[3];
;unsigned int time;
;bit f_timer_en;
;unsigned char div_beep_batt;
;unsigned char g_rep;
;signed int CalibrTemperature[2];
;#define REP_FAST 5
;#define REP_SLOW 10
;//-------------------------------------------------------------
;//------------------------------------------------------
;//------------------------------------------------------
;flash const BEEP_TRACK_DEF hello_sound[]={ {10,200}, {7,50},{3,50}, {10,200} };
;flash const BEEP_TRACK_DEF error_sound[]={ {20,500}, {10,1000} };
;flash const BEEP_TRACK_DEF calibr_sound[]={ {10,50}, {20,50}, {10,50} };
;flash const BEEP_TRACK_DEF key_sound[]={ {20, 20} };
;flash const BEEP_TRACK_DEF EEP_sound[]={ {20, 20}, {10, 40} };
;flash const BEEP_TRACK_DEF batt_sound[]={ {10,50}, {20,50} };
;flash const BEEP_TRACK_DEF timer_sound[]={ {10,20}, {20,20} };
;flash const BEEP_TRACK_DEF trimmer_sound[]={ {10,5} };
;
;//------------------------------------------------------
;void beep_work(void)
; 0002 0036 {

	.CSEG
_beep_work:
; 0002 0037 unsigned char i;
; 0002 0038 
; 0002 0039 if(ETIMSK & 0x4) return;
	ST   -Y,R17
;	i -> R17
	LDS  R30,125
	ANDI R30,LOW(0x4)
	BREQ _0x40003
	RJMP _0x20C000C
; 0002 003A i=cur_Batt/5;
_0x40003:
	LDS  R26,_cur_Batt
	LDS  R27,_cur_Batt+1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __DIVW21U
	MOV  R17,R30
; 0002 003B if(i<=BatCntr[1])
	__GETB1MN _BatCntr,1
	CP   R30,R17
	BRLO _0x40004
; 0002 003C   { // Alarm
; 0002 003D   if(div_beep_batt>(1000/20)) div_beep_batt=0;
	LDS  R26,_div_beep_batt
	CPI  R26,LOW(0x33)
	BRLO _0x40005
	LDI  R30,LOW(0)
	STS  _div_beep_batt,R30
; 0002 003E   if(!div_beep_batt) { beep_start(batt_sound, 2, 4); div_beep_batt=(1000/20); }
_0x40005:
	LDS  R30,_div_beep_batt
	CPI  R30,0
	BRNE _0x40006
	LDI  R30,LOW(_batt_sound*2)
	LDI  R31,HIGH(_batt_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _beep_start
	LDI  R30,LOW(50)
	STS  _div_beep_batt,R30
; 0002 003F   }
_0x40006:
; 0002 0040 if(i<=BatCntr[0] && !div_beep_batt)  // Warm
_0x40004:
	LDS  R30,_BatCntr
	CP   R30,R17
	BRLO _0x40008
	LDS  R30,_div_beep_batt
	CPI  R30,0
	BREQ _0x40009
_0x40008:
	RJMP _0x40007
_0x40009:
; 0002 0041   { beep_start(batt_sound, 2, 1); div_beep_batt=(5000/20); }
	LDI  R30,LOW(_batt_sound*2)
	LDI  R31,HIGH(_batt_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _beep_start
	LDI  R30,LOW(250)
	STS  _div_beep_batt,R30
; 0002 0042 if(f_beep_timer) { f_beep_timer=0; beep_start(timer_sound, 2, 25);  return; }
_0x40007:
	SBRS R2,2
	RJMP _0x4000A
	CLT
	BLD  R2,2
	LDI  R30,LOW(_timer_sound*2)
	LDI  R31,HIGH(_timer_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(25)
	ST   -Y,R30
	CALL _beep_start
	RJMP _0x20C000C
; 0002 0043 if(f_beep_EEP) { f_beep_EEP=0; if(f_sound_en) beep_start(EEP_sound, 2, 0); return; }
_0x4000A:
	SBRS R2,3
	RJMP _0x4000B
	CLT
	BLD  R2,3
	SBRS R2,0
	RJMP _0x4000C
	LDI  R30,LOW(_EEP_sound*2)
	LDI  R31,HIGH(_EEP_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _beep_start
_0x4000C:
	RJMP _0x20C000C
; 0002 0044 if(f_beep_key) { f_beep_key=0; if(f_sound_en) beep_start(key_sound, 1, 0); return; }
_0x4000B:
	SBRS R2,4
	RJMP _0x4000D
	CLT
	BLD  R2,4
	SBRS R2,0
	RJMP _0x4000E
	LDI  R30,LOW(_key_sound*2)
	LDI  R31,HIGH(_key_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _beep_start
_0x4000E:
	RJMP _0x20C000C
; 0002 0045 if(f_beep_trimmer) { f_beep_trimmer=0; if(f_sound_en) beep_start(trimmer_sound, 1, 0); return; }
_0x4000D:
	SBRS R2,5
	RJMP _0x4000F
	CLT
	BLD  R2,5
	SBRS R2,0
	RJMP _0x40010
	LDI  R30,LOW(_trimmer_sound*2)
	LDI  R31,HIGH(_trimmer_sound*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _beep_start
_0x40010:
	RJMP _0x20C000C
; 0002 0046 }
_0x4000F:
	RJMP _0x20C000C
;//------------------------------------------------------
;//------------------------------------------------------
;//------------------------------------------------------
;#define F_UP    1
;#define F_DOWN  2
;#define F_LEFT  4
;#define F_RIGHT 8
;#define _UP (mnu_keys & F_UP)
;#define _DOWN (mnu_keys & F_DOWN)
;#define _LEFT (mnu_keys & F_LEFT)
;#define _RIGHT (mnu_keys & F_RIGHT)
;//-------------------------------------------------------------
;void keys_driver(void)
; 0002 0054 {  // 20ms
_keys_driver:
; 0002 0055 unsigned char kf, n, m;
; 0002 0056 static unsigned char kf1;
; 0002 0057 static unsigned char cnt_rep;
; 0002 0058 
; 0002 0059 kf=0;
	CALL __SAVELOCR4
;	kf -> R17
;	n -> R16
;	m -> R19
	LDI  R17,LOW(0)
; 0002 005A if(!KEY_UP) kf|=F_UP;
	SBIS 0x10,4
	ORI  R17,LOW(1)
; 0002 005B if(!KEY_DOWN) kf|=F_DOWN;
	SBIS 0x10,5
	ORI  R17,LOW(2)
; 0002 005C if(!KEY_LEFT) kf|=F_LEFT;
	SBIS 0x10,6
	ORI  R17,LOW(4)
; 0002 005D if(!KEY_RIGHT) kf|=F_RIGHT;
	SBIS 0x10,7
	ORI  R17,LOW(8)
; 0002 005E for(m=1, n=0; m; m<<=1) if(kf & m) n++;
	LDI  R19,LOW(1)
	LDI  R16,LOW(0)
_0x40016:
	CPI  R19,0
	BREQ _0x40017
	MOV  R30,R19
	AND  R30,R17
	BREQ _0x40018
	SUBI R16,-1
; 0002 005F if(n>1) kf=0;
_0x40018:
	LSL  R19
	RJMP _0x40016
_0x40017:
	CPI  R16,2
	BRLO _0x40019
	LDI  R17,LOW(0)
; 0002 0060 if(kf!=kf1) { kf1=kf; mnu_keys=0; cnt_rep=0; return; }
_0x40019:
	LDS  R30,_kf1_S0020001000
	CP   R30,R17
	BREQ _0x4001A
	STS  _kf1_S0020001000,R17
	LDI  R30,LOW(0)
	STS  _mnu_keys,R30
	STS  _cnt_rep_S0020001000,R30
	CALL __LOADLOCR4
	RJMP _0x20C000B
; 0002 0061 if(kf==0) { mnu_keys=0; cnt_rep=0; return; }// all up
_0x4001A:
	CPI  R17,0
	BRNE _0x4001B
	LDI  R30,LOW(0)
	STS  _mnu_keys,R30
	STS  _cnt_rep_S0020001000,R30
	CALL __LOADLOCR4
	RJMP _0x20C000B
; 0002 0062 if(!cnt_rep) mnu_keys=kf;
_0x4001B:
	LDS  R30,_cnt_rep_S0020001000
	CPI  R30,0
	BRNE _0x4001C
	STS  _mnu_keys,R17
; 0002 0063 cnt_rep++;
_0x4001C:
	LDS  R30,_cnt_rep_S0020001000
	SUBI R30,-LOW(1)
	STS  _cnt_rep_S0020001000,R30
; 0002 0064 if( ((kf & F_UP) || (kf & F_DOWN)) && g_rep)
	SBRC R17,0
	RJMP _0x4001E
	SBRS R17,1
	RJMP _0x40020
_0x4001E:
	LDS  R30,_g_rep
	CPI  R30,0
	BRNE _0x40021
_0x40020:
	RJMP _0x4001D
_0x40021:
; 0002 0065   {
; 0002 0066   if(cnt_rep>g_rep+25) cnt_rep=25;
	LDS  R30,_g_rep
	SUBI R30,-LOW(25)
	LDS  R26,_cnt_rep_S0020001000
	CP   R30,R26
	BRSH _0x40022
	LDI  R30,LOW(25)
	STS  _cnt_rep_S0020001000,R30
; 0002 0067   if(cnt_rep==25) mnu_keys=kf;
_0x40022:
	LDS  R26,_cnt_rep_S0020001000
	CPI  R26,LOW(0x19)
	BRNE _0x40023
	STS  _mnu_keys,R17
; 0002 0068   }
_0x40023:
; 0002 0069 }
_0x4001D:
	CALL __LOADLOCR4
	RJMP _0x20C000B
;//-------------------------------------------------------------
;void TimerOn(void)
; 0002 006C {// 50Hz (20ms)
_TimerOn:
; 0002 006D #define TIME_DISPL_TEMPERATURE 50*10
; 0002 006E #define WAIT_DISPL_TEMPERATURE 50*2
; 0002 006F static unsigned char dev_clip=0;
; 0002 0070 static unsigned char dev_timer=0;
; 0002 0071 unsigned int i;
; 0002 0072 
; 0002 0073 if(g_MainMenuMode==0 || dev_clip==0)
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDS  R26,_g_MainMenuMode
	CPI  R26,LOW(0x0)
	BREQ _0x40025
	LDS  R26,_dev_clip_S0020002000
	CPI  R26,LOW(0x0)
	BRNE _0x40024
_0x40025:
; 0002 0074   {
; 0002 0075   cur_Batt=read_adc(ch_Batt);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _read_adc
	STS  _cur_Batt,R30
	STS  _cur_Batt+1,R31
; 0002 0076   cur_Power=read_adc(ch_Power);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _read_adc
	STS  _cur_Power,R30
	STS  _cur_Power+1,R31
; 0002 0077   }
; 0002 0078 i=read_adc(ch_Temperature);
_0x40024:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _read_adc
	MOVW R16,R30
; 0002 0079 if(i!=cur_Temperature)
	LDS  R30,_cur_Temperature
	LDS  R31,_cur_Temperature+1
	CP   R30,R16
	CPC  R31,R17
	BREQ _0x40027
; 0002 007A   {
; 0002 007B   if(++wd_Temperature>WAIT_DISPL_TEMPERATURE)
	LDS  R26,_wd_Temperature
	SUBI R26,-LOW(1)
	STS  _wd_Temperature,R26
	CPI  R26,LOW(0x65)
	BRLO _0x40028
; 0002 007C     {
; 0002 007D     wd_Temperature=0;
	LDI  R30,LOW(0)
	STS  _wd_Temperature,R30
; 0002 007E     if(i>cur_Temperature) dir_Temperature=TIME_DISPL_TEMPERATURE;
	LDS  R30,_cur_Temperature
	LDS  R31,_cur_Temperature+1
	CP   R30,R16
	CPC  R31,R17
	BRSH _0x40029
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RJMP _0x401D9
; 0002 007F     else if(i<cur_Temperature) dir_Temperature=-TIME_DISPL_TEMPERATURE;
_0x40029:
	LDS  R30,_cur_Temperature
	LDS  R31,_cur_Temperature+1
	CP   R16,R30
	CPC  R17,R31
	BRSH _0x4002B
	LDI  R30,LOW(65036)
	LDI  R31,HIGH(65036)
_0x401D9:
	STS  _dir_Temperature,R30
	STS  _dir_Temperature+1,R31
; 0002 0080     cur_Temperature=i;
_0x4002B:
	__PUTWMRN _cur_Temperature,0,16,17
; 0002 0081     }
; 0002 0082   }
_0x40028:
; 0002 0083 else wd_Temperature=0;
	RJMP _0x4002C
_0x40027:
	LDI  R30,LOW(0)
	STS  _wd_Temperature,R30
; 0002 0084 if(dir_Temperature>0) dir_Temperature--;
_0x4002C:
	LDS  R26,_dir_Temperature
	LDS  R27,_dir_Temperature+1
	CALL __CPW02
	BRGE _0x4002D
	LDI  R26,LOW(_dir_Temperature)
	LDI  R27,HIGH(_dir_Temperature)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	RJMP _0x401DA
; 0002 0085 else if(dir_Temperature<0) dir_Temperature++;
_0x4002D:
	LDS  R26,_dir_Temperature+1
	TST  R26
	BRPL _0x4002F
	LDI  R26,LOW(_dir_Temperature)
	LDI  R27,HIGH(_dir_Temperature)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
_0x401DA:
	ST   -X,R31
	ST   -X,R30
; 0002 0086 if(++dev_clip>=30)  { dev_clip=0; f_clip=!f_clip; }
_0x4002F:
	LDS  R26,_dev_clip_S0020002000
	SUBI R26,-LOW(1)
	STS  _dev_clip_S0020002000,R26
	CPI  R26,LOW(0x1E)
	BRLO _0x40030
	LDI  R30,LOW(0)
	STS  _dev_clip_S0020002000,R30
	LDI  R30,LOW(32)
	EOR  R3,R30
; 0002 0087 if (f_timer_en)
_0x40030:
	SBRS R2,6
	RJMP _0x40031
; 0002 0088   { //  
; 0002 0089   if (++dev_timer>=50)
	LDS  R26,_dev_timer_S0020002000
	SUBI R26,-LOW(1)
	STS  _dev_timer_S0020002000,R26
	CPI  R26,LOW(0x32)
	BRLO _0x40032
; 0002 008A     {
; 0002 008B     dev_timer=0;
	LDI  R30,LOW(0)
	STS  _dev_timer_S0020002000,R30
; 0002 008C     if(cur_model.timer_mode!=1)
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x18)
	CPI  R30,LOW(0x8)
	BREQ _0x40033
; 0002 008D       {
; 0002 008E       time++;
	LDI  R26,LOW(_time)
	LDI  R27,HIGH(_time)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0002 008F       if(time && !(time%cur_model.timer_set)) f_beep_timer=1;
	LDS  R30,_time
	LDS  R31,_time+1
	SBIW R30,0
	BREQ _0x40035
	__GETW1MN _cur_model,9
	LDS  R26,_time
	LDS  R27,_time+1
	CALL __MODW21U
	SBIW R30,0
	BREQ _0x40036
_0x40035:
	RJMP _0x40034
_0x40036:
	SET
	BLD  R2,2
; 0002 0090       }
_0x40034:
; 0002 0091     else
	RJMP _0x40037
_0x40033:
; 0002 0092       {
; 0002 0093       if(time) time--;
	LDS  R30,_time
	LDS  R31,_time+1
	SBIW R30,0
	BREQ _0x40038
	LDI  R26,LOW(_time)
	LDI  R27,HIGH(_time)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0002 0094       if(time==0) { f_timer_en=0; f_beep_timer=1; }
_0x40038:
	LDS  R30,_time
	LDS  R31,_time+1
	SBIW R30,0
	BRNE _0x40039
	CLT
	BLD  R2,6
	SET
	BLD  R2,2
; 0002 0095       }
_0x40039:
_0x40037:
; 0002 0096     }
; 0002 0097   }
_0x40032:
; 0002 0098 if(div_beep_batt) div_beep_batt--;
_0x40031:
	LDS  R30,_div_beep_batt
	CPI  R30,0
	BREQ _0x4003A
	SUBI R30,LOW(1)
	STS  _div_beep_batt,R30
; 0002 0099 if(div_trimmer) { div_trimmer--;  if(div_trimmer==1) save_trimmer();  }
_0x4003A:
	LDS  R30,_div_trimmer
	LDS  R31,_div_trimmer+1
	SBIW R30,0
	BREQ _0x4003B
	LDI  R26,LOW(_div_trimmer)
	LDI  R27,HIGH(_div_trimmer)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	LDS  R26,_div_trimmer
	LDS  R27,_div_trimmer+1
	SBIW R26,1
	BRNE _0x4003C
	RCALL _save_trimmer
_0x4003C:
; 0002 009A 
; 0002 009B keys_driver();
_0x4003B:
	RCALL _keys_driver
; 0002 009C keys_menu();
	RCALL _keys_menu
; 0002 009D beep_work();
	RCALL _beep_work
; 0002 009E }
	LD   R16,Y+
	LD   R17,Y+
	RET
;//-------------------------------------------------------------
;void save_trimmer(void)
; 0002 00A1 {
_save_trimmer:
; 0002 00A2 unsigned char i;
; 0002 00A3 
; 0002 00A4 if(!div_trimmer) return;
	ST   -Y,R17
;	i -> R17
	LDS  R30,_div_trimmer
	LDS  R31,_div_trimmer+1
	SBIW R30,0
	BRNE _0x4003D
	RJMP _0x20C000C
; 0002 00A5 div_trimmer=0;
_0x4003D:
	LDI  R30,LOW(0)
	STS  _div_trimmer,R30
	STS  _div_trimmer+1,R30
; 0002 00A6 for(i=0; i<4; i++)
	LDI  R17,LOW(0)
_0x4003F:
	CPI  R17,4
	BRSH _0x40040
; 0002 00A7   {
; 0002 00A8   EEP_models[cur_model_ind].modes[cur_mode_ind].trimmers[i]=
; 0002 00A9       cur_model.modes[cur_mode_ind].trimmers[i];
	LDS  R30,_cur_model_ind
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,23
	MOVW R26,R30
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	SUBI R26,LOW(-161)
	SBCI R27,HIGH(-161)
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	__POINTW2MN _cur_model,23
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	SUBI R26,LOW(-161)
	SBCI R27,HIGH(-161)
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	POP  R26
	POP  R27
	CALL __EEPROMWRB
; 0002 00AA   }
	SUBI R17,-1
	RJMP _0x4003F
_0x40040:
; 0002 00AB BEEP1;
	SET
	BLD  R2,3
; 0002 00AC }
_0x20C000C:
	LD   R17,Y+
	RET
;//-------------------------------------------------------------
;void MODEL_reset(unsigned char ind)
; 0002 00AF {
_MODEL_reset:
; 0002 00B0 static signed char nod_val[CURVE_NODES]= { -100, -66, -34, 0,  34, 66, 100 };

	.DSEG

	.CSEG
; 0002 00B1 unsigned char i, j, n;
; 0002 00B2 eeprom MODEL_SET *model;
; 0002 00B3 eeprom DEF_MODE *cm;
; 0002 00B4 char buff[12];
; 0002 00B5 
; 0002 00B6 #asm("cli")
	SBIW R28,14
	CALL __SAVELOCR6
;	ind -> Y+20
;	i -> R17
;	j -> R16
;	n -> R19
;	*model -> R20,R21
;	*cm -> Y+18
;	buff -> Y+6
	cli
; 0002 00B7 model=&EEP_models[ind];
	LDD  R30,Y+20
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	SUBI R30,LOW(-_EEP_models)
	SBCI R31,HIGH(-_EEP_models)
	MOVW R20,R30
; 0002 00B8 sprintf(buff,"Model %-i ", ind+1);
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x40000,0
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	SUBI R30,-LOW(1)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0002 00B9 for (i=0; i<8; i++) model->name[i]=buff[i];
	LDI  R17,LOW(0)
_0x40043:
	CPI  R17,8
	BRSH _0x40044
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R30
	ADD  R30,R20
	ADC  R31,R21
	MOVW R0,R30
	MOVW R30,R26
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	CALL __EEPROMWRB
	SUBI R17,-1
	RJMP _0x40043
_0x40044:
; 0002 00BA model->type=0;
	MOVW R26,R20
	ADIW R26,8
	CALL __EEPROMRDB
	ANDI R30,0xFE
	CALL __EEPROMWRB
; 0002 00BB model->modulation=0; // PPM
	MOVW R26,R20
	ADIW R26,8
	CALL __EEPROMRDB
	ANDI R30,LOW(0xF9)
	CALL __EEPROMWRB
; 0002 00BC model->timer_mode=0;
	MOVW R26,R20
	ADIW R26,8
	CALL __EEPROMRDB
	ANDI R30,LOW(0xE7)
	CALL __EEPROMWRB
; 0002 00BD model->timer_set=300;
	MOVW R26,R20
	ADIW R26,9
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	CALL __EEPROMWRW
; 0002 00BE model->num_ch=6;
	MOVW R26,R20
	ADIW R26,11
	CALL __EEPROMRDB
	ANDI R30,LOW(0xF0)
	ORI  R30,LOW(0x6)
	CALL __EEPROMWRB
; 0002 00BF model->num_freq=0;
	MOVW R26,R20
	ADIW R26,12
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0002 00C0 for (i=0; i<MAX_CONTRS; i++) model->contrs_reverse[i]=1;
	LDI  R17,LOW(0)
_0x40046:
	CPI  R17,10
	BRSH _0x40047
	MOVW R26,R20
	ADIW R26,13
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
	SUBI R17,-1
	RJMP _0x40046
_0x40047:
; 0002 00C1 for (i=0; i<3; i++)
	LDI  R17,LOW(0)
_0x40049:
	CPI  R17,3
	BRLO PC+3
	JMP _0x4004A
; 0002 00C2   {
; 0002 00C3   cm=&model->modes[i];
	MOVW R26,R20
	ADIW R26,23
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	STD  Y+18,R30
	STD  Y+18+1,R31
; 0002 00C4   for(j=0; j<3; j++)
	LDI  R16,LOW(0)
_0x4004C:
	CPI  R16,3
	BRLO PC+3
	JMP _0x4004D
; 0002 00C5     {
; 0002 00C6     cm->contr_ab[j].minRates=100;  cm->contr_ab[j].maxRates=100;
	MOV  R30,R16
	LDI  R31,0
	__GETWRS 22,23,18
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
	MOV  R30,R16
	LDI  R31,0
	__GETWRS 22,23,18
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
; 0002 00C7     cm->contr_ab[j].minDRates=150; cm->contr_ab[j].maxDRates=150;
	MOV  R30,R16
	LDI  R31,0
	__GETWRS 22,23,18
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LDI  R30,LOW(150)
	CALL __EEPROMWRB
	MOV  R30,R16
	LDI  R31,0
	__GETWRS 22,23,18
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,3
	LDI  R30,LOW(150)
	CALL __EEPROMWRB
; 0002 00C8     for(n=0; n<CURVE_NODES; n++) cm->contr_ab[j].cur_nodes[n]=nod_val[n];
	LDI  R19,LOW(0)
_0x4004F:
	CPI  R19,7
	BRSH _0x40050
	MOV  R30,R16
	LDI  R31,0
	__GETWRS 22,23,18
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,4
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_nod_val_S0020004000)
	SBCI R31,HIGH(-_nod_val_S0020004000)
	LD   R30,Z
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x4004F
_0x40050:
; 0002 00C9 }
	SUBI R16,-1
	RJMP _0x4004C
_0x4004D:
; 0002 00CA   cm->contr_tr.minRates=100;  cm->contr_tr.maxRates=100;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,33
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,34
	CALL __EEPROMWRB
; 0002 00CB   cm->contr_tr.tcut=120;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,35
	LDI  R30,LOW(120)
	CALL __EEPROMWRB
; 0002 00CC   for(n=0; n<CURVE_NODES; n++) cm->contr_tr.cur_nodes[n]=nod_val[n];
	LDI  R19,LOW(0)
_0x40052:
	CPI  R19,7
	BRSH _0x40053
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,36
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_nod_val_S0020004000)
	SBCI R31,HIGH(-_nod_val_S0020004000)
	LD   R30,Z
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x40052
_0x40053:
; 0002 00CD cm->contr_ap.minRates=100;  cm->contr_ap.maxRates=100;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,43
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,44
	CALL __EEPROMWRB
; 0002 00CE   for(n=0; n<CURVE_NODES; n++) cm->contr_ap.cur_nodes[n]=nod_val[n];
	LDI  R19,LOW(0)
_0x40055:
	CPI  R19,7
	BRSH _0x40056
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,45
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_nod_val_S0020004000)
	SBCI R31,HIGH(-_nod_val_S0020004000)
	LD   R30,Z
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x40055
_0x40056:
; 0002 00CF for(j=0; j<3; j++)
	LDI  R16,LOW(0)
_0x40058:
	CPI  R16,3
	BRSH _0x40059
; 0002 00D0     {
; 0002 00D1     cm->contr_d[j].minRates=100;  cm->contr_d[j].maxRates=100;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,52
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,52
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
; 0002 00D2     cm->contr_d[j].delay=0;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,52
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0002 00D3     }
	SUBI R16,-1
	RJMP _0x40058
_0x40059:
; 0002 00D4   for(j=0; j<2; j++)
	LDI  R16,LOW(0)
_0x4005B:
	CPI  R16,2
	BRLO PC+3
	JMP _0x4005C
; 0002 00D5     {
; 0002 00D6     cm->contr_v[j].minRates=100;  cm->contr_v[j].maxRates=100;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,61
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,61
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LDI  R30,LOW(100)
	CALL __EEPROMWRB
; 0002 00D7     cm->contr_v[j].from=j;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,61
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,2
	MOV  R30,R16
	CALL __EEPROMWRB
; 0002 00D8     for(n=0; n<CURVE_NODES; n++) cm->contr_v[j].cur_nodes[n]=nod_val[n];
	LDI  R19,LOW(0)
_0x4005E:
	CPI  R19,7
	BRSH _0x4005F
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,61
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,3
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_nod_val_S0020004000)
	SBCI R31,HIGH(-_nod_val_S0020004000)
	LD   R30,Z
	CALL __EEPROMWRB
	SUBI R19,-1
	RJMP _0x4005E
_0x4005F:
; 0002 00D9 }
	SUBI R16,-1
	RJMP _0x4005B
_0x4005C:
; 0002 00DA   for(j=0; j<MAX_CHANS; j++)
	LDI  R16,LOW(0)
_0x40061:
	CPI  R16,8
	BRSH _0x40062
; 0002 00DB     for(n=0; n<MAX_CONTRS; n++)
	LDI  R19,LOW(0)
_0x40064:
	CPI  R19,10
	BRSH _0x40065
; 0002 00DC       if(j==n) cm->chanels[j][n]=100; else cm->chanels[j][n]=0;
	CP   R19,R16
	BRNE _0x40066
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	SUBI R26,LOW(-81)
	SBCI R27,HIGH(-81)
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	LDI  R30,LOW(100)
	RJMP _0x401DB
_0x40066:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	SUBI R26,LOW(-81)
	SBCI R27,HIGH(-81)
	MOV  R30,R16
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
_0x401DB:
	CALL __EEPROMWRB
; 0002 00DD   for(j=0; j<4; j++) cm->trimmers[j]=0;
	SUBI R19,-1
	RJMP _0x40064
_0x40065:
	SUBI R16,-1
	RJMP _0x40061
_0x40062:
	LDI  R16,LOW(0)
_0x40069:
	CPI  R16,4
	BRSH _0x4006A
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	SUBI R26,LOW(-161)
	SBCI R27,HIGH(-161)
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	CALL __EEPROMWRB
	SUBI R16,-1
	RJMP _0x40069
_0x4006A:
; 0002 00DE }
	SUBI R17,-1
	RJMP _0x40049
_0x4004A:
; 0002 00DF #asm("sei")
	sei
; 0002 00E0 }
	CALL __LOADLOCR6
	ADIW R28,21
	RET
;//-------------------------------------------------------------
;void MODEL_init(unsigned char ind)
; 0002 00E3 {
_MODEL_init:
; 0002 00E4 #asm("cli")
;	ind -> Y+0
	cli
; 0002 00E5 save_trimmer();
	RCALL _save_trimmer
; 0002 00E6 cur_model_ind=ind;
	LD   R30,Y
	STS  _cur_model_ind,R30
; 0002 00E7 cur_model=EEP_models[ind];
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	SUBI R30,LOW(-_EEP_models)
	SBCI R31,HIGH(-_EEP_models)
	LDI  R26,LOW(_cur_model)
	LDI  R27,HIGH(_cur_model)
	LDI  R24,LOW(518)
	LDI  R25,HIGH(518)
	CALL __COPYME
; 0002 00E8 if (cur_model.modulation==0) TCCR1A=0x82;
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x6)
	BRNE _0x4006B
	LDI  R30,LOW(130)
	OUT  0x2F,R30
; 0002 00E9 if (cur_model.modulation==1) TCCR1A=0xC2;
_0x4006B:
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x6)
	CPI  R30,LOW(0x2)
	BRNE _0x4006C
	LDI  R30,LOW(194)
	OUT  0x2F,R30
; 0002 00EA if (cur_model.timer_mode!=1) time=0;
_0x4006C:
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x18)
	CPI  R30,LOW(0x8)
	BREQ _0x4006D
	LDI  R30,LOW(0)
	STS  _time,R30
	STS  _time+1,R30
; 0002 00EB else time=cur_model.timer_set;
	RJMP _0x4006E
_0x4006D:
	__GETW1MN _cur_model,9
	STS  _time,R30
	STS  _time+1,R31
; 0002 00EC PLL_SetFreq(cur_model.num_freq);
_0x4006E:
	__GETB1MN _cur_model,12
	ST   -Y,R30
	CALL _PLL_SetFreq
; 0002 00ED #asm("sei")
	sei
; 0002 00EE }
	ADIW R28,1
	RET
;//-------------------------------------------------------------
;void MODEL_copy (unsigned char from, unsigned char to)
; 0002 00F1 {
_MODEL_copy:
; 0002 00F2 unsigned char i;
; 0002 00F3 #asm("cli")
	ST   -Y,R17
;	from -> Y+2
;	to -> Y+1
;	i -> R17
	cli
; 0002 00F4 EEP_models[to].type=EEP_models[from].type;
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,8
	MOVW R22,R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,8
	MOVW R26,R30
	CALL __EEPROMRDB
	ANDI R30,LOW(0x1)
	MOVW R26,R22
	ANDI R30,LOW(0x1)
	MOV  R0,R30
	CALL __EEPROMRDB
	ANDI R30,0xFE
	OR   R30,R0
	CALL __EEPROMWRB
; 0002 00F5 EEP_models[to].modulation=EEP_models[from].modulation;
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,8
	MOVW R22,R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,8
	MOVW R26,R30
	CALL __EEPROMRDB
	LSR  R30
	ANDI R30,LOW(0x3)
	MOVW R26,R22
	ANDI R30,LOW(0x3)
	LSL  R30
	MOV  R0,R30
	CALL __EEPROMRDB
	ANDI R30,LOW(0xF9)
	OR   R30,R0
	CALL __EEPROMWRB
; 0002 00F6 EEP_models[to].timer_mode=EEP_models[from].timer_mode;
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,8
	MOVW R22,R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,8
	MOVW R26,R30
	CALL __EEPROMRDB
	LSR  R30
	LSR  R30
	LSR  R30
	ANDI R30,LOW(0x3)
	MOVW R26,R22
	ANDI R30,LOW(0x3)
	LSL  R30
	LSL  R30
	LSL  R30
	MOV  R0,R30
	CALL __EEPROMRDB
	ANDI R30,LOW(0xE7)
	OR   R30,R0
	CALL __EEPROMWRB
; 0002 00F7 EEP_models[to].timer_set=EEP_models[from].timer_set;
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,9
	MOVW R22,R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,9
	MOVW R26,R30
	CALL __EEPROMRDW
	MOVW R26,R22
	CALL __EEPROMWRW
; 0002 00F8 EEP_models[to].num_ch=EEP_models[from].num_ch;
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,11
	MOVW R22,R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,11
	MOVW R26,R30
	CALL __EEPROMRDB
	ANDI R30,LOW(0xF)
	MOVW R26,R22
	ANDI R30,LOW(0xF)
	MOV  R0,R30
	CALL __EEPROMRDB
	ANDI R30,LOW(0xF0)
	OR   R30,R0
	CALL __EEPROMWRB
; 0002 00F9 EEP_models[to].num_freq=EEP_models[from].num_freq;
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,12
	MOVW R22,R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,12
	MOVW R26,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
; 0002 00FA for(i=0; i<MAX_CONTRS; i++)
	LDI  R17,LOW(0)
_0x40070:
	CPI  R17,10
	BRSH _0x40071
; 0002 00FB   EEP_models[to].contrs_reverse[i]=EEP_models[from].contrs_reverse[i];
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,13
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,13
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL __EEPROMRDB
	MOVW R26,R22
	CALL __EEPROMWRB
	SUBI R17,-1
	RJMP _0x40070
_0x40071:
; 0002 00FC for(i=0; i<3; i++) EEP_models[to].modes[i]=EEP_models[from].modes[i];
	LDI  R17,LOW(0)
_0x40073:
	CPI  R17,3
	BRSH _0x40074
	LDD  R30,Y+1
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,23
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	PUSH R31
	PUSH R30
	LDD  R30,Y+2
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	__ADDW1MN _EEP_models,23
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	POP  R26
	POP  R27
	LDI  R24,165
	CALL __COPYEEL
	SUBI R17,-1
	RJMP _0x40073
_0x40074:
; 0002 00FD #asm("sei")
	sei
; 0002 00FE }
	RJMP _0x20C0009
;//-------------------------------------------------------------
;unsigned char g_list_topitem=0;
;unsigned char g_list_selitem=0;
;unsigned char g_list_cnt=0;
;
;//----------------
;void list_ini (unsigned char cnt,unsigned char sel)
; 0002 0106 {
_list_ini:
; 0002 0107 g_list_cnt=cnt; g_list_selitem=sel; g_list_topitem=0;
;	cnt -> Y+1
;	sel -> Y+0
	LDD  R30,Y+1
	STS  _g_list_cnt,R30
	LD   R30,Y
	STS  _g_list_selitem,R30
	LDI  R30,LOW(0)
	STS  _g_list_topitem,R30
; 0002 0108 if(g_list_selitem>=(g_list_topitem+MAX_LIST_LINES))
	SUBI R30,-LOW(5)
	LDS  R26,_g_list_selitem
	CP   R26,R30
	BRLO _0x40075
; 0002 0109   g_list_topitem=g_list_selitem-(MAX_LIST_LINES-1);
	LDS  R30,_g_list_selitem
	SUBI R30,LOW(4)
	RJMP _0x401DC
; 0002 010A else if(g_list_selitem<g_list_topitem) g_list_topitem=g_list_selitem;
_0x40075:
	LDS  R30,_g_list_topitem
	LDS  R26,_g_list_selitem
	CP   R26,R30
	BRSH _0x40077
	LDS  R30,_g_list_selitem
_0x401DC:
	STS  _g_list_topitem,R30
; 0002 010B }
_0x40077:
	ADIW R28,2
	RET
;//----------------
;void list_scroll (void)
; 0002 010E {
_list_scroll:
; 0002 010F if(_DOWN)
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x40078
; 0002 0110   {
; 0002 0111   if(g_list_selitem==g_list_cnt-1) return;
	LDS  R30,_g_list_cnt
	SUBI R30,LOW(1)
	LDS  R26,_g_list_selitem
	CP   R30,R26
	BRNE _0x40079
	RET
; 0002 0112   g_list_selitem++;
_0x40079:
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	STS  _g_list_selitem,R30
; 0002 0113   if(g_list_selitem>=(g_list_topitem+MAX_LIST_LINES))
	LDS  R30,_g_list_topitem
	SUBI R30,-LOW(5)
	LDS  R26,_g_list_selitem
	CP   R26,R30
	BRLO _0x4007A
; 0002 0114     g_list_topitem=g_list_selitem-(MAX_LIST_LINES-1);
	LDS  R30,_g_list_selitem
	SUBI R30,LOW(4)
	STS  _g_list_topitem,R30
; 0002 0115   BEEP;
_0x4007A:
	RJMP _0x401DD
; 0002 0116   }
; 0002 0117 else if(_UP)
_0x40078:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x4007C
; 0002 0118   {
; 0002 0119    if(g_list_selitem==0) return;
	LDS  R30,_g_list_selitem
	CPI  R30,0
	BRNE _0x4007D
	RET
; 0002 011A   g_list_selitem--;
_0x4007D:
	LDS  R30,_g_list_selitem
	SUBI R30,LOW(1)
	STS  _g_list_selitem,R30
; 0002 011B   if(g_list_selitem<g_list_topitem) g_list_topitem=g_list_selitem;
	LDS  R30,_g_list_topitem
	LDS  R26,_g_list_selitem
	CP   R26,R30
	BRSH _0x4007E
	LDS  R30,_g_list_selitem
	STS  _g_list_topitem,R30
; 0002 011C   BEEP;
_0x4007E:
_0x401DD:
	SET
	BLD  R2,4
; 0002 011D   }
; 0002 011E }
_0x4007C:
	RET
;//----------------
;void list_scroll_roll(void)
; 0002 0121 {
_list_scroll_roll:
; 0002 0122 if(g_list_selitem==g_list_cnt-1) { g_list_selitem=0; g_list_topitem=0; }
	LDS  R30,_g_list_cnt
	SUBI R30,LOW(1)
	LDS  R26,_g_list_selitem
	CP   R30,R26
	BRNE _0x4007F
	LDI  R30,LOW(0)
	STS  _g_list_selitem,R30
	RJMP _0x401DE
; 0002 0123 else
_0x4007F:
; 0002 0124   {
; 0002 0125   g_list_selitem++;
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	STS  _g_list_selitem,R30
; 0002 0126   if(g_list_selitem>=(g_list_topitem+MAX_LIST_LINES))
	LDS  R30,_g_list_topitem
	SUBI R30,-LOW(5)
	LDS  R26,_g_list_selitem
	CP   R26,R30
	BRLO _0x40081
; 0002 0127     g_list_topitem=g_list_selitem-(MAX_LIST_LINES-1);
	LDS  R30,_g_list_selitem
	SUBI R30,LOW(4)
_0x401DE:
	STS  _g_list_topitem,R30
; 0002 0128   }
_0x40081:
; 0002 0129 BEEP;
	SET
	BLD  R2,4
; 0002 012A }
	RET
;//-------------------------------------------------------------
;void change_paru(unsigned char *par, unsigned char max)
; 0002 012D {
_change_paru:
; 0002 012E if(_UP && (*par)<max) { (*par)++; BEEP; }
;	*par -> Y+1
;	max -> Y+0
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x40083
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	LD   R30,Y
	CP   R26,R30
	BRLO _0x40084
_0x40083:
	RJMP _0x40082
_0x40084:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	SUBI R30,-LOW(1)
	RJMP _0x401DF
; 0002 012F else if(_DOWN && (*par)>0) { (*par)--; BEEP; }
_0x40082:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x40087
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRSH _0x40088
_0x40087:
	RJMP _0x40086
_0x40088:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	SUBI R30,LOW(1)
_0x401DF:
	ST   X,R30
	SET
	BLD  R2,4
; 0002 0130 }
_0x40086:
	RJMP _0x20C000A
;//-------------------------------------------------------------
;void change_pars(signed char *par, signed char min, signed char max)
; 0002 0133 {
_change_pars:
; 0002 0134 if(_UP && (*par)<max) { (*par)++; BEEP; }
;	*par -> Y+2
;	min -> Y+1
;	max -> Y+0
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x4008A
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R26,X
	LD   R30,Y
	CP   R26,R30
	BRLT _0x4008B
_0x4008A:
	RJMP _0x40089
_0x4008B:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	SUBI R30,-LOW(1)
	RJMP _0x401E0
; 0002 0135 else if(_DOWN && (*par)>min) { (*par)--; BEEP; }
_0x40089:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x4008E
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R26,X
	LDD  R30,Y+1
	CP   R30,R26
	BRLT _0x4008F
_0x4008E:
	RJMP _0x4008D
_0x4008F:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	SUBI R30,LOW(1)
_0x401E0:
	ST   X,R30
	SET
	BLD  R2,4
; 0002 0136 }
_0x4008D:
_0x20C000B:
	ADIW R28,4
	RET
;//-------------------------------------------------------------
;void change_parr(unsigned char *par, unsigned char max)
; 0002 0139 {
_change_parr:
; 0002 013A if(_UP) { if((*par)>0) (*par)--; else *par=max; BEEP; }
;	*par -> Y+1
;	max -> Y+0
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x40090
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRLO _0x40091
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	SUBI R30,LOW(1)
	RJMP _0x401E1
_0x40091:
	LD   R30,Y
	LDD  R26,Y+1
	LDD  R27,Y+1+1
_0x401E1:
	ST   X,R30
	RJMP _0x401E2
; 0002 013B else if(_DOWN) { if((*par)<max) (*par)++; else *par=0; BEEP; }
_0x40090:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x40094
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	LD   R30,Y
	CP   R26,R30
	BRSH _0x40095
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	SUBI R30,-LOW(1)
	RJMP _0x401E3
_0x40095:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(0)
_0x401E3:
	ST   X,R30
_0x401E2:
	SET
	BLD  R2,4
; 0002 013C }
_0x40094:
	RJMP _0x20C000A
;//-------------------------------------------------------------
;void change_name_ch(unsigned char *ch)
; 0002 013F {
_change_name_ch:
; 0002 0140 char i;
; 0002 0141 
; 0002 0142 if(!_UP && !_DOWN) return;
	ST   -Y,R17
;	*ch -> Y+1
;	i -> R17
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BRNE _0x40098
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x40099
_0x40098:
	RJMP _0x40097
_0x40099:
	RJMP _0x20C0009
; 0002 0143 for(i=0; i<sizeof(Name_table); i++) if( *ch==Name_table[i]) break;
_0x40097:
	LDI  R17,LOW(0)
_0x4009B:
	MOV  R26,R17
	LDI  R30,LOW(65)
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x4009C
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	CP   R30,R26
	BREQ _0x4009C
; 0002 0144 if(i==sizeof(Name_table)) i=0;
	SUBI R17,-1
	RJMP _0x4009B
_0x4009C:
	CPI  R17,65
	BRNE _0x4009E
	LDI  R17,LOW(0)
; 0002 0145 if(_UP) { if(i<sizeof(Name_table)-1) i++; else i=0; }
_0x4009E:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x4009F
	CPI  R17,64
	BRGE _0x400A0
	SUBI R17,-1
	RJMP _0x400A1
_0x400A0:
	LDI  R17,LOW(0)
_0x400A1:
; 0002 0146 else if(_DOWN) { if(i>0) i--; else i=sizeof(Name_table)-1;  }
	RJMP _0x400A2
_0x4009F:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x400A3
	CPI  R17,1
	BRLT _0x400A4
	SUBI R17,1
	RJMP _0x400A5
_0x400A4:
	LDI  R17,LOW(64)
_0x400A5:
; 0002 0147 *ch=Name_table[i];
_0x400A3:
_0x400A2:
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_Name_table*2)
	SBCI R31,HIGH(-_Name_table*2)
	LPM  R30,Z
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ST   X,R30
; 0002 0148 BEEP;
	SET
	BLD  R2,4
; 0002 0149 }
_0x20C0009:
	LDD  R17,Y+0
_0x20C000A:
	ADIW R28,3
	RET
;//-------------------------------------------------------------
;void keys_menu(void)
; 0002 014C {
_keys_menu:
; 0002 014D unsigned char ind, ch, v;
; 0002 014E unsigned int i;
; 0002 014F DEF_MODE *rm;
; 0002 0150 unsigned char *p1;
; 0002 0151 eeprom unsigned char *p2;
; 0002 0152 
; 0002 0153 switch(pos[0])
	SBIW R28,6
	CALL __SAVELOCR6
;	ind -> R17
;	ch -> R16
;	v -> R19
;	i -> R20,R21
;	*rm -> Y+10
;	*p1 -> Y+8
;	*p2 -> Y+6
	LDS  R30,_pos
; 0002 0154   {
; 0002 0155   case 0: // Main screen
	CPI  R30,0
	BREQ PC+3
	JMP _0x400A9
; 0002 0156     if(_UP)
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x400AA
; 0002 0157      {
; 0002 0158      if(cur_model.timer_mode!=2)
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x18)
	CPI  R30,LOW(0x10)
	BREQ _0x400AB
; 0002 0159        {
; 0002 015A        if(!f_timer_en)
	SBRC R2,6
	RJMP _0x400AC
; 0002 015B          {
; 0002 015C          if(cur_model.timer_mode==1 && time==0) time=cur_model.timer_set;
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x18)
	CPI  R30,LOW(0x8)
	BRNE _0x400AE
	LDS  R26,_time
	LDS  R27,_time+1
	SBIW R26,0
	BREQ _0x400AF
_0x400AE:
	RJMP _0x400AD
_0x400AF:
	__GETW1MN _cur_model,9
	STS  _time,R30
	STS  _time+1,R31
; 0002 015D          f_timer_en=1;
_0x400AD:
	SET
	RJMP _0x401E4
; 0002 015E          }
; 0002 015F        else f_timer_en=0;
_0x400AC:
	CLT
_0x401E4:
	BLD  R2,6
; 0002 0160        BEEP;
	SET
	BLD  R2,4
; 0002 0161        }
; 0002 0162      }
_0x400AB:
; 0002 0163    if(_DOWN)
_0x400AA:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x400B1
; 0002 0164      {
; 0002 0165      if(cur_model.timer_mode!=2) f_timer_en=0;
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x18)
	CPI  R30,LOW(0x10)
	BREQ _0x400B2
	CLT
	BLD  R2,6
; 0002 0166      if(cur_model.timer_mode==1) time=cur_model.timer_set; else time=0;
_0x400B2:
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x18)
	CPI  R30,LOW(0x8)
	BRNE _0x400B3
	__GETW1MN _cur_model,9
	STS  _time,R30
	STS  _time+1,R31
	RJMP _0x400B4
_0x400B3:
	LDI  R30,LOW(0)
	STS  _time,R30
	STS  _time+1,R30
; 0002 0167      BEEP;
_0x400B4:
	SET
	BLD  R2,4
; 0002 0168      }
; 0002 0169    if(_RIGHT) { pos[0]=1; pos[1]=0; list_ini(menuT0L, 0); g_rep=REP_SLOW; BEEP;  }
_0x400B1:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x400B5
	LDI  R30,LOW(1)
	STS  _pos,R30
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	SET
	BLD  R2,4
; 0002 016A    if(_LEFT)
_0x400B5:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x400B6
; 0002 016B      {
; 0002 016C      if(g_MainMenuMode<1) g_MainMenuMode++; else g_MainMenuMode=0;
	LDS  R26,_g_MainMenuMode
	CPI  R26,LOW(0x1)
	BRSH _0x400B7
	LDS  R30,_g_MainMenuMode
	SUBI R30,-LOW(1)
	RJMP _0x401E5
_0x400B7:
	LDI  R30,LOW(0)
_0x401E5:
	STS  _g_MainMenuMode,R30
; 0002 016D      BEEP;
	SET
	BLD  R2,4
; 0002 016E      }
; 0002 016F   break;
_0x400B6:
	JMP  _0x400A8
; 0002 0170   case 1:
_0x400A9:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x400A8
; 0002 0171   switch(pos[1])
	__GETB1MN _pos,1
; 0002 0172     {
; 0002 0173     case 0: // 
	CPI  R30,0
	BREQ PC+3
	JMP _0x400BD
; 0002 0174     if(_LEFT) { pos[0]=0; g_rep=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x400BE
	LDI  R30,LOW(0)
	STS  _pos,R30
	STS  _g_rep,R30
	SET
	BLD  R2,4
	JMP  _0x400BC
; 0002 0175     if(_RIGHT)
_0x400BE:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x400BF
; 0002 0176       {
; 0002 0177       pos[1]=g_list_selitem+1; pos[2]=0;
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,1
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
; 0002 0178       switch(pos[1])
	__GETB1MN _pos,1
; 0002 0179         {
; 0002 017A         case 1: list_ini(MAX_MODELS, cur_model_ind); break;
	CPI  R30,LOW(0x1)
	BRNE _0x400C3
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDS  R30,_cur_model_ind
	RJMP _0x401E6
; 0002 017B         case 2: list_ini(menuT1L, 0); break;
_0x400C3:
	CPI  R30,LOW(0x2)
	BRNE _0x400C4
	LDI  R30,LOW(10)
	RJMP _0x401E7
; 0002 017C         case 3: T[0]=cur_model_ind; T[1]=cur_model_ind+1; if(T[1]>=MAX_MODELS) T[1]=0; break;
_0x400C4:
	CPI  R30,LOW(0x3)
	BRNE _0x400C5
	LDS  R30,_cur_model_ind
	STS  _T,R30
	LDS  R30,_cur_model_ind
	SUBI R30,-LOW(1)
	__PUTB1MN _T,1
	__GETB2MN _T,1
	CPI  R26,LOW(0x7)
	BRLO _0x400C6
	LDI  R30,LOW(0)
	__PUTB1MN _T,1
_0x400C6:
	RJMP _0x400C2
; 0002 017D         case 4: list_ini(menuT4L, 0); break;
_0x400C5:
	CPI  R30,LOW(0x4)
	BRNE _0x400C2
	LDI  R30,LOW(5)
_0x401E7:
	ST   -Y,R30
	LDI  R30,LOW(0)
_0x401E6:
	ST   -Y,R30
	RCALL _list_ini
; 0002 017E         }
_0x400C2:
; 0002 017F       BEEP;
	SET
	BLD  R2,4
; 0002 0180       break;
	JMP  _0x400BC
; 0002 0181       }
; 0002 0182     list_scroll();
_0x400BF:
	RCALL _list_scroll
; 0002 0183     break;
	JMP  _0x400BC
; 0002 0184     case 1: // Select
_0x400BD:
	CPI  R30,LOW(0x1)
	BRNE _0x400C8
; 0002 0185       if(_LEFT) { list_ini(menuT0L, pos[1]-1); pos[1]=0; BEEP; break; } // Cancel
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x400C9
	LDI  R30,LOW(4)
	ST   -Y,R30
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
	SET
	BLD  R2,4
	JMP  _0x400BC
; 0002 0186       if(_RIGHT)
_0x400C9:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x400CA
; 0002 0187         { // OK
; 0002 0188         MODEL_init(g_list_selitem);
	LDS  R30,_g_list_selitem
	ST   -Y,R30
	RCALL _MODEL_init
; 0002 0189         EEP_start_model=g_list_selitem;
	LDS  R30,_g_list_selitem
	LDI  R26,LOW(_EEP_start_model)
	LDI  R27,HIGH(_EEP_start_model)
	CALL __EEPROMWRB
; 0002 018A //        list_ini(menuT0L, pos[1]-1); pos[1]=0;
; 0002 018B         pos[0]=0; g_rep=0;
	LDI  R30,LOW(0)
	STS  _pos,R30
	STS  _g_rep,R30
; 0002 018C         BEEP1; break;
	SET
	BLD  R2,3
	JMP  _0x400BC
; 0002 018D         }
; 0002 018E       list_scroll();
_0x400CA:
	RCALL _list_scroll
; 0002 018F     break;
	JMP  _0x400BC
; 0002 0190     case 2: // Model
_0x400C8:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x400CB
; 0002 0191     switch(pos[2])
	__GETB1MN _pos,2
; 0002 0192       {
; 0002 0193       case 0:
	CPI  R30,0
	BREQ PC+3
	JMP _0x400CF
; 0002 0194         if(_LEFT)
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BRNE PC+3
	JMP _0x400D0
; 0002 0195           {
; 0002 0196           #asm("cli")
	cli
; 0002 0197           p1=(unsigned char *)&cur_model;
	LDI  R30,LOW(_cur_model)
	LDI  R31,HIGH(_cur_model)
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0002 0198           p2=(eeprom unsigned char *)&EEP_models[cur_model_ind];
	LDS  R30,_cur_model_ind
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	SUBI R30,LOW(-_EEP_models)
	SBCI R31,HIGH(-_EEP_models)
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0002 0199           for(i=0, v=0; i<sizeof(MODEL_SET); i++)
	__GETWRN 20,21,0
	LDI  R19,LOW(0)
_0x400D2:
	__CPWRN 20,21,518
	BRSH _0x400D3
; 0002 019A             if( (*(p1+i))!=(*(p2+i)) ) { v=1; break; }
	MOVW R30,R20
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	CP   R30,R0
	BREQ _0x400D4
	LDI  R19,LOW(1)
	RJMP _0x400D3
; 0002 019B           #asm("sei")
_0x400D4:
	__ADDWRN 20,21,1
	RJMP _0x400D2
_0x400D3:
	sei
; 0002 019C           if(v) { list_ini(menuT7L, 0); pos[2]=11;  BEEP; break; }
	CPI  R19,0
	BREQ _0x400D5
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(11)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 019D           list_ini(menuT0L, pos[1]-1); pos[1]=0;
_0x400D5:
	LDI  R30,LOW(4)
	ST   -Y,R30
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
; 0002 019E           BEEP;
	SET
	BLD  R2,4
; 0002 019F           break;
	RJMP _0x400CE
; 0002 01A0           }
; 0002 01A1         if(_RIGHT)
_0x400D0:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x400D6
; 0002 01A2           {
; 0002 01A3           pos[2]=g_list_selitem+1; pos[3]=0; f_edit=0;
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
	LDI  R30,LOW(0)
	__PUTB1MN _pos,3
	CLT
	BLD  R3,3
; 0002 01A4           switch(pos[2])
	__GETB1MN _pos,2
; 0002 01A5             {
; 0002 01A6             case 1: list_ini(menuT2L, 0); break;
	CPI  R30,LOW(0x1)
	BRNE _0x400DA
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _list_ini
	RJMP _0x400D9
; 0002 01A7             case 2: list_ini(menuT5L, 0); break;
_0x400DA:
	CPI  R30,LOW(0x2)
	BRNE _0x400DB
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _list_ini
	RJMP _0x400D9
; 0002 01A8             case 8: list_ini(menuT3L, 0); break;
_0x400DB:
	CPI  R30,LOW(0x8)
	BRNE _0x400DC
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _list_ini
	RJMP _0x400D9
; 0002 01A9             case 9: T[0]=cur_mode_ind; T[1]=cur_mode_ind+1; if(T[1]>2) T[1]=0; break;
_0x400DC:
	CPI  R30,LOW(0x9)
	BRNE _0x400D9
	LDS  R30,_cur_mode_ind
	STS  _T,R30
	LDS  R30,_cur_mode_ind
	SUBI R30,-LOW(1)
	__PUTB1MN _T,1
	__GETB2MN _T,1
	CPI  R26,LOW(0x3)
	BRLO _0x400DE
	LDI  R30,LOW(0)
	__PUTB1MN _T,1
_0x400DE:
; 0002 01AA             }
_0x400D9:
; 0002 01AB           BEEP;
	SET
	BLD  R2,4
; 0002 01AC           break;
	RJMP _0x400CE
; 0002 01AD           }
; 0002 01AE         list_scroll();
_0x400D6:
	RJMP _0x401E8
; 0002 01AF       break;
; 0002 01B0       case 1: // CONTROLS
_0x400CF:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x400DF
; 0002 01B1         switch(pos[3])
	__GETB1MN _pos,3
; 0002 01B2           {
; 0002 01B3         case 0:
	CPI  R30,0
	BRNE _0x400E6
; 0002 01B4           if(_LEFT) { list_ini(menuT1L, pos[2]-1); pos[2]=0;  BEEP; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x400E4
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
; 0002 01B5           if(_RIGHT)
_0x400E4:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x400E5
; 0002 01B6             {
; 0002 01B7             pos[3]=g_list_selitem+1; pos[4]=0;
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,3
	LDI  R30,LOW(0)
	__PUTB1MN _pos,4
; 0002 01B8             f_edit=0; f_edit_cur=0;
	CLT
	BLD  R3,3
	BLD  R3,4
; 0002 01B9             BEEP;
	SET
	BLD  R2,4
; 0002 01BA             break;
	RJMP _0x400E2
; 0002 01BB             }
; 0002 01BC           list_scroll();
_0x400E5:
	RCALL _list_scroll
; 0002 01BD         break;
	RJMP _0x400E2
; 0002 01BE         default:
_0x400E6:
; 0002 01BF           ch=pos[3]-1;
	__GETB1MN _pos,3
	SUBI R30,LOW(1)
	MOV  R16,R30
; 0002 01C0           rm=&cur_model.modes[cur_mode_ind];
	__POINTW2MN _cur_model,23
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0002 01C1           if(!f_edit_cur)
	SBRC R3,4
	RJMP _0x400E7
; 0002 01C2             {
; 0002 01C3             if(_RIGHT)
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x400E8
; 0002 01C4                 {
; 0002 01C5                 if( ((ch==0 || ch==1 || ch==3) && pos[4]==5) ||
; 0002 01C6                   ((ch==2 || ch==8 || ch==9) && pos[4]==4) ||
; 0002 01C7                   (ch==7 && pos[4]==3) )
	CPI  R16,0
	BREQ _0x400EA
	CPI  R16,1
	BREQ _0x400EA
	CPI  R16,3
	BRNE _0x400EC
_0x400EA:
	__GETB2MN _pos,4
	CPI  R26,LOW(0x5)
	BREQ _0x400EE
_0x400EC:
	CPI  R16,2
	BREQ _0x400EF
	CPI  R16,8
	BREQ _0x400EF
	CPI  R16,9
	BRNE _0x400F1
_0x400EF:
	__GETB2MN _pos,4
	CPI  R26,LOW(0x4)
	BREQ _0x400EE
_0x400F1:
	CPI  R16,7
	BRNE _0x400F3
	__GETB2MN _pos,4
	CPI  R26,LOW(0x3)
	BREQ _0x400EE
_0x400F3:
	RJMP _0x400E9
_0x400EE:
; 0002 01C8                     { f_edit=0; f_edit_cur=1; pos[5]=0; g_rep=REP_SLOW; BEEP; break; }
	CLT
	BLD  R3,3
	SET
	BLD  R3,4
	LDI  R30,LOW(0)
	__PUTB1MN _pos,5
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	BLD  R2,4
	RJMP _0x400E2
; 0002 01C9                 }
_0x400E9:
; 0002 01CA             if(ch==0 || ch==1 || ch==3) v=5;
_0x400E8:
	CPI  R16,0
	BREQ _0x400F7
	CPI  R16,1
	BREQ _0x400F7
	CPI  R16,3
	BRNE _0x400F6
_0x400F7:
	LDI  R19,LOW(5)
; 0002 01CB             else if(ch==2 || ch==8 || ch==9) v=4;
	RJMP _0x400F9
_0x400F6:
	CPI  R16,2
	BREQ _0x400FB
	CPI  R16,8
	BREQ _0x400FB
	CPI  R16,9
	BRNE _0x400FA
_0x400FB:
	LDI  R19,LOW(4)
; 0002 01CC             else if(ch==7) v=3;
	RJMP _0x400FD
_0x400FA:
; 0002 01CD             else v=3;
_0x401E9:
	LDI  R19,LOW(3)
; 0002 01CE             if(!f_edit)
_0x400FD:
_0x400F9:
	SBRC R3,3
	RJMP _0x40100
; 0002 01CF               {
; 0002 01D0               if(_LEFT) { list_ini(menuT2L, pos[3]-1); pos[3]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40101
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,3
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,3
	SET
	BLD  R2,4
	RJMP _0x400E2
; 0002 01D1               if(_RIGHT) { f_edit=1; if(pos[4]!=0) g_rep=REP_FAST; BEEP; break; }
_0x40101:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40102
	SET
	BLD  R3,3
	__GETB1MN _pos,4
	CPI  R30,0
	BREQ _0x40103
	LDI  R30,LOW(5)
	STS  _g_rep,R30
_0x40103:
	SET
	BLD  R2,4
	RJMP _0x400E2
; 0002 01D2               change_parr(&pos[4], v);
_0x40102:
	__POINTW1MN _pos,4
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R19
	RCALL _change_parr
; 0002 01D3               }
; 0002 01D4             else // edit
	RJMP _0x40104
_0x40100:
; 0002 01D5               {
; 0002 01D6               if (_LEFT)  { f_edit=0; g_rep=REP_SLOW; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40105
	CLT
	BLD  R3,3
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	SET
	BLD  R2,4
	RJMP _0x400E2
; 0002 01D7               if (_RIGHT)
_0x40105:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40106
; 0002 01D8                 {
; 0002 01D9                 if(pos[4]<v) pos[4]++; else pos[4]=0;
	__GETB2MN _pos,4
	CP   R26,R19
	BRSH _0x40107
	__GETB1MN _pos,4
	SUBI R30,-LOW(1)
	RJMP _0x401EA
_0x40107:
	LDI  R30,LOW(0)
_0x401EA:
	__PUTB1MN _pos,4
; 0002 01DA                 if(pos[4]!=0) g_rep=REP_FAST; else g_rep=REP_SLOW;
	__GETB1MN _pos,4
	CPI  R30,0
	BREQ _0x40109
	LDI  R30,LOW(5)
	RJMP _0x401EB
_0x40109:
	LDI  R30,LOW(10)
_0x401EB:
	STS  _g_rep,R30
; 0002 01DB                 BEEP; break;
	SET
	BLD  R2,4
	RJMP _0x400E2
; 0002 01DC                 }
; 0002 01DD               if(pos[4]==0) // reverse
_0x40106:
	__GETB1MN _pos,4
	CPI  R30,0
	BRNE _0x4010B
; 0002 01DE                 {
; 0002 01DF                 if(_UP || _DOWN)
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BRNE _0x4010D
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x4010C
_0x4010D:
; 0002 01E0                   { if(cur_model.contrs_reverse[ch]==1) cur_model.contrs_reverse[ch]=-1;
	__POINTW2MN _cur_model,13
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0x1)
	BRNE _0x4010F
	__POINTW2MN _cur_model,13
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LDI  R30,LOW(255)
	RJMP _0x401EC
; 0002 01E1                     else cur_model.contrs_reverse[ch]=1; BEEP; }
_0x4010F:
	__POINTW2MN _cur_model,13
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LDI  R30,LOW(1)
_0x401EC:
	ST   X,R30
	SET
	BLD  R2,4
; 0002 01E2                 break;
_0x4010C:
	RJMP _0x400E2
; 0002 01E3                 }
; 0002 01E4               if(ch<=3 && ch!=2) //     
_0x4010B:
	CPI  R16,4
	BRSH _0x40112
	CPI  R16,2
	BRNE _0x40113
_0x40112:
	RJMP _0x40111
_0x40113:
; 0002 01E5                 {
; 0002 01E6                 ind=ch; if(ch>2) ind=2;
	MOV  R17,R16
	CPI  R16,3
	BRLO _0x40114
	LDI  R17,LOW(2)
; 0002 01E7                 switch(pos[4])
_0x40114:
	__GETB1MN _pos,4
; 0002 01E8                   {
; 0002 01E9                   case 1: change_paru(&rm->contr_ab[ind].minRates, 150); break;
	CPI  R30,LOW(0x1)
	BRNE _0x40118
	MOV  R30,R17
	LDI  R31,0
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	RJMP _0x401ED
; 0002 01EA                   case 2: change_paru(&rm->contr_ab[ind].maxRates, 150); break;
_0x40118:
	CPI  R30,LOW(0x2)
	BRNE _0x40119
	MOV  R30,R17
	LDI  R31,0
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,1
	RJMP _0x401ED
; 0002 01EB                   case 3: change_paru(&rm->contr_ab[ind].minDRates, 150); break;
_0x40119:
	CPI  R30,LOW(0x3)
	BRNE _0x4011A
	MOV  R30,R17
	LDI  R31,0
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,2
	RJMP _0x401ED
; 0002 01EC                   case 4: change_paru(&rm->contr_ab[ind].maxDRates, 150); break;
_0x4011A:
	CPI  R30,LOW(0x4)
	BRNE _0x40117
	MOV  R30,R17
	LDI  R31,0
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,3
_0x401ED:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(150)
	ST   -Y,R30
	RCALL _change_paru
; 0002 01ED                   }
_0x40117:
; 0002 01EE                 }
; 0002 01EF               else if (ch==2) // 
	RJMP _0x4011C
_0x40111:
	CPI  R16,2
	BRNE _0x4011D
; 0002 01F0                 {
; 0002 01F1                 switch(pos[4])
	__GETB1MN _pos,4
; 0002 01F2                   {
; 0002 01F3                   case 1: change_paru(&rm->contr_tr.minRates, 150); break;
	CPI  R30,LOW(0x1)
	BRNE _0x40121
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,33
	RJMP _0x401EE
; 0002 01F4                   case 2: change_paru(&rm->contr_tr.maxRates, 150); break;
_0x40121:
	CPI  R30,LOW(0x2)
	BRNE _0x40122
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,34
	RJMP _0x401EE
; 0002 01F5                   case 3: change_paru(&rm->contr_tr.tcut,  150); break;
_0x40122:
	CPI  R30,LOW(0x3)
	BRNE _0x40120
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,35
_0x401EE:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(150)
	ST   -Y,R30
	RCALL _change_paru
; 0002 01F6                   }
_0x40120:
; 0002 01F7                 }
; 0002 01F8               else if(ch>=4 && ch<=6) //  
	RJMP _0x40124
_0x4011D:
	CPI  R16,4
	BRLO _0x40126
	CPI  R16,7
	BRLO _0x40127
_0x40126:
	RJMP _0x40125
_0x40127:
; 0002 01F9                 {
; 0002 01FA                 ind=ch-4;
	MOV  R30,R16
	SUBI R30,LOW(4)
	MOV  R17,R30
; 0002 01FB                 switch(pos[4])
	__GETB1MN _pos,4
; 0002 01FC                   {
; 0002 01FD                   case 1: change_paru(&rm->contr_d[ind].minRates, 150); break;
	CPI  R30,LOW(0x1)
	BRNE _0x4012B
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,52
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(150)
	RJMP _0x401EF
; 0002 01FE                   case 2: change_paru(&rm->contr_d[ind].maxRates, 150); break;
_0x4012B:
	CPI  R30,LOW(0x2)
	BRNE _0x4012C
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,52
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(150)
	RJMP _0x401EF
; 0002 01FF                   case 3: change_paru(&rm->contr_d[ind].delay, 100); break;
_0x4012C:
	CPI  R30,LOW(0x3)
	BRNE _0x4012A
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,52
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(100)
_0x401EF:
	ST   -Y,R30
	RCALL _change_paru
; 0002 0200                   }
_0x4012A:
; 0002 0201                 }
; 0002 0202              else if (ch==7) //  
	RJMP _0x4012E
_0x40125:
	CPI  R16,7
	BRNE _0x4012F
; 0002 0203                 {
; 0002 0204                 switch(pos[4])
	__GETB1MN _pos,4
; 0002 0205                   {
; 0002 0206                   case 1: change_paru(&rm->contr_ap.minRates, 150); break;
	CPI  R30,LOW(0x1)
	BRNE _0x40133
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,43
	RJMP _0x401F0
; 0002 0207                   case 2: change_paru(&rm->contr_ap.maxRates, 150); break;
_0x40133:
	CPI  R30,LOW(0x2)
	BRNE _0x40132
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,44
_0x401F0:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(150)
	ST   -Y,R30
	RCALL _change_paru
; 0002 0208                   }
_0x40132:
; 0002 0209                 }
; 0002 020A               else if(ch>=8)
	RJMP _0x40135
_0x4012F:
	CPI  R16,8
	BRSH PC+3
	JMP _0x40136
; 0002 020B                 { //  
; 0002 020C                 ind=ch-8;
	MOV  R30,R16
	SUBI R30,LOW(8)
	MOV  R17,R30
; 0002 020D                 switch(pos[4])
	__GETB1MN _pos,4
; 0002 020E                   {
; 0002 020F                   case 1: change_paru(&rm->contr_v[ind].minRates, 150); break;
	CPI  R30,LOW(0x1)
	BRNE _0x4013A
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,61
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(150)
	RJMP _0x401F1
; 0002 0210                   case 2: change_paru(&rm->contr_v[ind].maxRates, 150); break;
_0x4013A:
	CPI  R30,LOW(0x2)
	BRNE _0x4013B
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,61
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(150)
	RJMP _0x401F1
; 0002 0211                   case 3: change_paru(&rm->contr_v[ind].from, 7); break;
_0x4013B:
	CPI  R30,LOW(0x3)
	BRNE _0x40139
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,61
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
_0x401F1:
	ST   -Y,R30
	RCALL _change_paru
; 0002 0212                   }
_0x40139:
; 0002 0213                 }
; 0002 0214             }
_0x40136:
_0x40135:
_0x4012E:
_0x40124:
_0x4011C:
_0x40104:
; 0002 0215           }
; 0002 0216           else // edit curve
	RJMP _0x4013D
_0x400E7:
; 0002 0217             {
; 0002 0218             if(!f_edit)
	SBRC R3,3
	RJMP _0x4013E
; 0002 0219               {
; 0002 021A               if (_LEFT)  { f_edit_cur=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x4013F
	CLT
	BLD  R3,4
	SET
	BLD  R2,4
	RJMP _0x400E2
; 0002 021B               if (_RIGHT) { f_edit=1; g_rep=REP_FAST; BEEP; break; }
_0x4013F:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40140
	SET
	BLD  R3,3
	LDI  R30,LOW(5)
	STS  _g_rep,R30
	BLD  R2,4
	RJMP _0x400E2
; 0002 021C               change_paru(&pos[5], 6);
_0x40140:
	__POINTW1MN _pos,5
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _change_paru
; 0002 021D               }
; 0002 021E             else // edit
	RJMP _0x40141
_0x4013E:
; 0002 021F               {
; 0002 0220               if (_LEFT)  { f_edit=0; g_rep=REP_SLOW; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40142
	CLT
	BLD  R3,3
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	SET
	BLD  R2,4
	RJMP _0x400E2
; 0002 0221                if (_RIGHT) { if(pos[5]<6) pos[5]++; else pos[5]=0; BEEP; break; }
_0x40142:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40143
	__GETB2MN _pos,5
	CPI  R26,LOW(0x6)
	BRSH _0x40144
	__GETB1MN _pos,5
	SUBI R30,-LOW(1)
	RJMP _0x401F2
_0x40144:
	LDI  R30,LOW(0)
_0x401F2:
	__PUTB1MN _pos,5
	SET
	BLD  R2,4
	RJMP _0x400E2
; 0002 0222               if(ch<=3 && ch!=2)
_0x40143:
	CPI  R16,4
	BRSH _0x40147
	CPI  R16,2
	BRNE _0x40148
_0x40147:
	RJMP _0x40146
_0x40148:
; 0002 0223                 { //     
; 0002 0224                 ind=ch; if(ch>2) ind=2;
	MOV  R17,R16
	CPI  R16,3
	BRLO _0x40149
	LDI  R17,LOW(2)
; 0002 0225                 change_pars(&rm->contr_ab[ind].cur_nodes[pos[5]], -100, 100);
_0x40149:
	MOV  R30,R17
	LDI  R31,0
	__GETWRS 22,23,10
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,4
	RJMP _0x401F3
; 0002 0226                 }
; 0002 0227               else if (ch==2) //
_0x40146:
	CPI  R16,2
	BRNE _0x4014B
; 0002 0228                 change_pars(&rm->contr_tr.cur_nodes[pos[5]], -100, 100);
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,36
	RJMP _0x401F3
; 0002 0229               else if (ch==7) //  
_0x4014B:
	CPI  R16,7
	BRNE _0x4014D
; 0002 022A                 change_pars(&rm->contr_ap.cur_nodes[pos[5]], -100, 100);
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,45
	RJMP _0x401F3
; 0002 022B               else if(ch>=8)
_0x4014D:
	CPI  R16,8
	BRLO _0x4014F
; 0002 022C                 { //  
; 0002 022D                 ind=ch-8;
	MOV  R30,R16
	SUBI R30,LOW(8)
	MOV  R17,R30
; 0002 022E                 change_pars(&rm->contr_v[ind].cur_nodes[pos[5]], -100, 100);
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,61
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,3
_0x401F3:
	__GETB1MN _pos,5
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(156)
	ST   -Y,R30
	LDI  R30,LOW(100)
	ST   -Y,R30
	RCALL _change_pars
; 0002 022F                 }
; 0002 0230               }
_0x4014F:
_0x40141:
; 0002 0231             }
_0x4013D:
; 0002 0232         break;
; 0002 0233         }
_0x400E2:
; 0002 0234       break;
	RJMP _0x400CE
; 0002 0235       case 2: // CHANNELS
_0x400DF:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x40150
; 0002 0236       switch(pos[3])
	__GETB1MN _pos,3
; 0002 0237         {
; 0002 0238         case 0:
	CPI  R30,0
	BRNE _0x40157
; 0002 0239         if(_LEFT) { list_ini(menuT1L, pos[2]-1); pos[2]=0;  BEEP; break;}
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40155
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x40153
; 0002 023A         if(_RIGHT)
_0x40155:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40156
; 0002 023B           {
; 0002 023C           pos[3]=g_list_selitem+1; pos[4]=0;
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,3
	LDI  R30,LOW(0)
	__PUTB1MN _pos,4
; 0002 023D           list_ini(menuT2L, 0);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _list_ini
; 0002 023E           f_edit=0;
	CLT
	BLD  R3,3
; 0002 023F           BEEP;
	SET
	BLD  R2,4
; 0002 0240           break;
	RJMP _0x40153
; 0002 0241           }
; 0002 0242         list_scroll();
_0x40156:
	RCALL _list_scroll
; 0002 0243         break;
	RJMP _0x40153
; 0002 0244         default:
_0x40157:
; 0002 0245         if(!f_edit)
	SBRC R3,3
	RJMP _0x40158
; 0002 0246           {
; 0002 0247           if(_LEFT) { list_ini(menuT5L, pos[3]-1); pos[3]=0;  BEEP; break; } // 
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40159
	LDI  R30,LOW(8)
	ST   -Y,R30
	__GETB1MN _pos,3
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,3
	SET
	BLD  R2,4
	RJMP _0x40153
; 0002 0248           if(_RIGHT) { f_edit=1; g_rep=REP_FAST; BEEP; break; } // .
_0x40159:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x4015A
	SET
	BLD  R3,3
	LDI  R30,LOW(5)
	STS  _g_rep,R30
	BLD  R2,4
	RJMP _0x40153
; 0002 0249           list_scroll();
_0x4015A:
	RCALL _list_scroll
; 0002 024A           }
; 0002 024B         else
	RJMP _0x4015B
_0x40158:
; 0002 024C           {
; 0002 024D           ind=pos[3]-1; // ind chanel
	__GETB1MN _pos,3
	SUBI R30,LOW(1)
	MOV  R17,R30
; 0002 024E           if (_LEFT) { f_edit=0; g_rep=REP_SLOW; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x4015C
	CLT
	BLD  R3,3
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	SET
	BLD  R2,4
	RJMP _0x40153
; 0002 024F           if(_RIGHT) { list_scroll_roll(); break; }
_0x4015C:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x4015D
	RCALL _list_scroll_roll
	RJMP _0x40153
; 0002 0250           change_pars(&cur_model.modes[cur_mode_ind].chanels[ind][g_list_selitem],-100,100);
_0x4015D:
	__POINTW2MN _cur_model,23
	LDS  R30,_cur_mode_ind
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	SUBI R26,LOW(-81)
	SBCI R27,HIGH(-81)
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12U
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LDS  R30,_g_list_selitem
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(156)
	ST   -Y,R30
	LDI  R30,LOW(100)
	ST   -Y,R30
	RCALL _change_pars
; 0002 0251           }
_0x4015B:
; 0002 0252         break;
; 0002 0253         }
_0x40153:
; 0002 0254       break;
	RJMP _0x400CE
; 0002 0255       case 3: // 
_0x40150:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x4015E
; 0002 0256         if(!f_edit)
	SBRC R3,3
	RJMP _0x4015F
; 0002 0257           {
; 0002 0258           if(_LEFT) {  list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40160
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 0259           if(_RIGHT) { f_edit=1; g_rep=REP_FAST; BEEP; break; }
_0x40160:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40161
	SET
	BLD  R3,3
	LDI  R30,LOW(5)
	STS  _g_rep,R30
	BLD  R2,4
	RJMP _0x400CE
; 0002 025A           change_paru(&pos[3], 7);
_0x40161:
	__POINTW1MN _pos,3
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _change_paru
; 0002 025B           break;
	RJMP _0x400CE
; 0002 025C           }
; 0002 025D         if(_LEFT)  { f_edit=0; g_rep=REP_SLOW; BEEP; break; }
_0x4015F:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40162
	CLT
	BLD  R3,3
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 025E         if(_RIGHT) { if(pos[3]<7) pos[3]++; else pos[3]=0; BEEP; break; }
_0x40162:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40163
	__GETB2MN _pos,3
	CPI  R26,LOW(0x7)
	BRSH _0x40164
	__GETB1MN _pos,3
	SUBI R30,-LOW(1)
	RJMP _0x401F4
_0x40164:
	LDI  R30,LOW(0)
_0x401F4:
	__PUTB1MN _pos,3
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 025F         change_name_ch(&cur_model.name[pos[3]]); //  
_0x40163:
	__GETB1MN _pos,3
	LDI  R31,0
	SUBI R30,LOW(-_cur_model)
	SBCI R31,HIGH(-_cur_model)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _change_name_ch
; 0002 0260       break;
	RJMP _0x400CE
; 0002 0261       case 4: //  
_0x4015E:
	CPI  R30,LOW(0x4)
	BRNE _0x40166
; 0002 0262         if(_LEFT)  { list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40167
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 0263         if (_DOWN || _UP ) { cur_model.type=!cur_model.type; BEEP; }
_0x40167:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BRNE _0x40169
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x40168
_0x40169:
	__POINTW2MN _cur_model,8
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x1)
	CALL __LNEGB1
	ANDI R30,LOW(0x1)
	MOV  R0,R30
	LD   R30,X
	ANDI R30,0xFE
	OR   R30,R0
	ST   X,R30
	SET
	BLD  R2,4
; 0002 0264       break;
_0x40168:
	RJMP _0x400CE
; 0002 0265       case 5: // 
_0x40166:
	CPI  R30,LOW(0x5)
	BRNE _0x4016B
; 0002 0266         if(_LEFT) {  list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x4016C
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 0267         v=0;
_0x4016C:
	LDI  R19,LOW(0)
; 0002 0268         if (_UP &&  cur_model.num_freq<(PLL_CountChannel-1)) { cur_model.num_freq++; v=1; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x4016E
	__GETB2MN _cur_model,12
	CPI  R26,LOW(0x13)
	BRLO _0x4016F
_0x4016E:
	RJMP _0x4016D
_0x4016F:
	__GETB1MN _cur_model,12
	SUBI R30,-LOW(1)
	__PUTB1MN _cur_model,12
	SUBI R30,LOW(1)
	RJMP _0x401F5
; 0002 0269         else if (_DOWN && cur_model.num_freq) { cur_model.num_freq--; v=1;  }
_0x4016D:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x40172
	__GETB1MN _cur_model,12
	CPI  R30,0
	BRNE _0x40173
_0x40172:
	RJMP _0x40171
_0x40173:
	__GETB1MN _cur_model,12
	SUBI R30,LOW(1)
	__PUTB1MN _cur_model,12
	SUBI R30,-LOW(1)
_0x401F5:
	LDI  R19,LOW(1)
; 0002 026A         if(v) { PLL_SetFreq(cur_model.num_freq); BEEP; }
_0x40171:
	CPI  R19,0
	BREQ _0x40174
	__GETB1MN _cur_model,12
	ST   -Y,R30
	CALL _PLL_SetFreq
	SET
	BLD  R2,4
; 0002 026B       break;
_0x40174:
	RJMP _0x400CE
; 0002 026C       case 6:  // 
_0x4016B:
	CPI  R30,LOW(0x6)
	BRNE _0x40175
; 0002 026D         if(_LEFT) { list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40176
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 026E         v=cur_model.modulation; change_parr(&v, 1);
_0x40176:
	__GETB1MN _cur_model,8
	LSR  R30
	ANDI R30,LOW(0x3)
	MOV  R19,R30
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _change_parr
	POP  R19
; 0002 026F         if(cur_model.modulation!=v)
	__GETB1MN _cur_model,8
	LSR  R30
	ANDI R30,LOW(0x3)
	CP   R19,R30
	BREQ _0x40177
; 0002 0270           {
; 0002 0271           cur_model.modulation=v;
	__POINTW2MN _cur_model,8
	MOV  R30,R19
	ANDI R30,LOW(0x3)
	LSL  R30
	MOV  R0,R30
	LD   R30,X
	ANDI R30,LOW(0xF9)
	OR   R30,R0
	ST   X,R30
; 0002 0272           if (cur_model.modulation==0) TCCR1A=0x82;
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x6)
	BRNE _0x40178
	LDI  R30,LOW(130)
	RJMP _0x401F6
; 0002 0273           else if (cur_model.modulation==1) TCCR1A=0xC2;
_0x40178:
	__GETB1MN _cur_model,8
	ANDI R30,LOW(0x6)
	CPI  R30,LOW(0x2)
	BRNE _0x4017A
	LDI  R30,LOW(194)
_0x401F6:
	OUT  0x2F,R30
; 0002 0274           }
_0x4017A:
; 0002 0275       break;
_0x40177:
	RJMP _0x400CE
; 0002 0276       case 7: // 
_0x40175:
	CPI  R30,LOW(0x7)
	BRNE _0x4017B
; 0002 0277         if(_LEFT) { list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x4017C
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 0278         if (_UP && cur_model.num_ch<8) {  cur_model.num_ch++; BEEP; }
_0x4017C:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x4017E
	__GETB1MN _cur_model,11
	ANDI R30,LOW(0xF)
	CPI  R30,LOW(0x8)
	BRLO _0x4017F
_0x4017E:
	RJMP _0x4017D
_0x4017F:
	__POINTW2MN _cur_model,11
	LDI  R24,0
	LDI  R30,LOW(15)
	CALL __POSTINC_BITFB
	SET
	BLD  R2,4
; 0002 0279         if (_DOWN && cur_model.num_ch>2) {  cur_model.num_ch--; BEEP; }
_0x4017D:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x40181
	__GETB1MN _cur_model,11
	ANDI R30,LOW(0xF)
	CPI  R30,LOW(0x3)
	BRSH _0x40182
_0x40181:
	RJMP _0x40180
_0x40182:
	__POINTW2MN _cur_model,11
	LDI  R24,0
	LDI  R30,LOW(15)
	CALL __POSTDEC_BITFB
	SET
	BLD  R2,4
; 0002 027A       break;
_0x40180:
	RJMP _0x400CE
; 0002 027B       case 8: // TIMER
_0x4017B:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x40183
; 0002 027C         switch(pos[3])
	__GETB1MN _pos,3
; 0002 027D           {
; 0002 027E           case 0:
	CPI  R30,0
	BRNE _0x40187
; 0002 027F           if(_LEFT) { list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40188
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	RCALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
; 0002 0280           if(_RIGHT)
_0x40188:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40189
; 0002 0281             {
; 0002 0282             pos[3]=g_list_selitem+1; pos[4]=0;
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,3
	LDI  R30,LOW(0)
	__PUTB1MN _pos,4
; 0002 0283             if(pos[3]==1) g_rep=REP_FAST;
	__GETB2MN _pos,3
	CPI  R26,LOW(0x1)
	BRNE _0x4018A
	LDI  R30,LOW(5)
	STS  _g_rep,R30
; 0002 0284             BEEP;
_0x4018A:
	SET
	BLD  R2,4
; 0002 0285             break;
	RJMP _0x40186
; 0002 0286             }
; 0002 0287           list_scroll();
_0x40189:
	RCALL _list_scroll
; 0002 0288           break;
	RJMP _0x40186
; 0002 0289           case 1: // 
_0x40187:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x4018B
; 0002 028A           if(_LEFT) { list_ini(menuT3L, pos[3]-1); pos[3]=0; g_rep=REP_SLOW; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x4018C
	LDI  R30,LOW(2)
	ST   -Y,R30
	__GETB1MN _pos,3
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,3
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	SET
	BLD  R2,4
	RJMP _0x40186
; 0002 028B           if (_UP && cur_model.timer_set<3599) { cur_model.timer_set+=10; BEEP; }
_0x4018C:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x4018E
	__GETW2MN _cur_model,9
	CPI  R26,LOW(0xE0F)
	LDI  R30,HIGH(0xE0F)
	CPC  R27,R30
	BRLO _0x4018F
_0x4018E:
	RJMP _0x4018D
_0x4018F:
	__GETW1MN _cur_model,9
	ADIW R30,10
	__PUTW1MN _cur_model,9
	SET
	BLD  R2,4
; 0002 028C           if (_DOWN && cur_model.timer_set>=10) { cur_model.timer_set-=10; BEEP; }
_0x4018D:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x40191
	__GETW2MN _cur_model,9
	SBIW R26,10
	BRSH _0x40192
_0x40191:
	RJMP _0x40190
_0x40192:
	__GETW1MN _cur_model,9
	SBIW R30,10
	__PUTW1MN _cur_model,9
	SET
	BLD  R2,4
; 0002 028D           break;
_0x40190:
	RJMP _0x40186
; 0002 028E           case 2: // 
_0x4018B:
	CPI  R30,LOW(0x2)
	BRNE _0x40186
; 0002 028F           if(_LEFT)  { list_ini(menuT3L, pos[3]-1); pos[3]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40194
	LDI  R30,LOW(2)
	ST   -Y,R30
	__GETB1MN _pos,3
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,3
	SET
	BLD  R2,4
	RJMP _0x40186
; 0002 0290           v=cur_model.timer_mode; change_paru(&v, 2); cur_model.timer_mode=v;
_0x40194:
	__GETB1MN _cur_model,8
	LSR  R30
	LSR  R30
	LSR  R30
	ANDI R30,LOW(0x3)
	MOV  R19,R30
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _change_paru
	POP  R19
	__POINTW2MN _cur_model,8
	MOV  R30,R19
	ANDI R30,LOW(0x3)
	LSL  R30
	LSL  R30
	LSL  R30
	MOV  R0,R30
	LD   R30,X
	ANDI R30,LOW(0xE7)
	OR   R30,R0
	ST   X,R30
; 0002 0291           break;
; 0002 0292           }
_0x40186:
; 0002 0293       break;
	RJMP _0x400CE
; 0002 0294       case 9:  //  
_0x40183:
	CPI  R30,LOW(0x9)
	BREQ PC+3
	JMP _0x40195
; 0002 0295       if(!f_edit)
	SBRC R3,3
	RJMP _0x40196
; 0002 0296         {
; 0002 0297         if(_LEFT) { list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x40197
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 0298         if(_RIGHT)
_0x40197:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x40198
; 0002 0299           {
; 0002 029A           if(pos[3]<2) { f_edit=1; BEEP; break; }
	__GETB2MN _pos,3
	CPI  R26,LOW(0x2)
	BRSH _0x40199
	SET
	BLD  R3,3
	BLD  R2,4
	RJMP _0x400CE
; 0002 029B           cur_model.modes[T[1]]=cur_model.modes[T[0]];
_0x40199:
	__POINTW2MN _cur_model,23
	__GETB1MN _T,1
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	PUSH R31
	PUSH R30
	__POINTW2MN _cur_model,23
	LDS  R30,_T
	LDI  R31,0
	MOVW R22,R26
	LDI  R26,LOW(165)
	LDI  R27,HIGH(165)
	CALL __MULW12U
	ADD  R30,R22
	ADC  R31,R23
	POP  R26
	POP  R27
	LDI  R24,165
	CALL __COPYMML
; 0002 029C           list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP;  break;
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 029D           }
; 0002 029E         change_parr(&pos[3], 2);
_0x40198:
	__POINTW1MN _pos,3
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _change_parr
; 0002 029F         break;
	RJMP _0x400CE
; 0002 02A0         }
; 0002 02A1       if(_LEFT) { f_edit=0; BEEP; break; }
_0x40196:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x4019A
	CLT
	BLD  R3,3
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 02A2       if(_RIGHT) { if(pos[3]<1) pos[3]++; else pos[3]=0; BEEP; break; }
_0x4019A:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x4019B
	__GETB2MN _pos,3
	CPI  R26,LOW(0x1)
	BRSH _0x4019C
	__GETB1MN _pos,3
	SUBI R30,-LOW(1)
	RJMP _0x401F7
_0x4019C:
	LDI  R30,LOW(0)
_0x401F7:
	__PUTB1MN _pos,3
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 02A3       if(pos[3]<2) { change_parr(&T[pos[3]], 2); break; }
_0x4019B:
	__GETB2MN _pos,3
	CPI  R26,LOW(0x2)
	BRSH _0x4019E
	__GETB1MN _pos,3
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _change_parr
	RJMP _0x400CE
; 0002 02A4       break;
_0x4019E:
	RJMP _0x400CE
; 0002 02A5       case 10: // Reset
_0x40195:
	CPI  R30,LOW(0xA)
	BRNE _0x4019F
; 0002 02A6         if(_LEFT) // Cancel
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401A0
; 0002 02A7           { list_ini(menuT1L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400CE
; 0002 02A8         if(_RIGHT)
_0x401A0:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401A1
; 0002 02A9           { // OK
; 0002 02AA           MODEL_reset(cur_model_ind);
	LDS  R30,_cur_model_ind
	ST   -Y,R30
	CALL _MODEL_reset
; 0002 02AB           MODEL_init(cur_model_ind);
	LDS  R30,_cur_model_ind
	ST   -Y,R30
	CALL _MODEL_init
; 0002 02AC           list_ini(menuT1L, pos[2]-1); pos[2]=0;
	LDI  R30,LOW(10)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
; 0002 02AD           BEEP1;
	SET
	BLD  R2,3
; 0002 02AE           }
; 0002 02AF       break;
_0x401A1:
	RJMP _0x400CE
; 0002 02B0       case 11: // Save
_0x4019F:
	CPI  R30,LOW(0xB)
	BRNE _0x400CE
; 0002 02B1         if(_RIGHT)
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401A3
; 0002 02B2          {
; 0002 02B3          switch(g_list_selitem)
	LDS  R30,_g_list_selitem
; 0002 02B4            {
; 0002 02B5          case 0: // Save
	CPI  R30,0
	BRNE _0x401A7
; 0002 02B6            #asm("cli")
	cli
; 0002 02B7            EEP_models[cur_model_ind]=cur_model;
	LDS  R30,_cur_model_ind
	LDI  R31,0
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL __MULW12U
	SUBI R30,LOW(-_EEP_models)
	SBCI R31,HIGH(-_EEP_models)
	MOVW R26,R30
	LDI  R30,LOW(_cur_model)
	LDI  R31,HIGH(_cur_model)
	LDI  R22,LOW(518)
	LDI  R23,HIGH(518)
	CALL __COPYEM
; 0002 02B8            #asm("sei")
	sei
; 0002 02B9            BEEP1;
	SET
	BLD  R2,3
; 0002 02BA          break;
	RJMP _0x401A6
; 0002 02BB          case 1: BEEP; break; // Cancel
_0x401A7:
	CPI  R30,LOW(0x1)
	BREQ _0x401F8
; 0002 02BC          case 2: MODEL_init(cur_model_ind); BEEP; break; // Restore
	CPI  R30,LOW(0x2)
	BRNE _0x401A6
	LDS  R30,_cur_model_ind
	ST   -Y,R30
	CALL _MODEL_init
_0x401F8:
	SET
	BLD  R2,4
; 0002 02BD            }
_0x401A6:
; 0002 02BE          list_ini(menuT0L, pos[1]-1); pos[1]=0;
	LDI  R30,LOW(4)
	ST   -Y,R30
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
; 0002 02BF          break;
	RJMP _0x400CE
; 0002 02C0          }
; 0002 02C1        list_scroll();
_0x401A3:
_0x401E8:
	CALL _list_scroll
; 0002 02C2       break;
; 0002 02C3       }
_0x400CE:
; 0002 02C4     break;
	RJMP _0x400BC
; 0002 02C5     case 3: //  
_0x400CB:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x401AA
; 0002 02C6       if(!f_edit)
	SBRC R3,3
	RJMP _0x401AB
; 0002 02C7         {
; 0002 02C8         if(_LEFT) { list_ini(menuT0L, pos[1]-1); pos[1]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401AC
	LDI  R30,LOW(4)
	ST   -Y,R30
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
	SET
	BLD  R2,4
	RJMP _0x400BC
; 0002 02C9         if(_RIGHT)
_0x401AC:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401AD
; 0002 02CA           {
; 0002 02CB           if(pos[2]<2) { f_edit=1; BEEP; break; }
	__GETB2MN _pos,2
	CPI  R26,LOW(0x2)
	BRSH _0x401AE
	SET
	BLD  R3,3
	BLD  R2,4
	RJMP _0x400BC
; 0002 02CC           MODEL_copy(T[0],T[1]); MODEL_init(cur_model_ind);
_0x401AE:
	LDS  R30,_T
	ST   -Y,R30
	__GETB1MN _T,1
	ST   -Y,R30
	CALL _MODEL_copy
	LDS  R30,_cur_model_ind
	ST   -Y,R30
	CALL _MODEL_init
; 0002 02CD           list_ini(menuT0L, pos[1]-1); pos[1]=0; BEEP1; break;
	LDI  R30,LOW(4)
	ST   -Y,R30
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
	SET
	BLD  R2,3
	RJMP _0x400BC
; 0002 02CE           }
; 0002 02CF         change_parr(&pos[2], 2);
_0x401AD:
	__POINTW1MN _pos,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _change_parr
; 0002 02D0         break;
	RJMP _0x400BC
; 0002 02D1         }
; 0002 02D2       if(_LEFT) { f_edit=0; BEEP; break; }
_0x401AB:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401AF
	CLT
	BLD  R3,3
	SET
	BLD  R2,4
	RJMP _0x400BC
; 0002 02D3       if(_RIGHT) { if(pos[2]<1) pos[2]++; else pos[2]=0; BEEP; break; }
_0x401AF:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401B0
	__GETB2MN _pos,2
	CPI  R26,LOW(0x1)
	BRSH _0x401B1
	__GETB1MN _pos,2
	SUBI R30,-LOW(1)
	RJMP _0x401F9
_0x401B1:
	LDI  R30,LOW(0)
_0x401F9:
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x400BC
; 0002 02D4       if(pos[2]<2)
_0x401B0:
	__GETB2MN _pos,2
	CPI  R26,LOW(0x2)
	BRSH _0x401B3
; 0002 02D5         {
; 0002 02D6         change_parr(&T[pos[2]], MAX_MODELS-1);
	__GETB1MN _pos,2
	LDI  R31,0
	SUBI R30,LOW(-_T)
	SBCI R31,HIGH(-_T)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _change_parr
; 0002 02D7         break;
	RJMP _0x400BC
; 0002 02D8         }
; 0002 02D9     break;
_0x401B3:
	RJMP _0x400BC
; 0002 02DA     case 4: // OPTION
_0x401AA:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x400BC
; 0002 02DB     switch(pos[2])
	__GETB1MN _pos,2
; 0002 02DC       {
; 0002 02DD       case 0:
	CPI  R30,0
	BRNE _0x401B8
; 0002 02DE         if(_LEFT) { list_ini(menuT0L, pos[1]-1); pos[1]=0;  BEEP; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401B9
	LDI  R30,LOW(4)
	ST   -Y,R30
	__GETB1MN _pos,1
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,1
	SET
	BLD  R2,4
; 0002 02DF         if(_RIGHT)
_0x401B9:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401BA
; 0002 02E0           {
; 0002 02E1           pos[2]=g_list_selitem+1; pos[3]=0;
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,2
	LDI  R30,LOW(0)
	__PUTB1MN _pos,3
; 0002 02E2           if(pos[2]==3) g_list_selitem=0;
	__GETB2MN _pos,2
	CPI  R26,LOW(0x3)
	BRNE _0x401BB
	STS  _g_list_selitem,R30
; 0002 02E3           if(pos[2]==4) { EIMSK|=0x01; EIFR=0x01; }
_0x401BB:
	__GETB2MN _pos,2
	CPI  R26,LOW(0x4)
	BRNE _0x401BC
	IN   R30,0x39
	ORI  R30,1
	OUT  0x39,R30
	LDI  R30,LOW(1)
	OUT  0x38,R30
; 0002 02E4           BEEP; break;
_0x401BC:
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02E5           }
; 0002 02E6         list_scroll();
_0x401BA:
	CALL _list_scroll
; 0002 02E7       break;
	RJMP _0x401B7
; 0002 02E8       case 1: // Sound
_0x401B8:
	CPI  R30,LOW(0x1)
	BRNE _0x401BD
; 0002 02E9         if (_DOWN || _UP) { f_sound_en=!f_sound_en; BEEP; break;}
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BRNE _0x401BF
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x401BE
_0x401BF:
	LDI  R30,LOW(1)
	EOR  R2,R30
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02EA         if (_LEFT) { EEP_f_sound_en=f_sound_en;
_0x401BE:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401C1
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	LDI  R26,LOW(_EEP_f_sound_en)
	LDI  R27,HIGH(_EEP_f_sound_en)
	CALL __EEPROMWRB
; 0002 02EB           list_ini(menuT4L, pos[2]-1); pos[2]=0;
	LDI  R30,LOW(5)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
; 0002 02EC           BEEP1; }
	SET
	BLD  R2,3
; 0002 02ED       break;
_0x401C1:
	RJMP _0x401B7
; 0002 02EE       case 2: // Battery
_0x401BD:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x401C2
; 0002 02EF         if(!f_edit)
	SBRC R3,3
	RJMP _0x401C3
; 0002 02F0           {
; 0002 02F1           if(_LEFT) {  list_ini(menuT4L, pos[2]-1); pos[2]=0; BEEP; break;}
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401C4
	LDI  R30,LOW(5)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02F2           if(_RIGHT) { f_edit=1; g_rep=REP_FAST; BEEP; break;}
_0x401C4:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401C5
	SET
	BLD  R3,3
	LDI  R30,LOW(5)
	STS  _g_rep,R30
	BLD  R2,4
	RJMP _0x401B7
; 0002 02F3           change_parr(&pos[3], 2);
_0x401C5:
	__POINTW1MN _pos,3
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _change_parr
; 0002 02F4           break;
	RJMP _0x401B7
; 0002 02F5           }
; 0002 02F6         if(_LEFT) {  EEP_BatCntr[pos[3]]=BatCntr[pos[3]]; f_edit=0; g_rep=REP_SLOW; BEEP1; break; }
_0x401C3:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401C6
	__GETB1MN _pos,3
	LDI  R31,0
	MOVW R0,R30
	SUBI R30,LOW(-_EEP_BatCntr)
	SBCI R31,HIGH(-_EEP_BatCntr)
	MOVW R26,R30
	MOVW R30,R0
	SUBI R30,LOW(-_BatCntr)
	SBCI R31,HIGH(-_BatCntr)
	LD   R30,Z
	CALL __EEPROMWRB
	CLT
	BLD  R3,3
	LDI  R30,LOW(10)
	STS  _g_rep,R30
	SET
	BLD  R2,3
	RJMP _0x401B7
; 0002 02F7         if(_RIGHT) {  if(++pos[3]>2) pos[3]=0; BEEP; break; }
_0x401C6:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401C7
	__GETB1MN _pos,3
	SUBI R30,-LOW(1)
	__PUTB1MN _pos,3
	CPI  R30,LOW(0x3)
	BRLO _0x401C8
	LDI  R30,LOW(0)
	__PUTB1MN _pos,3
_0x401C8:
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02F8         change_paru( &BatCntr[pos[3]], 120);
_0x401C7:
	__GETB1MN _pos,3
	LDI  R31,0
	SUBI R30,LOW(-_BatCntr)
	SBCI R31,HIGH(-_BatCntr)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(120)
	ST   -Y,R30
	CALL _change_paru
; 0002 02F9       break;
	RJMP _0x401B7
; 0002 02FA       case 3: // Monitor
_0x401C2:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x401C9
; 0002 02FB         if(_LEFT) {  list_ini(menuT4L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401CA
	LDI  R30,LOW(5)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02FC         if(_RIGHT) { pos[3]=!pos[3]; BEEP; break; }
_0x401CA:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x8)
	BREQ _0x401CB
	__GETB1MN _pos,3
	CALL __LNEGB1
	__PUTB1MN _pos,3
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02FD         if (_DOWN &&  g_list_selitem<(cur_model.num_ch-MAX_LIST_LINES)) { g_list_selitem++; BEEP; break; }
_0x401CB:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x2)
	BREQ _0x401CD
	__GETB1MN _cur_model,11
	ANDI R30,LOW(0xF)
	SUBI R30,LOW(5)
	LDS  R26,_g_list_selitem
	CP   R26,R30
	BRLO _0x401CE
_0x401CD:
	RJMP _0x401CC
_0x401CE:
	LDS  R30,_g_list_selitem
	SUBI R30,-LOW(1)
	STS  _g_list_selitem,R30
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02FE         if (_UP && g_list_selitem) { g_list_selitem--; BEEP; break; }
_0x401CC:
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x1)
	BREQ _0x401D0
	LDS  R30,_g_list_selitem
	CPI  R30,0
	BRNE _0x401D1
_0x401D0:
	RJMP _0x401CF
_0x401D1:
	LDS  R30,_g_list_selitem
	SUBI R30,LOW(1)
	STS  _g_list_selitem,R30
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 02FF       break;
_0x401CF:
	RJMP _0x401B7
; 0002 0300       case 4: // Tachometer
_0x401C9:
	CPI  R30,LOW(0x4)
	BRNE _0x401D2
; 0002 0301         if(_LEFT) {  EIMSK&=0xfe; list_ini(menuT4L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401D3
	IN   R30,0x39
	ANDI R30,0xFE
	OUT  0x39,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
	RJMP _0x401B7
; 0002 0302       break;
_0x401D3:
	RJMP _0x401B7
; 0002 0303       case 5: // Version
_0x401D2:
	CPI  R30,LOW(0x5)
	BRNE _0x401B7
; 0002 0304         if(_LEFT) {  list_ini(menuT4L, pos[2]-1); pos[2]=0; BEEP; break; }
	LDS  R30,_mnu_keys
	ANDI R30,LOW(0x4)
	BREQ _0x401D5
	LDI  R30,LOW(5)
	ST   -Y,R30
	__GETB1MN _pos,2
	SUBI R30,LOW(1)
	ST   -Y,R30
	CALL _list_ini
	LDI  R30,LOW(0)
	__PUTB1MN _pos,2
	SET
	BLD  R2,4
; 0002 0305       break;
_0x401D5:
; 0002 0306       }
_0x401B7:
; 0002 0307     break;
; 0002 0308     }
_0x400BC:
; 0002 0309   break;
; 0002 030A   }
_0x400A8:
; 0002 030B mnu_keys=0;
	LDI  R30,LOW(0)
	STS  _mnu_keys,R30
; 0002 030C }
	CALL __LOADLOCR6
	ADIW R28,12
	RET
;//-------------------------------------------------------------
;void TX_init (void)
; 0002 030F {
_TX_init:
; 0002 0310 char i;
; 0002 0311 cur_model_ind=EEP_start_model;
	ST   -Y,R17
;	i -> R17
	LDI  R26,LOW(_EEP_start_model)
	LDI  R27,HIGH(_EEP_start_model)
	CALL __EEPROMRDB
	STS  _cur_model_ind,R30
; 0002 0312 f_sound_en=EEP_f_sound_en;
	LDI  R26,LOW(_EEP_f_sound_en)
	LDI  R27,HIGH(_EEP_f_sound_en)
	CALL __EEPROMRDB
	CALL __BSTB1
	BLD  R2,0
; 0002 0313 BatCntr[0]=EEP_BatCntr[0]; BatCntr[1]=EEP_BatCntr[1]; BatCntr[2]=EEP_BatCntr[2];
	LDI  R26,LOW(_EEP_BatCntr)
	LDI  R27,HIGH(_EEP_BatCntr)
	CALL __EEPROMRDB
	STS  _BatCntr,R30
	__POINTW2MN _EEP_BatCntr,1
	CALL __EEPROMRDB
	__PUTB1MN _BatCntr,1
	__POINTW2MN _EEP_BatCntr,2
	CALL __EEPROMRDB
	__PUTB1MN _BatCntr,2
; 0002 0314 CalibrTemperature[0]=EPP_CalibrTemperature[0];
	LDI  R26,LOW(_EPP_CalibrTemperature)
	LDI  R27,HIGH(_EPP_CalibrTemperature)
	CALL __EEPROMRDW
	STS  _CalibrTemperature,R30
	STS  _CalibrTemperature+1,R31
; 0002 0315 CalibrTemperature[1]=EPP_CalibrTemperature[1];
	__POINTW2MN _EPP_CalibrTemperature,2
	CALL __EEPROMRDW
	__PUTW1MN _CalibrTemperature,2
; 0002 0316 for (i=0; i<5; i++)
	LDI  R17,LOW(0)
_0x401D7:
	CPI  R17,5
	BRLT PC+3
	JMP _0x401D8
; 0002 0317   {
; 0002 0318   ADmin[i]=EEPR_ADmin[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmin)
	LDI  R27,HIGH(_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmin)
	LDI  R27,HIGH(_EEPR_ADmin)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0002 0319   ADmid[i]=EEPR_ADmid[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmid)
	LDI  R27,HIGH(_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmid)
	LDI  R27,HIGH(_EEPR_ADmid)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0002 031A   ADmax[i]=EEPR_ADmax[i];
	MOV  R30,R17
	LDI  R26,LOW(_ADmax)
	LDI  R27,HIGH(_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R30,R17
	LDI  R26,LOW(_EEPR_ADmax)
	LDI  R27,HIGH(_EEPR_ADmax)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
; 0002 031B   }
	SUBI R17,-1
	RJMP _0x401D7
_0x401D8:
; 0002 031C MODEL_init(cur_model_ind);
	LDS  R30,_cur_model_ind
	ST   -Y,R30
	CALL _MODEL_init
; 0002 031D }
	LD   R17,Y+
	RET
;/**************************************************
;  Nokia
;3310 - 84  48
;3410 - 96  65
;     
;**************************************************/
;
;// Driver for LCD Nokia 3320 (NXP PCF8511).
;
;
;
;#define NOK_3410
;//#define NOK_3310
;//------------------------------------------------
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <spi.h>
;#include <delay.h>
;#include <stdio.h>
;#include <LCD_3320.h>
;
;
;
;
;
;
;                                   //*************************************************************
;//unsigned char WidthS, HeightS;
;//unsigned char Width, Height;
;//unsigned char WidthS;
;//unsigned char HeightS;
;//__flash char WidthS;
;//__flash char HeightS;
;/*
;#ifdef NOK_3310
;#define MAX_LIST_LINES 4
;#endif
;
;
;#ifdef NOK_3410
;#define MAX_LIST_LINES 5
;#endif
;*/
;
;#ifdef NOK_3310
;unsigned char buff[6][84];
;#endif
;
;
;#ifdef NOK_3410
;unsigned char buff[8][96];
;#endif
;
;//WidthS=Width;
;//HeightS=Height;
;
;
;unsigned char posx, posy;
;
;//------------------------------------------------------
;#ifdef NOK_3310
;#define LCD_RESET PORTC.4
;#define LCD_DC PORTC.5
;//------------------------------------------------------
;void LCD_init(void) //  
;{
;unsigned int i;
;
;LCD_DC =0;
;LCD_RESET=0;
;delay_ms(1);
;LCD_RESET=1;
;delay_ms(1);
;LCD_DC=0;
;spi(0x21);     //  , . 
;spi(0xC8);     //   , Vop=0x48;
;spi(0x06);
;spi(0x13);      // bias=3
;spi(0x20);     //   
;spi(0x0c);
;delay_us(500);
;//*******************     3410
;LCD_DC=0 ;
;spi(64);
;spi(128);
;LCD_DC =1;
;for(i=0;i<909;i++) spi(0);   //    .
;
;LCD_DC=0  ;
;spi(64);
;spi(128);
;LCD_DC =1;
;//******************
;
;
;LCD_clear();
;LCD_refresh();
;}
;//------------------------------------------------------
;void LCD_refresh (void)  //   ( )
;{
;unsigned char i,j;
;
;LCD_DC=0 ;
;spi(64);
;LCD_DC=1;
;for(i=0; i<6; i++)
;  {
;  LCD_DC=0 ;
;  spi(64+i);
;  spi(128);
;  LCD_DC=1;
;  for (j=0; j<84; j++) spi(buff[i][j]);
;  }
;}
;
;
;#endif
;
;
;//------------------------------------------------------
;#ifdef NOK_3410
;#define LCD_RESET PORTC.4
;#define LCD_DC PORTC.5
;//------------------------------------------------------
;void LCD_init(void) //  
; 0003 007E {

	.CSEG
_LCD_init:
; 0003 007F unsigned int i;
; 0003 0080 LCD_DC =0;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	CBI  0x15,5
; 0003 0081 LCD_RESET=0;
	CBI  0x15,4
; 0003 0082 delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0003 0083 LCD_RESET=1;
	SBI  0x15,4
; 0003 0084 delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0003 0085 LCD_DC=0;
	CBI  0x15,5
; 0003 0086 spi(0x21);     //  , . 
	LDI  R30,LOW(33)
	ST   -Y,R30
	CALL _spi
; 0003 0087 spi(0xC8);     //   , Vop=0x48;
	LDI  R30,LOW(200)
	ST   -Y,R30
	CALL _spi
; 0003 0088 spi(0x06);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _spi
; 0003 0089 spi(0x13);      // bias=3
	LDI  R30,LOW(19)
	ST   -Y,R30
	CALL _spi
; 0003 008A spi(0x20);     //   
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _spi
; 0003 008B spi(0x0c);
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL _spi
; 0003 008C delay_us(500);
	__DELAY_USW 1500
; 0003 008D 
; 0003 008E LCD_DC=0 ;
	CBI  0x15,5
; 0003 008F spi(64);
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _spi
; 0003 0090 spi(128);
	LDI  R30,LOW(128)
	ST   -Y,R30
	CALL _spi
; 0003 0091 LCD_DC =1;
	SBI  0x15,5
; 0003 0092 for(i=0;i<909;i++) spi(0);   //    .
	__GETWRN 16,17,0
_0x60010:
	__CPWRN 16,17,909
	BRSH _0x60011
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _spi
	__ADDWRN 16,17,1
	RJMP _0x60010
_0x60011:
; 0003 0094 PORTC.5=0  ;
	CBI  0x15,5
; 0003 0095 spi(64);
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _spi
; 0003 0096 spi(128);
	LDI  R30,LOW(128)
	ST   -Y,R30
	CALL _spi
; 0003 0097 LCD_DC =1;
	SBI  0x15,5
; 0003 0098 
; 0003 0099 LCD_clear();
	RCALL _LCD_clear
; 0003 009A LCD_refresh();
	RCALL _LCD_refresh
; 0003 009B }
	RJMP _0x20C0008
;//------------------------------------------------------
;void LCD_refresh (void)  //   ( )
; 0003 009E {
_LCD_refresh:
; 0003 009F unsigned char i,j;
; 0003 00A0 
; 0003 00A1 LCD_DC=0 ;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R17
;	j -> R16
	CBI  0x15,5
; 0003 00A2 spi(64);
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _spi
; 0003 00A3 LCD_DC=1;
	SBI  0x15,5
; 0003 00A4 for(i=0; i<8; i++)
	LDI  R17,LOW(0)
_0x6001B:
	CPI  R17,8
	BRSH _0x6001C
; 0003 00A5   {
; 0003 00A6   LCD_DC=0 ;
	CBI  0x15,5
; 0003 00A7   spi(64+i);
	MOV  R30,R17
	SUBI R30,-LOW(64)
	ST   -Y,R30
	CALL _spi
; 0003 00A8   spi(128);
	LDI  R30,LOW(128)
	ST   -Y,R30
	CALL _spi
; 0003 00A9   LCD_DC=1;
	SBI  0x15,5
; 0003 00AA   for (j=0; j<96; j++) spi(buff[i][j]);
	LDI  R16,LOW(0)
_0x60022:
	CPI  R16,96
	BRSH _0x60023
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	CALL _spi
	SUBI R16,-1
	RJMP _0x60022
_0x60023:
; 0003 00AB }
	SUBI R17,-1
	RJMP _0x6001B
_0x6001C:
; 0003 00AC }
	RJMP _0x20C0008
;//------------------------------------------------------
;/*
;3310 - 84  48
;3410 - 96  65
;*/
;
;#endif
;
;
;//------------------------------------------------------
;//------------------------------------------------------
;//------------------------------------------------------
;
;
;#ifdef NOK_3310
;void LCD_clear (void)
;{
;unsigned char x, y;
;for (y=0; y<6; y++)
;for (x=0; x<84; x++) buff[y][x]=0;
;}
;#endif
;
;#ifdef NOK_3410
;void LCD_clear (void)
; 0003 00C6 {
_LCD_clear:
; 0003 00C7 unsigned char x, y;
; 0003 00C8 for (y=0; y<8; y++)
	ST   -Y,R17
	ST   -Y,R16
;	x -> R17
;	y -> R16
	LDI  R16,LOW(0)
_0x60025:
	CPI  R16,8
	BRSH _0x60026
; 0003 00C9 for (x=0; x<96; x++) buff[y][x]=0;  //   ?
	LDI  R17,LOW(0)
_0x60028:
	CPI  R17,96
	BRSH _0x60029
	LDI  R26,LOW(96)
	MUL  R16,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	ST   X,R30
	SUBI R17,-1
	RJMP _0x60028
_0x60029:
; 0003 00CA }
	SUBI R16,-1
	RJMP _0x60025
_0x60026:
_0x20C0008:
	LD   R16,Y+
	LD   R17,Y+
	RET
;#endif
;
;
;
;
;//------------------------------------------------------ 
;void LCD_pixel (unsigned char x, unsigned char y, unsigned char color)
; 0003 00D2 {   //  .      
_LCD_pixel:
; 0003 00D3 unsigned char i, bt;
; 0003 00D4 i=y>>3;
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+4
;	y -> Y+3
;	color -> Y+2
;	i -> R17
;	bt -> R16
	LDD  R30,Y+3
	LSR  R30
	LSR  R30
	LSR  R30
	MOV  R17,R30
; 0003 00D5 bt=1<<(y & 0x7);
	LDD  R30,Y+3
	ANDI R30,LOW(0x7)
	LDI  R26,LOW(1)
	CALL __LSLB12
	MOV  R16,R30
; 0003 00D6 if(color) buff[i][x]|=bt;
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x6002A
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	OR   R30,R16
	RJMP _0x6006A
; 0003 00D7 else buff[i][x]&=(~bt);
_0x6002A:
	LDI  R26,LOW(96)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_buff)
	SBCI R31,HIGH(-_buff)
	MOVW R26,R30
	LDD  R30,Y+4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	LD   R26,Z
	MOV  R30,R16
	COM  R30
	AND  R30,R26
	MOVW R26,R0
_0x6006A:
	ST   X,R30
; 0003 00D8 }
	JMP  _0x20C0004
;//------------------------------------------------------
;
;
;void LCD_line ( char x1, char y1, char x2, char y2, char mode ) // 
; 0003 00DD {
_LCD_line:
; 0003 00DE int dx, dy, stepx, stepy, fraction;
; 0003 00DF 
; 0003 00E0 dy = y2 - y1;
	SBIW R28,4
	CALL __SAVELOCR6
;	x1 -> Y+14
;	y1 -> Y+13
;	x2 -> Y+12
;	y2 -> Y+11
;	mode -> Y+10
;	dx -> R16,R17
;	dy -> R18,R19
;	stepx -> R20,R21
;	stepy -> Y+8
;	fraction -> Y+6
	LDD  R26,Y+13
	LDD  R30,Y+11
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R18,R30
; 0003 00E1 dx = x2 - x1;
	LDD  R26,Y+14
	LDD  R30,Y+12
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R16,R30
; 0003 00E2 if ( dy < 0 ) { dy= -dy; stepy= -1; }
	TST  R19
	BRPL _0x6002C
	MOVW R30,R18
	CALL __ANEGW1
	MOVW R18,R30
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x6006B
; 0003 00E3 else stepy = 1;
_0x6002C:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x6006B:
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0003 00E4 if ( dx < 0 ) { dx= -dx; stepx= -1; }
	TST  R17
	BRPL _0x6002E
	MOVW R30,R16
	CALL __ANEGW1
	MOVW R16,R30
	__GETWRN 20,21,-1
; 0003 00E5 else stepx = 1;
	RJMP _0x6002F
_0x6002E:
	__GETWRN 20,21,1
; 0003 00E6 dx <<= 1;
_0x6002F:
	LSL  R16
	ROL  R17
; 0003 00E7 dy <<= 1;
	LSL  R18
	ROL  R19
; 0003 00E8 LCD_pixel( x1, y1, mode );
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _LCD_pixel
; 0003 00E9 if ( dx > dy )
	__CPWRR 18,19,16,17
	BRGE _0x60030
; 0003 00EA   {
; 0003 00EB   fraction = dy - (dx >> 1);
	MOVW R30,R16
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R18
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 00EC   while ( x1 != x2 )
_0x60031:
	LDD  R30,Y+12
	LDD  R26,Y+14
	CP   R30,R26
	BREQ _0x60033
; 0003 00ED     {
; 0003 00EE     if ( fraction >= 0 ) { y1 += stepy; fraction -= dx; }
	LDD  R26,Y+7
	TST  R26
	BRMI _0x60034
	LDD  R30,Y+8
	LDD  R26,Y+13
	ADD  R30,R26
	STD  Y+13,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R16
	SBC  R31,R17
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 00EF     x1 += stepx;
_0x60034:
	MOV  R30,R20
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
; 0003 00F0     fraction += dy;
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 00F1     LCD_pixel( x1, y1, mode );
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _LCD_pixel
; 0003 00F2     }
	RJMP _0x60031
_0x60033:
; 0003 00F3   }
; 0003 00F4 else
	RJMP _0x60035
_0x60030:
; 0003 00F5   {
; 0003 00F6   fraction = dx - (dy >> 1);
	MOVW R30,R18
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R16
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 00F7   while ( y1 != y2 )
_0x60036:
	LDD  R30,Y+11
	LDD  R26,Y+13
	CP   R30,R26
	BREQ _0x60038
; 0003 00F8     {
; 0003 00F9     if ( fraction >= 0 ) { x1 += stepx; fraction -= dy; }
	LDD  R26,Y+7
	TST  R26
	BRMI _0x60039
	MOV  R30,R20
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 00FA     y1 += stepy;
_0x60039:
	LDD  R30,Y+8
	LDD  R26,Y+13
	ADD  R30,R26
	STD  Y+13,R30
; 0003 00FB     fraction += dx;
	MOVW R30,R16
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 00FC     LCD_pixel( x1, y1, mode );
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+14
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RCALL _LCD_pixel
; 0003 00FD     }
	RJMP _0x60036
_0x60038:
; 0003 00FE   }
_0x60035:
; 0003 00FF }
	CALL __LOADLOCR6
	ADIW R28,15
	RET
;
;
;//------------------------------------------------------ 
;void LCD_dashline ( char x1, char y1, char x2, char y2)
; 0003 0104 {
_LCD_dashline:
; 0003 0105 char mode;
; 0003 0106 int dx, dy, stepx, stepy, fraction;
; 0003 0107 
; 0003 0108 dy = y2 - y1;
	SBIW R28,6
	CALL __SAVELOCR6
;	x1 -> Y+15
;	y1 -> Y+14
;	x2 -> Y+13
;	y2 -> Y+12
;	mode -> R17
;	dx -> R18,R19
;	dy -> R20,R21
;	stepx -> Y+10
;	stepy -> Y+8
;	fraction -> Y+6
	LDD  R26,Y+14
	LDD  R30,Y+12
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R20,R30
; 0003 0109 dx = x2 - x1;
	LDD  R26,Y+15
	LDD  R30,Y+13
	SUB  R30,R26
	LDI  R31,0
	SBRC R30,7
	SER  R31
	MOVW R18,R30
; 0003 010A mode=1;
	LDI  R17,LOW(1)
; 0003 010B 
; 0003 010C if ( dy < 0 ) { dy= -dy; stepy = -1; }
	TST  R21
	BRPL _0x6003A
	MOVW R30,R20
	CALL __ANEGW1
	MOVW R20,R30
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x6006C
; 0003 010D else stepy = 1;
_0x6003A:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x6006C:
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0003 010E if ( dx < 0 ) { dx= -dx; stepx = -1; }
	TST  R19
	BRPL _0x6003C
	MOVW R30,R18
	CALL __ANEGW1
	MOVW R18,R30
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x6006D
; 0003 010F else stepx = 1;
_0x6003C:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x6006D:
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0003 0110 dx <<= 1;
	LSL  R18
	ROL  R19
; 0003 0111 dy <<= 1;
	LSL  R20
	ROL  R21
; 0003 0112 LCD_pixel( x1, y1, mode );
	LDD  R30,Y+15
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	ST   -Y,R17
	RCALL _LCD_pixel
; 0003 0113 if ( dx > dy )
	__CPWRR 20,21,18,19
	BRGE _0x6003E
; 0003 0114   {
; 0003 0115   fraction = dy - (dx >> 1);
	MOVW R30,R18
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 0116   while ( x1 != x2 )
_0x6003F:
	LDD  R30,Y+13
	LDD  R26,Y+15
	CP   R30,R26
	BREQ _0x60041
; 0003 0117     {
; 0003 0118     if(fraction >= 0 ) { y1 += stepy; fraction -= dx; }
	LDD  R26,Y+7
	TST  R26
	BRMI _0x60042
	LDD  R30,Y+8
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 0119     x1 += stepx;
_0x60042:
	LDD  R30,Y+10
	LDD  R26,Y+15
	ADD  R30,R26
	STD  Y+15,R30
; 0003 011A     fraction += dy;
	MOVW R30,R20
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 011B     if (mode) mode=0;
	CPI  R17,0
	BREQ _0x60043
	LDI  R17,LOW(0)
; 0003 011C     else mode=1;
	RJMP _0x60044
_0x60043:
	LDI  R17,LOW(1)
; 0003 011D     LCD_pixel( x1, y1, mode );
_0x60044:
	LDD  R30,Y+15
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	ST   -Y,R17
	RCALL _LCD_pixel
; 0003 011E     }
	RJMP _0x6003F
_0x60041:
; 0003 011F   }
; 0003 0120 else
	RJMP _0x60045
_0x6003E:
; 0003 0121   {
; 0003 0122   fraction = dx - (dy >> 1);
	MOVW R30,R20
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R18
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 0123   while ( y1 != y2 )
_0x60046:
	LDD  R30,Y+12
	LDD  R26,Y+14
	CP   R30,R26
	BREQ _0x60048
; 0003 0124     {
; 0003 0125     if ( fraction >= 0 ) { x1 += stepx; fraction -= dy; }
	LDD  R26,Y+7
	TST  R26
	BRMI _0x60049
	LDD  R30,Y+10
	LDD  R26,Y+15
	ADD  R30,R26
	STD  Y+15,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R20
	SBC  R31,R21
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 0126     y1 += stepy;
_0x60049:
	LDD  R30,Y+8
	LDD  R26,Y+14
	ADD  R30,R26
	STD  Y+14,R30
; 0003 0127     fraction += dx;
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0003 0128     if (mode) mode=0;
	CPI  R17,0
	BREQ _0x6004A
	LDI  R17,LOW(0)
; 0003 0129     else mode=1;
	RJMP _0x6004B
_0x6004A:
	LDI  R17,LOW(1)
; 0003 012A     LCD_pixel( x1, y1, mode );
_0x6004B:
	LDD  R30,Y+15
	ST   -Y,R30
	LDD  R30,Y+15
	ST   -Y,R30
	ST   -Y,R17
	RCALL _LCD_pixel
; 0003 012B     }
	RJMP _0x60046
_0x60048:
; 0003 012C   }
_0x60045:
; 0003 012D }
	CALL __LOADLOCR6
	ADIW R28,16
	RET
;
;
;//------------------------------------------------------ 
;void LCD_rectangle(char x, char y, char x1, char y1,unsigned char color)  // 
; 0003 0132 {
_LCD_rectangle:
; 0003 0133 LCD_line (x,y,x,y1,color);
;	x -> Y+4
;	y -> Y+3
;	x1 -> Y+2
;	y1 -> Y+1
;	color -> Y+0
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _LCD_line
; 0003 0134 LCD_line (x,y1,x1,y1,color);
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _LCD_line
; 0003 0135 LCD_line (x1,y1,x1,y,color);
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _LCD_line
; 0003 0136 LCD_line (x,y,x1,y,color);
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _LCD_line
; 0003 0137 }
	JMP  _0x20C0003
;
;
;//------------------------------------------------------  
;void LCD_fillrect  (char x, char y, char x1, char y1,unsigned char color)  //  
; 0003 013C {
_LCD_fillrect:
; 0003 013D unsigned char i;
; 0003 013E for (i=y; i<=y1; i++) LCD_line(x,i,x1,i,color);
	ST   -Y,R17
;	x -> Y+5
;	y -> Y+4
;	x1 -> Y+3
;	y1 -> Y+2
;	color -> Y+1
;	i -> R17
	LDD  R17,Y+4
_0x6004D:
	LDD  R30,Y+2
	MOV  R26,R17
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x6004E
	LDD  R30,Y+5
	ST   -Y,R30
	ST   -Y,R17
	LDD  R30,Y+5
	ST   -Y,R30
	ST   -Y,R17
	LDD  R30,Y+5
	ST   -Y,R30
	RCALL _LCD_line
	SUBI R17,-1
	RJMP _0x6004D
_0x6004E:
; 0003 013F }
	LDD  R17,Y+0
	RJMP _0x20C0007
;//------------------------------------------------------
;/*
;__flash const unsigned char font8x8[][8] = {
;    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},  //
;	{0x00,0x06,0x5F,0x5F,0x06,0x00,0x00,0x00},
;	{0x00,0x07,0x07,0x00,0x07,0x07,0x00,0x00},
;	{0x14,0x7F,0x7F,0x14,0x7F,0x7F,0x14,0x00},
;	{0x24,0x2E,0x6B,0x6B,0x3A,0x12,0x00,0x00},
;	{0x46,0x66,0x30,0x18,0x0C,0x66,0x62,0x02},
;	{0x30,0x7A,0x4F,0x5D,0x37,0x7A,0x48,0x00},
;	{0x04,0x07,0x03,0x00,0x00,0x00,0x00,0x00},
;	{0x00,0x1C,0x3E,0x63,0x41,0x00,0x00,0x00},
;	{0x00,0x41,0x63,0x3E,0x1C,0x00,0x01,0x00},
;	{0x08,0x2A,0x3E,0x1C,0x1C,0x3E,0x2A,0x08},
;	{0x08,0x08,0x3E,0x3E,0x08,0x08,0x08,0x00},
;	{0x00,0x80,0xE0,0x60,0x00,0x00,0x00,0x00},
;	{0x10,0x10,0x10,0x10,0x10,0x10,0x00,0x00},
;	{0x00,0x00,0x60,0x60,0x00,0x00,0x00,0x00},
;	{0x60,0x30,0x18,0x0C,0x06,0x03,0x01,0x00},
;	{0x3E,0x7F,0x41,0x41,0x41,0x7F,0x3E,0x00},
;	{0x40,0x42,0x7F,0x7F,0x40,0x40,0x00,0x00},
;	{0x62,0x73,0x5B,0x49,0x6F,0x66,0x00,0x00},
;	{0x22,0x63,0x49,0x49,0x7F,0x36,0x00,0x00},
;	{0x18,0x1C,0x16,0x53,0x7F,0x7F,0x50,0x00},
;	{0x27,0x67,0x45,0x45,0x7D,0x39,0x00,0x00},
;	{0x3C,0x7E,0x4B,0x49,0x79,0x30,0x00,0x00},
;	{0x03,0x03,0x71,0x79,0x0F,0x07,0x00,0x00},
;	{0x36,0x7F,0x49,0x49,0x7F,0x36,0x00,0x00},
;	{0x06,0x4F,0x49,0x69,0x3F,0x1E,0x00,0x00},
;	{0x00,0x00,0x66,0x66,0x00,0x00,0x00,0x00},
;	{0x00,0x80,0xE6,0x66,0x00,0x00,0x00,0x00},
;	{0x08,0x1C,0x36,0x63,0x41,0x00,0x00,0x00},
;	{0x14,0x14,0x14,0x14,0x14,0x14,0x00,0x00},
;	{0x00,0x41,0x63,0x36,0x1C,0x08,0x00,0x00},
;	{0x02,0x03,0x51,0x59,0x0F,0x06,0x00,0x00},
;	{0x3E,0x7F,0x41,0x5D,0x5D,0x1F,0x1E,0x00},
;	{0x7C,0x7E,0x13,0x13,0x7E,0x7C,0x00,0x00},
;	{0x41,0x7F,0x7F,0x49,0x49,0x7F,0x36,0x00},
;	{0x1C,0x3E,0x63,0x41,0x41,0x63,0x22,0x00},
;	{0x41,0x7F,0x7F,0x41,0x63,0x3E,0x1C,0x00},
;	{0x41,0x7F,0x7F,0x49,0x5D,0x41,0x63,0x00},
;	{0x41,0x7F,0x7F,0x49,0x1D,0x01,0x03,0x00},
;	{0x1E,0x3E,0x63,0x41,0x51,0x73,0x72,0x00},
;	{0x7F,0x7F,0x08,0x08,0x7F,0x7F,0x00,0x00},
;	{0x41,0x7F,0x7F,0x41,0x00,0x00,0x00,0x00},
;	{0x30,0x70,0x40,0x41,0x7F,0x3F,0x01,0x00},
;	{0x41,0x7F,0x7F,0x08,0x1C,0x77,0x63,0x00},
;	{0x41,0x7F,0x7F,0x41,0x40,0x60,0x70,0x00},
;	{0x7F,0x7F,0x0E,0x1C,0x0E,0x7F,0x7F,0x00},
;	{0x7F,0x7F,0x06,0x0C,0x18,0x7F,0x7F,0x00},
;	{0x1C,0x3E,0x63,0x41,0x63,0x3E,0x1C,0x00},
;	{0x41,0x7F,0x7F,0x49,0x09,0x0F,0x06,0x00},
;	{0x1E,0x3F,0x21,0x71,0x7F,0x5E,0x00,0x00},
;	{0x41,0x7F,0x7F,0x09,0x19,0x7F,0x66,0x00},
;	{0x22,0x67,0x4D,0x59,0x73,0x22,0x00,0x00},
;	{0x03,0x41,0x7F,0x7F,0x41,0x03,0x00,0x00},
;	{0x3F,0x7F,0x40,0x40,0x7F,0x3F,0x00,0x00},
;	{0x1F,0x3F,0x60,0x60,0x3F,0x1F,0x00,0x00},
;	{0x7F,0x7F,0x30,0x18,0x30,0x7F,0x7F,0x00},
;	{0x43,0x67,0x3C,0x18,0x3C,0x67,0x43,0x00},
;	{0x07,0x4F,0x78,0x78,0x4F,0x07,0x00,0x00},
;	{0x47,0x63,0x71,0x59,0x4D,0x67,0x73,0x00},
;	{0x00,0x7F,0x7F,0x41,0x41,0x00,0x00,0x00},
;	{0x01,0x03,0x06,0x0C,0x18,0x30,0x60,0x00},
;	{0x00,0x41,0x41,0x7F,0x7F,0x00,0x00,0x00},
;	{0x08,0x0C,0x06,0x03,0x06,0x0C,0x08,0x00},
;	{0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80},
;	{0x00,0x00,0x03,0x07,0x04,0x00,0x00,0x00},
;	{0x20,0x74,0x54,0x54,0x3C,0x78,0x40,0x00},
;	{0x41,0x7F,0x3F,0x48,0x48,0x78,0x30,0x00},
;	{0x38,0x7C,0x44,0x44,0x6C,0x28,0x00,0x00},
;	{0x30,0x78,0x48,0x49,0x3F,0x7F,0x40,0x00},
;	{0x38,0x7C,0x54,0x54,0x5C,0x18,0x00,0x00},
;	{0x48,0x7E,0x7F,0x49,0x01,0x03,0x02,0x00},
;	{0x4C,0x5E,0x52,0x52,0x7C,0x3E,0x02,0x00},
;	{0x41,0x7F,0x7F,0x08,0x04,0x7C,0x78,0x00},
;	{0x00,0x44,0x7D,0x7D,0x40,0x00,0x00,0x00},
;	{0x60,0xE0,0x80,0x80,0xFD,0x7D,0x00,0x00},
;	{0x41,0x7F,0x7F,0x10,0x38,0x6C,0x44,0x00},
;	{0x00,0x41,0x7F,0x7F,0x40,0x00,0x00,0x00},
;	{0x7C,0x7C,0x18,0x38,0x1C,0x7C,0x78,0x00},
;	{0x7C,0x7C,0x04,0x04,0x7C,0x78,0x00,0x00},
;	{0x38,0x7C,0x44,0x44,0x7C,0x38,0x00,0x00},
;	{0x84,0xFC,0xF8,0xA4,0x24,0x3C,0x18,0x00},
;	{0x18,0x3C,0x24,0xA4,0xF8,0xFC,0x84,0x00},
;	{0x44,0x7C,0x78,0x4C,0x04,0x1C,0x18,0x00},
;	{0x48,0x5C,0x54,0x54,0x74,0x24,0x00,0x00},
;	{0x00,0x04,0x3E,0x7F,0x44,0x24,0x00,0x00},
;	{0x3C,0x7C,0x40,0x40,0x3C,0x7C,0x40,0x00},
;	{0x1C,0x3C,0x60,0x60,0x3C,0x1C,0x00,0x00},
;	{0x3C,0x7C,0x70,0x38,0x70,0x7C,0x3C,0x00},
;	{0x44,0x6C,0x38,0x10,0x38,0x6C,0x44,0x00},
;	{0x9C,0xBC,0xA0,0xA0,0xFC,0x7C,0x00,0x00},  //
;	{0x4C,0x64,0x74,0x5C,0x4C,0x64,0x00,0x00},  //122
;
;    {0xFF,0x81,0x81,0x81,0x81,0x81,0x81,0xFF}, //       123
;    {0xFF,0x81,0xBD,0xBD,0xBD,0xBD,0x81,0xFF}, //       124
;
;    {0x01,0x31,0x79,0x79,0x7D,0x7F,0x7D,0x31},  // 125,126 ;
;    {0x11,0x11,0x11,0x10,0x10,0x10,0x38,0x10},
;
;    {0x3E,0x08,0x1C,0x1C,0x7C,0x3E,0x1E,0x1E},  // 127,128 ;
;    {0x1E,0x1C,0x18,0x18,0x18,0x1C,0x0E,0x0E},
;
;    {0xF0,0x08,0x04,0x02,0x01,0x51,0xF1,0xF1},  //, 129,130,131,132
;    {0xFD,0xF1,0xF1,0x71,0x1A,0x0C,0x08,0xF0},
;    {0x0F,0x10,0x24,0x74,0x9C,0x8E,0x9F,0x9F},
;    {0x9F,0x9F,0x9F,0x9E,0x40,0x20,0x10,0x0F}
;
;} ;
;*/
; //  
;__flash const unsigned char font_norm[][9] = {
;
;    {0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  
;	{0x03,0x5F,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  !
;	{0x04,0x03,0x00,0x03,0x00,0x00,0x00,0x00,0x00},    //  "
;	{0x07,0x24,0x7E,0x24,0x24,0x7E,0x24,0x00,0x00},    //  #
;	{0x06,0x04,0x2A,0x7F,0x2A,0x10,0x00,0x00,0x00},    //  $
;	{0x08,0x02,0x05,0x62,0x18,0x26,0x50,0x20,0x00},    //  %
;	{0x07,0x36,0x49,0x49,0x56,0x20,0x50,0x00,0x00},    //  &
;	{0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  
;	{0x03,0x3E,0x41,0x00,0x00,0x00,0x00,0x00,0x00},    //  (
;	{0x03,0x41,0x3E,0x00,0x00,0x00,0x00,0x00,0x00},    //  )
;	{0x06,0x14,0x08,0x3E,0x08,0x14,0x00,0x00,0x00},    //  *
;	{0x06,0x08,0x08,0x3E,0x08,0x08,0x00,0x00,0x00},    //  +
;	{0x04,0x80,0x60,0x00,0x00,0x00,0x00,0x00,0x00},    //  ,
;	{0x05,0x08,0x08,0x08,0x08,0x00,0x00,0x00,0x00},    //  -
;	{0x03,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  .
;	{0x04,0x60,0x1C,0x03,0x00,0x00,0x00,0x00,0x00},    //  /
;	{0x06,0x3E,0x61,0x5D,0x43,0x3E,0x00,0x00,0x00},    //  0
;	{0x06,0x04,0x02,0x7F,0x00,0x00,0x00,0x00,0x00},    //  1
;	{0x06,0x42,0x61,0x51,0x49,0x46,0x00,0x00,0x00},    //  2
;	{0x06,0x22,0x41,0x49,0x49,0x36,0x00,0x00,0x00},    //  3
;	{0x06,0x18,0x14,0x12,0x7F,0x10,0x00,0x00,0x00},    //  4
;	{0x06,0x27,0x45,0x45,0x45,0x39,0x00,0x00,0x00},    //  5
;	{0x06,0x3E,0x45,0x45,0x45,0x38,0x00,0x00,0x00},    //  6
;	{0x06,0x01,0x61,0x19,0x07,0x01,0x00,0x00,0x00},    //  7
;	{0x06,0x36,0x49,0x49,0x49,0x36,0x00,0x00,0x00},    //  8
;	{0x06,0x0E,0x51,0x51,0x51,0x3E,0x00,0x00,0x00},    //  9
;	{0x03,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  :
;	{0x04,0x80,0x62,0x00,0x00,0x00,0x00,0x00,0x00},    //  ;
;	{0x04,0x08,0x14,0x22,0x00,0x00,0x00,0x00,0x00},    //  <
;	{0x05,0x14,0x14,0x14,0x14,0x00,0x00,0x00,0x00},    //  =
;	{0x04,0x22,0x14,0x08,0x00,0x00,0x00,0x00,0x00},    //  >
;	{0x06,0x02,0x01,0x51,0x09,0x06,0x00,0x00,0x00},    //  ?
;	{0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  
;	{0x06,0x7C,0x12,0x11,0x12,0x7C,0x00,0x00,0x00},    //  A
;	{0x06,0x7F,0x49,0x49,0x49,0x3E,0x00,0x00,0x00},    //  B
;	{0x06,0x3E,0x41,0x41,0x41,0x22,0x00,0x00,0x00},    //  C
;	{0x06,0x7F,0x41,0x41,0x22,0x1C,0x00,0x00,0x00},    //  D
;	{0x06,0x7F,0x49,0x49,0x49,0x49,0x00,0x00,0x00},    //  E
;	{0x05,0x7F,0x09,0x09,0x01,0x00,0x00,0x00,0x00},    //  F
;	{0x06,0x3C,0x42,0x41,0x51,0x72,0x00,0x00,0x00},    //  G
;	{0x06,0x7F,0x08,0x08,0x08,0x7F,0x00,0x00,0x00},    //  H
;	{0x03,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  I
;	{0x06,0x30,0x40,0x40,0x40,0x3F,0x00,0x00,0x00},    //  J
;	{0x06,0x7F,0x08,0x14,0x22,0x41,0x00,0x00,0x00},    //  K
;	{0x06,0x7F,0x40,0x40,0x40,0x40,0x00,0x00,0x00},    //  L
;	{0x07,0x7F,0x02,0x04,0x04,0x02,0x7F,0x00,0x00},    //  M
;	{0x06,0x7F,0x04,0x08,0x10,0x7F,0x00,0x00,0x00},    //  N
;	{0x06,0x3E,0x41,0x41,0x41,0x3E,0x00,0x00,0x00},    //  O
;	{0x06,0x7F,0x09,0x09,0x09,0x06,0x00,0x00,0x00},    //  P
;	{0x06,0x3E,0x41,0x61,0xC1,0x3E,0x00,0x00,0x00},    //  Q
;	{0x06,0x7F,0x09,0x09,0x19,0x66,0x00,0x00,0x00},    //  R
;	{0x06,0x26,0x49,0x49,0x49,0x32,0x00,0x00,0x00},    //  S
;	{0x06,0x01,0x01,0x7F,0x01,0x01,0x00,0x00,0x00},    //  T
;	{0x06,0x3F,0x40,0x40,0x40,0x3F,0x00,0x00,0x00},    //  U
;	{0x07,0x07,0x38,0x40,0x40,0x38,0x07,0x00,0x00},    //  V
;	{0x08,0x3F,0x40,0x38,0x06,0x38,0x40,0x3F,0x00},    //  W
;	{0x06,0x63,0x14,0x08,0x14,0x63,0x00,0x00,0x00},    //  X
;	{0x06,0x03,0x04,0x78,0x04,0x03,0x00,0x00,0x00},    //  Y
;	{0x06,0x61,0x51,0x49,0x45,0x43,0x00,0x00,0x00},    //  Z
;	{0x03,0x7F,0x41,0x00,0x00,0x00,0x00,0x00,0x00},    //  [
;	{0x04,0x03,0x1C,0x60,0x00,0x00,0x00,0x00,0x00},    //  \
;	{0x03,0x41,0x7F,0x00,0x00,0x00,0x00,0x00,0x00},    //  ]
;	{0x06,0x04,0x02,0x01,0x02,0x04,0x00,0x00,0x00},    //  ^
;	{0x05,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00},    //  _
;	{0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  
;	{0x05,0x20,0x54,0x54,0x78,0x00,0x00,0x00,0x00},    //  a
;	{0x05,0x7F,0x44,0x44,0x38,0x00,0x00,0x00,0x00},    //  b
;	{0x05,0x38,0x44,0x44,0x44,0x00,0x00,0x00,0x00},    //  c
;	{0x05,0x38,0x44,0x44,0x7F,0x00,0x00,0x00,0x00},    //  d
;	{0x05,0x38,0x54,0x54,0x58,0x00,0x00,0x00,0x00},    //  e
;	{0x04,0x04,0x7E,0x05,0x00,0x00,0x00,0x00,0x00},    //  f
;	{0x05,0x18,0xA4,0xA4,0x7C,0x00,0x00,0x00,0x00},    //  g
;	{0x05,0x7F,0x04,0x04,0x78,0x00,0x00,0x00,0x00},    //  h
;	{0x02,0x7D,0x00,0x00,0x00,0x00,0x00,0x00,0x00},    //  i
;	{0x04,0x40,0x80,0x7D,0x00,0x00,0x00,0x00,0x00},    //  j
;	{0x05,0x7F,0x10,0x28,0x44,0x00,0x00,0x00,0x00},    //  k
;	{0x03,0x7F,0x40,0x00,0x00,0x00,0x00,0x00,0x00},    //  l
;	{0x06,0x7C,0x04,0x7C,0x04,0x78,0x00,0x00,0x00},    //  m
;	{0x05,0x7C,0x04,0x04,0x78,0x00,0x00,0x00,0x00},    //  n
;	{0x05,0x38,0x44,0x44,0x38,0x00,0x00,0x00,0x00},    //  o
;	{0x05,0xFC,0x24,0x24,0x18,0x00,0x00,0x00,0x00},    //  p
;	{0x05,0x18,0x24,0x24,0xFC,0x80,0x00,0x00,0x00},    //  q
;	{0x04,0x78,0x04,0x04,0x00,0x00,0x00,0x00,0x00},    //  r
;	{0x05,0x48,0x54,0x54,0x24,0x00,0x00,0x00,0x00},    //  s
;	{0x04,0x04,0x7F,0x44,0x00,0x00,0x00,0x00,0x00},    //  t
;	{0x05,0x3C,0x40,0x40,0x7C,0x00,0x00,0x00,0x00},    //  u
;	{0x06,0x04,0x38,0x40,0x38,0x04,0x00,0x00,0x00},    //  v
;	{0x08,0x3C,0x40,0x30,0x08,0x30,0x40,0x3C,0x00},    //  w
;	{0x06,0x44,0x28,0x10,0x28,0x44,0x00,0x00,0x00},    //  x
;	{0x06,0x04,0x98,0x60,0x18,0x04,0x00,0x00,0x00},    //  y
;	{0x06,0x44,0x64,0x54,0x4C,0x44,0x00,0x00,0x00},     //  z
;
;    {0x08, 0xFF,0x81,0x81,0x81,0x81,0x81,0x81,0xFF}, //       123
;    {0x08, 0xFF,0x81,0xBD,0xBD,0xBD,0xBD,0x81,0xFF}, //       124
;
;    {0x08, 0x01,0x31,0x79,0x79,0x7D,0x7F,0x7D,0x31},  // 125,126 ;
;    {0x08, 0x11,0x11,0x11,0x10,0x10,0x10,0x38,0x10},
;
;    {0x08, 0x3E,0x08,0x1C,0x1C,0x7C,0x3E,0x1E,0x1E},  // 127,128 ;
;    {0x08, 0x1E,0x1C,0x18,0x18,0x18,0x1C,0x0E,0x0E},
;    {0x06, 0x07,0x05,0x05,0x05,0x07,0x02,0x00,0x00}, // batt 129
;    {0x05, 0x01,0x02,0x0f,0x02,0x01,0x00,0x00,0x00}, // antenn 130
;    {0x08, 0x04,0x7f,0x44,0x00,0x02,0x05,0x02,0x00}, // t-gradC 131
;    {0x08, 0x0a,0xfe,0xab,0xff,0xfe,0xea,0xe0,0x40}, // RPM 132
;    {0x08, 0x3c,0x42,0x85,0x99,0x99,0x85,0x42,0x3c}, // Clock 133
;    {0x08, 0x20,0x30,0x38,0x3c,0x38,0x30,0x20,0x00}, // arrow up 134
;    {0x08, 0x04,0x0c,0x1c,0x3c,0x1c,0x0c,0x04,0x00}, // arrow down 135
;
;};
;
;
;//------------------------------------------------------
;__flash const unsigned char deg12x16[][24] = {
;// 0x30 - '0'.
;  {0x00, 0xF8, 0xFE, 0x06, 0x03, 0x03, 0x03, 0x03, 0x03, 0x06, 0xFE, 0xF8,
;  0x00, 0x07, 0x1F, 0x18, 0x30, 0x30, 0x30, 0x30, 0x30, 0x18, 0x1F, 0x07},
;// 0x31 - '1'.
;  {0x00, 0x00, 0x00, 0x0c, 0x0c, 0x0e, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
;  0x00, 0x00, 0x00, 0x30, 0x30, 0x30, 0x3f, 0x3f, 0x30, 0x30, 0x30, 0x00},
;// 0x32 - '2'.
;  {0x00, 0x1c, 0x1e, 0x07, 0x03, 0x03, 0x83, 0xc3, 0xe3, 0x77, 0x3e, 0x1c,
;  0x00, 0x30, 0x38, 0x3c, 0x3e, 0x37, 0x33, 0x31, 0x30, 0x30, 0x30, 0x30},
;// 0x33 - '3'.
;  {0x00, 0x0c, 0x0e, 0x07, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0x7e, 0x3c,
;  0x00, 0x0c, 0x1c, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x39, 0x1f, 0x0e},
;// 0x34 - '4'.
;  {0x00, 0xc0, 0xe0, 0x70, 0x38, 0x1c, 0x0e, 0x07, 0xff, 0xff, 0x00, 0x00,
;  0x00, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x3f, 0x3f, 0x03, 0x03},
;// 0x35 - '5'.
;  {0x00, 0x3f, 0x7f, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0xe3, 0xc3, 0x83,
;  0x00, 0x0c, 0x1c, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x38, 0x1f, 0x0f},
;// 0x36 - '6'.
;  {0x00, 0xc0, 0xf0, 0xf8, 0xdc, 0xce, 0xc7, 0xc3, 0xc3, 0xc3, 0x80, 0x00,
;  0x00, 0x0f, 0x1f, 0x39, 0x30, 0x30, 0x30, 0x30, 0x30, 0x39, 0x1f, 0x0f},
;// 0x37 - '7'.
;  {0x00, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0xc3, 0xf3, 0x3f, 0x0f, 0x03,
;  0x00, 0x00, 0x00, 0x00, 0x30, 0x3c, 0x0f, 0x03, 0x00, 0x00, 0x00, 0x00},
;// 0x38 - '8'.
;  {0x00, 0x00, 0xbc, 0xfe, 0xe7, 0xc3, 0xc3, 0xc3, 0xe7, 0xfe, 0xbc, 0x00,
;  0x00, 0x0f, 0x1f, 0x39, 0x30, 0x30, 0x30, 0x30, 0x30, 0x39, 0x1f, 0x0f},
;// 0x39 - '9'.
;  {0x00, 0x3c, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0xfe, 0xfc,
;  0x00, 0x00, 0x00, 0x30, 0x30, 0x30, 0x38, 0x1c, 0x0e, 0x07, 0x03, 0x00},
;// 0x3a - .
;  {0x00, 0x00, 0x00, 0x00, 0x70, 0x70, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00,
;  0x00, 0x00, 0x00, 0x00, 0x1c, 0x1c, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00}
;  };
;//------------------------------------------------------ 
;void LCD_setxy(char x,unsigned char y)        //   
; 0003 0247 {
_LCD_setxy:
; 0003 0248 posx=x;
;	x -> Y+1
;	y -> Y+0
	LDD  R30,Y+1
	STS  _posx,R30
; 0003 0249 posy=y;
	LD   R30,Y
	STS  _posy,R30
; 0003 024A }
	ADIW R28,2
	RET
;
;//------------------------------------------------------ 
;void LCD_deg12x16(unsigned char c, unsigned char color)    //  
; 0003 024E { // c = address of character in the font array
_LCD_deg12x16:
; 0003 024F char i, j;
; 0003 0250 unsigned char b;
; 0003 0251 
; 0003 0252 for(i=0; i<12; i++)
	CALL __SAVELOCR4
;	c -> Y+5
;	color -> Y+4
;	i -> R17
;	j -> R16
;	b -> R19
	LDI  R17,LOW(0)
_0x60050:
	CPI  R17,12
	BRGE _0x60051
; 0003 0253   {
; 0003 0254   b=deg12x16[c][i];
	LDD  R30,Y+5
	LDI  R26,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_deg12x16*2)
	SBCI R31,HIGH(-_deg12x16*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R19,Z
; 0003 0255   for(j=0; j<8; j++)
	LDI  R16,LOW(0)
_0x60053:
	CPI  R16,8
	BRGE _0x60054
; 0003 0256     {
; 0003 0257     LCD_pixel(posx, posy+j, (~(b ^ color)) & 1);
	LDS  R30,_posx
	ST   -Y,R30
	MOV  R30,R16
	LDS  R26,_posy
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+6
	EOR  R30,R19
	COM  R30
	ANDI R30,LOW(0x1)
	ST   -Y,R30
	RCALL _LCD_pixel
; 0003 0258     b >>= 1;
	LSR  R19
; 0003 0259     }
	SUBI R16,-1
	RJMP _0x60053
_0x60054:
; 0003 025A   posx++;
	LDS  R30,_posx
	SUBI R30,-LOW(1)
	STS  _posx,R30
; 0003 025B   }
	SUBI R17,-1
	RJMP _0x60050
_0x60051:
; 0003 025C posy+=8;
	LDS  R30,_posy
	SUBI R30,-LOW(8)
	STS  _posy,R30
; 0003 025D posx-=12;
	LDS  R30,_posx
	SUBI R30,LOW(12)
	STS  _posx,R30
; 0003 025E for(i=12; i<24; i++)
	LDI  R17,LOW(12)
_0x60056:
	CPI  R17,24
	BRGE _0x60057
; 0003 025F   {
; 0003 0260   b = deg12x16[c][i];
	LDD  R30,Y+5
	LDI  R26,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_deg12x16*2)
	SBCI R31,HIGH(-_deg12x16*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R19,Z
; 0003 0261   for(j=0; j<8; j++)
	LDI  R16,LOW(0)
_0x60059:
	CPI  R16,8
	BRGE _0x6005A
; 0003 0262     {
; 0003 0263     LCD_pixel(posx, posy+j, (~(b ^ color)) & 1);
	LDS  R30,_posx
	ST   -Y,R30
	MOV  R30,R16
	LDS  R26,_posy
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+6
	EOR  R30,R19
	COM  R30
	ANDI R30,LOW(0x1)
	ST   -Y,R30
	RCALL _LCD_pixel
; 0003 0264     b >>= 1;
	LSR  R19
; 0003 0265     }
	SUBI R16,-1
	RJMP _0x60059
_0x6005A:
; 0003 0266   posx++;
	LDS  R30,_posx
	SUBI R30,-LOW(1)
	STS  _posx,R30
; 0003 0267   }
	SUBI R17,-1
	RJMP _0x60056
_0x60057:
; 0003 0268 }
	CALL __LOADLOCR4
_0x20C0007:
	ADIW R28,6
	RET
;//------------------------------------------------------  ???????
;unsigned char LCD_get_char_len(unsigned char ch)
; 0003 026B {
_LCD_get_char_len:
; 0003 026C return font_norm[ch-32][0];
;	ch -> Y+0
	LD   R30,Y
	SUBI R30,LOW(32)
	LDI  R26,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_font_norm*2)
	SBCI R31,HIGH(-_font_norm*2)
	LPM  R30,Z
	JMP  _0x20C0001
; 0003 026D }
;//------------------------------------------------------
;void LCD_char(unsigned char ch, unsigned char color)    //  
; 0003 0270 { // c = address of character in the font array
_LCD_char:
; 0003 0271 unsigned char x, y, len, b;
; 0003 0272 flash unsigned char *p;
; 0003 0273 
; 0003 0274 //if(posx>75 || posy>40) return;
; 0003 0275 if(ch=='\t') { posx=72; return; }
	CALL __SAVELOCR6
;	ch -> Y+7
;	color -> Y+6
;	x -> R17
;	y -> R16
;	len -> R19
;	b -> R18
;	*p -> R20,R21
	LDD  R26,Y+7
	CPI  R26,LOW(0x9)
	BRNE _0x6005B
	LDI  R30,LOW(72)
	STS  _posx,R30
	RJMP _0x20C0006
; 0003 0276 p=font_norm[ch-32];
_0x6005B:
	LDD  R30,Y+7
	SUBI R30,LOW(32)
	LDI  R26,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_font_norm*2)
	SBCI R31,HIGH(-_font_norm*2)
	MOVW R20,R30
; 0003 0277 len=*p++;
	MOVW R30,R20
	__ADDWRN 20,21,1
	LPM  R19,Z
; 0003 0278 for(x=0; x<len; x++)
	LDI  R17,LOW(0)
_0x6005D:
	CP   R17,R19
	BRSH _0x6005E
; 0003 0279   {
; 0003 027A   b=*p++;
	MOVW R30,R20
	__ADDWRN 20,21,1
	LPM  R18,Z
; 0003 027B   for(y=0; y<8; y++)
	LDI  R16,LOW(0)
_0x60060:
	CPI  R16,8
	BRSH _0x60061
; 0003 027C     {
; 0003 027D     LCD_pixel(posx, posy+y, (~(b ^ color)) & 1);
	LDS  R30,_posx
	ST   -Y,R30
	MOV  R30,R16
	LDS  R26,_posy
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+8
	EOR  R30,R18
	COM  R30
	ANDI R30,LOW(0x1)
	ST   -Y,R30
	RCALL _LCD_pixel
; 0003 027E     b >>= 1;
	LSR  R18
; 0003 027F     }
	SUBI R16,-1
	RJMP _0x60060
_0x60061:
; 0003 0280   posx++;
	LDS  R30,_posx
	SUBI R30,-LOW(1)
	STS  _posx,R30
; 0003 0281   }
	SUBI R17,-1
	RJMP _0x6005D
_0x6005E:
; 0003 0282 }
_0x20C0006:
	CALL __LOADLOCR6
	ADIW R28,8
	RET
;//------------------------------------------------------
;void LCD_frame(unsigned char x)
; 0003 0285 {
_LCD_frame:
; 0003 0286 LCD_line(x-1, posy-1, posx-1, posy-1, 1);
;	x -> Y+0
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_posy
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_posx
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_posy
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_line
; 0003 0287 LCD_line(x-1, posy-1, x-1, posy+7, 1);
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_posy
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDD  R30,Y+2
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_posy
	SUBI R30,-LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_line
; 0003 0288 }
	JMP  _0x20C0001
;
;//------------------------------------------------------ 
;void  LCD_wrs (unsigned char*str,unsigned char color) //    
; 0003 028C {
_LCD_wrs:
; 0003 028D unsigned char x;
; 0003 028E 
; 0003 028F x=posx;
	ST   -Y,R17
;	*str -> Y+2
;	color -> Y+1
;	x -> R17
	LDS  R17,_posx
; 0003 0290 while(*str!='\0')  LCD_char(*str++, color);
_0x60062:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x60064
	LD   R30,X+
	STD  Y+2,R26
	STD  Y+2+1,R27
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _LCD_char
	RJMP _0x60062
_0x60064:
; 0003 0291 if(color==0) LCD_frame(x);
	LDD  R30,Y+1
	CPI  R30,0
	BRNE _0x60065
	ST   -Y,R17
	RCALL _LCD_frame
; 0003 0292 }
_0x60065:
	RJMP _0x20C0005
;
;//------------------------------------------------------
;void LCD_wrsf (unsigned char flash*str,unsigned char color) //    
; 0003 0296 {
_LCD_wrsf:
; 0003 0297 unsigned char x;
; 0003 0298 
; 0003 0299 x=posx;
	ST   -Y,R17
;	*str -> Y+2
;	color -> Y+1
;	x -> R17
	LDS  R17,_posx
; 0003 029A while(*str!='\0') LCD_char(*str++, color);
_0x60066:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x60068
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	SBIW R30,1
	LPM  R30,Z
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _LCD_char
	RJMP _0x60066
_0x60068:
; 0003 029B if(color==0) LCD_frame(x);
	LDD  R30,Y+1
	CPI  R30,0
	BRNE _0x60069
	ST   -Y,R17
	RCALL _LCD_frame
; 0003 029C }
_0x60069:
_0x20C0005:
	LDD  R17,Y+0
	ADIW R28,4
	RET
;#include <mega128.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include "LMX2306.h"
;
;//-------------------------------------------------------------
;void PLL_send(unsigned long data, unsigned char cn)
; 0004 0007 {

	.CSEG
_PLL_send:
; 0004 0008 unsigned long m;
; 0004 0009 
; 0004 000A m=1; m<<=cn-1;
	SBIW R28,4
;	data -> Y+5
;	cn -> Y+4
;	m -> Y+0
	__GETD1N 0x1
	CALL __PUTD1S0
	LDD  R30,Y+4
	SUBI R30,LOW(1)
	CALL __GETD2S0
	CALL __LSLD12
	CALL __PUTD1S0
; 0004 000B while(m)
_0x80003:
	CALL __GETD1S0
	CALL __CPD10
	BREQ _0x80005
; 0004 000C   {
; 0004 000D   if(data & m) PLL_DATA1; else PLL_DATA0;
	__GETD2S 5
	CALL __ANDD12
	CALL __CPD10
	BREQ _0x80006
	LDS  R30,101
	ORI  R30,8
	RJMP _0x8000C
_0x80006:
	LDS  R30,101
	ANDI R30,0XF7
_0x8000C:
	STS  101,R30
; 0004 000E //  delay_ms(1);
; 0004 000F   PLL_CLOCK1;
	LDS  R30,101
	ORI  R30,0x10
	STS  101,R30
; 0004 0010 //  delay_ms(1);
; 0004 0011   PLL_CLOCK0;
	LDS  R30,101
	ANDI R30,0xEF
	STS  101,R30
; 0004 0012   m>>=1;
	CALL __GETD1S0
	CALL __LSRD1
	CALL __PUTD1S0
; 0004 0013   }
	RJMP _0x80003
_0x80005:
; 0004 0014 PLL_LE=1;
	SBI  0x18,7
; 0004 0015 delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0004 0016 PLL_LE=0;
	CBI  0x18,7
; 0004 0017 }
	ADIW R28,9
	RET
;//-------------------------------------------------------------
;void PLL_SetFreq(unsigned char num_freq)
; 0004 001A {
_PLL_SetFreq:
; 0004 001B unsigned long data;
; 0004 001C unsigned int k;
; 0004 001D 
; 0004 001E //if(num_freq>=PLL_CountChannel) return; //  ...
; 0004 001F #asm("cli")
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
;	num_freq -> Y+6
;	data -> Y+2
;	k -> R16,R17
	cli
; 0004 0020 // F_Reg
; 0004 0021 PLL_send(0xd2L, 21);
	__GETD1N 0xD2
	CALL __PUTPARD1
	LDI  R30,LOW(21)
	ST   -Y,R30
	RCALL _PLL_send
; 0004 0022 // R_Reg
; 0004 0023 data=PLL_FreqOSC; data/=PLL_FreqStep; data<<=2;
	__GETD1N 0xFA0
	__PUTD1S 2
	__GETD2S 2
	__GETD1N 0xA
	CALL __DIVD21U
	__PUTD1S 2
	__GETD2S 2
	LDI  R30,LOW(2)
	CALL __LSLD12
	__PUTD1S 2
; 0004 0024 PLL_send(data, 21);
	CALL __PUTPARD1
	LDI  R30,LOW(21)
	ST   -Y,R30
	RCALL _PLL_send
; 0004 0025 // N_Reg
; 0004 0026 k=num_freq; k*=PLL_FreqStep; k+=PLL_FreqBand; // freq
	LDD  R16,Y+6
	CLR  R17
	__MULBNWRU 16,17,10
	MOVW R16,R30
	__ADDWRN 16,17,-30526
; 0004 0027 k/=PLL_FreqStep;
	MOVW R26,R16
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	MOVW R16,R30
; 0004 0028 data=(k>>3); // Bcount
	MOVW R30,R16
	CALL __LSRW3
	CLR  R22
	CLR  R23
	__PUTD1S 2
; 0004 0029 data<<=5;
	__GETD2S 2
	LDI  R30,LOW(5)
	CALL __LSLD12
	__PUTD1S 2
; 0004 002A data|=(k & 0x7); // Acount
	MOVW R30,R16
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	__GETD2S 2
	CLR  R22
	CLR  R23
	CALL __ORD12
	__PUTD1S 2
; 0004 002B data<<=2;
	__GETD2S 2
	LDI  R30,LOW(2)
	CALL __LSLD12
	__PUTD1S 2
; 0004 002C data|=0x1;
	LDD  R30,Y+2
	ORI  R30,1
	STD  Y+2,R30
; 0004 002D PLL_send(data, 21);
	__GETD1S 2
	CALL __PUTPARD1
	LDI  R30,LOW(21)
	ST   -Y,R30
	RCALL _PLL_send
; 0004 002E #asm("sei")
	sei
; 0004 002F }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
;//-------------------------------------------------------------
;unsigned int PLL_GetFreq(unsigned char num_freq)
; 0004 0032 {
_PLL_GetFreq:
; 0004 0033 unsigned int ret;
; 0004 0034 ret=num_freq; ret*=PLL_FreqStep; ret+=PLL_FreqBand;
	ST   -Y,R17
	ST   -Y,R16
;	num_freq -> Y+2
;	ret -> R16,R17
	LDD  R16,Y+2
	CLR  R17
	__MULBNWRU 16,17,10
	MOVW R16,R30
	__ADDWRN 16,17,-30526
; 0004 0035 return ret;
	MOVW R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,3
	RET
; 0004 0036 }
;//-------------------------------------------------------------
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
_0x20C0004:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20C0003:
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0002
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20C0002:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_spi:
	LD   R30,Y
	OUT  0xF,R30
_0x2040003:
	SBIS 0xE,7
	RJMP _0x2040003
	IN   R30,0xF
_0x20C0001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.DSEG

	.CSEG

	.DSEG
_posx:
	.BYTE 0x1
_posy:
	.BYTE 0x1

	.ESEG
_EEP_models:
	.BYTE 0xE2A
_EEP_start_model:
	.BYTE 0x1
_EEP_f_sound_en:
	.BYTE 0x1
_EEP_BatCntr:
	.BYTE 0x3

	.DSEG
_g_MainMenuMode:
	.BYTE 0x1

	.ESEG
_EEPR_ADmid:
	.BYTE 0xA
_EEPR_ADmax:
	.BYTE 0xA
_EEPR_ADmin:
	.BYTE 0xA
_EEP_FirstON:
	.BYTE 0x1
_EEP_Calibration:
	.BYTE 0x1
_EPP_CalibrTemperature:
	.BYTE 0x4

	.DSEG
_out_control:
	.BYTE 0x14
_ADmid:
	.BYTE 0xA
_ADmin:
	.BYTE 0xA
_ADmax:
	.BYTE 0xA
_out_ch:
	.BYTE 0x10
_cur_model:
	.BYTE 0x206
_cur_model_ind:
	.BYTE 0x1
_cur_mode_ind:
	.BYTE 0x1
_cur_Batt:
	.BYTE 0x2
_cur_Power:
	.BYTE 0x2
_cur_Temperature:
	.BYTE 0x2
_dir_Temperature:
	.BYTE 0x2
_wd_Temperature:
	.BYTE 0x1
_div_trimmer:
	.BYTE 0x2
_gRPM:
	.BYTE 0x6
_g_pos_d:
	.BYTE 0x6
_div_S0000002000:
	.BYTE 0x1
_beep_cntn:
	.BYTE 0x1
_beep_rep:
	.BYTE 0x1
_beep_freq:
	.BYTE 0x2
_div_trim_S000000A000:
	.BYTE 0x1
_nb_S000000B000:
	.BYTE 0x1
_sum_S000000B000:
	.BYTE 0x2
_BatCntr:
	.BYTE 0x3
_time:
	.BYTE 0x2
_CalibrTemperature:
	.BYTE 0x4
_modeNames:
	.BYTE 0xC
_modulNames:
	.BYTE 0x6
_menuT0:
	.BYTE 0x8
_menuT1:
	.BYTE 0x14
_menuT2:
	.BYTE 0x14
_menuT3:
	.BYTE 0x4
_menuT4:
	.BYTE 0xA
_menuT5:
	.BYTE 0x10
_TypesModel:
	.BYTE 0x4
_Timer_modes1:
	.BYTE 0x6
_menuT7:
	.BYTE 0x6
_menuT8:
	.BYTE 0x6
_dg_list_topitem:
	.BYTE 0x1
_dg_list_selitem:
	.BYTE 0x1
_dg_list_cnt:
	.BYTE 0x1
_dpos:
	.BYTE 0x6
_dT:
	.BYTE 0x2
_dcur_model:
	.BYTE 0x206
_dcur_mode:
	.BYTE 0x2
_dcur_mode_ind:
	.BYTE 0x1
_tmp:
	.BYTE 0xC
_g_list_topitem:
	.BYTE 0x1
_g_list_selitem:
	.BYTE 0x1
_g_list_cnt:
	.BYTE 0x1
_pos:
	.BYTE 0x6
_T:
	.BYTE 0x2
_mnu_keys:
	.BYTE 0x1
_div_beep_batt:
	.BYTE 0x1
_g_rep:
	.BYTE 0x1
_kf1_S0020001000:
	.BYTE 0x1
_cnt_rep_S0020001000:
	.BYTE 0x1
_dev_clip_S0020002000:
	.BYTE 0x1
_dev_timer_S0020002000:
	.BYTE 0x1
_nod_val_S0020004000:
	.BYTE 0x7
_buff:
	.BYTE 0x300
__seed_G105:
	.BYTE 0x4

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xBB8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANDD12:
	AND  R30,R26
	AND  R31,R27
	AND  R22,R24
	AND  R23,R25
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LSRD1:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	RET

__LSLD1:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETW2PF:
	LPM  R26,Z+
	LPM  R27,Z
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__GET_BITFB:
	MOV  R0,R24
	MOV  R24,R30
	LD   R30,X
	MOV  R1,R0
	TST  R1
	BREQ __GET_BITFB1
__GET_BITFB0:
	LSR  R30
	DEC  R1
	BRNE __GET_BITFB0
__GET_BITFB1:
	AND  R30,R24
	RET

__PUT_BITFB:
	AND  R30,R24
	MOV  R25,R30
	TST  R0
	BREQ __PUT_BITFB1
__PUT_BITFB0:
	LSL  R24
	LSL  R25
	DEC  R0
	BRNE __PUT_BITFB0
__PUT_BITFB1:
	COM  R24
	LD   R0,X
	AND  R0,R24
	OR   R0,R25
	ST   X,R0
	RET

__POSTINC_BITFB:
	RCALL __GET_BITFB
	MOV  R22,R30
	INC  R30
	RJMP __PUT_BITFB2

__POSTDEC_BITFB:
	RCALL __GET_BITFB
	MOV  R22,R30
	DEC  R30

__PUT_BITFB2:
	RCALL __PUT_BITFB
	MOV  R30,R22
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__COPYMML:
	CLR  R25
__COPYMM:
	PUSH R30
	PUSH R31
__COPYMM0:
	LD   R22,Z+
	ST   X+,R22
	SBIW R24,1
	BRNE __COPYMM0
	POP  R31
	POP  R30
	RET

__COPYME:
	PUSH R30
	PUSH R31
__COPYME0:
	WDR
	SBIC EECR,EEWE
	RJMP __COPYME0
	IN   R23,SREG
	CLI
	OUT  EEARL,R30
	OUT  EEARH,R31
	SBI  EECR,EERE
	IN   R22,EEDR
	OUT  SREG,R23
	ADIW R30,1
	ST   X+,R22
	SBIW R24,1
	BRNE __COPYME0
	POP  R31
	POP  R30
	RET

__COPYEM:
	PUSH R30
	PUSH R31
__COPYEM0:
	LD   R0,Z+
	PUSH R30
	MOV  R30,R0
	RCALL __EEPROMWRB
	POP  R30
	ADIW R26,1
	SUBI R22,1
	SBCI R23,0
	BRNE __COPYEM0
	POP  R31
	POP  R30
	RET

__COPYEEL:
	CLR  R25
__COPYEE:
	PUSH R30
	PUSH R31
__COPYEE0:
	PUSH R30
	PUSH R26
	PUSH R27
	MOVW R26,R30
	RCALL __EEPROMRDB
	POP  R27
	POP  R26
	PUSH R24
	PUSH R25
	RCALL __EEPROMWRB
	POP  R25
	POP  R24
	POP  R30
	ADIW R30,1
	ADIW R26,1
	SBIW R24,1
	BRNE __COPYEE0
	POP  R31
	POP  R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__BSTB1:
	CLT
	TST  R30
	BREQ PC+2
	SET
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
